# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Admserv.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Access_file = ".htaccess";
my $Adminuser = "admin";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Admserv.pm.  Changes made here will be lost.
package Cobalt::Admserv;

sub admserv_get_access
# admserv_get_access: get the access rights for a directory
# Arguments: a directory name
# Return value: a mode, as above
# Example: $protected = Cobalt::Admserv::admserv_get_access("/home/admserv/.cobalt/place");
{
    my ($dir) = @_;
    return "none" if (! -e "$dir/$Access_file");
    open(HTA,"$dir/$Access_file") ||
	return "4004 Cannot read $dir/.htaccess: $!";
    while (<HTA>)
    {
	next unless (/^require/o);
	if (/^require valid/o)
	{
	    close HTA;
	    return "valid";
	}
	elsif (/^require (\w+) (.+) $Adminuser/o)
	{
	    close HTA;
	    return "require $1 $2";
	}
    }
    close HTA;
    return "any";
}


1;
