# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Admserv.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Allow_cgis_file = "/etc/httpd/conf/ALLOW_USER_CGIS";
my %Features = ("networker","1","telnetConfig","1","dhcpd","0","shiftjis","Cobalt interface message for shiftjis (We should never see this)","pagebuilder","0","www","1","mx","1","gated","1","dns","1","nfs","0","securetty","1","english","1","atalk","0","fpx","1","siteAdminRedirect","1","users","1","ntp","0","mon_textdb_only","0","search","0","anonFTP","1","specialHomeSkel","0","viewGroups","0","cobaltHomePage","0","lastNameFirst","1","warnRootOnly","1","vsites","1","pam","1","discuss","0","docorg","0","groups","1","smb","0","mail","1","nat","0","squid","0","autoGenWebUsage","0","japanese","0","cobaltRedirect","0","backups","1","vmachine","1","mon_port_testing","1","viewUsers","0","usersCGIInWizard","1","privatedirs","0","telnetDefault","1","ssl","0","siteManagement","1","adm","1","bind8","1","personalRedirect","1","webRequests","1","usersAddUser","0","adminRedirect","1","quotas","1","snmp","1","defaultUserNameGen","1","groupdirs","1","proftpd","1");
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Admserv.pm.  Changes made here will be lost.
package Cobalt::Admserv;

sub admserv_set_user_cgis
# Turn CGI access for users on or off
# Arguments: 1 for on, 0 for off
# Side effects: creates the file which tells cgiwrap wether or not
#   to allow user CGIs.  cgiwrap just looks to see if the file
#   exists, and if it does it permits users to run CGIs in their
#   own area.
# Return value: the usual status string
# Example: Cobalt::Admserv::admserv_set_user_cgis(0);
{
    my ($turnon) = @_;

    return "1001 User CGIs not allowed on this system."
      unless ($Features{'www'});

    if ($turnon && -e $Allow_cgis_file)
    {
	return "2003 User CGIs were already enabled, no change";
    }
    elsif ($turnon)
    {
	open(ALLOW,">$Allow_cgis_file")
	    || return "4005 Cannot turn on user CGIs: $!";
	close ALLOW;
	return "2004 User CGIs are enabled";
    }
    elsif (-e $Allow_cgis_file)
    {
	unlink($Allow_cgis_file)
	    || return "4006 Cannot turn off user CGIs: $!";
	return "2005 User CGIs disabled";

    }
    else
    {
	return "2006 User CGIs were already disabled, no change.";
    }
}


1;
