# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from AlertDB.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $MonDBDir = "/var/cobalt";
my $Status_db = "/var/cobalt/status";
my $success = "";
my %Servers = ("smb","Windows file sharing (SMB)","mail","E-mail","filesystem","Disk","www","Web Server","dns","Domain Name Service (DNS)","net","Network","nfs","Unix file sharing (NFS)","cpu","CPU","ftp","File Transfer Protocol (FTP)","userspace","Quota","telnet","Telnet server","atalk","Apple file sharing (AppleShare)","adm","Administrative Web Server","ntp","Network Time Protocol (NTP)","ssl","Secure Web Server","groupspace","Quota","snmp","Simple Network Management Protocol (SNMP)","mem","Memory");
my %Status = ("none","0","0","none","green","1","1","green","2","yellow","red","3","3","red","yellow","2");
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/AlertDB.pm.  Changes made here will be lost.
package Cobalt::AlertDB;

sub db_add_entry
# Set the entry for a server
# Arguments: list: (server,severity,ctime,mtime,advice,debug message,instance,
#   status,data1,data2,data3)
#   Instance would be a subcategory of the server--e.g., for disk there
#   would be an instance for each user's quota.  Only used internally.
#   NOTE: The message passed to db_add_entry is now ignored, we use 
#   msg_build_alert() to create our messages instead.  The message passed
#   to db_add_entry() is used for debugging purposes only.
#   NOTE2: The status argument is also ignored.
#   NOTE3: It would be annoying to try to fix all calls to db_add_entry(),
#   so it's staying as is.
# Side effects: updates the database and the log
{
    my ($server,$sev,$ctime,$mtime,$advice,$debug_msg,$instance,
	$status,$data1,$data2,$data3) = @_;

    my (%STATUS,$ptr,$sorting,$message);
    mkdir($MonDBDir,0755) unless (-d $MonDBDir);
    unless(tie(%STATUS, 'DB_File', $Status_db, O_CREAT()|O_RDWR(),0644))
    {
	return "4054 Cannot access database $Status_db: $!";
    }
    if ($STATUS{"$server.sorted"} == -1)
    {
	# I'm in the middle of sorting
	$sorting = 1;
    }
    else
    {
	$STATUS{"$server.sorted"} = 0; # we are no longer in sorted order
    }

    # Keep old state information
    my ($oldsev,$oldctime,$oldstatus,$olddata1,$olddata2,$olddata3) 
	= split('\|',$STATUS{"$server.$instance"});
    ($status = $oldstatus);# unless (defined($status));
    ($status = 0) unless (defined($status));
    ($data1 = $olddata1) unless (defined($data1));
    ($data1 = 0) unless (defined($data1));
    ($data2 = $olddata2) unless (defined($data2));
    ($data2 = 0) unless (defined($data2));
    ($data3 = $olddata3) unless (defined($data3));
    ($data3 = 0) unless (defined($data3));
    ($oldsev = -1) unless (defined($oldsev));
    ($oldsev == $sev) ? ($ctime = $oldctime) : ($ctime = $mtime);
    ($ctime = $^T) if ($ctime > $^T);   # if they set the clock back...
    $ptr = $STATUS{"$server.wptr"} + 1; # advance the write pointer
    $STATUS{"$server.wptr"} += 1;

    $message = msg_build_alert($server,$instance,
			       $sev,$ctime,$mtime,$data1,$data2,$data3,$status);

    if ($sev == $Status{'green'})
    {
	# Make sure we don't carry notified status with us
	my ($re,$no,$at) = split(/\D/o,$status);
	$status = "${re}#0#${at}";
    }
    $STATUS{"$server.$ptr"} 
           = join('|',$sev,$ctime,$mtime,$advice,$message,$instance);
    $STATUS{"$server.$instance"} = "$sev|$ctime|$status|$data1|$data2|$data3";
    untie %STATUS;

    unless ($sorting)
    {
	# don't log any information while sorting, that would be redundant
	my $svname = $Servers{$server};
	$svname = $server unless ($svname);
	open(LOG,">>$MonDBDir/$server.log") ||
	    return "3050 Cannot write log file $MonDBDir/$service.log: $!";
	print LOG "<FONT COLOR=\"$Status{$sev}\">$svname, ",
	          msg_localtime($mtime), 
	          ": $message</FONT><!-- $instance $advice $debug_msg ($data1/$data2/$data3)-->\n";
	print STDERR "<FONT COLOR=\"$Status{$sev}\">$svname, ",
	          msg_localtime($mtime), 
	          ": $message</FONT><!-- $instance $advice $debug_msg -->\n"
		      if ($Debug);
	close LOG;
	return $success;
    }
}

use Cobalt::Language;

1;
