# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from AlertDB.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Status_db = "/var/cobalt/status";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/AlertDB.pm.  Changes made here will be lost.
package Cobalt::AlertDB;

# Some sample code for reading the database
#    db_start($server);
#    while (@foo = db_get_entry($server))
#    {
#	last if ($foo[0] == 0);
#	print join('|',@foo);
#	print "\n";
#    }

sub db_get_entry
# Get the next entry for a server
# Arguments: server name, optional boolean of wether to include 
#   mail spool entries (1 if we should)
# Returns: the next entry in the database
#   an array of (severity,ctime,mtime,flags,message,instance);
#   Returns 0 if there are no further messages
{
    my ($server,$showspool) = @_;
    my %STATUS;
    my ($severity,$ctime,$mtime,$flags,$message,$inst);
    unless(tie(%STATUS, 'DB_File', $Status_db, O_RDWR(),0644))
    {
	return "4051 Cannot read database $Status_db: $!";
    }
    my $wptr = $STATUS{"$server.wptr"};
    while ($STATUS{"$server.rptr"} <= $wptr)
    {
	my $rptr = $STATUS{"$server.rptr"};
	$STATUS{"$server.rptr"} += 1;
	($severity,$ctime,$mtime,$flags,$message,$inst) = 
	    split('\|',$STATUS{"$server.$rptr"});

	if (($server eq "disk") && ($inst =~ /,mail$/o) && (! $showspool))
	{
	    # Special case; mail spool warnings don't show up in the UI.
	    next;
	}
	untie %STATUS;
	return ($severity,$ctime,$mtime,$flags,$message,$inst);
    }

    if (! $inst)
    {
	# no state at all
	untie %STATUS;
	my $message = msg_build_alert($server,$server,-1);
	return (0,$^T,$^T,0,$message,0);
    }
    else
    {
	untie %STATUS;
	return 0;  # no further questions
    }
}

use Cobalt::Language;

1;
