# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from AlertDB.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Status_db = "/var/cobalt/status";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/AlertDB.pm.  Changes made here will be lost.
package Cobalt::AlertDB;

sub db_prev_entry
# Get information about the previous entry in the database
# Arguments: server, instance
# Return value: severity,ctime,status,data1,data2,data3
# Side effects: none
{
    my ($server,$instance) = @_;
    my %STATUS;
    unless(tie(%STATUS, 'DB_File', $Status_db, O_RDONLY(),0644))
    {
	return "4058 Cannot access database $Status_db: $!";
    }
    my ($sev,$ctime,$status,$d1,$d2,$d3) 
	= split('\|',$STATUS{"$server.$instance"});
    untie %STATUS;
    return 0 unless ($ctime);
    $status = "0#0#0" unless ($status =~ /^[\d\#]+$/o);
    return ($sev,$ctime,$status,$d1,$d2,$d3);
}

use Cobalt::Language;

1;
