# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from AlertDB.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Status_db = "/var/cobalt/status";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/AlertDB.pm.  Changes made here will be lost.
package Cobalt::AlertDB;

sub db_set_history
# Set the current state and related data for a server
# Arguments: server, instance, status, data1, data2, data3
# Side effects: updates the database with the new status
#   Only the status is actually updated; the data remains whatever
#   it was before.  There's really no reason we take it in as
#   arguments.
# Return value: the arguments passed in
{
    my ($server,$instance,$status,$data1,$data2,$data3) = @_;
    my %STATUS;
    unless(tie(%STATUS, 'DB_File', $Status_db, O_RDWR(),0644))
    {
	return "4059 Cannot access database $Status_db: $!";
    }
    my ($sev,$ctime,$flags);
    ($sev,$ctime,$flags,$data1,$data2,$data3) = 
	split('\|',$STATUS{"$server.$instance"});
    $STATUS{"$server.$instance"} = "$sev|$ctime|$status|$data1|$data2|$data3";
    untie %STATUS;
    return ($sev,$ctime,$status,$data1,$data2,$data3);
}

use Cobalt::Language;

1;
