# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from AlertDB.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Status_db = "/var/cobalt/status";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/AlertDB.pm.  Changes made here will be lost.
package Cobalt::AlertDB;

sub db_sort
# Sort the entries in the database
# Arguments: server name
# Side effects: re-orders the entries in the database
{
    my ($server) = @_;
    my ($rptr,$entry,@entries);
    my %STATUS;
    unless(tie(%STATUS, 'DB_File', $Status_db, O_RDWR(),0644))
    {
	return "4056 Cannot read database $Status_db: $!";
    }
    if ($STATUS{"$server.sorted"})
    {
	untie %STATUS;
	return;
    }
    $STATUS{"$server.sorted"} = -1;  # flag to tell us we're sorting
    my $wptr = $STATUS{"$server.wptr"};
    for ($rptr = 1; $rptr <= $wptr; $rptr++)
    {
	if (defined($STATUS{"$server.$rptr"}))
	{
	    my $ent = $STATUS{"$server.$rptr"};
	    push(@entries,$ent);
	}
    }
    # reset the pointers, we're about to re-add
    $STATUS{"$server.wptr"} = 0;
    $STATUS{"$server.rptr"} = 1;
    untie %STATUS;
    foreach $entry (sort { $b cmp $a } @entries)
    {
	db_add_entry($server,split('\|',$entry));
    }
    unless(tie(%STATUS, 'DB_File', $Status_db, O_RDWR(),0644))
    {
	return "4057 Cannot read database $Status_db: $!";
    }
    $STATUS{"$server.sorted"} = 1;
    untie %STATUS;
}


use Cobalt::Language;

1;
