# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Atalk.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $AppleVolumes = "/etc/atalk/AppleVolumes.system";
my $AppleVolumes_lock = "/etc/locks/AppleVolumes_lock";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Atalk.pm.  Changes made here will be lost.
package Cobalt::Atalk;

#
# atalk_del_volume
#
# adds a volume to the volume list
#
# arg: $volume = path to volume
#
sub atalk_del_volume {
  my $volume = shift;

  my $found = 0;

  return "4025 Lock file /etc/locks/AppleVolumes_lock exists: $!" if (-e $AppleVolumes_lock);
  open (VOLLOCK, ">$AppleVolumes_lock")
    or return "4026 Cannot open lock file /etc/locks/AppleVolumes_lock: $!";
  open (VOL, "$AppleVolumes")
    or return "4027 Cannot open /etc/atalk/AppleVolumes.system: $!";
  
  my $inconfig = 0;
  while (<VOL>) {
    if ($inconfig) {
      if (/^\# Cobalt config stop/) {
	$inconfig = 0;
      }
      if (/^$volume\s+\"/) {
	# skip this line
	next;
      }
    }
    if (/^\# Cobalt config start/) {
      $inconfig = 1;
    }
    print VOLLOCK;
  }
  close(VOLLOCK);
  close(VOL);

  rename($AppleVolumes_lock, $AppleVolumes)
    or return "4028 Cannot rename /etc/locks/AppleVolumes_lock to /etc/atalk/AppleVolumes.system: $!";
  return "2014 Atalk volume $volume removed or didn't exist";
}


1;
