# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Dhcpd.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Dhcpd_conf = "/etc/dhcpd.conf";
my $Lockdir = "/etc/locks";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Dhcpd.pm.  Changes made here will be lost.
package Cobalt::Dhcpd;

sub dhcpd_clean_ranges
# Clean out the list of addresses to give out dynamically; should be called
#   after dhcpd_set_parameters().
# Arguments: none
# Return value: a hash table of the ranges which were deleted in the form:
#    %hash = ($low1 => $high1, $low2 => $high2, ...);
# Side effects: calls dhcpd_get_params() to figure out what subnet
#    eth0 is on, and removes all ranges that are not on that subnet;
#    then restarts dhcpd.
{
  # Get the current settings
  my ($gateway,$netmask) = (dhcpd_get_parameters())[3,4];
  my %wiped; # our hash of what ranges we wiped

  return "4060 DHCP server configuration files in use" if (-e "$Lockdir/dhcpd.conf");
  open(LOCK,"> $Lockdir/dhcpd.conf") 
    || return "4061 Could not update DHCP server configuration: $!";
  open(CONF, "$Dhcpd_conf") || return "4062 Could not update DHCP server configuration: $!";
  while(<CONF>) {
    if (/range ([\d\.]+) ([\d\.]+);/o) {
      # if we just changed the netmask and/or gateway, we need
      # to clear any dynamic ranges that will no longer work.
      if (Cobalt::Network::net_network_ismember($1,$gateway,$netmask) &&
	  Cobalt::Network::net_network_ismember($2,$gateway,$netmask)) {
	# This range is out of...range.
	$wiped{$1} = $2;
      }
      else {
	# This range still on the same subnet as eth0
	print LOCK;
      }
    } else {
      # Not a range statement, leave it alone
      print LOCK;
    }
  }
  close LOCK;
  close CONF;
  rename("$Lockdir/dhcpd.conf","$Dhcpd_conf") || return "4063 Could not update DHCP server configuration: $!";

  Cobalt::Dhcpd::dhcpd_hup(); # Kick it
  return "2019 DHCP server updated successfully";
}


1;
