# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Dhcpd.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Dhcpd_conf = "/etc/dhcpd.conf";
my $Dhcpd_default_lease = "86400";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Dhcpd.pm.  Changes made here will be lost.
package Cobalt::Dhcpd;

sub dhcpd_create_conf
# Create the configuration file for dhcpd server with defaults
#   which are largely from current network parameters
# Arguments: none
# Side Effects: writes $Dhcpd_conf; creates a new one if none exists
# Return value: status string like '4000 S.O.S.'
{
    if( -e $Dhcpd_conf ) { return "4059 DHCP server configuration file already exist"; }

    my ( $domainName ,$dnsAddr1, $dnsAddr2 )=Cobalt::Network::net_get_dnsclient();
    my ($addr,$mask) = Cobalt::Network::net_get_ipaddr();
    my $gateway=( Cobalt::Network::net_get_gateway() )[ 0 ];

    # Check that the gateway is on the same subnet as the DHCP server
    if ($gateway && $gateway ne '0.0.0.0' &&
	!Cobalt::Netutil::netutil_test_network_in_network($gateway,32,
							  $addr,$mask)) {
      # The gateway is not on eth0's network, use the eth0's address
      # as the gateway.
      $gateway = $addr;
    }

    my $netmask=( Cobalt::Network::net_get_ipaddr() )[ 1 ];

    my $ret1=Cobalt::Dhcpd::dhcpd_set_parameters( $domainName, $dnsAddr1, $dnsAddr2, $gateway, $netmask, $Dhcpd_default_lease );
    if( $ret1!~/^2/ ) { return $ret1; }

    # create null subnet declaration
    my $ret2=Cobalt::Dhcpd::dhcpd_set_range();
    if( $ret2!~/^2/ ) { return $ret2; }

    return $ret1;
}


1;
