# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Dhcpd.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Dhcpd_conf = "/etc/dhcpd.conf";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Dhcpd.pm.  Changes made here will be lost.
package Cobalt::Dhcpd;

sub dhcpd_get_macs
# Obtains a listing of mac address associated names/ips
# Arguments: none
# Return value: hash of the form mac->name
#   mac address is of the form 55:66:77:AA:BB:CC
#   name may be a computer name or an ip address
{
	my($mac,$host,%max);
	# it's not an error to have no config file; it just means
	# we haven't made one yet.
	return if (! -e $Dhcpd_conf);
	open(DHCPcnf,"$Dhcpd_conf") || return "4029 Could not read DHCP server configuration: $!";
	while(<DHCPcnf>)
	{
		$mac = $1 if (/^\s*hardware ethernet ([^\;]+)\;/o);
		$host = $1 if (/^\s*fixed-address ([^\;]+)\;/o);
		if ($mac && $host)
		{
			$max{$mac} = $host;
			$mac = $host = '';
		}
	}
	close(DHCPcnf);

	return(%max);
}


1;
