# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Dhcpd.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Dhcpd_conf = "/etc/dhcpd.conf";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Dhcpd.pm.  Changes made here will be lost.
package Cobalt::Dhcpd;

sub dhcpd_get_parameters
# Returns dhcp server settings
# Arguments: none
# Return value: domain name, dns server 1, dns server 2, 
#   gateway, netmask, maximum lease time, 
# Reads $Dhcpd_conf; returns null if no conf file
#  
{
	my($domain,$dns1,$dns2,$gw,$nm,$maxlease);

	# if no config file, read in our defaults from system settings
	return if (! -e "$Dhcpd_conf");
	#if (! -e "$Dhcpd_conf") {
	#  ($domain,$dns1,$dns2) = Cobalt::Network::net_get_dnsclient();
	#  $gw = (Cobalt::Network::net_get_gateway())[0];
	#  $nm = (Cobalt::Network::net_get_ipaddr())[1];
	#  $maxlease = $Dhcpd_default_lease;
	#}
	#else {
	  # read from the config file
	  open(DHCPcnf,"$Dhcpd_conf") || return "4044 Could not read DHCP server configuration: $!";
	  while(<DHCPcnf>)
	  {
	    if (/^option domain-name \"([^\"]+)\"\;/o) { 
	      $domain = $1; 
	    }
	    elsif (/^option domain-name-servers ([\d\.]+)(, ([\d\.]+))?\;/o) {
	      ($dns1,$dns2) = ($1,$3);
	    }
	    elsif (/option routers ([\d\.]+)\;/o) {
	      $gw = $1;
	    }
	    elsif (/option subnet-mask ([\d\.]+)\;/o) {
	      $nm = $1;
	    }
	    elsif (/max-lease-time (\d+)\;/o) {
	      $maxlease = $1;
	    }
	  }
	  close(DHCPcnf);
	#}

	return ($domain,$dns1,$dns2,$gw,$nm,$maxlease);
}


1;
