# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Dhcpd.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Dhcpd_conf = "/etc/dhcpd.conf";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Dhcpd.pm.  Changes made here will be lost.
package Cobalt::Dhcpd;

sub dhcpd_get_range
# Obtains a list of dhcp service ranges
# Arguments: none
# Return value: hash of the form (low ip -> high ip)
{
	my(%range);
	
	# it's not an error to have no config file; it just means
	# we haven't made one yet.
	return if (! -e $Dhcpd_conf);
	open(DHCPcnf,"$Dhcpd_conf") || return "4036 Could not read DHCP server configuration: $!";
	while(<DHCPcnf>)
	{
		$range{$1}=$2 if (/^\s*range ([\d\.]+) ([\d\.]+)\;/o);
	}
	close(DHCPcnf);

	return(%range);
}


1;
