# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Dhcpd.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Dhcpd_conf = "/etc/dhcpd.conf";
my $Lockdir = "/etc/locks";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Dhcpd.pm.  Changes made here will be lost.
package Cobalt::Dhcpd;

sub dhcpd_set_macs
# Saves a list of fixed ip addresses by mac address
# Arguments: hash of mac->ip/name
# Return value: Assuring string of the form "2121 Every little thing, gonna' be alright now"
{
	my(%max) = @_;
	sleep 2 if (-e "$Lockdir/dhcpd.conf"); # Avoid race
	return "4030 DHCP server configuration files in use" if (-e "$Lockdir/dhcpd.conf");

	my($ignore); # Hats off for all the lost code out there..
	open(DHCPcnf,"$Dhcpd_conf") 
          || return "4031 Could not read DHCP server configuration: $!";
	open(DHCPnew,"> $Lockdir/dhcpd.conf") 
	  || return "4032 Could not update DHCP server configuration: $!";
	while(<DHCPcnf>)
	{
		print DHCPnew unless (/^host /o ... /^}\s*$/o);
	}
	close(DHCPcnf);

	my($mac);
	foreach $mac (keys %max)
	{
	  print STDERR "Adding $mac and ", $max{$mac}, "\n" if ($Debug);
	  # Check our arguments
	  if ($mac !~ /^(([0-9A-Fa-f]{1,2}):){5}[0-9A-Fa-f]{2}$/o) {
	    unlink("$Lockdir/dhcpd.conf");
	    return "4033 Invalid mac address $mac";
	  }
	  if (!Cobalt::Netutil::netutil_test_ipaddr($max{$mac}) && ($max{$mac} !~ /[a-z]/io)) {
	    unlink("$Lockdir/dhcpd.conf");
	    return "4034 Invalid IP address $max{$mac}";
	  }

	  my $hname; # Must respect both IP and name arguments
	  if ($max{$mac} =~ /[a-z]/io)
	  {
	    $hname = $max{$mac};
	  } else # Try to resolve the name of this host
	  {
	    $hname = gethostbyaddr(pack('C4',split('\.',$max{$mac})),2);
	    $hname = $max{$mac} unless ($hname);  # default to IP address
	  }
	  
	  print DHCPnew <<EOF if ($max{$mac} && $mac);
host $hname {
  hardware ethernet $mac;
  fixed-address $max{$mac};
}

EOF
	}

	close(DHCPnew);

	rename("$Lockdir/dhcpd.conf","$Dhcpd_conf") 
            || return "4035 Could not update DHCP server configuration: $!";
	
	Cobalt::Dhcpd::dhcpd_hup(); # Kick it
	return "2015 DHCP server updated successfully";
}


1;
