# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Dhcpd.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Dhcpd_conf = "/etc/dhcpd.conf";
my $Lockdir = "/etc/locks";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Dhcpd.pm.  Changes made here will be lost.
package Cobalt::Dhcpd;

sub dhcpd_set_name
# Set the server identifier for the DHCP server
# Arguments: hostname
# Side effects: modifies dhcpd.conf, restarts dhcpd
# Return value: status string like "2867 The pizza attacks!"
{
  my ($name) = @_;
  sleep 2 if (-e "$Lockdir/dhcpd.conf"); # Avoid race
  return "4045 DHCP server configuration files in use" if (-e "$Lockdir/dhcpd.conf");
  open(DHCPcnf,$Dhcpd_conf) 
    || return "4046 Could not read DHCP server configuration: $!";
  open(DHCPnew,"> $Lockdir/dhcpd.conf") 
    || return "4047 Could not update DHCP server configuration: $!";
  while (<DHCPcnf>) {
    if (/^server-identifier /o) {
      print DHCPnew "server-identifier $name;\n";
    } else {
      print DHCPnew;
    }
  }
  close DHCPcnf;
  close DHCPnew;
  rename("$Lockdir/dhcpd.conf","$Dhcpd_conf")
    || return "4048 Could not update DHCP server configuration: $!";
  Cobalt::Dhcpd::dhcpd_hup();
  return "2017 DHCP server updated successfully";
}


1;
