# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Email.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Sendmail_cw = "/etc/sendmail.cw";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Email.pm.  Changes made here will be lost.
package Cobalt::Email;

sub mail_add_cw 
# Adds alias(s) to sendmail.cw, unless it's already defined
# Arguments: an array of host/domain names
# Return value: a string like "2000 I can't believe it's not butter"
# Example: &good_stuff if (Sendmail_cw_add('mail.com','me.mail.com'));
# Note: Does NOT restart sendmail
{
    my @additions=@_;
    my @aliases=Cobalt::Email::mail_list_cw();

    # build hash
    my $alias;
    my %aliasesHash;
    foreach $alias ( @aliases ) { $aliasesHash{ $alias }=1; }
    foreach $alias ( @additions ) {
	if( !Cobalt::Netutil::netutil_test_domainname( $alias ) ) {
	    my $name=$alias;
	    return "4124 invalid hostname $name";
	}

	$aliasesHash{ $alias }=1;
    }

    Cobalt::Email::lock_sendmail(1) || return "4125 Email alias list in use, please try again soon";

    # read in user additions
    my $userArea;
    my $userAdditions;
    open( SND, "<$Sendmail_cw" ) || 
      return "4126 Cannot open my sendmail.cw file: $!";
    while( <SND> ) {
	if( /include all aliases for your machine here/ ) { $userArea=1; }
	if( $userArea ) { $userAdditions.=$_; }
    }
    close( SND );

    open( SND, ">$Sendmail_cw" ) || 
      return "4127 Cannot open my sendmail.cw file: $!";
    foreach $alias ( keys %aliasesHash ) { print SND "$alias\n"; }
    print SND "\n$userAdditions";
    close( SND );

    Cobalt::Email::lock_sendmail(0);

    Cobalt::Email::mail_sendmail_hup();

    return "2036 Email server alias added successfully";
}


1;
