# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Email.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $EmailVirtUser = "/etc/virtusertable";
my $Lockdir = "/etc/locks";
my $MakeMap_cmd = "/usr/bin/makemap";
my $Sauce_log = "/var/cobalt/sauce.log";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Email.pm.  Changes made here will be lost.
package Cobalt::Email;

sub mail_build_virtusertable
# Build the virtusertable database based on the entries in the
# virtusertable file 
# Arguments: 
#       1. a set of aliases to put in the table, in the form
#          of a reference to a hash table, $aliasname => aliasto
#       2. a set of domains and their fqdn routes to put in the
#          table, in the form of a reference to a hash table, $domain => fqdnroute
# Rewrites the virtusertable with whatever aliases it is given as an
#   argument, plus whatever it finds below the "custom additions below"
#   lines at the bottom.
# Return value: 0 on failure, 1 on success
# Side effects: little green men on acid
{
	my($aliases,$routes) = @_;
	my($table_data,$key,$val,$end);
	my($lockfile) = "$Lockdir/virtusertable";

                                                # do the aliases
	while (($key,$val) = each %$aliases) {
	    $table_data .= "$key\t$val\n";
	}

	$table_data .= "\n# accept-email-at-domain routes\n";

	                                        # do the routes
	while (($key,$val) = each %$routes) {
	    $table_data .= "\@".$key."\t\%1\@".$val."\n";
	}

	sleep 2 if (-e $lockfile );             # make an attempt to wait for it
        return 0 if ( -e $lockfile );           # give up

        open( DBWRITE, "> $lockfile" )
	    || return 0;
        open( DBREAD, "$EmailVirtUser" )
	    || return 0;

	print DBWRITE "# This file is automatically generated\n";
	print DBWRITE "# Please put custom changes at the end\n";
	print DBWRITE "# Cobalt Networks 1998\n\n";
	print DBWRITE "$table_data\n";

	                                        # handle custom lines
        while (<DBREAD>) {
	    unless($end) {
		if (/^# Put custom additions below/o) {
		    print DBWRITE;
		    $end = 1;
		}
	    } else {
		print DBWRITE;
	    }
	}
        close DBWRITE;
        close DBREAD;

	                                        # we can't write to this file...eek!
	unless (-w $EmailVirtUser) {
	  unlink("$lockfile");
	  return 0;
	}
	    
	                                        # build the database, save the text
	system("$MakeMap_cmd hash $EmailVirtUser.db < $lockfile >>$Sauce_log 2>&1")
	    && return 0;
	rename("$lockfile","$EmailVirtUser") 
	    || return 0;

	                                        # if we've come this far...
	return 1;
}


1;
