# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Email.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Sendmail_cw = "/etc/sendmail.cw";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Email.pm.  Changes made here will be lost.
package Cobalt::Email;

sub mail_del_cw 
# Removes alias(s) from sendmail.cw
# Arguments: an array of host/domain names
# Return value: a string like "4000 I smell smoke"
# Example: &good_stuff if (Sendmail_cw_del('nomore.mail.com','less.mail.isp'));
# Note: Does NOT restart sendmail
{
    my @subtractions=@_;

    # build hash
    my %aliasesHash;
    my $alias;
    my @aliases=Cobalt::Email::mail_list_cw();
    foreach $alias ( @aliases ) { $aliasesHash{ $alias }=1; }
    foreach $alias ( @subtractions ) { delete $aliasesHash{ $alias }; }

    foreach $alias ( keys %aliasesHash ) {
	if( !Cobalt::Netutil::netutil_test_domainname( $alias ) ) {
	    my $name=$alias;
	    return "4128 invalid hostname $name";
	}
    }

    Cobalt::Email::lock_sendmail(1) || return "4129 Email alias list in use, please try again soon";

    my $userArea=0;
    my $userAdditions;
    open( SND, "<$Sendmail_cw" ) || 
      return "4130 Cannot open my sendmail.cw file: $!";
    while( <SND> ) {
	if( /include all aliases for your machine here/ ) { $userArea=1; }
	if( $userArea ) { $userAdditions.= $_; }
    }
    close( SND );

    open( SND, ">$Sendmail_cw" ) || 
      return "4131 Cannot write my sendmail.cw file: $!";
    foreach $alias ( keys %aliasesHash ) { print SND "$alias\n"; }
    print SND "\n$userAdditions";
    close( SND );

    Cobalt::Email::lock_sendmail(0);

    Cobalt::Email::mail_sendmail_hup();

    return "2037 Email server alias removed successfully";	
}


1;
