# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Email.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Lockdir = "/etc/locks";
my $Sendmail_conf = "/etc/sendmail.cf";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Email.pm.  Changes made here will be lost.
package Cobalt::Email;

sub mail_set_AutoAlias
# Enables/Disables AutoRebuildAliases in /etc/sendmail.cf
# Arguments: 1 to enable, 0 to disable
# Return value: string like "2000 I am starting an ISP and.."
# Site effects: edits /etc/sendmail.cf
{
	my($auto_rebuild) = $_[0];
	return "4081 sendmail configuration is locked" if (-e "$Lockdir/sendmail.cf");
	open(TMPCF,"> $Lockdir/sendmail.cf") || return "4082 Can not open sendmail configuration file";
	open(SNDCF,"$Sendmail_conf")
	  || return "4083 Cannot read mail server config file: $!";
	while(<SNDCF>) 
	{
		if(/AutoRebuildAliases/)
		{
			print TMPCF "O AutoRebuildAliases\n" if($auto_rebuild);
			print TMPCF "#O AutoRebuildAliases\n" unless($auto_rebuild);
		} else {
			print TMPCF;
		}
	}
	close(SNDCF);
	close(TMPCF);

	rename("$Lockdir/sendmail.cf","$Sendmail_conf") || return "4084 Could not write sendmail configuration";

	return "2024 AutoRebuildAliases set successfully" if ($auto_rebuild);
	return "2025 AutoRebuildAliases disabled successfully" unless ($auto_rebuild);
}


1;
