# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Email.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Lockdir = "/etc/locks";
my $MailAccessDB = "/etc/mail/access";
my $MakeMap_cmd = "/usr/bin/makemap";
my $Sauce_log = "/var/cobalt/sauce.log";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Email.pm.  Changes made here will be lost.
package Cobalt::Email;

sub mail_set_deny
# Set the list of domains we refuse to accept mail from
# Arguments: list of domain or host names
# Side effects: modifies /etc/mail/deny and rebuilds deny.db
# Example: Cobalt::Email::mail_set_deny("cybersell.com","owlsnest.com");
{
        my (@denys) = @_;
	my ($notend) = 1;
	my ($i);

	# check for existing lockfile, bail if one found
        return "4137 Cannot lock relay access database: $!" if ( -e "$Lockdir/access" );

	# open the lockfile for writing, the real file for reading
	open (DBREAD, "$MailAccessDB")
	  || return "4176 Cannot read relay access database: $!";
        open (DBWRITE, "> $Lockdir/access")
          || return "4177 Cannot write relay access database: $!";

	while (<DBREAD>)
	{
		if ($notend)
		{
			if (/Mail rejected due to possible SPAM/o)
			{
			        # clear out all existing denies
				next;
			}
			elsif (/^# Put custom additions below/o)
			{
				foreach $i (@denys)
				{
					print DBWRITE "$i\t550 Mail rejected due to possible SPAM\n";
				}
				print DBWRITE "# Put custom additions below (Do not change/remove this line).\n";
				$notend = 0;
			}
			else
			{
				print DBWRITE;
			}
		}
		else
		{
			print DBWRITE;
		}
	}

	close (DBREAD);
	close (DBWRITE);

	unless (-w $MailAccessDB) {
	  unlink("$Lockdir/access");
	  return "4178 Cannot write relay access database: $!";
	}

        print STDERR "$MakeMap_cmd hash $MailAccessDB < $Lockdir/access" if ($Debug);
        system("$MakeMap_cmd hash $MailAccessDB < $Lockdir/access >>$Sauce_log 2>&1")
          && return "4179 Cannot build virtual alias database: $!";

        rename("$Lockdir/access","$MailAccessDB") || return "4182 Cannot unlock relay access database: $!";

        Cobalt::Email::mail_sendmail_hup();

	return "2041 Set mail site blocking";
}


1;
