# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Email.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Lockdir = "/etc/locks";
my $Sendmail_conf = "/etc/sendmail.cf";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Email.pm.  Changes made here will be lost.
package Cobalt::Email;

sub mail_set_max_document
# Sets the maximum document size in bytes that sendmail will accept
# Arguments: natural byte value, 0 for unlimited
# Return value: string like "2000 It does taste like butter"
# Site effects: edits /etc/sendmail.cf
{
        # local variables should be lowercased for consistency (and for
        # the preprocessor, unfortunately...)
	my($max_doc_size) = $_[0];
	return "4085 Invalid maximum document size" if ($max_doc_size < 0);
	return "4086 sendmail is not configured" unless (-e "$Sendmail_conf");
	return "4087 sendmail configuration is locked" if (-e "$Lockdir/sendmail.cf");
	open(TMPCF,"> $Lockdir/sendmail.cf") || return "4088 Can not open sendmail configuration file";
	open(SNDCF,"$Sendmail_conf")
	  || return "4089 Cannot read mail server config file: $!";
	while(<SNDCF>) 
	{
		if(/MaxMessageSize/o)
		{
			print TMPCF "O MaxMessageSize=$max_doc_size\n" if($max_doc_size);
			print TMPCF "#O MaxMessageSize=1000000\n" if(!$max_doc_size);
		} else {
			print TMPCF;
		}
	}
	close(SNDCF);
	close(TMPCF);

	rename("$Lockdir/sendmail.cf","$Sendmail_conf") || return "4090 Could not write sendmail configuration";

	Cobalt::Email::mail_sendmail_hup();

	return "2026 New maximum document size set";
}


1;
