# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Email.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Lockdir = "/etc/locks";
my $Sendmail_conf = "/etc/sendmail.cf";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Email.pm.  Changes made here will be lost.
package Cobalt::Email;

sub mail_set_privacy
# Enables/Disables both expn and vrfy smtp commands in /etc/sendmail.cf
# Arguments: 1 to enable, 0 to disable
# Return value: string like "4000 No.  Not now.  Not ever."
# Site effects: edits /etc/sendmail.cf
{
	my($privacies) = $_[0];
	return "4077 sendmail configuration is locked" if (-e "$Lockdir/sendmail.cf");
	open(TMPCF,"> $Lockdir/sendmail.cf") || return "4078 Can not open sendmail configuration file";
	open(SNDCF,"$Sendmail_conf")
	  || return "4079 Cannot read mail server config file: $!";
	while(<SNDCF>) 
	{
		if(/O PrivacyOptions=/o)
		{
			print TMPCF "O PrivacyOptions=authwarnings,noexpn,novrfy\n" if($privacies);
			print TMPCF "O PrivacyOptions=authwarnings\n" unless($privacies);
		} else {
			print TMPCF;
		}
	}
	close(SNDCF);
	close(TMPCF);

	rename("$Lockdir/sendmail.cf","$Sendmail_conf") || return "4080 Could not write sendmail configuration";

	return "2022 Email privacy set successfully" if ($privacies);
	return "2023 Email privacy disabled successfully" unless ($privacies);
}


1;
