# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Email.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Email.pm.  Changes made here will be lost.
package Cobalt::Email;

sub mail_virtuser_add_route
# Adds a hash of "domain" and "fqdn to route to"
# Arguments: hash  (domain => fqdn to route to)
# Return value: string like "2000 Itchy and scratchy"
# Side effects: Rebuilds /etc/virtusertable.db from modified /etc/virtusertable
{
	my(%add_route) = @_;
	
	my(%aliases) = Cobalt::Email::mail_virtuser_list_alias();
	my(%routes) = Cobalt::Email::mail_virtuser_list_route();

	my($r);
	foreach $r (keys %add_route)
	{
	    if( $routes{ $r } ) {
		return "4096 Another site is already accepting email for the domain $r";
	    }
	    $routes{"$r"} = $add_route{"$r"}; # No duplicate aliases allowed
	}
	
	Cobalt::Email::mail_build_virtusertable(\%aliases, \%routes)
	    || return "4097 Could not modify email alias list";

	return "2030 Email virtual users added successfully";
}


1;
