# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Email.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $EmailVirtUser = "/etc/virtusertable";
my $Lockdir = "/etc/locks";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Email.pm.  Changes made here will be lost.
package Cobalt::Email;

sub mail_virtuser_list_alias
# Returns a hash of fully qualified email addresses or @domains and target user names or error messages
# Arguments: none
# Return value: an alias hash (alias => user)
# Example: my(%aliases) = Cobalt::Email::mail_virtuser_list_alias();
{
	my(%aliases); 

	sleep 2 if (-e "$Lockdir/virtusertable");
	
	return "4099 Email alias list in use, please try again soon" 
	  if (-e "$Lockdir/virtusertable");
	
	open(VRT,"$EmailVirtUser") || return ''; # Null return if no flat file
	while(<VRT>) 
	{
            if( /custom additions below/o ) { last; }
	    chop;
	    next if (/^\s*\#/o);
	    next if (/^\s*\@\S+\s+\%1\@\S+/o); # skip accept-email-at-domain routes
	    $aliases{"$1"} = $2 if (/^\s*(\S+)\s*(.*)$/o); 
	}
	close (VRT);

	return(%aliases);
}


1;
