# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Email.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Lockdir = "/etc/locks";
my $Sendmail_conf = "/etc/sendmail.cf";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Email.pm.  Changes made here will be lost.
package Cobalt::Email;

sub sendmail_set_delivery_mode
# sets the delivery mode of sendmail
#
# Arguments: $mode = (i)nteractive, (b)background, (q)ueue 
{
  my($mode) = shift;
  
  my %delivery_modes = (
			'i' => 'interactive',
			'interactive' => 'interactive',
			'b' => 'background',
			'background' => 'background',
			'q' => 'queue',
			'queue' => 'queue'
		       );
  
  return "4184 Invalid delivery mode: $mode" if ( ! $delivery_modes{$mode});
  
  return "4185 sendmail configuration is locked" if (-e "$Lockdir/sendmail.cf");
  open(TMPCF,"> $Lockdir/sendmail.cf") || return "4186 Can not open sendmail configuration file";
  open(SNDCF,"$Sendmail_conf")
    || return "4187 Cannot read mail server config file: $!";
  while(<SNDCF>) 
    {
      if(/O DeliveryMode=/o)
	{
	  print TMPCF "O DeliveryMode=$delivery_modes{$mode}\n";
	} else {
	  print TMPCF;
	}
    }
  close(SNDCF);
  close(TMPCF);
  
  rename("$Lockdir/sendmail.cf","$Sendmail_conf") || return "4188 Could not write sendmail configuration";
  
  return "2042 Sendmail DeliveryMode set successfully";
}


1;
