# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Email.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Cron_basedir = "/etc/cron.";
my $Sendmail_flush_script = "/usr/local/sbin/flush_sendmail_queue";
my @Cron_Intervals = ("quarter-hourly","half-hourly","hourly","quarter-daily","daily","weekly","monthly");
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Email.pm.  Changes made here will be lost.
package Cobalt::Email;

sub sendmail_set_queue_interval
# sets the sendmail queue flushing interval by setting a symbolic link
# from the correct /etc/cron.* directory to the flush_sendmail_queue script.
# we flush the sendmail queue this way rather than letting sendmail do it
# to synchronize the flushing with the fetchmail retrieval
# args: $interval = fetchmail interval
{
  my ($interval) = shift;
  my $crondir;

  my $found = 0;
  
  # if $interval is 'never' set $found = 1
  # this causes any existing interval to be removed
  $found = 1 if ($interval eq 'never');

  foreach $crondir (@Cron_Intervals) {
    # sanity check to make sure not more than one symlink exists
    if (-e "$Cron_basedir$crondir/flush_sendmail_queue") {
      unlink("$Cron_basedir$crondir/flush_sendmail_queue");
    }
    if ($interval eq $crondir) {
      symlink($Sendmail_flush_script, "$Cron_basedir$crondir/flush_sendmail_queue");
      $found = 1;
    }
  }

  if ($found) {
    return "2043 Sendmail flush queue set successfully";
  } else {
    return "4189 Sauce doesn't support requested flush interval";
  }
}


1;
