# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Expert.pm

# Copyright 1998 Cobalt Microserver (http://www.cobaltmicro.com)

use strict;
### START HARDCODED PATHS
my $Console = "/dev/console";
my $Htconf = "/etc/httpd/conf";
my $If_cfg_dir = "/etc/sysconfig/network-scripts";
my $Ifdown = "/etc/sysconfig/network-scripts/ifdown";
my $Lockdir = "/etc/locks";
my $Logrotate_dir = "/etc/logrotate.d";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = $Debug;
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Expert.pm.  Changes made here will be lost.
package Cobalt::Expert;

sub vhost_del
# Remove a virtual interface
# Arguments: an interface name
# Side effects: removes the ifcfg-eth0:xx file, the /etc/logrotate.d file,
#   cleans httpd.conf
{
    my ($netif) = @_;
    unless (open(IFCFG,"$If_cfg_dir/ifcfg-$netif"))
    {
	return "4154 Cannot read $If_cfg_dir/ifcfg-$virtif: $!";
    }
    my $addr;
    while (<IFCFG>)
    {
	if (/^IPADDR=(.+)/o)
	{
	    $addr = $1;
	    last;
	}
    }
    close IFCFG;
    return "4150 Cannot remove interface: ifcfg-$virtif is locked"
	if (-e "$Lockdir/ifcfg-$netif");
    open(O,">$Lockdir/ifcfg-$netif")
	|| return "4151 Cannot lock interface config ifcfg-$virtif: $!";
    close O;
    if (-e "$Lockdir/httpd.conf")
    {
	unlink("$Lockdir/ifcfg-$netif");
	return "4149 $Htconf/httpd.conf is locked";
    }
    unless (open(HTCTMP,">$Lockdir/httpd.conf"))
    {
	unlink("$Lockdir/ifcfg-$netif");
	return "4152 Cannot write $Lockdir/httpd.conf: $!";
    }
    unless (open(HTCONF,"$Htconf/httpd.conf"))
    {
	unlink("$Lockdir/ifcfg-$netif");
	unlink("$Lockdir/httpd.conf");
	return "4153 Cannot read $Htconf/httpd.conf: $!";
    }
    while (<HTCONF>)
    {
	if (/^Listen $addr/o)
	{
	    next;
	}
	elsif (/^<VirtualHost $addr>/o)
	{
	    while (<HTCONF>)
	    {
		last if (/^<\/VirtualHost>/o);
	    }
	}
	else
	{
	    print HTCTMP;
	}
    }
    close HTCONF;
    close HTCTMP;
    unless (rename("$Lockdir/httpd.conf","$Htconf/httpd.conf"))
    {
	unlink("$Lockdir/ifcfg-$netif");
	unlink("$Lockdir/httpd.conf");
	return "3149 Cannot update $Htconf/httpd.conf: $!";
    }

    unlink(">$Logrotate_dir/$addr-apache");
    system("$Ifdown $netif >$Console 2>&1");
    unlink("$If_cfg_dir/ifcfg-$netif");
    unlink("$Lockdir/ifcfg-$netif");
    return "2142 Virtual interface deleted successfully";
}

use Cobalt::Language;

1;
