# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Expert.pm

# Copyright 1998 Cobalt Microserver (http://www.cobaltmicro.com)

use strict;
### START HARDCODED PATHS
my $Debug = "0";
my $Htconf = "/etc/httpd/conf";
my $Htgroup_dir = "/home/sites";
my $If_cfg_dir = "/etc/sysconfig/network-scripts";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = $Debug;
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Expert.pm.  Changes made here will be lost.
package Cobalt::Expert;

sub vhost_get
# Get the information about a virtual interface
# Arguments: Interface name (eth0:4 or whatever)
# Return value: IP address, netmask, fully qualified host name, group
# Side effects: reads the ifcfg-NAME and httpd.conf files
# Example: ($addr,$mask,$host,$group) = vhost_get("eth0:0");
{
    my ($netif) = @_;
    my ($addr,$mask,$host,$group);

    print STDERR "Getting information about interface $netif\n" if ($Debug);
    open(IFCFG,"$If_cfg_dir/ifcfg-$netif")
	|| return "4146 Cannot read interface config ifcfg-$virtif: $!";
    while (<IFCFG>)
    {
	if (/^IPADDR=(.+)/o)
	{
	    $addr = $1;
	}
	elsif (/^NETMASK=(.+)/o)
	{
	    $mask = $1;
	}
    }
    close IFCFG;

    my $inentry = 0;
    open(HTCONF,"$Htconf/httpd.conf") 
	|| return "4147 Cannot read $Htconf/httpd.conf: $!";
    while (<HTCONF>)
    {
	if (/^<VirtualHost $addr>/)
	{
	    $inentry = 1;
	    print STDERR "Found entry for $addr\n" if ($Debug);
	}
	elsif (($inentry) && (/^ServerName (.+)/o))
	{
	    $host = $1;
	    print STDERR "Found host entry for $addr: $host\n" if ($Debug);
	}
	elsif (($inentry) && (/^DocumentRoot $Htgroup_dir\/(.+)/o))
	{
	    $group = $1;
	    close HTCONF;
	    last;
	}
	elsif (/^<\/VirtualHost/o)
	{
	    $inentry = 0;  # end of entry
	}
    }
    return ($addr,$mask,$host,$group);
}

use Cobalt::Language;

1;
