# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Expert.pm

# Copyright 1998 Cobalt Microserver (http://www.cobaltmicro.com)

use strict;
### START HARDCODED PATHS
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = $Debug;
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Expert.pm.  Changes made here will be lost.
package Cobalt::Expert;

sub vhost_get_byaddr
# Get information about a virtual interface based on the IP address
# Arguments: IP address
# Return value: interface, netmask, hostname, group
#   Returns 0 if we don't serve this (or if it isn't a virtual interface)
# Example: ($netif,$mask,$host,$group) = vhost_get_byaddr("192.168.41.5");
{
    my ($addr) = @_;
    my @netifs = vhost_list();
    my $netif;
    foreach $netif (@netifs)
    {
	my ($ipaddr,$mask,$host,$group) = vhost_get($netif);
	if ($ipaddr eq $addr)
	{
	    return($netif,$mask,$host,$group);
	}
    }
    return 0;
}

use Cobalt::Language;

1;
