# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Fetchmail.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Fetchmail.pm.  Changes made here will be lost.
package Cobalt::Fetchmail;

# writes the fetchmailrc file for multidrop to a specified filename
# Arguments:
#    $filename:  filename
#    $server:    remote e-mail server hostname
#    $username:  username on remote e-mail server
#    $passwd:    password to log into the remote server
#    $etrn:      use sendmail etrn mode instead of POP3 or IMAP4
sub _write_domain_rc
{
  my ($filename, $server, $username, $passwd, $etrn) = @_;

  # set umask so file is created with only user read/write
  umask(0177);

  # there might be a " in the password
  $passwd =~ s/\"/\\\"/g;

  open(FMRC, ">$filename")
    or return "4191 Cannot write fetchmailrc: $!";
  print FMRC "# last modifed " . localtime() . "\n";
  print FMRC "poll \"$server\"\n";
  print FMRC "localdomains " . (Cobalt::Network::net_get_dnsclient())[0] . "\n";
  if ($etrn) { print FMRC "proto ETRN\n"; }
  print FMRC "username \"$username\"\n";
  print FMRC "password \"$passwd\"\n";
  print FMRC "to *\n";
  close(FMRC);
}


1;
