# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Fetchmail.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Cron_basedir = "/etc/cron.";
my $Fetchmail_script = "/usr/local/sbin/fetch_remote_mail";
my @Cron_Intervals = ("quarter-hourly","half-hourly","hourly","quarter-daily","daily","weekly","monthly");
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Fetchmail.pm.  Changes made here will be lost.
package Cobalt::Fetchmail;

sub fm_set_interval
# sets the fetchmail frequency by setting a symbolic link from the correct
# /etc/cron.* directory to the fetch_remote_mail script.
# args: $interval = fetchmail interval
{
  my ($interval) = shift;
  my $crondir;

  my $found = 0;
  
  # if $interval is 'never' set $found = 1
  # this causes any existing interval to be removed
  $found = 1 if ($interval eq 'never');

  foreach $crondir (@Cron_Intervals) {
    # sanity check to make sure not more than one symlink exists
    if (-e "$Cron_basedir$crondir/fetch_remote_mail") {
      unlink("$Cron_basedir$crondir/fetch_remote_mail");
    }
    if ($interval eq $crondir) {
      symlink($Fetchmail_script, "$Cron_basedir$crondir/fetch_remote_mail");
      $found = 1;
    }
  }

  if (! $found) {
    return "4666: unsupported fetchmail interval";
  }
}


1;
