# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Fileman.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Fileman.pm.  Changes made here will be lost.
package Cobalt::Fileman;

sub careful_cp
# Copy a file.  Only handles plain files and symlinks
# Arguments: source file, destination file
# Side effects: makes the destination file a duplicate of the source
#   file, and sets the mode, ownership, and timestamp to be the same.
{
    my ($from,$to) = @_;
    my ($offset,$buf,$blksize,$len,$written,$atime,$mtime,$uid,$gid,$mode);
    if (-l $from)
    {
	# it's a symlink
	my $linksrc = readlink($from);
	unless (symlink($linksrc,$to))
	{
	    # Can't link, try to copy
	    Cobalt::Fileman::careful_cp($linksrc,$to);  # The OS will save us from loops
	}
    }
    elsif (! -f $from)
    {
	return;
    }
    else
    {
	# it's a file
	open(FROM,$from) || return "4315 Cannot read source file $from: $!";
	open(TO,">$to") 
	    || return "4316 Cannot write target file $to: $!";
	# this block of code is ripped right out of the perl book
	$blksize = (stat FROM)[11] || 16384;
	$buf = "";
	while ($len = sysread FROM, $buf, $blksize)
	{
	    if (! defined $len)
	    {
		next if ($! =~ /^Interrupted/o);
		return "4317 System read error reading $from: $!";
	    }
	    $offset = 0;
	    while ($len)  # handle partial writes
	    {
		$written = syswrite TO, $buf, $len, $offset;
		return "4318 System write error writing $to: $!"
		    unless (defined $written);
		$len -= $written;
		$offset += $written;
	    }
	}
	# end rip
	close FROM;
	close TO;

	# fix timestamp and perms
	($atime,$mtime,$mode,$uid,$gid) = (stat($from))[8,9,2,4,5];
	utime($atime,$mtime,$to);
	chmod($mode,$to);
	chown($uid,$gid,$to);
    }
}


1;
