# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Fileman.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Fileman.pm.  Changes made here will be lost.
package Cobalt::Fileman;

sub file_copy
# Copy a file, after checking that the user has rights to read the source
# and write the dest
# Arguments: source, dest, user name
# Side effects: copies the file
# Example: Cobalt::Fileman::file_copy("/home/httpd/html/users/lola/oldfile",
#                    "/home/httpd/html/users/lola/newfile","lola");
{
    my ($src,$dest,$username) = @_;

    # Check that I'm cool to touch these files
    return "4306 $username is not allowed to read $src" 
	unless (Cobalt::Fileman::file_rights($username,$src));
    if (-e $dest)
    {
	return "4307 $username is not allowed to overwrite $dest" 
	    unless (Cobalt::Fileman::file_rights($username,$dest) == 1);
    }
    else
    {
	# new file, check the directory
	$dest =~ /^(.+)\/[^\/]+/o;  # find the parent
	return "4308 $username is not allowed to write in $1" 
	    unless (Cobalt::Fileman::file_rights($username,$1) == 1);
    }

    if (-d $src)
    {
	Cobalt::Fileman::file_copydir($src,$dest);
    }
    elsif (-f $src)
    {
	Cobalt::Fileman::careful_cp($src,$dest);
    }
    return "2045 File copied successfully";
}


1;
