# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Fileman.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Fileman.pm.  Changes made here will be lost.
package Cobalt::Fileman;

#################################


sub file_copydir
# Copies files from the source to the destination.  If the files
# are the same, don't copy.
# Arguments: a source directory and a destination directory
# Side effects: copies any files which appear to have changed
#   or which don't exist in the destination area.  Does not delete
#   anything.
{
    my ($src,$dst) = @_;
    my ($file,$atime,$mtime,$uid,$gid,$mode);
    unless (-d $src)
    {
	return;
    }
    mkdir($dst,(stat($src))[2])	unless (-d $dst);
    unless (opendir(DIR,$src))
    {
	return;
    }
    my @files = sort(grep(!/^\.\.?$/o,readdir(DIR)));
    closedir DIR;
    foreach $file (@files)
    {
	if ((-d "$src/$file") && (! -l "$src/$file"))
	{
	    # recurse
	    Cobalt::Fileman::file_copydir("$src/$file","$dst/$file");
	    ($atime,$mtime,$mode,$uid,$gid) = (stat("$src/$file"))[8,9,2,4,5];
	    utime($atime,$mtime,"$dst/$file");
	    chmod($mode,"$dst/$file");
	    chown($uid,$gid,"$dst/$file");
	}
	elsif ((! -f "$src/$file") && (! -l "$src/$file"))
	{
	    next;
	}
	else
	{
	    # replace with a fresh copy
	    unlink ("$dst/$file") if (-e "$src/$file");
	    Cobalt::Fileman::careful_cp("$src/$file","$dst/$file");
	}
    }    
}


1;
