# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Fileman.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Htgroup_dir = "/home/sites";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Fileman.pm.  Changes made here will be lost.
package Cobalt::Fileman;

sub file_mkdir
# Make a directory, after checking that the user is allowed to do so
# Arguments: new directory name, name of user making the directory
# Side effects: creates the directory and any parents
# Example: Cobalt::Fileman::file_mkdir("/home/httpd/html/users/joe/new_folder","joe");
{
    my ($dir,$username) = @_;
    $dir =~ /^(.+)\/[^\/]+/o;  # find the parent
    my $parent = $1;

    return "4195 $dir already exists" if (-e $dir);
    # Check that I'm cool to touch this directory
    return "4196 $username is not allowed to write to $parent" 
	unless (Cobalt::Fileman::file_rights($username,$parent) == 1);

    Cobalt::Fileman::file_mkdir($parent,$username) unless (-e $parent);
    my ($uid,$gid) = (stat(_))[4,5];
    if ($dir =~ /^$Htgroup_dir/o)
    {
	# it's in the group area
	mkdir($dir,02575)
	    || return "4197 Cannot create group subdirectory $dir: $!";
	chown($uid,$gid,$dir)
	    || return "4198 Cannot set uid/gid for directory $dir: $!";
	chmod(02575,$dir)
	    || return "4199 Cannot set mode for directory $dir: $!";
    }
    else
    {
	mkdir($dir,0755)
	    || return "4233 Cannot create directory $dir: $!";
	chown($uid,$gid,$dir)
	    || return "4300 Cannot set uid/gid for directory $dir: $!";
	chmod(0755,$dir)
	    || return "4305 Cannot set mode for directory $dir: $!";
    }
    return "2044 Directory created successfully";
}


1;
