# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Fileman.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Fileman.pm.  Changes made here will be lost.
package Cobalt::Fileman;

sub file_move
# Move or rename a file
# First verifies that the user has permission to do so
# Arguments: source, dest, username
# Side effects: moves or copies the file
# Example: Cobalt::Fileman::file_move("/home/httpd/html/users/lola/oldfile",
#                    "/home/httpd/html/users/lola/newfile","lola");
{
    my ($src,$dest,$username) = @_;

    return "4309 $username is not allowed to move $src" 
	unless (Cobalt::Fileman::file_rights($username,$src) == 1);
    if (-e $dest)
    {
	return "4310 $username is not allowed to overwrite $dest" 
	    unless (Cobalt::Fileman::file_rights($username,$dest) == 1);
    }
    else
    {
	# new file, check the directory
	$dest =~ /^(.+)\/[^\/]+/o;  # find the parent
	return "4311 $username is not allowed to write in $1" 
	    unless (Cobalt::Fileman::file_rights($username,$1) == 1);
    }

    if (-d $src)
    {
	Cobalt::Fileman::file_copydir($src,$dest);
	Cobalt::Utility::sauce_deltree($src);
    }
    elsif ( (stat($src))[0] == (stat($dest))[0] )
    {
	# On the same devince
	rename($src,$dest);
    }
    else
    {
	# crossing a filesystem
	Cobalt::Fileman::careful_cp($src,$dest);
	unlink($src);
    }
    return "2046 File moved successfully";
}


1;
