# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Fpx.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Fpx_admsrvexe = "/usr/local/frontpage/currentversion/bin/fpsrvadm.exe";
my $Fpx_cnfdir = "/usr/local/frontpage";
my %Features = ("networker","1","telnetConfig","1","dhcpd","0","shiftjis","Cobalt interface message for shiftjis (We should never see this)","pagebuilder","0","www","1","mx","1","gated","1","dns","1","nfs","0","securetty","1","english","1","atalk","0","fpx","1","siteAdminRedirect","1","users","1","ntp","0","mon_textdb_only","0","search","0","anonFTP","1","specialHomeSkel","0","viewGroups","0","cobaltHomePage","0","lastNameFirst","1","warnRootOnly","1","vsites","1","pam","1","discuss","0","docorg","0","groups","1","smb","0","mail","1","nat","0","squid","0","autoGenWebUsage","0","japanese","0","cobaltRedirect","0","backups","1","vmachine","1","mon_port_testing","1","viewUsers","0","usersCGIInWizard","1","privatedirs","0","telnetDefault","1","ssl","0","siteManagement","1","adm","1","bind8","1","personalRedirect","1","webRequests","1","usersAddUser","0","adminRedirect","1","quotas","1","snmp","1","defaultUserNameGen","1","groupdirs","1","proftpd","1");
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Fpx.pm.  Changes made here will be lost.
package Cobalt::Fpx;

sub fpx_get_web
# Are FrontPage Server Extensions enabled?
# Returns 1 if FP web is present, 0 otherwise
# Arguments: user or site group name
# Side effects: none
{
  my($group)=@_;
  
  return 0 unless ($Features{'fpx'});
  return 0 unless (-x $Fpx_admsrvexe);

  # Test user vs group/site
  my($user);
  if(user_exist($group))  ### User web
  {
    $user=$group; # Clean variable names
    $group=''; 

    my($site)=vsite_getgroup($user);
    return 0 unless ($site);

    # Get fpx status from Apache conf, much faster than fpadmsrv.exe
    my(@fpxusers)=vsite_get_fpx($site);
    my($userinstance);
    foreach $userinstance (@fpxusers)
    {
      return 1 if ($userinstance eq $user);
    }
  } else
  {
    my($siteName)=(vsite_get_bygroup($group))[1];
    # If the site root web exists it's going to have a config
    return 1 if (-e "$Fpx_cnfdir/$siteName:80.cnf");
  }
  return 0; 
}


1;
