# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Fpx.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Htconf = "/etc/httpd/conf";
my $Htgroup_dir = "/home/sites";
my $Webdir = "web";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Fpx.pm.  Changes made here will be lost.
package Cobalt::Fpx;

sub fpx_hose_apacheconf
# Generates an alternate Apache-like configuration file
# that uses incorrect syntax.  This alternate configuration
# is what fpadmsrv.exe would like to see, and would not
# work AS an Apache configuration file.
#
# Arguments: none
# Return value: true for success, false for failure
# Side effects: Writes new configuration file
{
  my(@vsites)=vsite_list();
  open(HTMUNGE,"> $Htconf/fp98.httpd.conf") || return 0;
  open(HTCNF,"$Htconf/httpd.conf") || return 0;
  while(<HTCNF>)
  {
    unless(/^<VirtualHost/.../^<\/VirtualHost/)
    {
      print HTMUNGE;
    }
  }
  close(HTCNF);

  my($vsite_instance);
  foreach $vsite_instance (@vsites)
  {
    print HTMUNGE <<EOF;
<VirtualHost @$vsite_instance[1]>
ServerName @$vsite_instance[1]
ServerAdmin admin
DocumentRoot $Htgroup_dir/@$vsite_instance[2]/$Webdir
</VirtualHost>

EOF
  }

  close(HTMUNGE);

  # httpd must be able to read this on FP client hits
  chmod(0644,"$Htconf/fp98.httpd.conf");

  return 1;
}


1;
