# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Ftp.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Ftpd_conf = "/etc/proftpd.conf";
my $Htgroup_dir = "/home/sites";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Ftp.pm.  Changes made here will be lost.
package Cobalt::Ftp;

sub ftp_get_anonymous
# Returns 1 if anonymous ftp is enabled or 0 if it isn't,
#   maximum number of anonymous users, incoming quota (blocks)
# Arguments: site group name
# Return value: array: (boolean of whether anonymous FTP is on, maximum 
#   number of anonymous users, quota for the anonymous FTP user)
{
    my($group) = $_[0];

    my $on=0;
    my $maxUsers=0;
    if (-r "$Ftpd_conf")
    {
      open(FTPD,"$Ftpd_conf")
	|| return "4346 Cannot read FTP config file /etc/proftpd.conf: $!";
      while(<FTPD>)
      {
        if(/<Anonymous $Htgroup_dir\/$group\/ftp/) { $on=1; }
        if($on)
        {
	  if(/MaxClients\s+(\S+)/)
          {
            $maxUsers=$1;
            last;
	  }
	  if(/<\/Anonymous>/) { last; }
        }
      }
      close(FTPD);
    }

    my($ftpuser)=uc($group);
    return ($on,$maxUsers,(user_show($ftpuser))[2]);
}


1;
