# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Ftp.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Ftpd_conf = "/etc/proftpd.conf";
my $Htgroup_dir = "/home/sites";
my $MainGroup = "home";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Ftp.pm.  Changes made here will be lost.
package Cobalt::Ftp;

sub ftp_list_config
# Abstracts a list of supported IP addresses and associated anonymous ftp 
# sites.  
# Arguments: none
# Return value: hash of the form IP->site group anonymous ftp or 0
# Example %ftpstatus=ftp_list_config();
#         foreach $ip (keys %ftpstatus) { $anongroup=$ftpstatus{$ip}; }
{
    my($group,%ftp);
    my($ipaddr)=(Cobalt::Network::net_get_ipaddr())[0]; # Home site first
    $ftp{$ipaddr}=0;
    my($ip)=$ipaddr; # Init var

    if (-r "$Ftpd_conf")
    {
        open(FTPD,"$Ftpd_conf")
          || return "4347 Cannot read FTP config file /etc/proftpd.conf: $!";
        while(<FTPD>)
        {
	    if (/^<VirtualHost [\d\.]+>$/ ... /^<\/VirtualHost>$/)
	    {
		if (/^<VirtualHost ([\d\.]+)>$/) {
		    $ip=$1;
		    $ftp{$ip}=0;
		}
		if (/^\s*<Anonymous\s+$Htgroup_dir\/([^\/]+)/o) {
		    $ftp{$ip}=$1 if ($1 ne $MainGroup);
		}
	    } elsif (/^\s*<Anonymous\s+$Htgroup_dir\/$MainGroup/) {
		$ftp{$ipaddr}=$MainGroup;
	    }
	}
        close(FTPD);
    }
    return(%ftp);
}


1;
