# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Group.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Adminuser = "admin";
my $Firstgid = "110";
my $Gtmp = "/etc/locks/gtmp";
my $Htgtmp = "/etc/locks/htgtmp";
my $MaxMembers = "60000";
my $MaxNameLen = "12";
my $MaxQuota = "26624000";
my %Features = ("networker","1","telnetConfig","1","dhcpd","0","shiftjis","Cobalt interface message for shiftjis (We should never see this)","pagebuilder","0","www","1","mx","1","gated","1","dns","1","nfs","0","securetty","1","english","1","atalk","0","fpx","1","siteAdminRedirect","1","users","1","ntp","0","mon_textdb_only","0","search","0","anonFTP","1","specialHomeSkel","0","viewGroups","0","cobaltHomePage","0","lastNameFirst","1","warnRootOnly","1","vsites","1","pam","1","discuss","0","docorg","0","groups","1","smb","0","mail","1","nat","0","squid","0","autoGenWebUsage","0","japanese","0","cobaltRedirect","0","backups","1","vmachine","1","mon_port_testing","1","viewUsers","0","usersCGIInWizard","1","privatedirs","0","telnetDefault","1","ssl","0","siteManagement","1","adm","1","bind8","1","personalRedirect","1","webRequests","1","usersAddUser","0","adminRedirect","1","quotas","1","snmp","1","defaultUserNameGen","1","groupdirs","1","proftpd","1");
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Group.pm.  Changes made here will be lost.
package Cobalt::Group;

sub group_add_nohome
# group_add_nohome: Create a group
# Arguments: the name of the group, group quota, and (optional) list of members
# Side effects: adds entries to the group file
# Return value: the usual status string of format "816 I said NO camels"
{
    my ($return,$gid);
    my ($group,$quota,@members) = @_;
    return "4289 Invalid group name $group" if ($group !~ /^[\w\-\.]+$/o);
    return "4290 Group names must be no longer than 12 characters."
        if (length($group) > $MaxNameLen);
    my $warn_quota = ($MaxQuota / 1024);
    return "4291 Quotas may not exceed $warn_quota"
        if ($quota > $MaxQuota);
    return "4293 Group $group already exists"
        if (getgrnam($group));
    return "4294 Name $group already in use as a user"
        if (getpwnam($group));
    return "4295 Name $group is already in use as a mailing list or alias"
        if (Cobalt::List::alias_exist($group));
    return
        Cobalt::Group::group_abort("4296 Too many members; you may only have 60000 members per group")
            if ($#members >= $MaxMembers);

    return $return unless (($return = Cobalt::Group::lock_group()) =~ /^2/o);

    ### Add to the files in /etc
    setgrent();
    for ($gid = $Firstgid; getgrgid($gid); $gid++) {;}
    my $members = join(',',@members,$Adminuser);
    my $line = "${group}::${gid}:${members}\n";
    print STDERR "Adding to $Gtmp: $line" if ($Debug);
    open(GTMP,">>$Gtmp")
        || return Cobalt::Group::group_abort("4297 Cannot append to /etc/locks/gtmp: $!");
    print GTMP $line;
    close GTMP;
    unless ($Features{'pam'}) {
      my $hmembers = join(' ',@members,$Adminuser);
      my $htline = "${group}:${hmembers}\n";
      open(GTMP,">>$Htgtmp")
        || return Cobalt::Group::group_abort("4298 Cannot append to /etc/locks/htgtmp: $!");
      print GTMP $htline;
      close GTMP;
    }

    ### end game
    return $return unless (($return = Cobalt::Group::commit_group()) =~ /^2/o);
    Cobalt::Group::group_set_quota($group,$quota);

    ## gsri: believe this is necessary here as
    ##       group_add_user or group_set_user could be called later
    Cobalt::List::list_create($group,@members);  # no checkee returnee

    print STDERR "Completed adding $group\n" if ($Debug);
    return "2230 Group $group created successfully";
}


1;
