# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Group.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Gtmp = "/etc/locks/gtmp";
my $Htgroup_dir = "/home/sites";
my $Htgtmp = "/etc/locks/htgtmp";
my $Lockdir = "/etc/locks";
my $MainGroup = "home";
my %Features = ("networker","1","telnetConfig","1","dhcpd","0","shiftjis","Cobalt interface message for shiftjis (We should never see this)","pagebuilder","0","www","1","mx","1","gated","1","dns","1","nfs","0","securetty","1","english","1","atalk","0","fpx","1","siteAdminRedirect","1","users","1","ntp","0","mon_textdb_only","0","search","0","anonFTP","1","specialHomeSkel","0","viewGroups","0","cobaltHomePage","0","lastNameFirst","1","warnRootOnly","1","vsites","1","pam","1","discuss","0","docorg","0","groups","1","smb","0","mail","1","nat","0","squid","0","autoGenWebUsage","0","japanese","0","cobaltRedirect","0","backups","1","vmachine","1","mon_port_testing","1","viewUsers","0","usersCGIInWizard","1","privatedirs","0","telnetDefault","1","ssl","0","siteManagement","1","adm","1","bind8","1","personalRedirect","1","webRequests","1","usersAddUser","0","adminRedirect","1","quotas","1","snmp","1","defaultUserNameGen","1","groupdirs","1","proftpd","1");
my %System_groups = ("global","1","tty","1","users","1","adm","1","mail","1","site-adm","1","httpd","1","daemon","1","root","1","gopher","1","wheel","1","admin","1","bin","1","ftp","1","kmem","1","nobody","1","disk","1","homes","1","man","1","lp","1","dip","1","games","1","uucp","1","news","1","sys","1","mem","1");
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Group.pm.  Changes made here will be lost.
package Cobalt::Group;

#sub group_set_owner
# group_set_owner: set the owner for a group
# Arguments: group name, owner
# Side effects: creates the list
# Return value: the usual
# Not used in the current release
#{
#    my ($group,$owner) = @_;
#    return Cobalt::List::list_add("$group+owner",$owner);
#}

#sub group_get_owner
# group_get_owner: return the owner for the group
# Arguments: group name
# Side effects: none
# Return value: the group owner name
# Not used in the current release
#{
#    my ($group) = @_;
#    return Cobalt::List::list_show("$group+owner");
#}

sub group_del
# group_del: delete a group
# Arguments: the name of the group to delete
# Side effects: Removes the group from the group and htgroup file
# Return value: a status string of the form "604 Gotta dance!"
{
    my($name) = @_;
    return "4282 Group $name does not exist" unless (getgrnam($name));
    my $return;
    return "4200 Cannot modify $name: prohibited group"
	if (($System_groups{$name}) || ($name eq $MainGroup));
    return $return unless (($return = Cobalt::Group::lock_group()) =~ /^2/o);

    print STDERR "Cleaning from $Gtmp\n" if ($Debug);
    open(GROUP,$Gtmp) || return Cobalt::Group::group_abort("4203 Cannot open /etc/locks/gtmp: $!");
    open(GTMP,">$Lockdir/group") || 
	return Cobalt::Group::group_abort("4204 Cannot clobber /etc/locks/group: $!");
    "$name:" =~ /^$name:/;   # pre-compile the pattern
    while (<GROUP>)
    {
	print GTMP unless (//);
    }
    close GTMP;
    close GROUP;
    rename("$Lockdir/group",$Gtmp) ||
	return Cobalt::Group::group_abort("4205 Cannot rename /etc/locks/gtmp: $!");

    unless ($Features{'pam'}) {
      open(GROUP,$Htgtmp) 
	|| return Cobalt::Group::group_abort("4206 Cannot open /etc/locks/htgtmp: $!");
      open(GTMP,">$Lockdir/htgroup") || 
	return Cobalt::Group::group_abort("4207 Cannot clobber /etc/locks/htgroup: $!");
      "$name:" =~ /^$name:/;   # pre-compile, not in the loop
      while (<GROUP>)
      {
	print GTMP unless (//);
      }
      close GTMP;
      close GROUP;
      rename("$Lockdir/htgroup",$Htgtmp) ||
	return Cobalt::Group::group_abort("4208 Cannot rename /etc/locks/htgtmp: $!");
    }

    Cobalt::Utility::sauce_deltree("$Htgroup_dir/$name");
    Cobalt::Group::samba_del($name) if ($Features{'smb'});
    if ($Features{'atalk'})
    {
      my $atalk_ret = Cobalt::Atalk::atalk_del_volume("$Htgroup_dir/$name");
      return $atalk_ret unless ($atalk_ret =~ /^2/o);
    }

    return $return unless (($return = Cobalt::Group::commit_group()) =~ /^2/o);

    # Remove the discussion group and mailing list
    Cobalt::List::list_delete($name);
    # not useful for new discussion group
#    if (-d "$Discuss_html_dir/$name")
#    {
	# rm -r $Discuss_dir/$name $Discuss_html_dir/$name
#	Cobalt::Utility::sauce_deltree("$Discuss_dir/$name");
#	Cobalt::Utility::sauce_deltree("$Discuss_html_dir/$name");
#    }

    print STDERR "Completed deletion of $name\n" if ($Debug);
    return "2235 Group deleted successfully";
}


1;
