# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Group.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Discuss_dir = "/usr/httpd/cgi-bin/cobalt/discuss";
my $Discuss_html_dir = "/usr/httpd/html/cobalt/discuss";
my $Discuss_skel = "/etc/skel/discuss";
my $WWWuid = "15";
my %Features = ("networker","1","telnetConfig","1","dhcpd","0","shiftjis","Cobalt interface message for shiftjis (We should never see this)","pagebuilder","0","www","1","mx","1","gated","1","dns","1","nfs","0","securetty","1","english","1","atalk","0","fpx","1","siteAdminRedirect","1","users","1","ntp","0","mon_textdb_only","0","search","0","anonFTP","1","specialHomeSkel","0","viewGroups","0","cobaltHomePage","0","lastNameFirst","1","warnRootOnly","1","vsites","1","pam","1","discuss","0","docorg","0","groups","1","smb","0","mail","1","nat","0","squid","0","autoGenWebUsage","0","japanese","0","cobaltRedirect","0","backups","1","vmachine","1","mon_port_testing","1","viewUsers","0","usersCGIInWizard","1","privatedirs","0","telnetDefault","1","ssl","0","siteManagement","1","adm","1","bind8","1","personalRedirect","1","webRequests","1","usersAddUser","0","adminRedirect","1","quotas","1","snmp","1","defaultUserNameGen","1","groupdirs","1","proftpd","1");
my @Discuss_cgis = ("followup.sh","post.sh","wwwadmin.pl","wwwboard.pl","index.cgi");
my @Discuss_html = ("index.html","redirect.html");
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Group.pm.  Changes made here will be lost.
package Cobalt::Group;

sub group_mkdiscuss
# Creates a discussion group; sets up all the directories and files
# Arguments: group name, group id
# Side effects: creates the directories and copies HTML files
# Return value: the usual status string
{
    my ($group,$gid) = @_;
    my $cgroup = ucfirst($group);
    my $sfile;
    return "1254 Discussion groups not enabled"
      unless ($Features{'discuss'});

    # Make sure the top-level directories for discussion stuff
    # are all there and in place
    mkdir ($Discuss_html_dir,0755) unless (-d $Discuss_html_dir);
    mkdir ($Discuss_dir,0755) unless (-d $Discuss_dir);

    if ((-d "$Discuss_html_dir/$group") ||
	(-d "$Discuss_dir/$group"))
    {
	return "4246 Discussion directory for $group already exists";
    }

    # make directories
    mkdir("$Discuss_dir/$group",0755)
	|| print STDERR "Cannot make discussion directory: $!\n";
    mkdir("$Discuss_html_dir/$group",0775);
    mkdir("$Discuss_html_dir/$group/private",0775);
    chown($WWWuid,$gid,"$Discuss_html_dir/$group",
	  "$Discuss_html_dir/$group/private");
    chmod(0775,"$Discuss_html_dir/$group",
	  "$Discuss_html_dir/$group/private");
    
    # touch the data.txt file
    open(D,">$Discuss_html_dir/$group/data.txt")
      || return "4292 Cannot create /usr/httpd/html/cobalt/discuss/$group/data.txt: $!";
    close D;
    chmod(0664,"$Discuss_html_dir/$group/data.txt");
    chown($WWWuid,$gid,"$Discuss_html_dir/$group/data.txt");

    # HTML templates
    foreach $sfile (@Discuss_html)
    {
	open(IN,"$Discuss_skel/$sfile")
	    || return "4276 Cannot read discussion $sfile template: $!";
	open(OUT,">$Discuss_html_dir/$group/$sfile")
	    || return "4275 Cannot write discussion $sfile template: $!";
	while (<IN>)
	{
	    if (/XXX|GROUP/o)
	    {
		$_ =~ s/XXX/$cgroup/g;
		$_ =~ s/GROUP/$group/g;
	    }
	    print OUT;
	}
	close IN;
	close OUT;
	chown($WWWuid,$gid,"$Discuss_html_dir/$group/$sfile");
	chmod(0664,"$Discuss_html_dir/$group/$sfile");
    }

    # CGI templates
    foreach $sfile (@Discuss_cgis)
    {
	open(IN,"$Discuss_skel/$sfile")
	    || return "4249 Cannot read discussion $sfile template: $!";
	open(OUT,">$Discuss_dir/$group/$sfile")
	    || return "4269 Cannot write discussion $sfile template: $!";
	while (<IN>)
	{
	    if (/ROUP/o)
	    {
		$_ =~ s/CROUP/$cgroup/g;
		$_ =~ s/GROUP/$group/g;
	    }
	    print OUT;
	}
	close IN;
	close OUT;
	chmod(0755,"$Discuss_dir/$group/$sfile");
    }
    Cobalt::Admserv::admserv_set_access("$Discuss_html_dir/$group","require","group",$group);
    Cobalt::Admserv::admserv_set_access("$Discuss_dir/$group","require","group",$group);
    return "2223 Discussion group created successfully";
}


1;
