# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Group.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Adminuser = "admin";
my $Gtmp = "/etc/locks/gtmp";
my $Htgtmp = "/etc/locks/htgtmp";
my $Lockdir = "/etc/locks";
my $MaxMembers = "60000";
my %Features = ("networker","1","telnetConfig","1","dhcpd","0","shiftjis","Cobalt interface message for shiftjis (We should never see this)","pagebuilder","0","www","1","mx","1","gated","1","dns","1","nfs","0","securetty","1","english","1","atalk","0","fpx","1","siteAdminRedirect","1","users","1","ntp","0","mon_textdb_only","0","search","0","anonFTP","1","specialHomeSkel","0","viewGroups","0","cobaltHomePage","0","lastNameFirst","1","warnRootOnly","1","vsites","1","pam","1","discuss","0","docorg","0","groups","1","smb","0","mail","1","nat","0","squid","0","autoGenWebUsage","0","japanese","0","cobaltRedirect","0","backups","1","vmachine","1","mon_port_testing","1","viewUsers","0","usersCGIInWizard","1","privatedirs","0","telnetDefault","1","ssl","0","siteManagement","1","adm","1","bind8","1","personalRedirect","1","webRequests","1","usersAddUser","0","adminRedirect","1","quotas","1","snmp","1","defaultUserNameGen","1","groupdirs","1","proftpd","1");
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Group.pm.  Changes made here will be lost.
package Cobalt::Group;

sub group_set_membership
# group_set_membership: set the members list for a group
# Arguments: the name of the group and an array of members
# Side effects: modifies /etc/group, /etc/htgroup
#   This function ensures that the list contains no duplicate names.
{
    my ($group,@list) = @_;
    return Cobalt::Group::group_abort("4210 No such group: $group") unless (getgrnam($group));
    return 
	Cobalt::Group::group_abort("4245 Too many members; you may only have 60000 members per group")
	    if ($#list >= $MaxMembers);

    print STDERR "Membership of $group is being set to @list\n" if ($Debug);

    # Using the hash table is a cute way to guarantee no repeat
    # entries
    my %temp = map { $_, 1} @list;
    $temp{$Adminuser} = 1; # ditto for admin
    my $list = join(',',sort(keys(%temp)));

    # Don't go to any trouble if nothing is changing
    my $oldmembers = join(',',Cobalt::Group::group_show($group));
    if ($oldmembers eq $list)
    {
	return "2224 No change to group membership";
    }

    # fix the group file
    open(GROUP,$Gtmp) ||  return Cobalt::Group::group_abort("4211 Cannot read /etc/locks/gtmp: $!");
    open(GTMP,">$Lockdir/group") 
	|| return Cobalt::Group::group_abort("4212 Cannot append to /etc/locks/group: $!");
    "$group:x:" =~ /^$group:(.+):/;   # pre-compiled regexps are better
    while (<GROUP>)
    {
	if (//)
	{
	    print GTMP "$group:$1:$list\n";
	}
	else
	{
	    print GTMP;
	}
    }
    close GTMP;
    close GROUP;
    rename("$Lockdir/group",$Gtmp) ||
	return Cobalt::Group::group_abort("4213 Cannot replace /etc/locks/gtmp: $!");

    unless ($Features{'pam'}) {
      # Fix the htgroup file
      $list = join(' ',keys(%temp));
      open(GROUP,$Htgtmp) ||  return Cobalt::Group::group_abort("4214 Cannot read /etc/locks/htgtmp: $!");
      open(GTMP,">$Lockdir/htgroup") 
	|| return Cobalt::Group::group_abort("4215 Cannot append to /etc/locks/htgroup: $!");
      "$group:" =~ /^$group:/;   # pre-compile for speed
      while (<GROUP>)
      {
	if (//)
	{
	    print GTMP "$group:$list\n";
	}
	else
	{
	    print GTMP;
	}
      }
      close GTMP;
      close GROUP;
      rename("$Lockdir/htgroup",$Htgtmp) ||
	return Cobalt::Group::group_abort("4216 Cannot replace /etc/locks/htgtmp: $!");
    }

    # Fix the list membership to match the group membership
    Cobalt::List::list_set_mem($group,@list);
    return "2225 Group membership set successfully";
}


1;
