# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Group.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Adminuser = "admin";
my $Group = "/etc/group";
my $Gtmp = "/etc/locks/gtmp";
my $Htgroup = "/etc/htgroup";
my $Htgtmp = "/etc/locks/htgtmp";
my $Lockdir = "/etc/locks";
my %Features = ("networker","1","telnetConfig","1","dhcpd","0","shiftjis","Cobalt interface message for shiftjis (We should never see this)","pagebuilder","0","www","1","mx","1","gated","1","dns","1","nfs","0","securetty","1","english","1","atalk","0","fpx","1","siteAdminRedirect","1","users","1","ntp","0","mon_textdb_only","0","search","0","anonFTP","1","specialHomeSkel","0","viewGroups","0","cobaltHomePage","0","lastNameFirst","1","warnRootOnly","1","vsites","1","pam","1","discuss","0","docorg","0","groups","1","smb","0","mail","1","nat","0","squid","0","autoGenWebUsage","0","japanese","0","cobaltRedirect","0","backups","1","vmachine","1","mon_port_testing","1","viewUsers","0","usersCGIInWizard","1","privatedirs","0","telnetDefault","1","ssl","0","siteManagement","1","adm","1","bind8","1","personalRedirect","1","webRequests","1","usersAddUser","0","adminRedirect","1","quotas","1","snmp","1","defaultUserNameGen","1","groupdirs","1","proftpd","1");
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Group.pm.  Changes made here will be lost.
package Cobalt::Group;

##############################

sub lock_group
# Locks the group file so that nobody can collide with us.
# Arguments: none
# Side effects: copies /etc/group to /etc/gtmp
{
    my ($return);
    if (-e $Gtmp)
    {
	return Cobalt::Group::group_abort("4217 The group file is locked.");
    }
    else
    {
	# Lock the group file by creating the gtmp file as a
	# copy of the group file.
	print STDERR "Copying group file $Group to $Gtmp\n" if ($Debug);

	# inline for better performance
	open(SRC,$Group) 
	    || return Cobalt::Group::group_abort("4236 Cannot open source file /etc/group: $!");
	open(DEST,">$Gtmp") 
	    || return Cobalt::Group::group_abort("4237 Cannot open destination file /etc/locks/gtmp: $!");
	print DEST while (<SRC>);
	close DEST;
	close SRC;

	open(LOCK,">$Lockdir/group-$$")
	  || return Cobalt::Group::group_abort("4265 Cannot get group lock: $!");
	print LOCK "$$\n$0";
	close LOCK;

    	unless ($Features{'pam'}) {
	  if (! -e $Htgroup)
	  {
	    # this looks like a fresh system
	    print STDERR "Creating new htgroup file $Htgroup\n" if ($Debug);
	    open(HTGROUP,">$Htgroup")
	      || return "4248 Cannot write /etc/htgroup";
	    print HTGROUP "${Adminuser}:$Adminuser\n";
	    close HTGROUP;
	  }
	  
	  open(SRC,$Htgroup) 
	    || return Cobalt::Group::group_abort("4238 Cannot open source file /etc/htgroup: $!");
	  open(DEST,">$Htgtmp") 
	    || return Cobalt::Group::group_abort("4239 Cannot open destination file /etc/locks/htgtmp: $!");
	  print DEST while (<SRC>);
	  close DEST;
	  close SRC;
    	}
    }
    print STDERR "Locked $Group with $Gtmp\n" if ($Debug);
    return "2226 Group file locked";
}


1;
