# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Group.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Lockdir = "/etc/locks";
my $Smbconf = "/etc/smb.conf";
my %Features = ("networker","1","telnetConfig","1","dhcpd","0","shiftjis","Cobalt interface message for shiftjis (We should never see this)","pagebuilder","0","www","1","mx","1","gated","1","dns","1","nfs","0","securetty","1","english","1","atalk","0","fpx","1","siteAdminRedirect","1","users","1","ntp","0","mon_textdb_only","0","search","0","anonFTP","1","specialHomeSkel","0","viewGroups","0","cobaltHomePage","0","lastNameFirst","1","warnRootOnly","1","vsites","1","pam","1","discuss","0","docorg","0","groups","1","smb","0","mail","1","nat","0","squid","0","autoGenWebUsage","0","japanese","0","cobaltRedirect","0","backups","1","vmachine","1","mon_port_testing","1","viewUsers","0","usersCGIInWizard","1","privatedirs","0","telnetDefault","1","ssl","0","siteManagement","1","adm","1","bind8","1","personalRedirect","1","webRequests","1","usersAddUser","0","adminRedirect","1","quotas","1","snmp","1","defaultUserNameGen","1","groupdirs","1","proftpd","1");
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Group.pm.  Changes made here will be lost.
package Cobalt::Group;

sub samba_del
# Removes a share from the samba configuration file
# Arguments: share name (generally the group name)
# Side effects: modifies smb.conf
{
    my ($share) = @_;
    return "1256 Samba is not enabled on this system" 
      unless ($Features{'smb'});
    return "4235 Samba config file /etc/smb.conf is locked; try again later" if (-e "$Lockdir/smb.conf");
    open(SMB,"$Smbconf") 
	|| return "4230 Cannot modify samba config file /etc/smb.conf: $! ";
    open(SNB,">$Lockdir/smb.conf") 
	|| return "4231 Cannot write samba config file /etc/locks/smb.conf: $! ";
    # compile the expression now, not each time we loop
    ";$share BEGIN" =~ /;$share BEGIN/; 
    while (<SMB>)
    {
	last if (//);
	print SNB;
    }
    # compile the expression now, not each time we loop
    ";$share END" =~ /;$share END/;  
    while (<SMB>)
    {
	last if (//);
    }
    print SNB while (<SMB>);
    close SMB;
    close SNB;
    rename("$Lockdir/smb.conf",$Smbconf) ||
	return "4232 Cannot update /etc/smb.conf: $!";
    return "2258 Removed SMB share";
}


1;
