# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Language.pm.  Changes made here will be lost.
package Cobalt::Language;

####
# Now, some subroutines...

sub msg_get
# Read in a message from the database
# Arguments: message name
# Note that the string returned may include variables, so you may get
#   back a message like "User $name has violated the laws of physics"
#   which then needs to be eval'ed at run time to insert the proper
#   definition of (in this example) $name.
# If the string ends in "_L", then it is recognized as a list value,
#   and a list is returned.  The list is built out of the DB based on
#   key_L001 through key_Lnnn.
# Return value: A text string
# Examples: 
#  static message:
#    $text = Cobalt::Language::msg_get("copyright_info");
#  to do variable expansion:
#    $text = Cobalt::Language::msg_get('user_add_badname'); $text = eval "\"$text\""
{
  my ($package, $filename, $line) = caller;
  my ($msg_tag) = @_;
  #my %Messages;
  unless ($Cobalt::Language::Messages_Tied) {
    unless(tie(%Cobalt::Language::Messages, 'DB_File', 
	       "/etc/cobalt/messages/$LANGUAGE.db",O_RDONLY(),0644))
      {
	return "Cannot read messages database /etc/cobalt/messages/$LANGUAGE.db: $!";
      }
    $Cobalt::Language::Messages_Tied = 1;
  }
  my $message;
  if ($msg_tag =~ /_L$/o) {
    # Asking for a list
    my $item;
    my $i = 1;
    my $tag = sprintf("$msg_tag%.3d",$i);
    my @message;
    while ($item = $Cobalt::Language::Messages{$tag}) {
      push(@message,$item);
      $i++;
      $tag = sprintf("$msg_tag%.3d",$i);
      if ($i > 1000) {
	print STDERR "$msg_tag has sent us into an infinite loop at $package::$filename line $line\n";
	last;
      }
    }
    return "Cobalt interface message for $msg_tag (We should never see this)"
      unless ($#message > -1);
    return @message;
  } else {
    # Normal message string
    $message = $Cobalt::Language::Messages{$msg_tag};
  }
#  untie %Messages;
  $message = "$message (($package $filename $line))" if ($Debug);
  return "Cobalt interface message for $msg_tag (We should never see this)"
    unless ($message);
  return $message;
}

1;
