# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Language.pm.  Changes made here will be lost.
package Cobalt::Language;

sub msg_localtime
# Return the time string, formatted the way marketing likes it
# Arguments: time in seconds since the epoch
# Return value: a text string telling the time
{
    my ($time) = @_;
    my ($sec,$min,$hour,$mday,$mon,$year,$wday) = localtime($time);
    my $m;
    $year += 1900;
    $hour = "0$hour" if ($hour < 10);
    $min = "0$min" if ($min < 10);
    $sec = "0$sec" if ($sec < 10);
    if ($hour > 12)
    {
	$hour -= 12;
	$m = "P.M.";  # post meridian
    }
    elsif ($hour == 12)
    {
      $m = Cobalt::Language::msg_get('post_meridian');  # P.M. in english, pm in japanese
    }
    elsif ($hour == 24)
    {
      $hour = 0;
      $m = Cobalt::Language::msg_get('ante_meridian');
    }
    else
    {
      $m = Cobalt::Language::msg_get('ante_meridian');
    }

  if ($LANGUAGE eq "japanese") {
    return "${year}N $Months[$mon] $mday $Days[$wday] ${hour}:${min}${m}";
  } else {
    # Personally, I don't like this format.
    return "${hour}:${min} $m on $Days[$wday] $Months[$mon] $mday $year";

    # This would be more standard:
    #my $zone = Cobalt::Time::time_get_zone();
    #return "$Days[$wday] $Months[$mon] $mday ${hour}:${min}${m} $zone $year";
  }
}

1;  # Do not remove this line
1;
