# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Language_japanese.pm

# Copyright 1998 Cobalt Microserver (http://www.cobaltmicro.com)

use strict;
### START HARDCODED PATHS
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = $Debug;
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Language_japanese.pm.  Changes made here will be lost.
package Cobalt::Language_japanese;

sub msg_get_error
# Return the error message associated with an error index number
# Each index number should be unique, even if the message is duplicated
# Arguments: error number
# Return value: string
# Note that most of these errors are purely internal, but some of
#    them show up in the UI.  I have no idea which ones show up.
# This function is not used at runtime; it is used at RPM creation
#    time by the autoize script to replace the error messages in
#    the autoloaded perl files.
{
    my ($errnum) = @_;
    my %errs = (
		1010 => 'Repair of ftp $inst not implemented',
		1020 => 'Repair of cpu $inst not implemented',
		1030 => 'Repair or memory $inst not implemented',
		1040 => 'Repair of disk $inst not implemented',
		1050 => 'Repair of network $inst not implemented',
		1052 => 'SSL is not implemented in this release',
		1053 => 'Redirect not changed; httpd disabled',
		1054 => 'User CGIs not allowed on this system.',
		1100 => 'Mail service is not implemented in this release',
		1101 => 'Windows filesharing is not implemented in this release',
		1102 => 'NFS is not implemented in this release',
		1103 => 'DNS service is not implemented in this release',
		1104 => 'AppleShare service is not implemented in this release',
		1105 => 'NFS is not implemented in this release',
		1106 => 'Windows filesharing is not implemented in this release',
		1107 => 'Cannot set Windows domain controller: not implemented in this release',
		1109 => 'ntp service not available in this release',
		1253 => 'Groups not enabled',
		1254 => 'Discussion groups not enabled',
		1255 => 'Samba is not enabled on this system',
		1256 => 'Samba is not enabled on this system',
		1300 => 'No quotas on this system',
		1301 => 'Quotas not implemented',
		1400 => 'Users not implemented',
		1401 => 'Groups not implemented',
		1403 => 'SNMP not implemented in this release',
		1700 => 'No user web server on this system',
		1701 => 'No administrative web server on this system',
		1702 => 'SMB not supported',
		2029 => '$uid ̊ăZbg',
		2032 => '$dir ւ̃ANZXJ܂B',
		2039 => 'Date set',
		2040 => 'Time zone set to $zone',
		2054 => 'User CGIs not allowed on this system.',
		2055 => 'User CGIs were already disabled, no change.',
		2056 => 'Set access rights for $dir',
		2057 => 'User CGIs are enabled',
		2058 => 'User CGIs were already enabled, no change',
		2059 => 'User CGIs already enabled',
		2060 => 'User CGIs disabled',
		2061 => 'User CGIs are now enabled',
		2062 => 'User CGIs already disabled',
		2063 => 'Web servers restarted ($pid)',
		2064 => 'Daemons restarted',
		2065 => 'Updated admin server redirect',
		2066 => 'Redirect not changed; httpd disabled',
		2067 => 'No update to hostname or domain name needed',
		2101 => 'Directory created successfully',
		2102 => 'File copied successfully',
		2103 => 'File moved successfully',
		2104 => 'File deleted successfully',
		2140 => 'Virtual interface for address $addr has been set up',
		2141 => 'Set mail masquerading to $masqas',
		2142 => 'Virtual interface deleted successfully',
		2143 => 'Set mail site blocking',
		2222 => 'Membership of group $group set successfully',
		2231 => 'Group deleted successfully',
		2232 => 'Group deletion successful',
		2233 => 'Group deletion successful',
		2234 => 'Users added to group $group successfully',
		2235 => 'Group deleted successfully',
		2236 => 'Users removed successfully',
		2237 => 'Group $group created successfully',
		2238 => 'Group $group created successfully',
		2239 => 'Group $group created successfully',
		2257 => 'Added SMB share',
		2258 => 'Removed SMB share',
		2314 => 'Alias created successfully',
		2320 => 'Users removed from alias $list successfully',
		2321 => 'Successfully deleted list $alias',
		2323 => 'List membership for $list set successfully',
		2324 => 'List membership for $list successfully set',
		2325 => '$user already has auto-reply active',
		2326 => '$user already has auto-reply deactivated',
		2327 => 'Auto-reply message set in $messagefile',
		2328 => '$user now has no message file',
		2346 => 'users added to alias $alias successfully',
		2410 => 'Changed IP address from $oldaddr to $addr',
		2411 => 'Gateway changed from $oldgw to $gw',
		2412 => 'Name successfully changed from $oldname to $fullname',
		2413 => 'Set samba workgroup to $workgroup',
		2414 => 'Set samba domain controller to $server',
		2417 => 'No change to DNS client configuration',
		2418 => 'Wrote resolv.conf',
		2419 => 'Emptied resolv.conf',
		2431 => 'AppleShare server started',
		2433 => 'AppleShare server stopped',
		2440 => 'Anyone in the world can manage groups, yay!',
		2441 => 'No change to user management',
		2442 => 'No change to group management',
		2443 => 'No change to user management',
		2444 => 'No change to group management',
		2447 => 'Anyone in the world can manage users',
		2448 => 'Only the administrator may manage groups',
		2449 => 'Only the administrator may manage users',
		2450 => 'Mail server started',
		2451 => 'No change -- mail server was already $off',
		2452 => 'Mail server stopped',
		2453 => 'Ftp server started',
		2454 => 'No change -- atalk server was already $off',
		2455 => 'Updated NFS exports list',
		2456 => 'Telnet server started',
		2457 => 'Telnet server stopped',
		2458 => 'No change to telnet state',
		2459 => 'Telnet access restricted',
		2460 => 'Telnet access opened to all users',
		2461 => 'SNMP server started',
		2462 => 'SNMP server stopped',
		2463 => 'No change -- SNMP server was already $off',
		2464 => 'Ftp server stopped',
		2470 => '$IP responds',
		2480 => '$IP is listening on port 53',
		2491 => 'No change -- smb server was already $off',
		2493 => 'Smb server started',
		2494 => 'Nfs server started',
		2496 => 'Nfs server stopped',
		2497 => 'Smb server stopped',
		2498 => 'No change -- nfs server was already $off',
                2502 => 'NTP server started',
                2503 => 'NTP server stopped',
                2504 => 'No change -- NTP server was already $off',
		2516 => 'Cannot delete $username: no such user',
		2530 => 'User $username created successfully',
		2531 => 'User $username creation successful',
		2532 => 'User $name modified successfully',
		2533 => 'User $name modified successfully',
		2534 => 'User $username deleted',
		2535 => 'User $username deleted',
                2600 => 'Email virtual users added successfully',
                2601 => 'Email virtual users removed successfully',
                2602 => 'Email server alias added successfully',
                2603 => 'Email server alias removed successfully',
                2650 => 'Virtual FTP site created successfully',
                2651 => 'Virtual FTP site modified successfully',
                2652 => 'Virtual FTP site removed successfully',
                2660 => 'Name-based virtual server added successfully',
                2661 => 'Name-based virtual server deleted successfully',
		2701 => 'inetd restarted successfully',
		2702 => '$Servers{$server} restarted successfully',
		2703 => '$Servers{$server} successfully restarted',
		2704 => 'AppleShare server restarted',
		2705 => 'LCD restarted successfully',
		2706 => 'crond restarted successfully',
		2707 => 'custo restarted successfully',
		2708 => 'portmap restarted successfully',
		2709 => 'web server restarted successfully',
		2710 => 'admin server restarted successfully',
		2711 => 'ntp restarted successfully',
		2712 => 'snmp restarted successfully',
		2713 => 'ssl restarted successfully',
		2750 => 'Cannot enable the filters with no rules',
		2751 => 'The IP filtering rules have been installed',
		2752 => 'Filter rules set',
		2753 => 'Disabled IP filtering',
		2754 => 'Explicitly allowed by this rule',
		2755 => 'Allowed by default rule',
		2756 => 'Rule tests okay',
		2850 => 'DNS server started',
		2852 => 'DNS server started',
		2854 => 'DNS server stopped',
		2855 => 'No change -- the DNS server was already off',
		2856 => 'No change -- the DNS server was already on',
		3050 => 'Cannot write log file $MonDBDir/$server.log: $!',
		3051 => 'Cannot read log file $MonDBDir/$server.log: $!',
		3140 => '$Htconf/httpd.conf bNĂ܂B',
		3141 => '$Lockdir/httpd.conf ɏ߂܂: $!',
		3142 => '$Htconf/httpd.conf ǂݏo܂: $!',
		3143 => '$Htconf/httpd.conf XVł܂: $!',
		3144 => '$Logrotate_dir/$addr-apache 쐬ł܂: $!',
		3145 => 'Cannot update virtual interface config file: $!',
		3149 => '$Htconf/httpd.conf XVł܂: $!',
		3201 => '$group ̓_O[v쐬ł܂: $!\n',
		3228 => '$Group_skel ǂݏo܂: $!',
		3315 => 'bZ[W $messagefile ̏L҂ $uid ɐݒł܂łB: $!',
		3401 => 'Cannot read $Hostfile: $!',
		3402 => 'zXg t@Cɏ߂܂: zXg t@CbNĂ܂B',
		3403 => 'C^[tFCX̍\t@CXVł܂: $!',
		3404 => '$Htconf/httpd.conf XVł܂: $!',
		3405 => 'hosts t@CCł܂: $!',
		3406 => 'hosts t@CbNĂ܂BłxĂB',
		3407 => 'network t@CXVł܂: $!',
		3408 => 'hosts t@CXVł܂: $!',
		3409 => 'network t@CXVł܂: $!',
		3412 => 'hostname t@CύXł܂: $!',
		3413 => 'ċNɃT[õzXgύX邱Ƃ͂ł܂: $!',
		3415 => 'hosts t@CCł܂: $!',
		3416 => '[eBO e[ũGgǉł܂B',
		3417 => 'hosts t@CXVł܂: $!',
		3418 => '$Htconf/httpd.conf bNĂ܂BłxĂB',
		3419 => '$Htconf/httpd.conf ǂݏo܂: $!',
		3420 => '$Htconf/httpd.conf Cł܂: $!',
		3422 => '$AdminConf/httpd.conf bNĂ܂BłxĂB',
		3423 => '$AdminConf/httpd.conf ǂݏo܂: $!',
		3424 => '$AdminConf/httpd.conf Cł܂: $!',
		3425 => '$AdminConf/httpd.conf XVł܂: $!',
		3426 => '$AdminConf/srm.conf bNĂ܂BłxĂB',
		3427 => '$Lockdir/adm_srm.conf ɏ߂܂: $!',
		3428 => '$AdminConf/srm.conf ǂݏo܂: $!',
		3429 => '$AdminConf/srm.conf XVł܂: $!',
		3431 => 'AppleShare T[oNł܂: $!',
		3433 => 'N $Atalklink ؒfł܂: $!',
		3434 => 'Cannot create portmap link: $!',
		3435 => 'Cannot start portmapper: $!',
		3436 => 'Cannot break portmap link: $!',
		3437 => 'dq[̋ IP AhX t@C $MailIPList ɏ߂܂: $!',
		3438 => 'zXgt@C $MailNameList ɏ߂܂: $!',
		3455 => '[ T[oNł܂: $!',
		3456 => 'lbg[N T[o_EĂ܂: $!',
		3457 => 'N $Maillink ؒfł܂: $!',
		3458 => 'lbg[N T[o_EĂ܂: $!',
		3459 => 'lbg[N T[o_EĂ܂: $!',
		3464 => 'lbg[N T[o_EĂ܂: $!',
		3465 => 'lbg[N T[o_EĂ܂: $!',
		3466 => 'lbg[N T[o_EĂ܂: $!',
		3467 => '$Smbconf XVł܂: $!',
		3468 => 'samba \t@C $Smbconf ǂݏo܂: $!',
		3469 => 'samba \t@C $Smbconf ǂݏo܂: $!',
		3470 => '$Smbconf XVł܂: $!',
		3471 => 'samba \t@C $Smbconf ǂݏo܂: $!',
		3472 => 'smb \t@C $Smbconf ǂݏo܂: $!',
		3493 => 'smb T[oNł܂: $!',
		3494 => 'Cannot start nfs server: $!',
		3496 => 'Cannot break nfs link: $!',
		3497 => 'N $Smblink ؒfł܂: $!',
		3498 => 'Cannot start SNMP server: $!',
		3499 => 'Cannot stop SNMP server: $!',
                3500 => 'Cannot start ntp server: $!',
                3501 => 'Cannot stop ntp service: $!',
		3591 => '$homedir ̏L҂ $uid/$UserDirGroup ɕύXł܂: $!',
		3592 => '$User_skel ǂݏo܂: $!',
		3701 => 'O t@C $MonDBDir/lcd.log ɏ߂܂: $!',
		3702 => 'O t@C $MonDBDir/inetd.log ɏ߂܂: $!',
		3703 => 'O t@C $MonDBDir/portmap.log ɏ߂܂: $!',
		3704 => 'O t@C $MonDBDir/crond.log ɏ߂܂: $!',
		3705 => 'Cannot write log file $MonDBDir/$server.log: $!',
		3706 => 'Cannot write repair log $MonDBDir/$server.log: $!',
		3707 => 'Cannot run web server startup script: $!',
		3708 => 'Cannot read master file $badfile.master: $!',
		3709 => 'Cannot write config file $badfile: $!',
		3710 => 'Cannot write log file $MonDBDir/$server.log: $!',
		3711 => 'Cannot run admin server startup script: $!',
		3712 => 'Cannot read master file $badfile.master: $!',
		3713 => 'Cannot write admin config file $badfile: $!',
		3714 => 'Cannot read samba master file $Smbconf.master: $!',
		3715 => 'Cannot write samba config file $Smbconf: $!',
		3716 => 'Cannot write log file $MonDBDir/ntp.log: $!',
		3717 => 'Cannot write log file $MonDBDir/snmp.log: $!',
		3718 => 'Cannot write log file $MonDBDir/ssl.log: $!',
		4001 => '$dir/$Access_file 폜ł܂: $!',
		4002 => '$dir/$Access_file 쐬ł܂: $!',
		4003 => '$dir/$Access_file ǂݏo܂: $!',
		4004 => '$Htconf/srm.conf ǂݏo܂: $!',
		4005 => '$Lockdir/srm.conf ɏ߂܂: $!',
		4006 => 'srm.conf ̃_CNgXVł܂: $!',
		4008 => 'ȃfBNg: $dir',
		4009 => 'access.conf ͂ł܂!',
		4010 => 'access.conf ǂݏo܂B',
		4011 => 'EFu T[o PID t@C $Htpid ǂݏo܂: $!',
		4012 => 'ǗT[o PID t@C $AdminPid ǂݏo܂: $!',
		4013 => '$Htconf/access.conf ǂݏo܂: $!',
		4014 => '$Htconf/access.conf XVł܂: $!',
		4015 => '$Htconf/srm.conf is locked',
		4016 => '$Htconf/access.conf ̃bN߂܂: $!',
		4017 => 'httpd PID t@C $Htpid ǂݏo܂: $!',
		4018 => '[U CGI Iɂł܂: $!',
		4019 => '[U CGI Itɂł܂: $!',
		4051 => 'f[^x[X $Status_db ǂݏo܂: $!',
		4052 => 'f[^x[X $Status_db ɃANZXł܂: $!',
		4053 => 'f[^x[X $Status_db ɃANZXł܂: $!',
		4054 => 'f[^x[X $Status_db ɃANZXł܂: $!',
		4056 => 'f[^x[X $Status_db ǂݏo܂: $!',
		4057 => 'f[^x[X $Status_db ǂݏo܂: $!',
		4058 => 'f[^x[X $Status_db ɃANZXł܂: $!',
		4059 => 'f[^x[X $Status_db ɃANZXł܂: $!',
		4101 => '\[X t@C $from ǂݏo܂: $!\n',
		4102 => '^[Qbg t@C $to ɏ߂܂: $!\n',
		4103 => '$from ̓ǂݏoɃVXeǂݏoG[܂: $!\n',
		4104 => 'System write error writing $to: $!',
		4105 => 'fBNg $top ǂݏo܂: $!',
		4106 => '$dir ǂݏo܂: $!',
		4107 => 'O[v TufBNg $dir 쐬ł܂: $!',
		4108 => 'fBNg $dir 쐬ł܂: $!',
		4109 => 'fBNg $dir Ń[hݒł܂: $!',
		4110 => 'fBNg $dir Ƀ[hݒł܂: $!',
		4111 => 'fBNg $dir  uid/gid ݒł܂: $!',
		4112 => 'fBNg $dir  uid/gid ݒł܂: $!',
		4113 => '$username  $parent ւ݂̏Ă܂B',
		4114 => '$username  $src ̓ǂݏoĂ܂B',
		4115 => '$username  $dest ւ̏㏑Ă܂B',
		4116 => '$username  $1 ւ݂̏Ă܂B',
		4117 => '$username  $src ̈ړĂ܂B',
		4118 => '$username  $dest ւ̏㏑Ă܂B',
		4119 => '$username  $1 ւ݂̏Ă܂B',
		4120 => '$username  $tgt ̍폜Ă܂B',
		4121 => '$username  $dir ̓ǂݏoĂ܂B',
		4122 => '$dir ͊ɑ݂܂B',
		4138 => 'ȃzXg: $name',
		4139 => 'ȃzXg: $name',
		4140 => '$addr ͗L IP AhXł͂܂B',
		4141 => 'ȃzXg: $name',
		4142 => 'G[: O[v݂܂B',
		4143 => 'lbg[N XNvg fBNg $If_cfg_dir ǂݏo܂: $!',
		4144 => 'zC^[tFCX\ł܂: ifcfg-$netif ̓bNĂ܂B',
		4145 => 'C^[tFCX $netif ̃bN擾ł܂: $!',
		4146 => 'C^[tFCX̍\t@C ifcfg-$virtif ǂݏo܂: $!',
		4147 => '$Htconf/httpd.conf ǂݏo܂: $!',
		4148 => 'lbg[N XNvg fBNg $If_cfg_dir ǂݏo܂: $!',
		4149 => '$Htconf/httpd.conf bNĂ܂B',
		4150 => 'C^[tFCX폜ł܂: ifcfg-$virtif ̓bNĂ܂B',
		4151 => 'C^[tFCX̍\t@C ifcfg-$virtif bNł܂: $!',
		4152 => '$Lockdir/httpd.conf ɏ߂܂: $!',
		4153 => '$Htconf/httpd.conf ǂݏo܂: $!',
		4154 => '$If_cfg_dir/ifcfg-$virtif ǂݏo܂: $!',
		4155 => '[ T[o\ł܂: VXerW[łB',
		4156 => '[ T[o̍\t@CbNł܂: $!',
		4157 => '[ T[o̍\t@Cǂݏo܂: $!',
		4158 => '[ T[o̍\t@Cǂݏo܂: $!',
		4159 => '[ T[o̍\t@Cǂݏo܂: $!',
		4160 => 'dq[ۃt@C $MailDenyFile ɏ߂܂: $!',
		4161 => 'dq[ۃt@C $MailDenyFile ǂݏo܂: $!',
		4180 => '$user ̎ԐMbZ[Wǂݏo܂: $!',
		4181 => '$user ̎ԐMbZ[W߂܂: $!',
		4200 => 'Cannot modify $name: prohibited group',
		4201 => 'O[v $name ݂͑܂B',
		4202 => 'Cannot modify $name: prohibited group',
		4203 => '$Gtmp J܂: $!',
		4204 => '$Lockdir/group 폜ł܂: $!',
		4205 => '$Gtmp ̖OύXł܂: $!',
		4206 => '$Htgtmp J܂: $!',
		4207 => '$Lockdir/htgroup 폜ł܂: $!',
		4208 => '$Htgtmp ̖OύXł܂: $!',
		4209 => 'Samba \t@C smb.conf bNĂ܂B',
		4210 => '̃O[v݂͑܂: $group',
		4211 => '$Gtmp ǂݏo܂: $!',
		4212 => '$Lockdir/group ɕtł܂: $!',
		4213 => '$Gtmp uł܂: $!',
		4214 => '$Htgtmp ǂݏo܂: $!',
		4215 => '$Lockdir/htgroup ɒǉ݂ł܂: $!',
		4216 => '$Htgtmp uł܂: $!',
		4217 => 'group t@CbNĂ܂B',
		4218 => '$Htgroup  $Htgtmp Œuł܂: $!',
		4219 => '$Group   $Gtmp Œuł܂: $!',
		4220 => 'gtmp t@C $Gtmp 폜ł܂: $!',
		4221 => 'gtmp t@C $Gtmp 폜ł܂: $!',
		4222 => '$Gtmp ɕtł܂: $!',
		4223 => '$Htgtmp ɕtł܂: $!',
		4224 => '\[X t@C $Group_skel/$htmlfile J܂: $!',
		4225 => 't@C $home/$htmlfile J܂: $!',
		4226 => 'O[ṽz[ fBNg $home ͊ɑ݂܂B',
		4227 => 'z[ fBNg $home 쐬ł܂: $!',
		4228 => 'O[ṽvCx[g̈ $home/$Private_html 쐬ł܂: $!',
		4229 => 'samba \t@C $Smbconf Cł܂: $!',
		4230 => 'samba \t@C $Smbconf Cł܂: $!',
		4231 => 'samba \t@C $Lockdir/smb.conf ɏ߂܂: $!',
		4232 => '$Smbconf XVł܂: $!',
		4233 => 'fBNg $top ǂݏo܂: $!',
		4234 => 'ȃO[v: $group',
		4235 => 'Samba \t@C smb.conf bNĂ܂BłxĂB',
		4236 => '\[X t@C $Group J܂: $!',
		4237 => 't@C $Gtmp J܂: $!',
		4238 => '\[X t@C $Htgroup J܂: $!',
		4239 => 't@C $Htgtmp J܂: $!',
		4240 => '$group ƂO̓[UƂĊɎgĂ܂B',
		4241 => 'Name $group is already in use as a mailing list or alias',
		4242 => 'Group names must be no longer than $MaxNameLen characters.',
		4243 => 'Group quotas may not exceed $warn_quota',
		4244 => 'o[܂Bo[̐ 1 ̃O[vɂő $MaxMembers łB',
		4245 => 'o[܂Bo[̐ 1 ̃O[vɂő $MaxMembers łB',
		4246 => '$group ̓_fBNg͊ɑ݂܂B',
		4247 => '$Htgroup_dir/Network ̂ݔtH_쐬ł܂: $!\n',
		4248 => 'httpd PID t@C $Htpid ǂݏo܂: $!',
		4249 => '_ $sfile ev[gǂݏo܂: $!',
		4250 => 'Xg $list ͊ɑ݂܂B',
		4251 => '$Aliasfile ǂݏo܂; $!',
		4252 => 'GCAX t@C $Aliasfile ǂݏo܂: $!',
		4253 => 'GCAX t@C $Aliasfile ǂݏo܂: $!',
		4254 => '$Aliasfile ǂݏo܂; $!',
		4255 => '$Altmp ɏ߂܂; $!',
		4256 => '$Altmp ㏑ł܂ł: $!',
		4257 => '$Aliasfile ǂݏo܂; $!',
		4258 => '$Altmp ɏ߂܂; $!',
		4259 => '$Altmp 폜ł܂: $!',
		4260 => '$Aliasfile ǂݏo܂: $!',
		4261 => 'GCAX t@CbNĂ܂B',
		4262 => 'VKGCAX t@C쐬ł܂: $!',
		4263 => '$Newaliases_cmd sł܂: $!',
		4264 => 'altmp $Altmp 폜ł܂: $!',
		4265 => '\[X t@C $src J܂: $!',
		4266 => 't@C $dest J܂: $!',
		4267 => '$group ƂO̓VXeɂė\񂳂Ă܂B',
		4268 => 'List names may not exceed $MaxListNameLen characters',
		4269 => '_ $sfile ev[gɏ߂܂: $!',
		4270 => '[ Xgɖȕ܂܂Ă܂B',
		4271 => '[ Xgɖȕ܂܂Ă܂B',
		4272 => 'List name $alias has invalid characters',
		4273 => 'List name $list has invalid characters',
		4274 => 'List name $list has invalid characters',
		4275 => '_ $sfile ev[gɏ߂܂: $!',
		4276 => '_ $sfile ev[gǂݏo܂: $!',
		4277 => '\[X t@C $Group_skel/index.html J܂: $!',
		4278 => 't@C $home/index.html J܂: $!',
		4279 => '\[X t@C $Group_skel/private.tmpl J܂: $!',
		4280 => 't@C $home/$Private_html/index.html J܂: $!',
		4281 => 'Group quotas may not be set above $warn_quota',
		4282 => 'Group $name does not exist',
		4283 => 'Cannot open $Gtmp: $!',
		4284 => 'Cannot clobber $Lockdir/group: $!',
		4285 => 'Cannot rename $Gtmp: $!',
		4286 => 'Cannot open $Htgtmp: $!',
		4287 => 'Cannot clobber $Lockdir/htgroup: $!',
		4288 => 'Cannot rename $Htgtmp: $!',
		4289 => 'Invalid group name $group',
		4290 => 'Group names must be no longer than $MaxNameLen characters.',
		4291 => 'Group quotas may not exceed $warn_quota',
		4292 => 'The name $group is reserved by the sytem',
		4293 => 'Group $group already exists',
		4294 => 'Name $group already in use as a user',
		4295 => 'Name $group is already in use as a mailing list or alias',
		4296 => 'Too many members; you may only have $MaxMembers members per group',
		4297 => 'Cannot append to $Gtmp: $!',
		4298 => 'Cannot append to $Htgtmp: $!',
		4299 => 'Group $group already exists',
		4301 => 'No response from $IP',
		4302 => 'Nameserver timed out',
		4303 => 'Cannot create socket: $!',
		4304 => 'Cannot connect: $!',
		4320 => 'Invalid port',
		4321 => 'Unrecognized host $remote',
		4322 => 'Cannot run $Nbplkup: $!',
		4350 => 'Cannot read $Net_cfg: $!',
		4351 => 'Cannot read /proc/sys/kernel/hostname: $!',
		4352 => 'Cannot run $Ifconfig_cmd: $!',
		4353 => 'Cannot run $Ifconfig_cmd: $!',
		4354 => 'Cannot write $Resolvconf',
		4355 => 'Cannot read $Resolvconf: $!\n',
		4356 => 'ȃQ[gEFC: $gaw',
		4357 => 'zXg͎̃Q[gEFCɂ͂Ȃ܂B',
		4358 => 'Cannot read /proc/net/dev: $!',
		4359 => '[eBO e[uǂݏo܂: $!',
		4360 => ' ip AhX: $addr',
		4361 => '$Net_cfg Cł܂: $!',
		4362 => '$Net_cfg ̓bNĂ܂BzXgݒł܂B',
		4363 => 'Invalid character in name server address',
		4364 => 'IPAhXݒł܂: ifcfg-$netif ̓bNĂ܂B',
		4365 => 'C^[tFCX̍\t@C ifcfg-$netif ǂݏo܂: $!',
		4366 => 'C^[tFCX̍\t@C ifcfg-$netif Cł܂: $!',
		4367 => '$Net_cfg ̓bNĂ܂BQ[gEFCݒł܂B',
		4368 => 'Cannot read $Net_cfg: $!',
		4369 => '$Net_cfg Cł܂: $!',
		4370 => 'ȃzXg: $name',
		4371 => '\񂳂ꂽO: localhost',
		4372 => 'Cannot reconfigure network: system busy',
		4373 => 'Invalid domain name $domain',
                4374 => 'Invalid IP address: $ip',
		4375 => 'Cannot reconfigure network: system busy',
		4376 => 'ȃO[v: $group',
		4380 => 'UID $uid ̊Ălł܂: $!',
		4381 => 'UID $uid ̊Ăݒł܂: $!',
		4382 => 'UID $uid ̊Ă𓯊ł܂: $!',
		4383 => 'Cannot run df on $dir; $!',
		4384 => '$dir ̃t@CVXe𗝉ł܂B',
		4385 => '$id ̊Ălł܂: $!',
		4401 => 'Users_dir/$Access_file 폜ł܂: $!',
		4402 => 'Users_dir/$Access_file ɏ߂܂: $!',
		4403 => 'Groups_dir/$Access_file 폜ł܂: $!',
		4404 => 'Groups_dir/$Access_file ɏ߂܂: $!',
		4416 => '$Inetd_conf is locked',
		4417 => '$Sysinit_script ɏ߂܂: $!',
		4418 => '$Sysinit_script ǂݏo܂: $!',
		4419 => '$Sysinit_script bNł܂: $!',
		4420 => '$Mailscript ւ̃N쐬ł܂: $!',
		4421 => '[ T[o~ł܂: $!',
		4422 => '$Sysinit_script ɏ߂܂: $!',
		4423 => 'N $Smblink 쐬ł܂: $!',
		4424 => 'smb T[rX~ł܂: $!',
		4425 => 'Cannot create nfs link: $!',
		4426 => 'Cannot stop nfs server: $!',
		4427 => 'N $Atalklink 쐬ł܂: $!',
		4428 => 'AppleShare T[o~ł܂: $!',
		4429 => 'Cannot create $Nologin: #!',
		4430 => '$Inetd_conf ǂݏo܂: $!',
		4431 => '$Sysinit_script ǂݏo܂: $!',
		4432 => '$Inetd_conf ǂݏo܂: $!',
		4433 => '$Lockdir/inetd.conf ɏ߂܂: $!',
		4434 => '$Inetd_conf uł܂: $!',
		4435 => '$Sysinit_script bNł܂: $!',
		4436 => '$Inetd_conf ǂݏo܂: $!',
		4437 => '$Lockdir/inetd.conf ɏ߂܂: $!',
		4438 => '$Inetd_conf uł܂: $!',
		4439 => '$Inetd_conf is locked',
		4440 => '$Inetd_conf ǂݏo܂: $!',
		4441 => '$Lockdir/inetd.conf ɏ߂܂: $!',
		4442 => '$Inetd_conf uł܂: $!',
		4443 => '$Inetd_conf is locked',
		4444 => '$Inetd_conf ǂݏo܂: $!',
		4445 => '$Lockdir/inetd.conf ɏ߂܂: $!',
		4446 => '$Inetd_conf uł܂: $!',
		4447 => 'Cannot write exports file $Exports_file: $!',
		4448 => 'Cannot reread exports list: $!',
		4449 => 'Invalid export host $allow1',
		4450 => 'Cannot read load average: $!',
		4451 => 'Cannot run $Ps_cmd: $!',
		4452 => 'Cannot stop portmapper: $!',
		4453 => '$Inetd_conf is locked',
		4454 => '$Inetd_conf ǂݏo܂: $!',
		4455 => '$Lockdir/inetd.conf ɏ߂܂: $!',
		4456 => '$Inetd_conf uł܂: $!',
		4457 => '$Inetd_conf is locked',
		4458 => '$Inetd_conf ǂݏo܂: $!',
		4459 => '$Lockdir/inetd.conf ɏ߂܂: $!',
		4460 => '$Inetd_conf uł܂: $!',
		4461 => '$Inetd_conf ǂݏo܂: $!',
		4462 => 'Invalid export host $allow2',
		4463 => 'Cannot read exports file $Exports_file: $!',
		4464 => 'smb.conf ̓bNĂ܂B',
		4465 => 'samba \t@C $Lockdir/smb.conf ɏ߂܂: $!',
		4466 => 'vZX Xg LbVǂݏo܂: $!',
		4467 => 'smb.conf ̓bNĂ܂B',
		4468 => 'samba \t@C $Lockdir/smb.conf ɏ߂܂: $!',
		4469 => 'fBNg $top ǂݏo܂: $!',
		4470 => '$Inetd_conf is locked',
		4480 => 'tݒł܂: $!',
		4481 => 'f[^ۑł܂: $!',
		4483 => 'Invalid time zone $zone',
		4484 => '^C][ύXł܂: $!',
		4485 => '^C][	ݒł܂: $!',
		4486 => 'ȎԌ`',
		4487 => 'Cannot create link $SNMPlink: $!',
		4488 => 'Cannot break link $SNMPlink: $!',
                4489 => 'Cannot create link $NTPlink: $!',
                4490 => 'Cannot break link $NTPlink: $!',
		4500 => '[U $username ͊ɑ݂܂B',
		4501 => '[UɃR܂߂邱Ƃ͂ł܂B',
		4502 => '$Adminuser 폜ł܂B',
		4503 => '$username 쐬ł܂: fBNg $homedir ͊ɑ݂܂B',
		4504 => '̃[U݂͑܂B',
		4505 => 'OɃR܂߂邱Ƃ͂ł܂B',
		4506 => '$Uid_file ɏ߂܂: $!',
		4507 => 'pX[h t@CbNĂ܂B',
		4508 => '$Passwd bNł܂: $!',
		4509 => '$Ptmp bNł܂: $!',
		4510 => '$Passwd  $Ptmp Œuł܂: $!',
		4511 => '$Htpasswd  $Htptmp Œuł܂: $!',
		4512 => 'ptmp t@C $Ptmp 폜ł܂: $!',
		4513 => 'htptmp t@C $Htptmp 폜ł܂: $!',
		4514 => 'j UID',
		4515 => '$Ptmp ɕtł܂: $!',
		4516 => '$Htptmp ɕtł܂: $!',
		4517 => '[U폜邽߂ $Ptmp J܂: $!',
		4518 => '$Lockdir/passwd 폜ł܂: $!',
		4519 => '$Ptmp ړł܂: $!',
		4520 => 'htpasswd t@C $Htpasswd J܂: $!',
		4521 => '$Htptmp 폜ł܂: $!',
		4522 => 'Cannot delete $username: prohibited user',
		4523 => 'Cannot modify $name: no such user',
		4524 => 'Cannot modify $name: prohibited user',
		4525 => '[UĂ $warn_quota ȏɂ͐ݒł܂B',
		4527 => 'z[ fBNg $homedir 쐬ł܂: $!',
		4528 => '$homedir/$Private_html 쐬ł܂: $!',
		4529 => 'lbg[N̂ݔtH_쐬ł܂: $!',
		4530 => 'Name $username is already in use as a group',
		4531 => '$username ɂ̓t@C܂B',
		4532 => '$Ptmp ǂݏo܂: $!',
		4533 => 'ꎞt@C $Lockdir/passwd ɏ߂܂: $!',
		4534 => 'pX[hɐ䕶܂߂邱Ƃ͂ł܂B',
		4535 => 'w肵pX[h܂BpX[h $MaxPassLen łȂ΂Ȃ܂B',
		4536 => 'w肵pX[hZ܂BpX[h $MinPassLen ȏłȂ΂Ȃ܂B',
		4537 => 'fBNg $top ǂݏo܂: $!',
		4538 => '$Ptmp ǂݏo܂: $!',
		4539 => '\[X t@C $User_skel/$htmlfile J܂: $!',
		4540 => '$Htptmp ̖OύXł܂: $!',
		4541 => 'ꎞt@C $Lockdir/passwd ɏ߂܂: $!',
		4542 => 't@C $homedir/$htmlfile J܂: $!',
		4543 => 'ȃ[U: $username',
		4544 => 'The quota must be a positive integer',  #***
		4545 => 'Name $username is already in use as a mailing list or alias',
		4546 => '$username ͗\񂳂ꂽOłB',
		4547 => '$Htptmp 폜ł܂: $!',
		4548 => '$Htptmp ̖OύXł܂: $!',
		4549 => 'htpasswd t@C $Htpasswd J܂: $!',
		4550 => '\[X t@C $User_skel/index.html J܂: $!',
		4551 => '\[X t@C $src J܂: $!',
		4552 => 't@C $dest J܂: $!',
		4553 => 't@C $homedir/index.html J܂: $!',
		4554 => 'Names must be no longer than $MaxNameLen characters.',
		4555 => 'User quotas may not exceed $warn_quota',
		4570 => '\[X t@C $User_skel/private.tmpl J܂: $!',
		4571 => 't@C $homedir/index.html J܂: $!',
                4585 => 'Cannot update the web server configuration file',
                4586 => 'Virtual name-based web server $addr does not exist.',
                4587 => 'Cannot open web configuration',
                4588 => 'Web configuration in use, please try again',
                4589 => 'Cannot update the web server configuration file',
		4600 => 'Email alias list in use, please try again soon',
                4601 => 'Could not modify email alias list.',
		4602 => 'Email alias list in use, please try again soon',
		4603 => 'Email alias list in use, please try again soon',
		4604 => 'Email alias list in use, please try again soon',
		4605 => 'Could not modify email alias list.',
                4650 => 'Cannot write ftp configuration file: $!',
                4651 => 'FTP server in use, please try again soon',
                4652 => 'FTP virtual host $ip not found',
                4653 => 'Could not edit FTP configuration',
                4654 => 'Cannot read the ftp configuration file: $!',
		4701 => 'sȃT[rX',
		4702 => 'inetd X^[gł܂B',
		4703 => '$Servers{$server} _E܂܂łB',
		4705 => 'dq[𑗐Mł܂: $!',
		4706 => 'cron X^[gł܂B',
		4707 => 'custo X^[gł܂B',
		4708 => 'portmap vZXX^[gł܂B',
		4709 => 'LCD X^[gł܂B',
		4710 => 'Unable to restart web server',
		4711 => 'Unable to restart administrative web server',
		4712 => 'Cannot run $Smb_testparm: $!',
		4713 => 'Unable to restart ntp',
		4714 => 'Unable to restart snmp',
		4715 => 'Unable to restart ssl',
		4740 => 'Cannot write IP filter rules',
		4741 => 'Cannot set IP filter boot script: $!',
		4742 => 'Cannot run IP filter script: $!',
		4743 => 'Cannot read IP filter configuration: $!',
		4744 => 'Cannot read default IP filter configuration: $!',
		4745 => 'Unable to flush filter rules: $!',
		4746 => 'Invalid source IP $src_ip',
		4747 => 'Invalid source netmask $src_mask',
		4748 => 'Invalid source port $src_port',
		4749 => 'Invalid destination IP $dst_ip',
		4750 => 'Invalid destination netmask $dst_mask',
		4751 => 'Invalid destination port $dst_port',
		4752 => 'Unknown protocol $proto',
		4753 => 'Invalid policy $policy',
		4754 => 'Your address is blocked by: $pol $src_ip/$src_mask => $dst_ip/$dst_mask',
		4755 => 'Your address is blocked by the default rule',
		4756 => 'You cannot specify a port without a protocol',
		4757 => 'Rule number $rc is invalid: $2',
		4758 => 'Invalid ruleset $rule: $2',
		4850 => '$Named_disabled  $Named_boot ɃRs[ł܂: $!',
		4851 => 'DNS T[őNɎs܂: $!',
		4852 => '$Named_boot ɏ߂܂: $!',
		4853 => 'DNS T[őNɎs܂: $!',
		4854 => 'DNS T[o̒~Ɏs܂: $!',
		4856 => '$Named_boot ̖O $Named_disabled ɕύXł܂: $!',
		4857 => '$Named_pid ǂݏo܂: $!',
		);

    if ($errs{$errnum})
    {
	return $errs{$errnum};
    }
    else
    {
	# We should never see this
	return "Cobalt error number $errnum";
    }
}

use Cobalt::Language;

1;
