# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from List.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Aliasfile = "/etc/aliases";
my $Altmp = "/etc/locks/altmp";
my $Lockdir = "/etc/locks";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/List.pm.  Changes made here will be lost.
package Cobalt::List;

sub alias_delete
# Remove the specified aliases from the aliasfile
# Arguments: array of aliases to be removed
# Return value: number of actual aliases removed
{
    my (@aliases) = @_;
    my ($lock, $line, $count);
    return("2069 Aliases deleted successfully") if ($#aliases < 0);
    return $lock if (($lock = Cobalt::List::lock_aliases()) !~ /^2/);
    open(ALIAS, $Aliasfile) ||
	Cobalt::List::abort("4406 Cannot read from /etc/aliases: $!");
    open( ALIAS_NEW, "> $Lockdir/aliases") ||
	Cobalt::List::abort("4407 Cannot write to /etc/locks/aliases: $!");
    while ($line = <ALIAS>) {
	my ($alias) = split(/:/, $line);
	print ALIAS_NEW $line unless grep /$alias/, @aliases;
	++$count;
    }
    close ALIAS;
    close ALIAS_NEW;
    rename ("$Lockdir/aliases", $Altmp) ||
	Cobalt::List::abort("4408 Cannot rename /etc/locks/aliases: $!");
    return Cobalt::List::abort($lock) if (($lock = Cobalt::List::commit_aliases()) !~ /^2/);
    return("4409 Invalid aliases specified") unless $count;
    return("2070 Aliases deleted successfully");
}


1;
