# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from List.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Aliasfile = "/etc/aliases";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/List.pm.  Changes made here will be lost.
package Cobalt::List;

sub alias_get_bytarget
# Returns all the aliases which go to a given target
#   In other words, if the aliases file looks like:
#     ron.decline: ron
#     rdecline: ron
#   then alias_get_bytarget("ron") would return ("ron.decline","rdecline");
# Arguments: recipient address
# Return value: an array of ( alias1, alias2, ... )
# Note: group aliases all go into the majordomo aliases file, so we don't
#   need to filter those out.  The only alias we could collide with would
#   be forwarding aliases.
{
    my ($target) = @_;
    my @list;
    "joe: $target" =~ /^(.+):\s*$target\s*$/;  # precompile the regexp
    open (ALIAS, "$Aliasfile") || return ("4395 Cannot read from /etc/aliases: $!");
    while ( <ALIAS> ) {
      if (//) {
	next if (Cobalt::User::user_exist($1));  # skip forwarding aliases
	push(@list,$1);
      }
    }
    close ALIAS;
    return @list;
}


1;
