# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from List.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Aliasfile = "/etc/aliases";
my $Altmp = "/etc/locks/altmp";
my $Lockdir = "/etc/locks";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/List.pm.  Changes made here will be lost.
package Cobalt::List;

sub alias_set
# Update aliases of the given user with the provided list
# Arguments: user name, new array of aliases
# Return value: number of actual aliases set
{
    my ($user, @aliases) = @_;
    return "4398 You cannot have a mailing list or alias which points to itself or which includes itself as a member." if (grep(/^$user$/,@aliases));
    my $lock;
    return $lock if (($lock = Cobalt::List::lock_aliases()) !~ /^2/);
    open(ALIAS, $Aliasfile) ||
	Cobalt::List::abort("4399 Cannot read from /etc/aliases: $!");
    open( ALIAS_NEW, "> $Lockdir/aliases") ||
	Cobalt::List::abort("4400 Cannot write to /etc/locks/aliases: $!");
    "$user:" =~ /^$user:/; # compile once per function call
    while (<ALIAS>) {
	print ALIAS_NEW unless (//);
    }
    close ALIAS;
    print ALIAS_NEW "$user:\t" . join(", ", Cobalt::List::uniq(sort @aliases)) . "\n"
	if ($#aliases >= 0);
    close ALIAS_NEW;
    rename ("$Lockdir/aliases", $Altmp) ||
	Cobalt::List::abort("4405 Cannot rename /etc/locks/aliases: $!");
    return Cobalt::List::abort($lock) if (($lock = Cobalt::List::commit_aliases()) !~ /^2/);
    return("2066 Alias set successfully");
}


1;
