# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from List.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Lockdir = "/etc/locks";
my $Majordomo_dir = "/usr/local/majordomo";
my $Majordomo_group = "daemon";
my $Majordomo_user = "admin";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/List.pm.  Changes made here will be lost.
package Cobalt::List;

sub list_config_update
# Update the config info for a list
# Arguments: list name, config variable, config value
# Return value: 1 on success, 0 means failure
{
    my ($list, $var, $val) = @_;
    my $lock;
    return $lock if (($lock = Cobalt::List::lock_aliases()) !~ /^2/);
    $list =~ tr[A-Z][a-z];	# lowercase the characters
    open (LIST, "< $Majordomo_dir/lists/$list.config") ||
	Cobalt::List::abort("4497 Cannot read configuration file for $list: $!");
    open (LIST_NEW, "> $Lockdir/$list.config") ||
	Cobalt::List::abort("4498 Cannot write to /etc/locks/$list.config: $!");
    while (<LIST>) {
	if (/^$var/o) {
	    print LIST_NEW "$var = $val\n";
	}
	else {
	    print LIST_NEW;
	}
    }
    close LIST;
    close LIST_NEW;
    Cobalt::Utility::sauce_cp("$Lockdir/$list.config", "$Majordomo_dir/lists/$list.config")||
	Cobalt::List::abort("4499 Cannot copy /etc/locks/$list.config: $!");
    unlink ("$Lockdir/$list.config") ||
	Cobalt::List::abort("4514 Cannot unlink /etc/locks/$list.config: $!");
    chmod 0664, "$Majordomo_dir/lists/$list.config";
    chown (scalar getpwnam($Majordomo_user), scalar getgrnam($Majordomo_group),
        "$Majordomo_dir/lists/$list.config");
    Cobalt::List::unlock_aliases();
    return ("2081 List configuration updated successfully");
}


1;
