# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from List.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Majordomo_aliases = "/etc/aliases.majordomo";
my $Majordomo_dir = "/usr/local/majordomo";
my $Majordomo_group = "daemon";
my $Majordomo_list_owner = "admin";
my $Majordomo_user = "admin";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/List.pm.  Changes made here will be lost.
package Cobalt::List;

sub list_create
# Create a list with the specified membership
# Arguments: array of list name, members
# Return value: number of members actually added, 0 otherwise
# Side effects: add/udpate file(s) belonging to the list
{
    my ($list, @members) = @_;
    my $lock;
    $list =~ tr[A-Z][a-z];	# lowercase the characters
    return ("4411 List $list already exists")
	if (-e "$Majordomo_dir/lists/$list");
#    return "4999 list_invalid_adding_self" if (grep(/^$list$/,@members));
    return $lock if (($lock = Cobalt::List::lock_aliases()) !~ /^2/);
    open( LIST, "> $Majordomo_dir/lists/$list" ) ||
	Cobalt::List::abort("4412 Cannot write to /usr/local/majordomo/lists/$list: $!");
    print LIST join "\n", Cobalt::List::uniq(sort @members);
    if ($#members < 0) {
	print LIST "nobody\n";
    }
    else {
	print LIST "\n";
    }
    close LIST;
    chmod 0664, "$Majordomo_dir/lists/$list";
    chown (scalar getpwnam($Majordomo_user), scalar getgrnam($Majordomo_group),
        "$Majordomo_dir/lists/$list");
    open( ALIAS, ">> $Majordomo_aliases") ||
	Cobalt::List::abort("4413 Cannot append to /etc/aliases.majordomo: $!");
    print ALIAS "$list:\t\"|$Majordomo_dir/wrapper resend -l $list $list-list\"\n";
    print ALIAS "$list-list:\t:include:$Majordomo_dir/lists/$list\n";
    print ALIAS "owner-$list:\t$Majordomo_list_owner\n";
    print ALIAS "$list-request:\t\"|$Majordomo_dir/wrapper request-answer $list\"\n";
    print ALIAS "$list-approval:\t$Majordomo_list_owner\n\n";
    close ALIAS;
    return Cobalt::List::abort($lock) if (($lock = Cobalt::List::commit_aliases()) !~ /^2/);

    # cannot send mail during installation or sysreset
    # kludge..never do it -- gsri
#    if (-e "$Majordomo_aliases") {
#       open (MAIL, "| $Mail_cmd majordomo") ||
#           return ("4999 list_cant_send_mail");
#       print MAIL "\nconfig $list $list.gooey\n";
#       close MAIL;
#    }
    return("2071 List created successfully: $list");
}


1;
