# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from List.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Majordomo_dir = "/usr/local/majordomo";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/List.pm.  Changes made here will be lost.
package Cobalt::List;

######################################################

sub list_lists
# Returns a list of all the mailing lists
# Arguments: none
# Return value: an array of all the mailing lists
{
    opendir (DIR, "$Majordomo_dir/lists") ||
	return ("4496 Cannot open /usr/local/majordomo/lists: $!");

    my (@lists, $list);
    foreach $list (sort readdir (DIR)) {
        next if ($list =~ /[^-_0-9a-z]/);       # skip non-list files
        next if ($list =~ /^(RCS|CVS|core)$/);  # files and directories to ignore
        next if (-d "$Majordomo_dir/lists/$list"); # skip directories
	push @lists, $list;
    }

    closedir (DIR);
    return @lists;
}


1;
