# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from List.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Lockdir = "/etc/locks";
my $Majordomo_dir = "/usr/local/majordomo";
my $Majordomo_group = "daemon";
my $Majordomo_user = "admin";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/List.pm.  Changes made here will be lost.
package Cobalt::List;

sub list_set_mem
# (Re)sets the membership of a list
# Arguments: list name
# Return value: number of members if successful, 0 if not
# Side effects: modify list membership file
{
    my ($list, @members) = @_;
    $list =~ tr[A-Z][a-z];	# lowercase the characters
    return "4492 You cannot have a mailing list or alias which points to itself or which includes itself as a member." if (grep(/^$list$/,@members));
    my $lock;
    return $lock if (($lock = Cobalt::List::lock_aliases()) !~ /^2/);
    open( LIST, "> $Lockdir/$list.majordomo" ) ||
	Cobalt::List::abort("4493 Cannot write to /etc/locks/$list.majordomo: $!");
    print LIST join "\n", Cobalt::List::uniq(sort @members);
    if ($#members < 0) {
	print LIST "nobody\n";
    }
    else {
	print LIST "\n";
    }
    close LIST;
    Cobalt::Utility::sauce_cp("$Lockdir/$list.majordomo", "$Majordomo_dir/lists/$list") ||
	Cobalt::List::abort("4494 Cannot copy /etc/locks/$list.majordomo: $!");
    unlink ("$Lockdir/$list.majordomo") ||
	Cobalt::List::abort("4495 Cannot unlink /etc/locks/$list.majordomo: $!");
    chmod 0664, "$Majordomo_dir/lists/$list";
    chown (scalar getpwnam($Majordomo_user), scalar getgrnam($Majordomo_group),
        "$Majordomo_dir/lists/$list");
    Cobalt::List::unlock_aliases();
    return("2073 List membership set successfully: $list");
}


1;
