# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from List.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $MainGroup = "home";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/List.pm.  Changes made here will be lost.
package Cobalt::List;

sub list_sites_create
# Create a list for a particular site
# Arguments: site group name, listname, members
# Return value: true if successful, false otherwise
{
    my ($group, $list, @members) = @_;
    my $ret;
    $list =~ tr[A-Z][a-z];	# lowercase the characters
    return $ret if (($ret = list_create("${list}_${group}", @members)) !~ /^2/);

    # i don't really like this code here -- gsri
    # add entries to virtusertable so $list@$fqdn works
    my $fqdn = ($group eq $MainGroup) ?
	netutil_get_fulldomain() : (vsite_get_bygroup($group))[1];
    my %alias = ("${list}\@${fqdn}" => "${list}_${group}",
		 "${list}-list\@${fqdn}" => "${list}_${group}-list",
		 "${list}-approval\@${fqdn}" => "${list}_${group}-approval",
		 "${list}-request\@${fqdn}" => "${list}_${group}-request",
		 "owner-${list}\@${fqdn}" => "owner-${list}_${group}");
    return $ret if (($ret = mail_virtuser_add_alias(%alias)) !~ /^2/);

    return ("2077 List created successfully: $list");
}


1;
