# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from List.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Aliasfile = "/etc/aliases";
my $Altmp = "/etc/locks/altmp";
my $Lockdir = "/etc/locks";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/List.pm.  Changes made here will be lost.
package Cobalt::List;

######################################################

sub lock_aliases
# Lock the aliases file so that nobody can collide with us.
# Arguments: none
# Side effects: copies /etc/aliases to /etc/altmp
{
    if (-e $Altmp)
    {
	return ("4261 The aliases file is locked.");
    }
    else
    {
	# Lock the aliases file by creating the altmp file as a
	# copy of the aliases file.
	print STDERR "Copying aliases file $Aliasfile to $Altmp\n" if ($Debug);
	Cobalt::Utility::sauce_cp($Aliasfile,$Altmp);
    }
    print STDERR "Locked $Aliasfile with $Altmp\n" if ($Debug);

    open(LOCK,">$Lockdir/list-$$")
      || Cobalt::List::abort("4266 Cannot get aliases file lock: $!");
    print LOCK "$$\n$0";
    close LOCK;

    return "2260 Aliases file has been locked";
}


1;
