# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Mail.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Console = "/dev/console";
my $MailDenyFile = "/etc/mail/deny";
my $MakeMap_cmd = "/usr/bin/makemap";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Mail.pm.  Changes made here will be lost.
package Cobalt::Mail;

sub mail_set_deny
# Set the list of domains we refuse to accept mail from
# Arguments: list of domain or host names
# Side effects: modifies /etc/mail/deny and rebuilds deny.db
# Example: mail_set_deny("cybersell.com","owlsnest.com");
{
    my @spammers = @_;
    open(DENY,">$MailDenyFile") ||
	return "4160 Cannot write mail deny file $MailDenyFile: $!";
    print DENY join("\tMail refused\n",@spammers);
    print DENY "\tMail refused\n";
    close DENY;
    print STDERR "$MakeMap_cmd hash $MailDenyFile < $MailDenyFile"
	if ($Debug);
    system("$MakeMap_cmd hash $MailDenyFile < $MailDenyFile >$Console 2>&1");
    return "2143 Set mail site blocking";
}


1;
