# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Mail.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Lockdir = "/etc/locks";
my $Sendmail_conf = "/etc/sendmail.cf";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Mail.pm.  Changes made here will be lost.
package Cobalt::Mail;

sub mail_set_masq
# Set the domain that we want to masquerade as
# Arguments: domain name, or blank for no masquerading
# Side effects: edits sendmail.cf, restarts sendmail
# Example: mail_set_masq("cobaltmicro.com");
{
    my ($masqas) = @_;
    $masqas ||= '';
    return "4155 Cannot configure mail server: system is busy"
	if (-e "$Lockdir/sendmail.cf");
    unless (open(SO,">$Lockdir/sendmail.cf"))
    {
	return "4156 Cannot lock mail server config file: $!";
    }
    unless (open(SI,$Sendmail_conf))
    {
	unlink("$Lockdir/sendmail.cf");
	return "4157 Cannot read mail server config file: $!";
    }
    while (<SI>)
    {
	if (/^DM/o)
	{
	    print SO "DM$masqas\n";
	}
	else
	{
	    print SO;
	}
    }
    close SI;
    close SO;
    unless (rename("$Lockdir/sendmail.cf",$Sendmail_conf))
    {
	unlink("$Lockdir/sendmail.cf");
	return "4158 Cannot read mail server config file: $!";
    }
    return "2141 Set mail masquerading to $masqas";
}


1;
