# This file was built automatically from Messages.pm

# Copyright 1998 Cobalt Microserver (http://www.cobaltmicro.com)

use strict;
### START HARDCODED PATHS
my $Debug = "0";
my $Htgroup_dir = "/home/httpd/html/groups";
my $UserServer_dir = "/home/httpd";
my $Userdir = "/home/httpd/html/users";
my %Disks = ("/home","[U","/var","Xv[","/","VXe");
my %Servers = ("smb","Windows t@CL (SMB)","adm","ǗEFu T[o","mail","dq[","www","EFu T[o","dns","Domain Name Service (DNS)","net","lbg[N","nfs","UNIX t@CL (NFS)","cpu","CPU","ftp","File Transfer Protocol (FTP)","disk","fBXN","atalk","Apple t@CL (AppleShare)","mem","");
my %Status = ("none","0","0","none","green","1","1","green","2","yellow","red","3","3","red","yellow","2");
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = $Debug;
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Messages.pm.  Changes made here will be lost.
package Cobalt::Messages;

sub msg_build_alert
# Build the message
# Arguments: ($server,$inst,$severity,$ctime,$mtime,$data1,$data2,$data3,$status);
#   $server:     the name of the server (or service); e.g., "disk",
#                "ftp", or "smb".
#   $inst:       a particular subsystem or instance of the server;
#                for example, the "disk" server has an instance for
#                each disk, and for each user and group quota.
#   $severity:   A number indicating the state of this instance 
#                1 = green, 2 = yellow, 3 = red
#   $ctime:      The time at which this severity was entered
#   $mtime:      The time when this particular report was generated
#   $data1, $data2, $data3, $status:  Additional information, defined per
#                service and instance
# Return value: a nicely stated message string
{
    my ($server,$inst,$severity,$ctime,$mtime,$data1,$data2,$data3,$status) = @_;

    # To make things easy, just make a mapping between severity and
    # the adverb which describes that severity
    # 1 = green, 2 = yellow, 3 = red
    my %adverbs = (1 => "lightly",
		   2 => "moderately",
		   3 => "heavily",
		   );
    
    my ($message);
    $severity = -1 unless (defined($severity));

    my $time = msg_localtime($ctime);

    if    ($server eq "adm")  # Administrative web server
    {
	if ($severity == $Status{"green"})
	{
	    $message = "The $Servers{$server} server has been running normally since $time";
	} elsif ($severity == -1) {
	    $message = "No information is available for $Servers{$server}.  The service is not active or has not yet been examined.";
	} else {
	    $message = "The $Servers{$server} server has not been responding since $time";
	}
    }
    elsif ($server eq "atalk")  # Appletalk server
    {
	if ($severity == $Status{"green"}) { 
	    $message = "The $Servers{$server} server has been running normally since $time";
	} elsif ($severity == -1) {
	    $message = "No information is available for $Servers{$server}.  The service is not active or has not yet been examined.";
	} else {
	    $message = "The $Servers{$server} server has not been responding since $time";
	}
    }
    elsif ($server eq "cpu")  # CPU load
    {
	# data1 is the load average
	if ($severity == -1)
	{
	    $message = "No information has been gathered yet.  Reports are generated every 15 minutes.";
	}
	else
	{
	    $message = "Over the past fifteen minutes, the CPU has been $adverbs{$severity} loaded [ load average $data1 ]";
	}
    }
    elsif ($server eq "crond")  # scheduled command daemon
    {
	# user never sees this
	if ($severity == $Status{"green"}) { 
	    $message = "crond is running normally since $time";
	} elsif ($severity == -1) {
	    $message = "No information is available for $Servers{$server}.  Most likely the service has not yet been examined.";
	} else {
	    $message = "crond is not running since $time";
	}
    }
    elsif ($server eq "custo")  # independent cron monitor daemon
    {
	# user never sees this
	if ($severity == $Status{"green"}) { 
	    $message = "custo is running normally since $time";
	} elsif ($severity == -1) {
	    $message = "No information is available for $Servers{$server}.  The service is not active or has not yet been examined.";
	} else {
	    $message = "custo is not running since $time";
	}
    }
    elsif ($server eq "disk")
    {
	if ($severity == -1)
	{
	    return "No disk usage information is available.  Disk usage reports will be generated hourly.";
	}
	if    ($inst =~ /^(.+),0$/o) # user quota
	{
	    # $data1 is the percent of the quota used
	    $message = "User $1 is at $data1% of quota";
	}
	elsif ($inst =~ /^(.+),1$/o) # group quota
	{
	    # $data1 is the percent of the quota used
	    $message = "Group $1 is at $data1% of quota";
	}
	elsif ($inst =~ /^(.+),mail$/o) # user mail spool
	{
	    # data1 is the size (in kb) of the user's mail spool
	    $message = "User $1 has $data1 kilobytes of mail";
	}
	elsif ($inst =~ /^$UserServer_dir/o) # area usage
	{
	    # $data1 is the usage in bytes 
	    if ($inst eq $Userdir)
	    {
		$message = "$data1 bytes used in the user area";
	    }
	    elsif ($inst eq $Htgroup_dir)
	    {
		$message = "$data1 bytes used in the group area";
	    }
	    else
	    {
		$message = "$inst is using $data1 bytes";
	    }
	}
	elsif ($inst =~ /^\//o) # disk usage per partition
	{
	    # $data1 is the percent of capacity used
	    $message = "$Disks{$inst} area of the disk is $data1% full";
	}
    }
    elsif ($server eq "dns")
    {
	if    ($inst eq "dns")  # check that name service answers on its port
	{
	    if ($severity == $Status{"green"}) {
		$message = "The $Servers{$server} server has been running normally since $time";
	    } elsif ($severity == -1) {
		$message = "No information is available for the $Servers{$server} server.  The service is not active or has not yet been examined.";
	    } else {
		$message = "The $Servers{$server} server not been responding since $time";
	    }
	}
	elsif ($inst eq "named") # name server process
	{
	    if ($severity == $Status{"green"}) { 
		$message = "The $Servers{$server} server process has been running normally since $time";
	    } elsif ($severity == -1) {
		$message = "No information is available for the $Servers{$server} server.  The service is not active or has not yet been examined.";
	    } else { 
		$message = "The $Servers{$server} server process has not been responding since $time";
	    }
	}
    }
    elsif ($server eq "ftp")  # FTP server (run via inetd)
    {
	if ($severity == $Status{"green"}) { 
	    $message = "The $Servers{$server} server has been running normally since $time";
	} elsif ($severity == -1) {
	    $message = "No information is available for $Servers{$server}.  The service is not active or has not yet been examined.";
	} else {
	    $message = "The $Servers{$server} server has not been responding since $time";
	}
    }
    elsif ($server eq "inetd")  # master internet service broker
    {
	# user never sees this
	if ($severity == $Status{"green"}) { 
	    $message = "The inetd process is running normally since $time";
	} elsif ($severity == -1) {
	    $message = "No information is available for inetd.  The service is not active or has not yet been examined.";
	} else {
	    $message = "The inetd process is not running since $time";
	}
    }
    elsif ($server eq "lcd")  # the LCD panel process
    {
	# user never sees this
	if ($severity == $Status{"green"}) { 
	    $message = "The lcdsleep process is running normally since $time";
	} elsif ($severity == -1) {
	    $message = "No information is available for lcdsleep.  Most likely the process has not yet been checked.";
	} else {
	    $message = "The lcdsleep process is not running since $time";
	}
    }
    elsif ($server eq "mail")
    {
	if ($severity == -1) {
	    $message = "No information is available for the $inst server.  Mail service is not active or has not yet been examined.";
	}

	if    ($inst eq "SMTP")  # SMTP server
	{
	    if ($severity == $Status{"green"}) { 
		$message = "The $inst server has been running normally since $time";
	    } elsif ($severity == -1) {
		$message = "No information is available for the $inst server.  Mail service is not active or has not yet been examined.";
	    } else {
		$message = "The $inst server has not been responding since $time";
	    }
	}
	elsif ($inst eq "POP3")  # POP3 server (run via inetd)
	{
	    if ($severity == $Status{"green"}) { 
		$message = "The $inst server has been running normally since $time";
	    } elsif ($severity == -1) {
		$message = "No information is available for the $inst server.  Mail service is not active or has not yet been examined.";
	    } else {
		$message = "The $inst server has not been responding since $time";
	    }
	}
	elsif ($inst eq "IMAP")  # IMAP server (run via inetd)
	{
	    if ($severity == $Status{"green"}) { 
		$message = "The $inst server has been running normally since $time";
	    } elsif ($severity == -1) {
		$message = "No information is available for $Servers{$server}.  Mail service is not active or has not yet been examined.";
	    } else {
		$message = "The $inst server has not been responding since $time";
	    }
	}
    }
    elsif ($server eq "mem")
    {
	if ($severity == -1)
	{
	    return "No memory usage information is available yet.  Reports are generated every 15 minutes.";
	}
	if    ($inst eq "swapping")  # how much swapping is going on?
	{
	    # data3 is the number of swaps per second
	    $message = "Over the past fifteen minutes, virtual memory has been $adverbs{$severity} used [ $data3 swaps/second ]";
	}
	elsif ($inst eq "vmem")  # virtual memory use
	{
	    # data1 is the percentage of virtual memory used
	    $message = "$data1% of virtual memory is in use";
	}
    }
    elsif ($server eq "net")
    {
	if ($severity == -1)
	{
	    return "No information on the network is available yet.  Reports will be generated every 15 minutes.";
	}

	if    ($inst eq "collisions")  # collisions since boot
	{
	    # data1 is the collision rate since boot

	    if (! $severity)
	    {
		$message = "The Cobalt Qube's network interface has been idle since boot.";
	    }
	    else
	    {
		# how long have we been up?
		open(UPTIME,"/proc/uptime") 
		    || die "Cannot read /proc/uptime: $!\n";
		my $uptime = (split('\s',<UPTIME>))[0];  
		close UPTIME;
		
		my $since = $uptime - ($^T - $mtime);
		my $days = int($since / 86400);
		if ($days)
		{
		    ($since -= ($days * 86400));
		    $days = "$days days ";
		}
		else
		{
		    $days = "";
		}
		my $hours = int($since / 3600);
		if ($hours)
		{
		    ($since -= ($hours * 3600));
		    $hours = "$hours hours ";
		}
		else
		{
		    $hours = "";
		}
		my $mins = int($since / 60);
		($mins) ? ($mins = "$mins minutes") : ($mins = "");
		
		$message = "Over the past $days$hours$mins, the network has been $adverbs{$severity} loaded [ $data1% collision rate ]";
	    }
	}
	elsif ($inst eq "col15")  # collisions over past 15 minutes
	{
	    # The collision rate over the past 15 minutes is stored
	    # in $data3
	    if (! $severity)
	    {
		$message = "The Cobalt Qube's network interface has been idle over the past 15 minutes.";
	    }
	    else
	    {
		$message = "Over the past fifteen minutes, the network has been $adverbs{$severity} loaded [ $data3% collision rate ]";
	    }
	}
    }
    elsif ($server eq "nfs")
    {
	if    ($inst eq "rpc.nfsd")  # NFS server daemon
	{
	    if ($severity == $Status{"green"}) { 
		$message = "The $server process (NFS) is running normally since $time";
	    } elsif ($severity == -1) {
		$message = "No information is available for NFS.  The service is not active or has not yet been examined.";
	    } else {
		$message = "The $server process (NFS) is not responding since $time";
	    }
	}
	elsif ($inst eq "rpc.mountd")  # NFS authentication daemon
	{
	    if ($severity == $Status{"green"}) { 
		$message = "The $server process (NFS) is running normally since $time";
	    } elsif ($severity == -1) {
		$message = "No information is available for NFS.  The service is not active or has not yet been examined.";
	    } else {
		$message = "The $server process (NFS) is not responding since $time";
	    }
	}
	elsif ($inst eq "showmount")  # NFS testing
	{
	    if ($severity == $Status{"green"}) { 
		$message = "The NFS server is running normally since $time";
	    } elsif ($severity == -1) {
		$message = "No information is available for NFS.  The service is not active or has not yet been examined.";
	    } else {
		$message = "The NFS server is not responding since $time";
	    }
	}
    }
    elsif ($server eq "portmap") # portmapper process (used by NFS and NIS)
    {
	# user never sees this
	if ($severity == $Status{"green"}) { 
	    $message = "The portmap process is running normally since $time";
	} elsif ($severity == -1) {
	    $message = "No information is available for portmap.  The service is not active or has not yet been examined.";
	} else {
	    $message = "The portmap process is not running since $time";
	}
    }
    elsif ($server eq "smb")
    {
	if    ($inst eq "smb")  # network connections to the smb port
	{
	    if ($severity == $Status{"green"}) { 
		$message = "The $Servers{$server} server has been running normally since $time";
	    } elsif ($severity == -1) {
		$message = "No information is available for $Servers{$server}.  The service is not active or has not yet been examined.";
	    } else {
		$message = "The $Servers{$server} server has not been responding since $time";
	    }
	}
	elsif ($inst eq "smbd")  # samba server process
	{
	    if ($severity == $Status{"green"}) { 
		$message = "The $Servers{$server} process has been running normally since $time";
	    } elsif ($severity == -1) {
		$message = "No information is available for $Servers{$server}.  The service is not active or has not yet been examined.";
	    } else {
		$message = "The $Servers{$server} process has not been running since $time";
	    }
	}
	elsif ($inst eq "nmbd")  # netbios name service daemon process
	{
	    if ($severity == $Status{"green"}) { 
		$message = "The $Servers{$server} process has been running normally since $time";
	    } elsif ($severity == -1) {
		$message = "No information is available for $Servers{$server}.  The service is not active or has not yet been examined.";
	    } else {
		$message = "The $Servers{$server} process has not been running since $time";
	    }
	}
    }
    elsif ($server eq "www")  # main web server
    {
	if ($severity == $Status{"green"}) { 
	    $message = "The $Servers{$server} has been running normally since $time";
	} elsif ($severity == -1) {
	    $message = "No information is available for the $Servers{$server} yet.  Reports are generated every 15 minutes.";
	} else {
	    $message = "The $Servers{$server} has not been responding since $time";
	}
    }

    $message ||= "No information is available.  The service is not active or has not yet been examined.";
    print STDERR $message if ($Debug);  # be verbose when in debug mode
    return $message;
}

1;
