# This file was built automatically from Messages.pm

# Copyright 1998 Cobalt Microserver (http://www.cobaltmicro.com)

use strict;
### START HARDCODED PATHS
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = $Debug;
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Messages.pm.  Changes made here will be lost.
package Cobalt::Messages;

sub msg_get_ui_message
# Return the UI message associated with an given key
# Arguments: message key
# Return value: message string
# This function is not used at runtime; it is used at RPM creation
#    time by the releasify.pl script to replace the messages in
#    the UI.
{
    my ($key) = @_;
    my %messages = (
		    'addGroup' => 'Add Group',
		    'addUser' => 'Add User',
		    'adminPasswordIncorrect' => 'Please enter the correct admin password.',
		    'backToUserList' => 'Back To User List',
		    'backupNotValid' => 'Your requested backup set is not valid.',
		    'backupTitle' => 'Qube File Backup',
		    'cancel' => 'Cancel',
		    'date' => 'Date',
		    'dayOfWeek' => 'Day Of Week',
		    'defaultVacationReply' => "Thanks for your email.\nI will reply to you as soon as possible.",
		    'diskQuotaNotPositive' => 'Disk quota should be a positive integer.',
		    'diskQuotaTooBig' => 'Disk quota must be smaller than $maxQuotaInMB.',
		    'dnsAddFail' => 'Add domain name service failed! Invalid domain name <b>$domain</b>',
		    'dnsBadPair' => 'Invalid IP and host name:\&nbsp; <b>$hostip \&nbsp; $hostname</b>',
		    'dnsBadPriIP' => 'Invalid primary server IP address <b>$newip</b> for the domain <b>$domain</b>',
		    'dnsChangeConfirm' => '$dnsAddr may not be a functional DNS server. Use it anyway?',
		    'dnsConfiguration' => 'Configuration',
		    'dnsDefaultDomainRm' => 'Default domain removed from the host name <b>$hostname</b>',
		    'dnsDomain' => 'Domain',
		    'dnsEditIP' => 'Edit Host IP',
		    'dnsEditName' => 'Edit Host Name',
		    'dnsHostRm' => 'Delete&nbsp;Entry?',
		    'dnsNotValid' => '$dnsAddr is not a valid DNS Address. 241.12.34.4 is valid, for example.',
		    'dnsPriTitle' => 'Primary DNS Status',
		    'dnsSecTitle' => 'Secondary DNS Status',
		    'dnsStopVerify', => 'Stop DNS service for the domain $domain?',
		    'domainNameNotValid' => '$domainName is not a valid domain name. For example, cobaltmicro.com is a valid domain name',
		    'groupAddOK' => 'Group added successfully.',
		    'groupNameNotValid' => 'Only lowercase alphabetic, digits, ".", "-" and "_" are allowed in group names.',
		    'help' => 'Help',
		    'hostNameNotValid' => '$hostName is not a valid host name.',
		    'hour' => 'Hour',
		    'installResetConfirm' => 'Software installation success. This software needs reboot to take effect. Reboot now?',
		    'installReplaceConfirm' => '$_[ 0 ] version $_[ 1 ] already exist.  Replace it with version $_[ 2 ]?',
		    'localhostNotAllowed' => 'localhost is a reserved name.',
		    'modifyGroup' => 'Modify $group',
		    'modifyUser' => 'Modify $userName',
		    'noCollisionInfoAll' => 'No information on cumulative network collision is available yet. Reports will be generated every 15 minutes.',
		    'noCollisionInfo15' => 'No information on 15 minutes network collision is available yet.  Reports will be generated every 15 minutes.',
		    'noFaxOrEmail' => 'Please at least fill in fax or email.',
		    'noFirstName' => 'First name is essential.',
		    'noForwardAddr' => 'Please enter e-mail address to which to forward.',
		    'noFullName' => 'Full name is essential.',
		    'noGroupMembers' => 'No Group Members',
		    'noGroupName' => 'Please fill in group name.',
		    'noGroups' => 'No groups have been setup.',
		    'noHostName' => 'Cobalt Qube name is essential.',
		    'noIMAPInfo' => 'No information is available for the IMAP server. Mail service is not active or has not been examined.',
		    'noLastName' => 'Last name is essential.',
		    'noPackage' => 'Please specify a package to install.',
		    'noPassword' => 'Password is essential.',
		    'noPOPInfo' => 'No information is available for the POP3 server.  Mail service is not active or has not been examined.',
		    'noQuotesInFullName' => 'Please do not put quotes in the full name.',
		    'noWebRequestInfo' => 'No request has been made for your web content.',
		    'noSMTPInfo' => 'No information is available for the SMTP server. Mail service is not active or has not been examined.',
		    'noUserInfo' => 'Full name, user name and password are essential.',
		    'noUsers' => 'No registered users.',
		    'packageExtensionNotValid' => 'Installation package invalid. It must have a .pkg file extension.',
		    'removeGroup' => 'Remove $group',
		    'removeUser' => 'Remove $userName',
		    'requests' => 'Requests',
		    'restoreTitle' => 'Cobalt Qube File Restore',
		    'restoreWarn' => 'Not <a href=\"#failure\">all files</a> could be restored successfully.',
		    'restoreRept' => 'The following files were restored:',
		    'restoreFail' => 'The following files could not be restored:',
		    'restoreOK' => 'backup archive has been restored.',
		    'saveChanges' => 'Save Changes',
		    'saving' => 'Saving configuration...',
		    'setGroupDefaults' => 'Set Group Defaults',
		    'setUserDefaults' => 'setUserDefaults',
		    'unknown' => 'Unknown',
		    'unlimited' => 'Unlimited',
		    'unresolvedDomains' => 'Unresolved Domains',
		    'userAddOK' => 'User added successfully.',
		    'userNameNotValid' => 'Only lowercase alphabets, digits, ".", "-" and "_" are allowed in user name.',
		    'userRemoveConfirm' => 'Are you sure you want to remove user $userName? This will remove all his/her files and account.',
		    'userWebTitle' => 'Your Web Content, Ranked By Number Of Requests (TOP&nbsp;$showNum)',
		    'webDailyTitle' => 'HITS PER DAY (UP TO $maxDayShown DAYS)',
		    'webDayOfWeekTitle' => 'CUMMULATIVE HITS BY DAY OF WEEK',
		    'webHourlyTitle' => 'AVERAGE HITS PER HOUR',
		    );

    if ($messages{$key})
    {
	return $messages{$key};
    }
    else
    {
	# We should never see this
	return "Cobalt user interface message for $key";
    }
}

1;
1;
