# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Messages_eng.pm

# Copyright 1998 Cobalt Microserver (http://www.cobaltmicro.com)

use strict;
### START HARDCODED PATHS
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = $Debug;
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Messages_eng.pm.  Changes made here will be lost.
package Cobalt::Messages_eng;

sub msg_get_error
# Return the error message associated with an error index number
# Each index number should be unique, even if the message is duplicated
# Arguments: error number
# Return value: string
# Note that most of these errors are purely internal, but some of
#    them show up in the UI.  I have no idea which ones show up.
# This function is not used at runtime; it is used at RPM creation
#    time by the autoize script to replace the error messages in
#    the autoloaded perl files.
{
    my ($errnum) = @_;
    my %errs = (
		1010 => 'Repair of ftp $inst not implemented',
		1020 => 'Repair of cpu $inst not implemented',
		1030 => 'Repair or memory $inst not implemented',
		1040 => 'Repair of disk $inst not implemented',
		1050 => 'Repair of network $inst not implemented',
		1100 => 'Mail service not implemented in this release',
		1101 => 'Windows filesharing is not implemented in this release',
		1102 => 'NFS is not implemented in this release',
		1103 => 'DNS service is not implemented in this release',
		1104 => 'AppleShare service is not implemented in this release',
		1105 => 'NFS is not implemented in this release',
		1106 => 'Windows filesharing is not implemented in this release',
		1107 => 'Cannot set Windows domain controller: not implemented in this release',
		2029 => 'Quota set for $uid',
		2032 => 'Opened access to $dir',
		2039 => 'Date set',
		2040 => 'Time zone set to $zone',
		2056 => 'Set access rights for $dir',
		2057 => 'User CGIs are enabled',
		2057 => 'User CGIs were already disabled, no change.',
		2058 => 'User CGIs were already enabled, no change',
		2059 => 'User CGIs already enabled',
		2060 => 'User CGIs disabled',
		2061 => 'User CGIs are now enabled',
		2062 => 'User CGIs already disabled',
		2063 => 'Web servers restarted ($pid)',
		2064 => 'Daemons restarted',
		2065 => 'Updated admin server redirect',
		2067 => 'No update to hostname or domain name needed',
		2101 => 'Directory created successfully',
		2102 => 'File copied successfully',
		2103 => 'File moved successfully',
		2104 => 'File deleted successfully',
		2140 => 'Virtual interface for address $addr has been set up',
		2141 => 'Set mail masquerading to $masqas',
		2142 => 'Virtual interface deleted successfully',
		2143 => 'Set mail site blocking',
		2222 => 'Membership of group $group set successfully',
		2233 => 'Group deletion successful',
		2234 => 'Users added to group $group successfully',
		2235 => 'Group deleted successfully',
		2236 => 'Users removed successfully',
		2237 => 'Group $group created successfully',
		2238 => 'Group $group created successfully',
		2257 => 'Added SMB share',
		2258 => 'Removed SMB share',
		2314 => 'Alias created successfully',
		2320 => 'Users removed from alias $list successfully',
		2321 => 'Successfully deleted list $alias',
		2323 => 'List membership for $list set successfully',
		2324 => 'List membership for $list successfully set',
		2325 => '$user already has auto-reply active',
		2326 => '$user already has auto-reply deactivated',
		2327 => 'Auto-reply message set in $messagefile',
		2328 => '$user now has no message file',
		2346 => 'users added to alias $alias successfully',
		2410 => 'Changed IP address from $oldaddr to $addr',
		2411 => 'Gateway changed from $oldgw to $gw',
		2412 => 'Name successfully changed from $oldname to $fullname',
		2413 => 'Set samba workgroup to $workgroup',
		2414 => 'Set samba domain controller to $server',
		2417 => 'No change to DNS client configuration',
		2418 => 'wrote resolv.conf',
		2419 => 'emptied resolv.conf',
		2431 => 'AppleShare server started',
		2433 => 'AppleShare server stopped',
		2440 => 'Anyone in the world can manage groups',
		2441 => 'No change to user management',
		2442 => 'No change to group management',
		2443 => 'No change to user management',
		2444 => 'No change to group management',
		2447 => 'Anyone in the world can manage users',
		2448 => 'Only the administrator may manage groups',
		2449 => 'Only the administrator may manage users',
		2450 => 'Mail server started',
		2451 => 'No change -- mail server was already $off',
		2452 => 'Mail server stopped',
		2453 => 'Ftp server started',
		2454 => 'No change -- AppleShare server was already $off',
		2455 => 'Updated NFS exports list',
		2456 => 'Telnet server started',
		2457 => 'Telnet server stopped',
		2458 => 'No change to telnet state',
		2459 => 'Telnet access restricted',
		2460 => 'Telnet access opened to all users',
		2464 => 'Ftp server stopped',
		2470 => '$IP responds',
		2480 => '$IP is listening on port 53',
		2491 => 'No change -- smb server was already $off',
		2493 => 'Smb server started',
		2494 => 'Nfs server started',
		2496 => 'Nfs server stopped',
		2497 => 'Smb server stopped',
		2498 => 'No change -- nfs server was already $off',
		2530 => 'User $username created successfully',
		2531 => 'User $username creation successful',
		2532 => 'User $name modified successfully',
		2533 => 'User $name modified successfully',
		2534 => 'User $username deleted',
		2535 => 'User $username deleted',
		2701 => 'inetd restarted successfully',
		2702 => '$Servers{$server} restarted successfully',
		2703 => '$Servers{$server} successfully restarted',
		2704 => 'AppleShare server restarted',
		2705 => 'LCD restarted successfully',
		2706 => 'crond restarted successfully',
		2707 => 'custo restarted successfully',
		2708 => 'portmap restarted successfully',
		2709 => 'web server restarted successfully',
		2710 => 'admin server restarted successfully',
		2850 => 'DNS server started',
		2852 => 'DNS server started',
		2854 => 'DNS server stopped',
		2855 => 'No change -- the DNS server was already off',
		2856 => 'No change -- the DNS server was already on',
		3050 => 'Cannot write log file $MonDBDir/$server.log: $!',
		3051 => 'Cannot read log file $MonDBDir/$server.log: $!',
		3140 => '$Htconf/httpd.conf is locked',
		3141 => 'Cannot write $Lockdir/httpd.conf: $!',
		3142 => 'Cannot read $Htconf/httpd.conf: $!',
		3143 => 'Cannot update $Htconf/httpd.conf: $!',
		3144 => 'Cannot create $Logrotate_dir/$addr-apache: $!',
		3145 => 'Cannot update virtual interface config file: $!',
		3149 => 'Cannot update $Htconf/httpd.conf: $!',
		3201 => 'Cannot make discussion group for $group: $!\n',
		3228 => 'Cannot read $Group_skel: $!',
		3315 => 'Could not set owner to $uid for message $messagefile: $!',
		3402 => 'Cannot write hosts file: hosts file is locked',
		3403 => 'Cannot update interface config file: $!',
		3404 => 'Cannot update $Htconf/httpd.conf: $!',
		3405 => 'Cannot modify hosts file: $!',
		3406 => 'The hosts file is locked.  Please try again later',
		3407 => 'Cannot update network file: $!',
		3408 => 'Cannot update hosts file: $!',
		3409 => 'Cannot update network file: $!',
		3412 => 'Cannot change hostname file: $!',
		3413 => 'Cannot change name without rebooting: $!',
		3415 => 'Cannot modify hosts file: $!',
		3416 => 'Cannot add routing table entry',
		3417 => 'Cannot update hosts file: $!',
		3418 => '$Htconf/httpd.conf is locked, try again later',
		3419 => 'Cannot read $Htconf/httpd.conf: $!',
		3420 => 'Cannot modify $Htconf/httpd.conf: $!',
		3422 => '$AdminConf/httpd.conf is locked, try again later',
		3423 => 'Cannot read $AdminConf/httpd.conf: $!',
		3424 => 'Cannot modify $AdminConf/httpd.conf: $!',
		3425 => 'Cannot update $AdminConf/httpd.conf: $!',
		3426 => '$AdminConf/srm.conf is locked, try again later',
		3427 => 'Cannot write $Lockdir/adm_srm.conf: $!',
		3428 => 'Cannot read $AdminConf/srm.conf: $!',
		3429 => 'Cannot update $AdminConf/srm.conf: $!',
		3431 => 'Cannot start AppleShare server: $!',
		3433 => 'Cannot break link $Atalklink: $!',
		3434 => 'Cannot create portmap link: $!',
		3435 => 'Cannot start portmapper: $!',
		3436 => 'Cannot break portmap link: $!',
		3437 => 'Cannot write mail IP allow file $MailIPList: $!',
		3438 => 'Cannot write name allow file $MailNameList: $!',
		3455 => 'Cannot start mail server: $!',
		3456 => 'Network server down: $!',
		3457 => 'Cannot break link $Maillink: $!',
		3458 => 'Network server down: $!',
		3459 => 'Network server down: $!',
		3464 => 'Network server down: $!',
		3465 => 'Network server down: $!',
		3466 => 'Network server down: $!',
		3467 => 'Cannot update $Smbconf: $!',
		3468 => 'Cannot read samba config file $Smbconf: $! ',
		3469 => 'Cannot read samba config file $Smbconf: $! ',
		3470 => 'Cannot update $Smbconf: $!',
		3471 => 'Cannot read samba config file $Smbconf: $! ',
		3472 => 'Cannot read samba config file $Smbconf: $! ',
		3493 => 'Cannot start SMB server: $!',
		3494 => 'Cannot start NFS server: $!',
		3496 => 'Cannot break NFS link: $!',
		3497 => 'Cannot break link $Smblink: $!',
		3591 => 'Cannot set ownership for $homedir to $uid/$UserDirGroup: $!',
		3592 => 'Cannot read $User_skel: $!',
		3701 => 'Cannot write log file $MonDBDir/lcd.log: $!',
		3702 => 'Cannot write log file $MonDBDir/inetd.log: $!',
		3703 => 'Cannot write log file $MonDBDir/portmap.log: $!',
		3704 => 'Cannot write log file $MonDBDir/crond.log: $!',
		3705 => 'Cannot write log file $MonDBDir/$server.log: $!',
		3706 => 'Cannot write repair log $MonDBDir/$server.log: $!',
		3707 => 'Cannot run web server startup script: $!',
		3708 => 'Cannot read master file $badfile.master: $!',
		3709 => 'Cannot write config file $badfile: $!',
		3710 => 'Cannot write log file $MonDBDir/$server.log: $!',
		3711 => 'Cannot run admin server startup script: $!',
		3712 => 'Cannot read master file $badfile.master: $!',
		3713 => 'Cannot write admin config file $badfile: $!',
		3714 => 'Cannot read samba master file $Smbconf.master: $!',
		3715 => 'Cannot write samba config file $Smbconf: $!',
		4001 => 'Cannot remove $dir/$Access_file: $!',
		4002 => 'Cannot create $dir/$Access_file: $!',
		4003 => 'Cannot read $dir/$Access_file: $!',
		4004 => 'Cannot read $Htconf/srm.conf: $!',
		4005 => 'Cannot write $Lockdir/srm.conf: $!',
		4006 => 'Cannot update redirect in srm.conf: $!',
		4008 => 'Invalid directory $dir',
		4009 => 'Could not parse access.conf!',
		4010 => 'Cannot read access.conf',
		4011 => 'Cannot read web server PID file $Htpid: $!',
		4012 => 'Cannot read admin server PID file $AdminPid: $!',
		4013 => 'Cannot read $Htconf/access.conf: $!',
		4014 => 'Cannot update $Htconf/access.conf: $!',
		4016 => 'Cannot write lock for $Htconf/access.conf: $!',
		4017 => 'Cannot read httpd PID file $Htpid: $!',
		4018 => 'Cannot turn on user CGIs: $!',
		4019 => 'Cannot turn off user CGIs: $!',
		4051 => 'Cannot read database $Status_db: $!',
		4052 => 'Cannot access database $Status_db: $!',
		4053 => 'Cannot access database $Status_db: $!',
		4054 => 'Cannot access database $Status_db: $!',
		4056 => 'Cannot read database $Status_db: $!',
		4057 => 'Cannot read database $Status_db: $!',
		4058 => 'Cannot access database $Status_db: $!',
		4059 => 'Cannot access database $Status_db: $!',
		4101 => 'Cannot read source file $from: $!\n',
		4102 => 'Cannot write target file $to: $!\n',
		4103 => 'System read error reading $from: $!\n',
		4105 => 'Cannot read directory $top: $!',
		4106 => 'Cannot read directory $dir: $!',
		4107 => 'Cannot create group subdirectory $dir: $!',
		4108 => 'Cannot create directory $dir: $!',
		4109 => 'Cannot set mode in directory $dir: $!',
		4110 => 'Cannot set mode for directory $dir: $!',
		4111 => 'Cannot set uid/gid in directory $dir: $!',
		4112 => 'Cannot set uid/gid for directory $dir: $!',
		4113 => '$username is not allowed to write to $parent',
		4114 => '$username is not allowed to read $src',
		4115 => '$username is not allowed to overwrite $dest',
		4116 => '$username is not allowed to write in $1',
		4117 => '$username is not allowed to move $src',
		4118 => '$username is not allowed to overwrite $dest',
		4119 => '$username is not allowed to write in $1',
		4120 => '$username is not allowed to delete $tgt',
		4121 => '$username is not allowed to read $dir',
		4122 => '$dir already exists',
		4140 => '$addr is not a valid IP address',
		4141 => 'invalid hostname $name',
		4142 => 'Error: Group does not exist',
		4143 => 'Cannot read network script directory $If_cfg_dir: $!',
		4144 => 'Cannot configure virtual interface: ifcfg-$netif is locked',
		4145 => 'Cannot get lock for interface $netif: $!',
		4146 => 'Cannot read interface config ifcfg-$netif: $!',
		4147 => 'Cannot read $Htconf/httpd.conf: $!',
		4148 => 'Cannot read network script directory $If_cfg_dir: $!',
		4149 => '$Htconf/httpd.conf is locked',
		4150 => 'Cannot remove interface: ifcfg-$netif is locked',
		4151 => 'Cannot lock interface config ifcfg-$netif: $!',
		4152 => 'Cannot write $Lockdir/httpd.conf: $!',
		4153 => 'Cannot read $Htconf/httpd.conf: $!',
		4154 => 'Cannot read $If_cfg_dir/ifcfg-$netif: $!',
		4155 => 'Cannot configure mail server: system is busy',
		4156 => 'Cannot lock mail server config file: $!',
		4157 => 'Cannot read mail server config file: $!',
		4158 => 'Cannot read mail server config file: $!',
		4159 => 'Cannot read mail server config file: $!',
		4160 => 'Cannot write mail deny file $MailDenyFile: $!',
		4161 => 'Cannot read mail deny file $MailDenyFile: $!',
		4180 => 'Cannot read auto-reply message for $user: $!',
		4181 => 'Cannot write auto-reply message for $user: $!',
		4201 => 'Group $name does not exist',
		4203 => 'Cannot open $Gtmp: $!',
		4204 => 'Cannot clobber $Lockdir/group: $!',
		4205 => 'Cannot rename $Gtmp: $!',
		4206 => 'Cannot open $Htgtmp: $!',
		4207 => 'Cannot clobber $Lockdir/htgroup: $!',
		4208 => 'Cannot rename $Htgtmp: $!',
		4209 => 'Samba configuration file $Smbconf is locked',
		4210 => 'No such group: $group',
		4211 => 'Cannot read $Gtmp: $!',
		4212 => 'Cannot append to $Lockdir/group: $!',
		4213 => 'Cannot replace $Gtmp: $!',
		4214 => 'Cannot read $Htgtmp: $!',
		4215 => 'Cannot append to $Lockdir/htgroup: $!',
		4216 => 'Cannot replace $Htgtmp: $!',
		4217 => 'The group file is locked.',
		4218 => 'Cannot replace $Htgroup with $Htgtmp: $!',
		4219 => 'Cannot replace $Group with $Gtmp: $!',
		4220 => 'Cannot delete group lock file $Gtmp: $!',
		4221 => 'Cannot delete group lock file $Gtmp: $!',
		4222 => 'Cannot append to group lock file $Gtmp: $!',
		4223 => 'Cannot append to $Htgtmp: $!',
		4224 => 'Cannot open source file $Group_skel/$htmlfile: $!',
		4225 => 'Cannot open destination file $home/$htmlfile: $!',
		4226 => 'Group home $home already exists',
		4227 => 'Cannot create home $home: $!',
		4228 => 'Cannot create group private area $home/$Private_html: $!',
		4229 => 'Cannot modify samba config file $Smbconf: $! ',
		4230 => 'Cannot modify samba config file $Smbconf: $! ',
		4231 => 'Cannot write samba config file $Lockdir/smb.conf: $! ',
		4232 => 'Cannot update $Smbconf: $!',
		4233 => 'Cannot read directory $top: $!',
		4234 => 'Invalid group name $group',
		4235 => 'Samba config file $Smbconf is locked; try again later',
		4236 => 'Cannot open source file $Group: $!',
		4237 => 'Cannot open destination file $Gtmp: $!',
		4238 => 'Cannot open source file $Htgroup: $!',
		4239 => 'Cannot open destination file $Htgtmp: $!',
		4240 => 'Name $group already in use as a user',
		4241 => 'Name $group is already in use as a mailing list or alias',
		4244 => 'Too many group members; you may only have $MaxMembers members per group',
		4245 => 'Too many members; you may only have $MaxMembers members per group',
		4246 => 'Discussion directory for $group already exists',
		4247 => 'Cannot make $Htgroup_dir/Network Trash Folder: $!\n',
		4248 => 'Cannot read httpd PID file $Htpid: $!',
		4249 => 'Cannot read discussion $sfile template: $!',
		4250 => 'List $list already exists',
		4251 => 'Cannot read $Aliasfile; $!',
		4252 => 'Cannot read alias file $Aliasfile: $!',
		4253 => 'Cannot read alias file $Aliasfile: $!',
		4254 => 'Cannot read $Aliasfile; $!',
		4255 => 'Cannot write $Altmp; $!',
		4256 => 'Could not overwrite $Altmp: $!',
		4257 => 'Cannot read $Aliasfile; $!',
		4258 => 'Cannot write $Altmp; $!',
		4259 => 'Cannot clobber $Altmp: $!',
		4260 => 'Cannot read $Aliasfile: $!',
		4261 => 'The aliases file is locked.',
		4262 => 'Cannot create new aliases file: $!',
		4263 => 'Cannot run $Newaliases_cmd: $!',
		4264 => 'Cannot delete aliases lock file $Altmp: $!',
		4265 => 'Cannot open source file $src: $!',
		4266 => 'Cannot open destination file $dest: $!',
		4267 => 'The name $group is reserved by the sytem',
		4269 => 'Cannot write discussion $sfile template: $!',
		4270 => 'Mailing list has invalid characters',
		4271 => 'Mailing list has invalid characters',
		4275 => 'Cannot write discussion $sfile template: $!',
		4276 => 'Cannot read discussion $sfile template: $!',
		4277 => 'Cannot open source file $Group_skel/index.html: $!',
		4278 => 'Cannot open destination file $home/index.html: $!',
		4279 => 'Cannot open source file $Group_skel/private.tmpl: $!',
		4280 => 'Cannot open destination file $home/$Private_html/index.html: $!',
		4301 => 'No response from $IP',
		4302 => 'Nameserver timed out',
		4303 => 'Cannot create socket: $!',
		4304 => 'Cannot connect: $!',
		4320 => 'Invalid port',
		4321 => 'Unrecognized host $remote',
		4322 => 'Cannot run $Nbplkup: $!',
		4350 => 'Cannot read $Net_cfg: $!',
		4351 => 'Cannot read /proc/sys/kernel/hostname: $!',
		4353 => 'Cannot run $Ifconfig_cmd: $!',
		4354 => 'Cannot write $Resolvconf',
		4355 => 'Cannot read $Resolvconf: $!\n',
		4356 => 'Invalid gateway $gaw',
		4357 => 'Host cannot be its own gateway',
		4359 => 'Cannot read routing table: $!',
		4360 => 'Invalid ip address: $addr',
		4361 => 'Cannot modify $Net_cfg: $!',
		4362 => '$Net_cfg is locked, cannot set hostname',
		4364 => 'Cannot set IP address: $If_cfg is locked',
		4365 => 'Cannot read interface config $If_cfg: $!',
		4366 => 'Cannot modify interface config $If_cfg: $!',
		4367 => '$Net_cfg is locked, cannot set gateway',
		4368 => 'Cannot read $Net_cfg: $!',
		4369 => 'Cannot modify $Net_cfg: $!',
		4370 => 'Invalid hostname: $name',
		4371 => 'Reserved name: localhost',
		4380 => 'Cannot get quota for UID $uid: $!',
		4381 => 'Cannot set quota for UID $uid: $!',
		4382 => 'Cannot sync quota for UID $uid: $!',
		4383 => 'Cannot run df on $dir; $!',
		4384 => 'Cannot fathom the filesystem for $dir',
		4385 => 'Cannot get quota for $id: $!',
		4401 => 'Cannot delete Users_dir/$Access_file: $!',
		4402 => 'Cannot write Users_dir/$Access_file: $!',
		4403 => 'Cannot delete Groups_dir/$Access_file: $!',
		4404 => 'Cannot write Groups_dir/$Access_file: $!',
		4417 => 'Cannot write $Sysinit_script: $!',
		4418 => 'Cannot read $Sysinit_script: $!',
		4419 => 'Cannot lock $Sysinit_script: $!',
		4420 => 'Cannot create link to $Mailscript: $!',
		4421 => 'Cannot stop mail server: $!',
		4422 => 'Cannot write $Sysinit_script: $!',
		4423 => 'Cannot create link $Smblink: $!',
		4424 => 'Cannot stop smb service: $!',
		4425 => 'Cannot create nfs link: $!',
		4426 => 'Cannot stop nfs server: $!',
		4427 => 'Cannot create link $Atalklink: $!',
		4428 => 'Cannot stop AppleShare server: $!',
		4429 => 'Cannot create $Nologin: $!',
		4430 => 'Cannot read $Inetd_conf: $!',
		4431 => 'Cannot read $Sysinit_script: $!',
		4432 => 'Cannot read $Inetd_conf: $!',
		4433 => 'Cannot write $Lockdir/inetd.conf: $!',
		4434 => 'Cannot replace $Inetd_conf: $!',
		4435 => 'Cannot lock $Sysinit_script: $!',
		4436 => 'Cannot read $Inetd_conf: $!',
		4437 => 'Cannot write $Lockdir/inetd.conf: $!',
		4438 => 'Cannot replace $Inetd_conf: $!',
		4440 => 'Cannot read $Inetd_conf: $!',
		4441 => 'Cannot write $Lockdir/inetd.conf: $!',
		4442 => 'Cannot replace $Inetd_conf: $!',
		4444 => 'Cannot read $Inetd_conf: $!',
		4445 => 'Cannot write $Lockdir/inetd.conf: $!',
		4446 => 'Cannot replace $Inetd_conf: $!',
		4447 => 'Cannot write exports file $Exports_file: $!',
		4448 => 'Cannot reread exports list: $!',
		4450 => 'Cannot read load average: $!',
		4451 => 'Cannot run $Ps_cmd: $!',
		4452 => 'Cannot stop portmapper: $!',
		4454 => 'Cannot read $Inetd_conf: $!',
		4455 => 'Cannot write $Lockdir/inetd.conf: $!',
		4456 => 'Cannot replace $Inetd_conf: $!',
		4458 => 'Cannot read $Inetd_conf: $!',
		4459 => 'Cannot write $Lockdir/inetd.conf: $!',
		4460 => 'Cannot replace $Inetd_conf: $!',
		4461 => 'Cannot read $Inetd_conf: $!',
		4463 => 'Cannot read exports file $Exports_file: $!',
		4464 => '$Smbconf is locked',
		4465 => 'Cannot write samba config file $Lockdir/smb.conf: $! ',
		4466 => 'Cannot read process list cache: $!',
		4467 => 'Samba configuration file $Smbconf is locked',
		4468 => 'Cannot write samba config file $Lockdir/smb.conf: $! ',
		4469 => 'Cannot read directory $top: $!',
		4480 => 'Cannot set date: $!',
		4481 => 'Cannot save data: $!',
		4484 => 'Cannot change timezone: $!',
		4485 => 'Cannot set timezone: $!',
		4486 => 'Invalid time format',
		4500 => 'User $username already exists',
		4501 => 'User names cannot contain colons',
		4502 => 'Cannot delete $Adminuser',
		4503 => 'Cannot create $username: directory $homedir already exists.',
		4504 => 'No such user',
		4505 => 'Names may not contain colons',
		4506 => 'Cannot write $Uid_file: $!',
		4507 => 'The password file is locked.',
		4508 => 'Cannot lock $Passwd: $!',
		4509 => 'Cannot lock $Ptmp: $!',
		4510 => 'Cannot replace $Passwd with $Ptmp: $!',
		4511 => 'Cannot replace $Htpasswd with $Htptmp: $!',
		4512 => 'Cannot delete password lock file $Ptmp: $!',
		4513 => 'Cannot delete web password lock file $Htptmp: $!',
		4514 => 'Malformed UID',
		4515 => 'Cannot append to $Ptmp: $!',
		4516 => 'Cannot append to $Htptmp: $!',
		4517 => 'Cannot open $Ptmp to delete user: $!',
		4518 => 'Cannot clobber $Lockdir/passwd: $!',
		4519 => 'Cannot move $Ptmp: $!',
		4520 => 'Cannot open htpasswd file $Htpasswd: $!',
		4521 => 'Cannot clobber $Htptmp: $!',
		4525 => 'User quotas may not be set above $warn_quota',
		4527 => 'Cannot create home $homedir: $!',
		4528 => 'Cannot create $homedir/$Private_html: $!',
		4529 => 'Cannot create Network Trash Folder: $!',
		4531 => '$username has no files.',
		4532 => 'Cannot read $Ptmp: $!',
		4533 => 'Cannot write lock file $Lockdir/passwd: $!',
		4534 => 'The password may not contain control characters',
		4535 => 'The given password is too long.  Passwords must be less than $MaxPassLen characters',
		4536 => 'The given password is too short.  Passwords must be at least $MinPassLen characters.',
		4537 => 'Cannot read directory $top: $!',
		4538 => 'Cannot read $Ptmp: $!',
		4539 => 'Cannot open source file $User_skel/$htmlfile: $!',
		4540 => 'Cannot rename $Htptmp: $!',
		4541 => 'Cannot write temporary file $Lockdir/passwd: $!',
		4542 => 'Cannot open destination file $homedir/$htmlfile: $!',
		4543 => 'Invalid user name $username',
		4546 => '$username is a reserved name',
		4547 => 'Cannot clobber $Htptmp: $!',
		4548 => 'Cannot rename $Htptmp: $!',
		4549 => 'Cannot open htpasswd file $Htpasswd: $!',
		4550 => 'Cannot open source file $User_skel/index.html: $!',
		4551 => 'Cannot open source file $src: $!',
		4552 => 'Cannot open destination file $dest: $!',
		4553 => 'Cannot open destination file $homedir/index.html: $!',
		4570 => 'Cannot open source file $User_skel/private.tmpl: $!',
		4571 => 'Cannot open destination file $homedir/index.html: $!',
		4701 => 'Unknown service',
		4702 => 'Unable to restart inetd',
		4703 => '$Servers{$server} remained down',
		4705 => 'Cannot send mail: $!',
		4706 => 'Unable to restart cron',
		4707 => 'Unable to restart custo',
		4708 => 'Unable to restart portmap',
		4709 => 'Unable to restart LCD',
		4710 => 'Unable to restart web server',
		4711 => 'Unable to restart administrative web server',
		4712 => 'Cannot run $Smb_testparm: $!',
		4850 => 'Cannot copy $Named_disabled to $Named_boot: $!',
		4851 => 'DNS server start failed: $!',
		4852 => 'Cannot write to $Named_boot: $!',
		4853 => 'DNS server start failed: $!',
		4854 => 'DNS server stop failed: $!',
		4856 => 'Cannot rename $Named_boot to $Named_disabled: $!',
		4857 => 'Cannot read $Named_pid: $!',
		);

    if ($errs{$errnum})
    {
	return $errs{$errnum};
    }
    else
    {
	# We should never see this
	return "Cobalt error number $errnum";
    }
}

use Cobalt::Language;

1;
