# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Messages_eng.pm

# Copyright 1998 Cobalt Microserver (http://www.cobaltmicro.com)

use strict;
### START HARDCODED PATHS
my $DiskRed = "90";
my $DiskYel = "80";
my $Htgroup_dir = "/home/sites";
my $LoadRed = "6";
my $LoadYel = "3";
my $QuotRed = "95";
my $QuotYel = "85";
my $UserServer_dir = "/usr/httpd";
my $Userdir = "/home/sites";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = $Debug;
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Messages_eng.pm.  Changes made here will be lost.
package Cobalt::Messages_eng;

sub msg_get_message
# Given the flags from the monitoring database, return the message.
#   This message should provide advice on how the user should deal
#   with the problem at hand.
# Arguments: service, instance, flags
# Return value: message string
# We should be able to figure out the message to give based just on
#   the service and instance.  Instead, we're basing it just on flags,
#   at least for now.
{
    my ($service,$instance,$flags) = @_;
 
    my ($severity,$ctime,$status,$data1,$data2,$data3) = 
        db_prev_entry($service,$instance);

    my %messages = (
		    100 => 
"The disk is nearly full; an amber warning light means that you
have consumed more than $DiskYel% of your free disk space, and a red warning  
light signals that you have used more than $DiskRed% of your disk.  You
either need to move some files to another storage device and delete
them from the Cobalt Qube or else delete them altogether.",
		    110 =>
"You may have exceeded your disk space quota on the Cobalt Qube;  an
amber light means that you have consumed $QuotYel% of your allocated disk
space, and a red light signals that you have used $QuotRed% of your quota.
You need to delete some files or else eventually you will be denied
the ability to add files to the Cobalt Qube.",
		    120 =>
"The CPU in the Cobalt Qube is overloaded; it is attempting to do
too many things at the same time.  An amber light means that there
are $LoadYel times as many tasks waiting to be executed as are actually
running, and a red light means that there are $LoadRed times as many.   
Consider moving some of the services to other Cobalt Qube microservers,  
or reduce the complexity of the CGI scripts running on the Cobalt Qube
itself.",
		    125 =>
"The Cobalt Qube needs more memory than it currently has.  Consider
adding more DRAM to the microserver.",
		    130 =>
"The Cobalt Qube is experiencing too many network collisions.  This
problem can be caused by improper network wiring, but is more likely
due to heavy network traffic.  Consider using a switched hub to reduce
the amount of network traffic experienced by the Cobalt Qube.",
		    140 =>
"The Cobalt Qube needs more memory than it currently has.  Consider
adding more DRAM to the microserver.",
		    150 =>
"The Cobalt Qube needs more memory than it currently has.  Consider
adding more DRAM to the microserver.",
		    160 =>
"You are storing too much email on the Cobalt Qube, and consuming
too much disk space.  Please either move some of your email from the
Cobalt Qube to your own computer, or turn off the ``Leave Mail on Server''
option within your email reader.",
		    200 =>
"The Cobalt Qube is experiencing internal errors in attempting to 
establish network server connections.  Try rebooting the microserver
to cure the problem.  If it doesn't, contact Cobalt Technical Support
at www.cobaltmicro.com.",
		    210 =>
"One of the services appears to be down.  Within the Cobalt Qube
Control Panel, try turning the service off and then on again to see
if this corrects the problem.  If not, try rebooting the microserver
itself.  If this still doesn't correct the problem, contact Cobalt
Technical Support at www.cobaltmicro.com.",
		    220 =>
"The Cobalt Qube's NFS server appears to be malfunctioning.  NFS is
not fully supported in this release.",
		    230 =>
"The Cobalt Qube's AppleTalk service does not appear to be
functioning properly.  Within the Cobalt Qube Control Panel, try  
turning AppleTalk off and then on again to see if this corrects the  
problem.  If not, try rebooting the microserver itself.  If this
still doesn't correct the problem, contact Cobalt Technical Support
at www.cobaltmicro.com.",
		    300 =>
"One of the internal processes running on the Cobalt Qube has failed.
Try rebooting the microserver; if this still doesn't correct the 
problem, contact Cobalt Technical Support at www.cobaltmicro.com.",
		    );

    if (defined($messages{$flags}))
    {
	return $messages{$flags};
    }
    else
    {
	#                  For Future Expansion
	#
	# eventually we should switch to this as the way to define
	# messages.  For now, it isn't.

	if    ($service eq "adm")    # Administrative web server
	{
	    return "The administrative web server appears to be down.  Try rebooting the
microserver.  If this doesn't correct the problem, contact Cobalt
Technical Support at www.cobaltmicro.com.";
	}
	elsif ($service eq "atalk")  # Appletalk server
	{
	    return "The Cobalt Qube's AppleTalk service does not appear to be
functioning properly.  Within the Cobalt Qube Control Panel, try  
turning AppleTalk off and then on again to see if this corrects the  
problem.  If not, try rebooting the microserver itself.  If this
still doesn't correct the problem, contact Cobalt Technical Support
at www.cobaltmicro.com.";
	}
	elsif ($service eq "cpu")    # CPU load
	{
	    # $data1 is the load average
	    return "The CPU in the Cobalt Qube is overloaded; it is attempting to do
too many things at the same time.  An amber light means that there
are $LoadYel times as many tasks waiting to be executed as are actually
running, and a red light means that there are $LoadRed times as many.   
Consider moving some of the services to other Cobalt Qube microservers,  
or reduce the complexity of the CGI scripts running on the Cobalt Qube
itself.";
	}
	elsif ($service eq "crond")  # scheduled command daemon
	{
	    # doesn't show up in UI (don't translate)
	    return "The cron daemon is down.  Reboot.";
	}
	elsif ($service eq "custo")  # independent cron monitor daemon
	{
	    # doesn't show up in UI (don't translate)
	    return "A monitoring process has died.  Reboot.";
	}
	elsif ($service eq "disk")   # disk usage
	{
	    if    ($instance =~ /([^,]+),0$/o) # user quota
	    {
		# $data1 is the percentage of quota used
		# $1 is the user login name
		return "You are using $data1% of your disk space quota on the Cobalt Qube.
You need to delete some files or else eventually you will be denied
the ability to add files to the Cobalt Qube.";
	    }
	    elsif ($instance =~ /([^,]+),1$/o) # group quota
	    {
		# $data1 is the percentage of quota used
		# $1 is the group name
		return "Group $1 is using $data1% of its disk space quota on the Cobalt Qube.
You need to delete some files or else eventually you will be denied
the ability to add files to the Cobalt Qube.";
	    }
	    elsif ($instance =~ /([^,]+),mail$/o) # user mail spool
	    {
		# $data1 is the size (in kb) of the user's spool
		# $1 is the users login name
		return "You have $data1 kilobytes of mail stored on the Cobalt Qube.
Please either move some of your email from the
Cobalt Qube to your own computer, or turn off the ``Leave Mail on Server''
option within your email reader.";
	    }
	    elsif ($instance =~ /^$UserServer_dir/o) # area usage
	    {
		# $data1 is the usage in bytes 
		if ($instance eq $Userdir)         # user area
		{
		    return "The disk is nearly full; an amber warning light means that you
have consumed more than $DiskYel% of your free disk space, and a red warning  
light signals that you have used more than $DiskRed% of your disk.  You
either need to move some files to another storage device and delete
them from the Cobalt Qube or else delete them altogether.";
		}
		elsif ($instance eq $Htgroup_dir)  # group area
		{
		    return "The disk is nearly full; an amber warning light means that you
have consumed more than $DiskYel% of your free disk space, and a red warning  
light signals that you have used more than $DiskRed% of your disk.  You
either need to move some files to another storage device and delete
them from the Cobalt Qube or else delete them altogether.";
		}
		else                           # some other area (?)
		{
		    return "The disk is nearly full; an amber warning light means that you
have consumed more than $DiskYel% of your free disk space, and a red warning  
light signals that you have used more than $DiskRed% of your disk.  You
either need to move some files to another storage device and delete
them from the Cobalt Qube or else delete them altogether.";
		}
	    }
	    elsif ($instance =~ /^(\/.+)/o) # disk usage per partition
	    {
		# $data1 is the percent of capacity used
		# $1 is the partition name
		    return "The $1 disk is at $data1% of its capacity.  You
either need to move some files to another storage device and delete
them from the Cobalt Qube or else delete them altogether.";
	    }
	}	
	elsif ($service eq "dns")
	{
	    if    ($instance eq "dns")   # check name service on its port
	    {
		return "The DNS server appears to be down.  Within the Cobalt Qube
Control Panel, try turning the service off and then on again to see
if this corrects the problem.  If not, try rebooting the microserver
itself.  If this still doesn't correct the problem, contact Cobalt
Technical Support at www.cobaltmicro.com.";
	    }
	    elsif ($instance eq "named") # name server process
	    {
		return "The DNS server appears to be down.  Within the Cobalt Qube
Control Panel, try turning the service off and then on again to see
if this corrects the problem.  If not, try rebooting the microserver
itself.  If this still doesn't correct the problem, contact Cobalt
Technical Support at www.cobaltmicro.com.";
	    }
	}
	elsif ($service eq "ftp")     # FTP server (run via inetd)
	{
		return "The FTP server appears to be down.  Within the Cobalt Qube
Control Panel, try turning the service off and then on again to see
if this corrects the problem.  If not, try rebooting the microserver
itself.  If this still doesn't correct the problem, contact Cobalt
Technical Support at www.cobaltmicro.com.";
	}
	elsif ($service eq "inetd")   # master internet service broker
	{
	    return "One of the internal processes running on the Cobalt Qube has failed.
Try rebooting the microserver; if this still doesn't correct the 
problem, contact Cobalt Technical Support at www.cobaltmicro.com.";
	}
	elsif ($service eq "lcd")     # the LCD panel process
	{
	    return "One of the internal processes running on the Cobalt Qube has failed.
Try rebooting the microserver; if this still doesn't correct the 
problem, contact Cobalt Technical Support at www.cobaltmicro.com.";
	}
	elsif ($service eq "mail")    # mail server
	{
	    if    ($instance eq "SMTP")  # SMTP server
	    {
		"The SMTP (mail) server appears to be down.  Within the Cobalt Qube
Control Panel, try turning mail service off and then on again to see
if this corrects the problem.  If not, try rebooting the microserver
itself.  If this still doesn't correct the problem, contact Cobalt
Technical Support at www.cobaltmicro.com.";
	    }
	    elsif ($instance eq "POP3")  # POP3 server (run via inetd)
	    {
		"The POP3 (mail) server appears to be down.  Within the Cobalt Qube
Control Panel, try turning mail service off and then on again to see
if this corrects the problem.  If not, try rebooting the microserver
itself.  If this still doesn't correct the problem, contact Cobalt
Technical Support at www.cobaltmicro.com.";
	    }
	    elsif ($instance eq "IMAP")  # IMAP server (run via inetd)
	    {
		"The IMAP (mail) server appears to be down.  Within the Cobalt Qube
Control Panel, try turning mail service off and then on again to see
if this corrects the problem.  If not, try rebooting the microserver
itself.  If this still doesn't correct the problem, contact Cobalt
Technical Support at www.cobaltmicro.com.";
	    }
	}
	elsif ($service eq "mem")
	{
	    if    ($instance eq "swapping")  # how much swapping is going on?
	    {
		return "The Cobalt Qube needs more memory than it currently has.  Consider
adding more DRAM to the microserver.";
	    }
	    elsif ($instance eq "vmem")      # virtual memory use
	    {
		return "The Cobalt Qube needs more memory than it currently has.  Consider
adding more DRAM to the microserver.";
	    }
	}
	elsif ($service eq "net")               # network interface
	    {
		if    ($instance eq "collisions")  # collisions since boot
		{
		    return "The Cobalt Qube is experiencing too many network collisions.  This
problem can be caused by improper network wiring, but is more likely
due to heavy network traffic.  Consider using a switched hub to reduce
the amount of network traffic experienced by the Cobalt Qube.";
		}
		elsif ($instance eq "col15")  # collisions over past 15 minutes
		{
		    return "The Cobalt Qube is experiencing too many network collisions.  This
problem can be caused by improper network wiring, but is more likely
due to heavy network traffic.  Consider using a switched hub to reduce
the amount of network traffic experienced by the Cobalt Qube.";
		}
	    }
	elsif ($service eq "nfs")    # Network File System (UNIX filesharing)
	{
	    if    ($instance eq "rpc.nfsd")    # NFS server daemon
	    {
		return "The Cobalt Qube's NFS server appears to be malfunctioning.  NFS is
not fully supported in this release.";
	    }
	    elsif ($instance eq "rpc.mountd")  # NFS authentication daemon
	    {
		return "The Cobalt Qube's NFS server appears to be malfunctioning.  NFS is
not fully supported in this release.";
	    }
	    elsif ($instance eq "showmount")   # NFS testing
	    {
		return "The Cobalt Qube's NFS server appears to be malfunctioning.  NFS is
not fully supported in this release.";
	    }
	}
	elsif ($service eq "portmap") # portmapper process (used by NFS and NIS)
	{
		return "The Cobalt Qube's NFS server appears to be malfunctioning.  NFS is
not fully supported in this release.";
	}
	elsif ($service eq "smb")     # windows file sharing
	{
	    if    ($instance eq "smb")   # network connections to the smb port
	    {
		return "The windows file sharing service appears to be down.  Within the Cobalt Qube
Control Panel, try turning the service off and then on again to see
if this corrects the problem.  If not, try rebooting the microserver
itself.  If this still doesn't correct the problem, contact Cobalt
Technical Support at www.cobaltmicro.com.";
	    }
	    elsif ($instance eq "smbd")  # samba server process
	    {
		return "The windows file sharing service appears to be down.  Within the Cobalt Qube
Control Panel, try turning the service off and then on again to see
if this corrects the problem.  If not, try rebooting the microserver
itself.  If this still doesn't correct the problem, contact Cobalt
Technical Support at www.cobaltmicro.com.";
	    }
	    elsif ($instance eq "nmbd")  # netbios name service daemon process
	    {
		return "The windows file sharing service appears to be down.  Within the Cobalt Qube
Control Panel, try turning the service off and then on again to see
if this corrects the problem.  If not, try rebooting the microserver
itself.  If this still doesn't correct the problem, contact Cobalt
Technical Support at www.cobaltmicro.com.";
	    }
	}
	elsif ($service eq "www")     # main web server
	{
		return "The main web server appears to be down.  Try rebooting the microserver;
if this still doesn't correct the problem, contact Cobalt
Technical Support at www.cobaltmicro.com.";
	}

	return "Message number $flags for $service";
    }
}

use Cobalt::Language;

1;
