# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Messages_jpn.pm

# Copyright 1998 Cobalt Microserver (http://www.cobaltmicro.com)

use strict;
### START HARDCODED PATHS
my $Debug = "0";
my $Htgroup_dir = "/home/sites";
my $UserServer_dir = "/usr/httpd";
my $Userdir = "/home/sites";
my %Disks = ("/home","[U","/var","Xv[","/","VXe");
my %Servers = ("ssl","Secure Web Server","smb","Windows t@CL (SMB)","ntp","Network Time Protocol","adm","ǗEFu T[o","mail","dq[","www","EFu T[o","dns","Domain Name Service (DNS)","net","lbg[N","nfs","UNIX t@CL (NFS)","cpu","CPU","ftp","File Transfer Protocol (FTP)","disk","fBXN","atalk","Apple t@CL (AppleShare)","snmp","Simple Network Management Protocol","mem","");
my %Status = ("none","0","0","none","green","1","1","green","2","yellow","red","3","3","red","yellow","2");
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = $Debug;
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Messages_jpn.pm.  Changes made here will be lost.
package Cobalt::Messages_jpn;

sub msg_build_alert
# Build the message
# Arguments: ($server,$inst,$severity,$ctime,$mtime,$data1,$data2,$data3,$status);
#   $server:     the name of the server (or service); e.g., "disk",
#                "ftp", or "smb".
#   $inst:       a particular subsystem or instance of the server;
#                for example, the "disk" server has an instance for
#                each disk, and for each user and group quota.
#   $severity:   A number indicating the state of this instance 
#                1 = green, 2 = yellow, 3 = red
#   $ctime:      The time at which this severity was entered
#   $mtime:      The time when this particular report was generated
#   $data1, $data2, $data3, $status:  Additional information, defined per
#                service and instance
# Return value: a nicely stated message string
{
    my ($server,$inst,$severity,$ctime,$mtime,$data1,$data2,$data3,$status) = @_;

    # To make things easy, just make a mapping between severity and
    # the adverb which describes that severity
    # 1 = green, 2 = yellow, 3 = red
    my %adverbs = (1 => "y",
		   2 => "x",
		   3 => "d",
		   );
    
    my ($message);
    $severity = -1 unless (defined($severity));

    my $time = msg_localtime($ctime);

    if    ($server eq "adm")  # Administrative web server
    {
	if ($severity == $Status{"green"})
	{
	    $message = "$time ȗA$Servers{$server} T[o͐ɓ삵Ă܂B";
	} elsif ($severity == -1) {
	    $message = "$Servers{$server} T[oɊւ͂܂BT[rXANeBuɂȂĂȂAsĂ܂B";
	} else {
	    $message = "$time ȗA$Servers{$server} T[o牞܂B";
	}
    }
    elsif ($server eq "atalk")  # Appletalk server
    {
	if ($severity == $Status{"green"}) { 
	    $message = "$time ȗA$Servers{$server} T[o͐ɓ삵Ă܂B";
	} elsif ($severity == -1) {
	    $message = "$Servers{$server} T[oɊւ͂܂BT[rXANeBuɂȂĂȂAsĂ܂B";
	} else {
	    $message = "$time ȗA$Servers{$server} T[o牞܂B";
	}
    }
    elsif ($server eq "cpu")  # CPU load
    {
	# data1 is the load average
	if ($severity == -1)
	{
	    $message = "񂪎WĂ܂B|[g 15 ɐ܂B";
	}
	else
	{
	    $message = "ߋ 15 ԁACPU ׂ̕$adverbs{$severity}ɂȂĂ܂B[ϕ: $data1]";
	}
    }
    elsif ($server eq "crond")  # scheduled command daemon
    {
	# user never sees this
	if ($severity == $Status{"green"}) { 
	    $message = "crond is running normally since $time";
	} elsif ($severity == -1) {
	    $message = "$Servers{$server} Ɋւ͂܂BT[rXĂȂ\܂B";
	} else {
	    $message = "crond is not running since $time";
	}
    }
    elsif ($server eq "custo")  # independent cron monitor daemon
    {
	# user never sees this
	if ($severity == $Status{"green"}) { 
	    $message = "custo is running normally since $time";
	} elsif ($severity == -1) {
	    $message = "$Servers{$server} T[oɊւ͂܂BT[rXANeBuɂȂĂȂAsĂ܂B";
	} else {
	    $message = "custo is not running since $time";
	}
    }
    elsif ($server eq "disk")
    {
	if ($severity == -1)
	{
	    return "fBXNgpɊւ͂܂BfBXNgp󋵃|[g 1 Ԃɐ܂B";
	}
	if    ($inst =~ /^(.+),0$/o) # user quota
	{
	    # $data1 is the percent of the quota used
	    $message = "[U $1 ͊Ă $data1% gpĂ܂B";
	}
	elsif ($inst =~ /^(.+),1$/o) # group quota
	{
	    # $data1 is the percent of the quota used
	    $message = "O[v $1 ͊Ă $data1% gpĂ܂B";
	}
	elsif ($inst =~ /^(.+),mail$/o) # user mail spool
	{
	    # data1 is the size (in kb) of the user's mail spool
	    $message = "[U $1 ͓dq[ ${data1}KB gpĂ܂B";
	}
	elsif ($inst =~ /^$UserServer_dir/o) # area usage
	{
	    # $data1 is the usage in bytes 
	    if ($inst eq $Userdir)
	    {
		$message = "[Ü $data1 oCggpB";
	    }
	    elsif ($inst eq $Htgroup_dir)
	    {
		$message = "O[v̈ $data1 oCggpB";
	    }
	    else
	    {
		$message = "$inst  $data1 oCggpĂ܂B";
	    }
	}
	elsif ($inst =~ /^\//o) # disk usage per partition
	{
	    # $data1 is the percent of capacity used
	    $message = "fBXN $Disks{$inst} ̈悪 $data1% tłB";
	}
    }
    elsif ($server eq "dns")
    {
	if    ($inst eq "dns")  # check that name service answers on its port
	{
	    if ($severity == $Status{"green"}) {
		$message = "$time ȗA$Servers{$server} T[o͐ɓ삵Ă܂B";
	    } elsif ($severity == -1) {
		$message = "$Servers{$server} T[oɊւ͂܂BT[rXANeBuɂȂĂȂAsĂ܂B";
	    } else {
		$message = "$time ȗA$Servers{$server} T[o牞܂B";
	    }
	}
	elsif ($inst eq "named") # name server process
	{
	    if ($severity == $Status{"green"}) { 
		$message = "$time ȗA$Servers{$server} T[o vZX͐ɓ삵Ă܂B";
	    } elsif ($severity == -1) {
		$message = "$Servers{$server} T[oɊւ͂܂BT[rXANeBuɂȂĂȂAsĂ܂B";
	    } else { 
		$message = "$time ȗA$Servers{$server} T[o vZX牞܂B";
	    }
	}
    }
    elsif ($server eq "ftp")  # FTP server (run via inetd)
    {
	if ($severity == $Status{"green"}) { 
	    $message = "$time ȗA$Servers{$server} T[o͐ɓ삵Ă܂B";
	} elsif ($severity == -1) {
	    $message = "$Servers{$server} T[oɊւ͂܂BT[rXANeBuɂȂĂȂAsĂ܂B";
	} else {
	    $message = "$time ȗA$Servers{$server} T[o牞܂B";
	}
    }
    elsif ($server eq "inetd")  # master internet service broker
    {
	# user never sees this
	if ($severity == $Status{"green"}) { 
	    $message = "The inetd process is running normally since $time";
	} elsif ($severity == -1) {
	    $message = "No information is available for inetd.  The service is not active or has not yet been examined.";
	} else {
	    $message = "The inetd process is not running since $time";
	}
    }
    elsif ($server eq "lcd")  # the LCD panel process
    {
	# user never sees this
	if ($severity == $Status{"green"}) { 
	    $message = "The lcdsleep process is running normally since $time";
	} elsif ($severity == -1) {
	    $message = "No information is available for lcdsleep.  Most likely the process has not yet been checked.";
	} else {
	    $message = "The lcdsleep process is not running since $time";
	}
    }
    elsif ($server eq "mail")
    {
	if ($severity == -1) {
	    $message = "$inst T[oɊւ͂܂B[ T[rXANeBuɂȂĂȂAsĂ܂B";
	}

	if    ($inst eq "SMTP")  # SMTP server
	{
	    if ($severity == $Status{"green"}) { 
		$message = "$time ȗA$inst T[o͐ɓ삵Ă܂B";
	    } elsif ($severity == -1) {
		$message = "$inst T[oɊւ͂܂B[ T[rXANeBuɂȂĂȂAsĂ܂B";
	    } else {
		$message = "$time ȗA$inst T[o牞܂B";
	    }
	}
	elsif ($inst eq "POP3")  # POP3 server (run via inetd)
	{
	    if ($severity == $Status{"green"}) { 
		$message = "$time ȗA$inst T[o͐ɓ삵Ă܂B";
	    } elsif ($severity == -1) {
		$message = "$inst T[oɊւ͂܂B[ T[rXANeBuɂȂĂȂAsĂ܂B";
	    } else {
		$message = "$time ȗA$inst T[o牞܂B";
	    }
	}
	elsif ($inst eq "IMAP")  # IMAP server (run via inetd)
	{
	    if ($severity == $Status{"green"}) { 
		$message = "$time ȗA$inst T[o͐ɓ삵Ă܂B";
	    } elsif ($severity == -1) {
		$message = "$Servers{$server} Ɋւ͂܂B[ T[rXANeBuɂȂĂȂAsĂ܂B";
	    } else {
		$message = "$time ȗA$inst T[o牞܂B";
	    }
	}
    }
    elsif ($server eq "mem")
    {
	if ($severity == -1)
	{
	    return "gpɊւ͂܂B|[g 15 ɐ܂B";
	}
	if    ($inst eq "swapping")  # how much swapping is going on?
	{
	    # data3 is the number of swaps per second
	    $message = "ߋ 15 ԁAz̎gp$adverbs{$severity}ȂĂ܂B[$data3 Xbv/b]";
	}
	elsif ($inst eq "vmem")  # virtual memory use
	{
	    # data1 is the percentage of virtual memory used
	    $message = "z $data1% gpłB";
	}
    }
    elsif ($server eq "net")
    {
	if ($severity == -1)
	{
	    return "lbg[NɊւ͂܂B|[g 15 ɐ܂B";
	}

	if    ($inst eq "collisions")  # collisions since boot
	{
	    # data1 is the collision rate since boot

	    if (! $severity)
	    {
		$message = "NȗACobalt Qube ̃lbg[N C^[tFCXAChԂłB";
	    }
	    else
	    {
		# how long have we been up?
		open(UPTIME,"/proc/uptime") 
		    || die "/proc/uptime ǂݏo܂: $!\n";
		my $uptime = (split('\s',<UPTIME>))[0];  
		close UPTIME;
		
		my $since = $uptime - ($^T - $mtime);
		my $days = int($since / 86400);
		if ($days)
		{
		    ($since -= ($days * 86400));
		    $days = "$days ";
		}
		else
		{
		    $days = "";
		}
		my $hours = int($since / 3600);
		if ($hours)
		{
		    ($since -= ($hours * 3600));
		    $hours = "$hours ";
		}
		else
		{
		    $hours = "";
		}
		my $mins = int($since / 60);
		($mins) ? ($mins = "$mins ") : ($mins = "");
		
		$message = "ߋ$days$hours$mins̊ԁAlbg[Nׂ̕$adverbs{$severity}ɂȂĂ܂B[ $data1% ̏Փ˗ ]";
	    }
	}
	elsif ($inst eq "col15")  # collisions over past 15 minutes
	{
	    # The collision rate over the past 15 minutes is stored
	    # in $data3
	    if (! $severity)
	    {
		$message = "ߋ 15 ԁACobalt Qube ̃lbg[N C^[tFCXAChԂłB";
	    }
	    else
	    {
		$message = "ߋ 15 ԁAlbg[Nׂ̕$adverbs{$severity}ȂĂ܂B[$data3% ̏Փ˗]";
	    }
	}
    }
    elsif ($server eq "nfs")
    {
	if    ($inst eq "rpc.nfsd")  # NFS server daemon
	{
	    if ($severity == $Status{"green"}) { 
		$message = "The $server process (NFS) is running normally since $time";
	    } elsif ($severity == -1) {
		$message = "No information is available for NFS.  The service is not active or has not yet been examined.";
	    } else {
		$message = "The $server process (NFS) is not responding since $time";
	    }
	}
	elsif ($inst eq "rpc.mountd")  # NFS authentication daemon
	{
	    if ($severity == $Status{""}) { 
		$message = "The $server process (NFS) is running normally since $time";
	    } elsif ($severity == -1) {
		$message = "No information is available for NFS.  The service is not active or has not yet been examined.";
	    } else {
		$message = "The $server process (NFS) is not responding since $time";
	    }
	}
	elsif ($inst eq "showmount")  # NFS testing
	{
	    if ($severity == $Status{"green"}) { 
		$message = "The NFS server is running normally since $time";
	    } elsif ($severity == -1) {
		$message = "No information is available for NFS.  The service is not active or has not yet been examined.";
	    } else {
		$message = "The NFS server is not responding since $time";
	    }
	}
    }
    elsif ($server eq "portmap") # portmapper process (used by NFS and NIS)
    {
	# user never sees this
	if ($severity == $Status{"green"}) { 
	    $message = "The portmap process is running normally since $time";
	} elsif ($severity == -1) {
	    $message = "No information is available for portmap.  The service is not active or has not yet been examined.";
	} else {
	    $message = "The portmap process is not running since $time";
	}
    }
    elsif ($server eq "smb")
    {
	if    ($inst eq "smb")  # network connections to the smb port
	{
	    if ($severity == $Status{"green"}) { 
		$message = "$time ȗA$Servers{$server} T[o͐ɓ삵Ă܂B";
	    } elsif ($severity == -1) {
		$message = "$Servers{$server} T[oɊւ͂܂BT[rXANeBuɂȂĂȂAsĂ܂B";
	    } else {
		$message = "$time ȗA$Servers{$server} T[o牞܂B";
	    }
	}
	elsif ($inst eq "smbd")  # samba server process
	{
	    if ($severity == $Status{"green"}) { 
		$message = "$time ȗA$Servers{$server} vZX͐ɓ삵Ă܂B";
	    } elsif ($severity == -1) {
		$message = "$Servers{$server} T[oɊւ͂܂BT[rXANeBuɂȂĂȂAsĂ܂B";
	    } else {
		$message = "$time ȗA$Servers{$server} vZX͓삵Ă܂B";
	    }
	}
	elsif ($inst eq "nmbd")  # netbios name service daemon process
	{
	    if ($severity == $Status{"green"}) { 
		$message = "$time ȗA$Servers{$server} vZX͐ɓ삵Ă܂B";
	    } elsif ($severity == -1) {
		$message = "$Servers{$server} T[oɊւ͂܂BT[rXANeBuɂȂĂȂAsĂ܂B";
	    } else {
		$message = "$time ȗA$Servers{$server} vZX͓삵Ă܂B";
	    }
	}
    }
    elsif ($server eq "www")  # main web server
    {
	if ($severity == $Status{"green"}) { 
	    $message = "$time ȗA$Servers{$server} ͐ɓ삵Ă܂B";
	} elsif ($severity == -1) {
	    $message = "$Servers{$server} Ɋւ͂܂܂B|[g 15 ɐ܂B";
	} else {
	    $message = "$time ȗA$Servers{$server} 牞܂B";
	}
    }

    $message ||= "͂܂BT[rXANeBuɂȂĂȂAsĂ܂B";
    print STDERR $message if ($Debug);  # be verbose when in debug mode
    return $message;
}

use Cobalt::Language;

1;
