# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Monitor.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Df_cmd = "/bin/df";
my %Status = ("none","0","0","none","green","1","1","green","2","yellow","red","3","3","red","yellow","2");
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Monitor.pm.  Changes made here will be lost.
package Cobalt::Monitor;

sub mon_diskwatch
# File systems: check if a specific disk is full
# Arguments: a filesystem to look at, 
#   yellow threshold (%), and red threshold (%)
# Return value: a description of any problems found, as per the tests given
# Side effects: adds entries to the database
{
    my ($filesys,$yelp,$redp) = @_;
    my ($cap,$header,$freespace);
    
    # Why the -e?  Because I'm paranoid.
    unless ((-e $filesys) && (open (DF, "$Df_cmd $filesys|")))
    {
	print STDERR "Cannot run $Df_cmd $filesys: $!\n";
	return -1;
    }

    $header = <DF>; # toss the header line

    while (<DF>)
    {
        ($cap,$freespace) = (split(/\s+/o))[4,3];
	chop $cap; # remove the % sign
    }
    close DF;
    if ($cap >= $redp)
    {
      Cobalt::Monitor::mon_set_state("filesystem",$filesys,$Status{"red"},
		    "-","-","-","$cap,$freespace");
    }
    elsif ($cap >= $yelp)
    {
      Cobalt::Monitor::mon_set_state("filesystem",$filesys,$Status{"yellow"},
		    "-","-","-","$cap,$freespace");
    }
    else
    {
      Cobalt::Monitor::mon_set_state("filesystem",$filesys,$Status{"green"},
		    "-","-","-","$cap,$freespace");
    }
}


1;
