# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Monitor.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $DB_dir_root = "/var/cobalt";
my $Issuefile = "/etc/issue";
my $Status_db = "/var/cobalt/status";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Monitor.pm.  Changes made here will be lost.
package Cobalt::Monitor;

sub mon_get_state
# Get the state of a service
# Arguments: service or (service,instance)
#   Given just the service return the most severe instance within
#   the service (e.g., any red, then any yellow, then any green)
# Return value:  ($condition,$cond_time,$update_time,$notified,$attempts,
#                $reserved,$data)
# Example: @info = Cobalt::Monitor::mon_get_state("mem");
{
  my ($service,$instance) = @_;
  $instance ||= "PRIME";

  my ($condition,$cond_time,$update_time,$notified,$attempts,$reserved,$data);
  # The .state file is the textfile database which stores the state
  # for this service.  Check if we're using that instead of the Berkeley
  # DB file
  if (-e "$DB_dir_root/$service.state") {
    # Do it the text file way
    if (open(US, "$DB_dir_root/$service.state")) {
      "$instance|" =~ /^$instance\|/;  # pre-compile the pattern
      while (<US>) {
	next unless (//);

	# If we get here, we have a match
	chomp;
	($instance,$condition,$cond_time,$update_time,$notified,$attempts,$reserved,$data) = split(/\|/o);
	last;
      }
      close(US);
    }

    # If we've just booted and haven't re-run monitor yet, we consider
    # ourselves to have no state information
    $condition = -1
      if ((stat($Issuefile))[10] > (stat("$DB_dir_root/$service.state"))[10]);

  }
  else {
    # Do it with da database...
    my %STATUS;
    unless(tie(%STATUS, 'DB_File', $Status_db, O_RDONLY(),0644)) {
      return "4672 Cannot read database /var/cobalt/status: $!";
    }
    ($condition,$cond_time,$update_time,$notified,$attempts,$reserved,$data) =
      split(/\|/o,$STATUS{"$service|$instance"});
    untie %STATUS;

    # If we've just booted and haven't re-run monitor yet, we consider
    # ourselves to have no state information
    $condition = -1
      if ((stat($Issuefile))[10] > (stat($Status_db))[10]);
  }

  return -1 unless ($update_time);  # no state at all

  return ($condition,$cond_time,$update_time,$notified,$attempts,
	  $reserved,$data);
}


1;
