# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Monitor.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $DB_dir_root = "/var/cobalt";
my $Status_db = "/var/cobalt/status";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Monitor.pm.  Changes made here will be lost.
package Cobalt::Monitor;

sub mon_list_instances
# Get the list of instances associated with a service
# Arguments: service name
# Return value: list of instances, sorted by severity
#    most severe will be at the top of the list
# Example: @disks = Cobalt::Monitor::mon_list_instances("filesystems");
{
  my ($service) = @_;

  my %STATUS;
  my $fit_to_be_untied = 0;
  my @instances;
  if (-e "$DB_dir_root/$service.state") {
    # Do it the text file way
    if (open(US, "$DB_dir_root/$service.state")) {
      while (<US>) {
	chomp;
	my @parts = split(/\|/o, $_, 2);
	$STATUS{"$service|$parts[0]"} = $parts[1];
	push(@instances,$parts[0]);
      }
      close(US);
    }
  }
  else {
    # Let's do it databasefully
    unless(tie(%STATUS, 'DB_File', $Status_db, O_RDONLY(),0644)) {
      return "4673 Cannot read database /var/cobalt/status: $!";
    }
    $fit_to_be_untied = 1;
    @instances = split(/\,/o,$STATUS{"$service|LIST"});
  }
  # sort the instances by condition
  @instances = sort {
    (split(/\|/o,$STATUS{"$service|$b"}))[0] <=>
      (split(/\|/o,$STATUS{"$service|$a"}))[0]
  } @instances;
  untie %STATUS if ($fit_to_be_untied);
  return @instances;
}


1;
