# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Monitor.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Console = "/dev/console";
my $Sauce_log = "/var/cobalt/sauce.log";
my %Features = ("networker","1","telnetConfig","1","dhcpd","0","shiftjis","Cobalt interface message for shiftjis (We should never see this)","pagebuilder","0","www","1","mx","1","gated","1","dns","1","nfs","0","securetty","1","english","1","atalk","0","fpx","1","siteAdminRedirect","1","users","1","ntp","0","mon_textdb_only","0","search","0","anonFTP","1","specialHomeSkel","0","viewGroups","0","cobaltHomePage","0","lastNameFirst","1","warnRootOnly","1","vsites","1","pam","1","discuss","0","docorg","0","groups","1","smb","0","mail","1","nat","0","squid","0","autoGenWebUsage","0","japanese","0","cobaltRedirect","0","backups","1","vmachine","1","mon_port_testing","1","viewUsers","0","usersCGIInWizard","1","privatedirs","0","telnetDefault","1","ssl","0","siteManagement","1","adm","1","bind8","1","personalRedirect","1","webRequests","1","usersAddUser","0","adminRedirect","1","quotas","1","snmp","1","defaultUserNameGen","1","groupdirs","1","proftpd","1");
my %Status = ("none","0","0","none","green","1","1","green","2","yellow","red","3","3","red","yellow","2");
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Monitor.pm.  Changes made here will be lost.
package Cobalt::Monitor;

#############################################################################
#
# Connect to various TCP ports to verify that network services are running
#

sub mon_portwatch
# Try to connect to a network port on a machine and verify that it
#            responds properly.
# Arguments:
#            the name of the service (text description)
#            the host (name or IP address) on which the service is running
#            the port (name or number) on which the service is running
#            the instance of the service (defaults to service name if null)
# Return value: none of note
# Side effects: updates the database to record the last time the state
#            of the service changed
{
    my ($service,$remote,$port,$inst) = @_;
    $inst ||= $service;  # default value
    my ($proto,$iaddr,$paddr);

    # Set our variables for the connection
    $proto = getprotobyname('tcp');
    if ($port =~ /\D/o) { $port = getservbyname($port, 'tcp') }
    unless ($port)
    {
	return "4682 Invalid port";
    }
    unless ($iaddr = inet_aton($remote))
    {
	return "4683 Unrecognized host $remote";
    }
    $paddr = sockaddr_in($port, $iaddr);

    # Make sure we don't hang forever...
    alarm 10;
    $SIG{'ALRM'} = sub { 
      print LOG "Failed to send to $service $inst: $!\n";
      Cobalt::Monitor::mon_set_state($service,$inst,$Status{"red"},"-","-","-","-");
      close LOG;
      return;
    };

    # Try to bind to a socket and connect to the service
    unless (socket(S, PF_INET(), SOCK_STREAM(), $proto))
    {
      print STDERR "Can't create socket: $!\n" if ($Debug);
      Cobalt::Monitor::mon_set_state($service,$inst,$Status{"red"},"-","-","-","-");
      return 0;
    }
    unless (connect(S, $paddr))
    {
      print STDERR "Can't connect to $port on $remote: $!\n" if ($Debug);
      Cobalt::Monitor::mon_set_state($service,$inst,$Status{"red"},"-","-","-","-");
      return 0;
    } elsif ($service eq 'adm') # Fix complaining Apache 
    {
      print S "GET /.cobalt/sysManage/index.html HTTP/1.0\n\n";
    }

    # test beyond the fact that something answered
    if ($Features{'mon_port_testing'})
    {
      my $bad_response = 0;
      open(LOG,">>$Sauce_log") || open(LOG,">>$Console");
      $| = 1; select(S); $| = 1; select(STDOUT);
      if ($service eq "mail") {
	my $line = <S> || "";
	unless ($line) {
	  $bad_response = 1;
	  print LOG scalar(localtime($^T)), " Null response from $inst";
	  goto BAD;
	}
	if ($inst eq "pop3") {
	  print S "quit\n" || print LOG "Can't send quit to $inst server: $!\n";
	  $line = <S> || "";
	  unless ($line =~ /^\+OK/o) {
	    $bad_response = 1;
	    print LOG scalar(localtime($^T)), " Bad response from $inst: $line";
	    goto BAD;
	  }
	}
	elsif ($inst eq "imap") {
	  unless ($line =~ /OK/o) { 	  # check the banner
	    $bad_response = 1;
	    print LOG scalar(localtime($^T)), " Bad response from $inst: $line";
	    goto BAD;
	  }
	  print S "cobalt LOGIN Active_Monitor\n";
	  $line = <S> || "";
	  unless ($line =~ /^cobalt/o) {  # now check the response
	    $bad_response = 1;
	    print LOG scalar(localtime($^T)), " Bad response from $inst: $line";
	    goto BAD;
	  }
	  print S "cobalt LOGOUT\n";
	}
	elsif ($inst eq "smtp") {
	  print S "ETRN\n";
	  $line = <S> || "";
	  unless ($line =~ /^\d/o) {  # check the response
	    $bad_response = 1;
	    print LOG scalar(localtime($^T)), " Bad response from $inst: $line";
	    goto BAD;
	  }
	  print S "QUIT\n";
	}
      }
      elsif ($service eq "ftp") {
	my $line = <S> || "";
	unless ($line) {
	  $bad_response = 1;
	  print LOG scalar(localtime($^T)), " Null response from $service";
	  goto BAD;
	}
	print S "user active_monitor\n";
	$line = <S> || "";
	unless ($line =~ /^\d/o) {
	  $bad_response = 1;
	  print LOG scalar(localtime($^T)), " Bad response from $service: $line";
	  goto BAD;
	}
	print S "quit\n" || print LOG "Can't send quit to $inst server: $!\n";
      }
      elsif ($service eq "telnet") {
	# Leaves messy log entries...how do we cleanly send a close?
	print S "quit\r\n";
      }

      # abort the communication and jump here when things break
BAD:
      close S;
      close LOG;
      alarm 0;
      $SIG{'ALRM'} = 'DEFAULT';

      if ($bad_response) {
	Cobalt::Monitor::mon_set_state($service,$inst,$Status{"red"},"-","-","-","-");
	return;
      }
    }

    # Make sure the alarm is off
    alarm 0;
    $SIG{'ALRM'} = 'DEFAULT';
    Cobalt::Monitor::mon_set_state($service,$inst,$Status{"green"},"-","-","-","-");
    return;
}


1;
