# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Monitor.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $ProcCache = "/etc/locks/proclist";
my $Ps_cmd = "/bin/ps";
my %Status = ("none","0","0","none","green","1","1","green","2","yellow","red","3","3","red","yellow","2");
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Monitor.pm.  Changes made here will be lost.
package Cobalt::Monitor;

sub mon_procwatch
# Check to see if a process is running
# Arguments: process name (the command) and the name of the server
#   (for use in the database)
# Side effects: updates the database
# Return value: none
{
    my ($process,$service) = @_;
    # Use the cached process list instead of running ps over and over
    if ((-e "$ProcCache") && ((time() - (stat(_))[10]) < 300))
    {
	unless (open (PS,"$ProcCache"))
	{
	    return "4680 Cannot read process list cache: $!";
	}
    }
    else
    {
	unless (open (PS,"$Ps_cmd axw|"))
	{
	    print STDERR "Cannot run $Ps_cmd: $!\n" if ($Debug);
	    return "4681 Cannot run /bin/ps: $!";
	}	
	<PS>;  # chop the top line (which is just header)
    }

    "$process" =~ /$process/;  # minor speed increase by pre-compiling
    while (<PS>)
    {
	next unless (//);
	chomp;
	/^\s*\d+\s+\S+\s+\S+\s+\S+\s+(.+)/o;
	my ($cmd) = ($1);
	next unless ($cmd);
	if ($cmd =~ /$process/)
	{
	    close PS;
	    print STDERR "Found $process in $cmd\n" if ($Debug);
	    Cobalt::Monitor::mon_set_state($service,$process,$Status{"green"},"-","-","-","-");
	    return;
	}
    }
    close PS;

    # got down here without seeing it...
    Cobalt::Monitor::mon_set_state($service,$process,$Status{"red"},"-","-","-","-");
}


1;
