# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Monitor.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my %Status = ("none","0","0","none","green","1","1","green","2","yellow","red","3","3","red","yellow","2");
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Monitor.pm.  Changes made here will be lost.
package Cobalt::Monitor;

sub mon_quotawatch
# monitor the quota for a user or group (or site)
# Arguments: name, type, yellow threshold (%), red threshold (%)
#   type = $UsrQuota or $GrpQuota
# Side effects: updates the database
# Return value: none
{
    my ($name,$type,$yelp,$redp) = @_;

    if ($name eq "*USERS") {
      Cobalt::Monitor::mon_set_state("userspace","*USERS");
      return;
    }
    elsif ($name eq "*GROUPS") {
      Cobalt::Monitor::mon_set_state("groupspace","*GROUPS");
      return;
    }

    # The rest of this code never gets used...we moved all
    # the quota checking logic directly into Cobalt::Monitor::mon_set_state()
    my ($used,$soft) = Cobalt::Quota::repquota($name,$type);
    my ($t,$severity,$state);
    return unless ($soft); # No quota.  No point.
    ($type) ? ($t = "group") : ($t = "user");

    my $share = int(($used / $soft) * 1000) / 10;
    if ($share >= $redp)    { $state = "red";    }
    elsif ($share >= $yelp) { $state = "yellow"; }
    else                    { $state = "green";  }

    Cobalt::Monitor::mon_set_state("${t}space",$name,$Status{$state},
		  "-","-","-","$share,$used,$soft");
    return($Status{$state},$used);

}


1;
