# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Monitor.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Adminuser = "admin";
my $DB_dir_root = "/var/cobalt";
my $GrpQuota = "1";
my $Htusers_dir = "/usr/httpd/users";
my $MonDBDir = "/var/cobalt";
my $QuotRed = "95";
my $QuotYel = "85";
my $Status_db = "/var/cobalt/status";
my $UsrQuota = "0";
my %Features = ("networker","1","telnetConfig","1","dhcpd","0","shiftjis","Cobalt interface message for shiftjis (We should never see this)","pagebuilder","0","www","1","mx","1","gated","1","dns","1","nfs","0","securetty","1","english","1","atalk","0","fpx","1","siteAdminRedirect","1","users","1","ntp","0","mon_textdb_only","0","search","0","anonFTP","1","specialHomeSkel","0","viewGroups","0","cobaltHomePage","0","lastNameFirst","1","warnRootOnly","1","vsites","1","pam","1","discuss","0","docorg","0","groups","1","smb","0","mail","1","nat","0","squid","0","autoGenWebUsage","0","japanese","0","cobaltRedirect","0","backups","1","vmachine","1","mon_port_testing","1","viewUsers","0","usersCGIInWizard","1","privatedirs","0","telnetDefault","1","ssl","0","siteManagement","1","adm","1","bind8","1","personalRedirect","1","webRequests","1","usersAddUser","0","adminRedirect","1","quotas","1","snmp","1","defaultUserNameGen","1","groupdirs","1","proftpd","1");
my %Servers = ("smb","Windows file sharing (SMB)","mail","Email","filesystem","Disk","www","Web Server","dns","Domain Name Service (DNS)","net","Network","nfs","Unix file sharing (NFS)","cpu","CPU","ftp","File Transfer Protocol (FTP)","userspace","Quota","telnet","Telnet server","atalk","Apple file sharing (AppleShare)","modem","Modem","adm","Administrative Web Server","ntp","Network Time Protocol (NTP)","ssl","Secure Web Server","groupspace","Quota","snmp","Simple Network Management Protocol (SNMP)","mem","Memory");
my %Status = ("none","0","0","none","green","1","1","green","2","yellow","red","3","3","red","yellow","2");
my %Subsys_dirs = ("smb","/var/lock/subsys/smb","adm","/var/lock/subsys/ahttpd","mail","/var/lock/subsys/sendmail","inetd","/var/lock/subsys/inet","dns","/var/lock/subsys/named","www","/var/lock/subsys/httpd","snmp","/var/lock/subsys/snmpd","crond","/var/lock/subsys/cron");
my %System_groups = ("global","1","tty","1","users","1","adm","1","mail","1","site-adm","1","httpd","1","daemon","1","root","1","gopher","1","wheel","1","admin","1","bin","1","ftp","1","kmem","1","nobody","1","disk","1","homes","1","man","1","lp","1","dip","1","games","1","uucp","1","news","1","sys","1","mem","1");
my %System_users = ("mail","1","httpd","1","root","1","gopher","1","squid","1","guest","1","anonymous","1","halt","1","ftp","1","nobody","1","operator","1","games","1","adm","1","daemon","1","bin","1","shutdown","1","lp","1","sync","1","news","1","uucp","1");
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Monitor.pm.  Changes made here will be lost.
package Cobalt::Monitor;

sub mon_set_state
# Set the state of a service
# There are two special instances: "PRIME" is the main instance for
#   this server.  "LIST" is the list of all instances for this server.
# Arguments: service, instance, condition, notified, attempts, reserved, data
#   An argument of "-" in any field indicates that the previous value
#   should be preserved.
#   If the service is userspace or groupspace and the instance begins
#   with *, then do the quota check on all the users/groups
# Return value: status string of the form "3105 Jack not name, jack job!"
{
  my ($service,$instance,$condition,$notified,$attempts,
      $reserved,$data) = @_;
  $instance ||= "PRIME";

  # Open and peek at our database
  my %STATUS;
  my %instances;  # all the instances there are
  if (($Features{'mon_textdb_only'}) || (-e "$DB_dir_root/$service.state")) {
    # Do it the text file way
    if (open(US, "$DB_dir_root/$service.state")) {
      while (<US>) {
	chomp;
	my @parts = split(/\|/o, $_, 2);
	$STATUS{"$service|$parts[0]"} = $parts[1];
	$instances{$parts[0]} = 1;
      }
      close(US);
    }
  }
  else {
    # Do it with da database...
    unless(tie(%STATUS, 'DB_File', $Status_db, O_RDWR()|O_CREAT(),0644)) {
      return "4674 Cannot read database /var/cobalt/status: $!";
    }
    %instances = map {$_ =~ s/^.+\|//o; $_ , 1} grep(/$service\|/,keys %STATUS);
  }
  delete $instances{'PRIME'}; # PRIME is special
  delete $instances{'LIST'};  # LIST is also special

  # Open the log file just once...
  open(LOG,">>$MonDBDir/$service.log") ||
    return "3029 Cannot write log file /var/cobalt/$service.log: $!";

  # Now we get into special cases...
  # We do the quota checks right here for increased performance.
  # This way we read the database exactly once and write the database
  # exactly once.
  # We also build our list of all the instances associated with this
  # service at this time, while we're here anyway.
  # For users and groups %instance is a hash of name => ID
  # However, sometimes we really do want to call this function for
  # just one user--e.g., to set the "notified" flag.  In that case,
  # don't do this.  How do we know?  Real usernames don't begin with
  # an asterisk (*).
  my @instances;  # the instances we're checking now
  if    (($service eq "userspace") && ($instance =~ /^\*/o)) {
    # Do the magic bulk user check
    setpwent();
    my ($name,$uid);
    while (($name,$uid) = (getpwent())[0,2]) {
      next if ($name eq $Adminuser);
      next if ($name =~ /^[A-Z]/o);  # capitalized names are special
      push (@instances,$name) unless ($System_users{$name});
      $instances{$name} = $uid;
    }
    endpwent();
  }
  elsif (($service eq "groupspace")  && ($instance =~ /^\*/o)) { 
    # Do the magic bulk group check
    setgrent();
    my ($name,$gid);
    while (($name,$gid) = (getgrent())[0,2]) {
      push (@instances,$name) unless ($System_groups{$name});
      $instances{$name} = $gid;
    }
    endgrent();
  }
  else { 
    # Normal update of a service's state information
    @instances = ($instance); 
  }

  # Make sure this instance is on the list of instances. 
  $instances{$instance} ||= 1;

  # We don't want to keep state between reboots; it looks weird
  # Find out how long we've been up (outside the loop)
  open(UPTIME,"/proc/uptime") || die "Cannot read /proc/uptime: $!\n";
  my $uptime = (split('\s',<UPTIME>))[0];
  close UPTIME;

  # Figure out my name for the logs
  my $svname = $Servers{$service};
  $svname ||= $service;

  my ($update_time,$cond_time,$inst);
 INST:
  foreach $inst (@instances) {

    if (($service =~ /^(user|group)space$/o) && ($instance =~ /^\*/o)) {
      # magic bulk quota check; here we do the work 
      # of retrieving the values for this actual user.
      # code copied from mon_quotawatch
      my ($qtype);
      ($service =~ /^group/o) ? ($qtype = $GrpQuota) : ($qtype = $UsrQuota);
      my ($used,$soft) = Cobalt::Quota::repquota($inst,$qtype,
				  $instances{$inst},$Htusers_dir);
      my ($severity,$state);
      next INST if (!$soft);
      
      my $share = int(($used / $soft) * 1000) / 10;
      if    ($share >= $QuotRed) { $state = "red";    }
      elsif ($share >= $QuotYel) { $state = "yellow"; }
      else                       { $state = "green";  }
      
      $condition = $Status{$state};
      $notified = "-";
      $attempts = "-";
      $reserved = "-";
      $data = "$share,$used,$soft";
    }

    # o_ for old, p_ for prime
    my ($o_condition,$o_cond_time,$o_update_time,$o_notified,$o_attempts,
	$o_reserved,$o_data) = split(/\|/o,$STATUS{"$service|$inst"});
    $update_time = $^T;

    # - means the prevous value should be preserved
    if ($notified eq "-")  { $notified = $o_notified; }
    if ($attempts eq "-")  { $attempts = $o_attempts; }
    if ($reserved eq "-")  { $reserved = $o_reserved; }
    if ($condition eq "-") { $condition = $o_condition; }
    if ($data eq "-")      { $data = $o_data; }

    if ($condition == $o_condition) {     # condition is the same
      if ($o_cond_time > $^T) {
	# The clock has been set back, or time is moving backwards again
	$cond_time = $^T;
      } elsif (($^T - $uptime) < $o_cond_time) {
	# we've been up all this time
        if (-e "$Subsys_dirs{$service}") {
          my $subsys_time = (stat("$Subsys_dirs{$service}"))[10];
          if ($subsys_time > $o_cond_time) {
            # The subsys file is newer, the service must have been
            # stopped & restarted or something
            $cond_time = $subsys_time;
          }
          else {
            # No change to the subsys file
            $cond_time = $o_cond_time;
          }
        } else {
          # No subsys file (may not be appropriate for this service)
          $cond_time = $o_cond_time;
        }
      } else {
	# we've rebooted
	$cond_time = $^T;
      }
    }
    else {                                # condition has changed
      $cond_time = $^T;
    }
    
    # if all is well, reset the auto-repair counters
    # Note that these counters mostly apply to the PRIME instance; 
    # the others don't, in general, use them because regardless of
    # how many things are wrong with the CPU, we only want to be
    # told once, "The CPU is overloaded".  The exception is for
    # quota problems--each user and group going over quota gets
    # an individual notification.
    if ($condition <= $Status{"green"}) {
      $notified = 0;
      $attempts = 0;
    }

    # sanitation defaults
    $condition ||= 0;
    $attempts ||= 0;
    $notified ||= 0;
    $reserved ||= 0;
    $data ||= 0;

    $STATUS{"$service|$inst"} = join('|',($condition,$cond_time,
					      $update_time,$notified,
					      $attempts,$reserved,$data));

    if ($#instances < 50) { 
      # This is a luxury we can only afford if we aren't in a huge loop
      my $message = Cobalt::Monitor::mon_build_alert($service,$inst,$condition,
				 $cond_time,$update_time,$data);
      print LOG "<FONT COLOR=\"$Status{$condition}\">$svname, ",
      Cobalt::Language::msg_localtime($update_time), 
      ": $message</FONT><!-- $inst ($data)-->\n";
    }
  }
  if ($#instances >= 50) { 
    # we need to record *something* in the log...
    print LOG "<FONT COLOR=\"$Status{$condition}\">$svname, ",
    Cobalt::Language::msg_localtime($update_time), ": examination complete at ",
    scalar(localtime(time())), "</FONT>\n";
  }
  close LOG;

  # Set the PRIME instance to the worst offender, and clean out
  # stale entries in the database
  # Could possibly get a slight performance boost by doing this within the
  # foreach loop, but then we wouldn't clean out old entries...and this
  # still only cycles us through the user list twice total
  my $instp;
  my ($p_condition,$p_cond_time,$p_update_time,$p_notified,
      $p_attempts,$p_reserved,$p_data) = 
	split(/\|/o,$STATUS{"$service|PRIME"});
  my ($w_condition,$w_cond_time) = (0,$^T);
  foreach $instp (keys %instances) {
    if(!$STATUS{"$service|$instp"}) {
      delete $instances{$instp};          # Take it off the list
      delete $STATUS{"$service|$instp"};  # Clear the entry
    }
    my ($l_condition,$l_cond_time,$l_update_time,$l_notified,$l_attempts,
	$l_reserved,$l_data) = split(/\|/o,$STATUS{"$service|$instp"});
    next unless ($l_condition);  # no state yet
    # If this hasn't been checked in over an hour, then it is probably
    # not a valid service anymore (or it's just stale information)
    if (($^T - $l_update_time) > 4000) {
      delete $instances{$instp};          # Take it off the list
      delete $STATUS{"$service|$instp"};  # Clear the entry
    }
    # otherwise, it's a candidate for Worst Offender
    elsif ($w_condition < $l_condition) {
      $w_condition = $l_condition;
      $w_cond_time = $l_cond_time;
      $p_data = $instp; # PRIME stores the instance of the worst in $data
    }
    last if ($w_condition == $Status{"red"});  # doesn't get any worse
  }

  # if all is well, reset the auto-repair counters
  # (see also above comments)
  if ($w_condition <= $Status{"green"}) {
    $p_attempts = 0;
    $p_notified = 0;
  }

  # Store the primary information
  $STATUS{"$service|PRIME"} = join('|',($w_condition,$w_cond_time,
					$^T,$p_notified,$p_attempts,
					$p_reserved,$p_data))
				   unless ($instance eq "PRIME");

  # Now, we also store our list of instances
  unless (($service eq "userspace") || ($service eq "groupspace")) {
    $STATUS{"$service|LIST"} = join(',',sort keys(%instances));
  } elsif ($instance =~ /^\*/o) {  # only on the bulk check
    # for users and groups, %instances includes *all* users and groups;
    # @instances is just the ones we check quotas for.
    # %instances contains the rest so we can cache the information
    $STATUS{"$service|LIST"} = join(',',sort @instances);
  }

  # Save this information in the database
  if (($Features{'mon_textdb_only'}) || (-e "$DB_dir_root/$service.state")) {
    sleep 10 if (-e "$DB_dir_root/$service.state.lock");
    if (-e "$DB_dir_root/$service.state.lock") {
      return "4675 Cannot get write lock for /var/cobalt/$service.state: $!";
    }
    open(STATE,">$DB_dir_root/$service.state.lock") ||
      return "4676 Cannot write /var/cobalt/$service.state: $!";
    my $key;
    foreach $key (keys %STATUS) {
      $key =~ s/^[^\|]+\|//o;  # strip off the "$service|" part of the key
      print STATE join('|',$key, $STATUS{"$service|$key"}, "\n");
    }
    close STATE;
    unless (rename("$DB_dir_root/$service.state.lock",
		   "$DB_dir_root/$service.state")) {
      unlink("$DB_dir_root/$service.state.lock");
      return "4677 Cannot store state file /var/cobalt/$service.state: $!";
    }
  }
  else {
    untie %STATUS;
  }
  return "2091 Set state for $service $instance";
}


1;
