# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Monitor.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $MailSpoolMax = "5000";
my $Mailspool = "/home/spool/mail";
my %Status = ("none","0","0","none","green","1","1","green","2","yellow","red","3","3","red","yellow","2");
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Monitor.pm.  Changes made here will be lost.
package Cobalt::Monitor;

sub mon_spoolwatch
# monitor the size of a user's mail spool
# Arguments: name
# Side effects: updates the database
# Return value: none
{
    my ($name) = @_;
    # Get the size of the user's mail spool, in kilobytes
    my ($size) = int((stat("$Mailspool/$name"))[7] / 1024);
    if ($size >= $MailSpoolMax)
    {
      Cobalt::Monitor::mon_set_state("mailspace",$name,$Status{"red"},"-","-","-",$size);
    }
    else
    {
      Cobalt::Monitor::mon_set_state("mailspace",$name,$Status{"green"},"-","-","-",$size);
    }
}


1;
