# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from NAS.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Group = "/etc/group";
my $Gtmp = "/etc/locks/gtmp";
my $Htgroup = "/etc/htgroup";
my $Htgtmp = "/etc/locks/htgtmp";
my $Lockdir = "/etc/locks";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/NAS.pm.  Changes made here will be lost.
package Cobalt::NAS;

sub commit_group
# Commits the changes to the group file by moving gtmp back onto group
# Arguments: none
# Side effects: rebuilds the group files based on the aliases file, and
#   replaces /etc/group with /etc/gtmp
{
    rename($Htgtmp,$Htgroup) 
	|| return Cobalt::NAS::group_abort("4719 Cannot replace /etc/htgroup with /etc/locks/htgtmp: $!");
    rename($Gtmp,$Group) 
	|| return Cobalt::NAS::group_abort("4720 Cannot replace /etc/group with /etc/locks/gtmp: $!");
    print STDERR "Unlocked $Gtmp\n" if ($Debug);

    unlink("$Lockdir/group-$$");
    endgrent();   # sync
    return "2099 Group changes committed successfully";
}


1;
