# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from NAS.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Adminuser = "admin";
my $Group = "/etc/group";
my $Gtmp = "/etc/locks/gtmp";
my $Htgroup = "/etc/htgroup";
my $Htgtmp = "/etc/locks/htgtmp";
my $Lockdir = "/etc/locks";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/NAS.pm.  Changes made here will be lost.
package Cobalt::NAS;

##############################################################


sub lock_group
# Locks the group file so that nobody can collide with us.
# Arguments: none
# Side effects: copies /etc/group to /etc/gtmp
{
    my ($return);
    if (-e $Gtmp)
    {
	return Cobalt::NAS::group_abort("4709 The group file is locked.");
    }
    else
    {
	# Lock the group file by creating the gtmp file as a
	# copy of the group file.
	print STDERR "Copying group file $Group to $Gtmp\n" if ($Debug);

	# inline for better performance
	open(SRC,$Group) 
	    || return Cobalt::NAS::group_abort("4713 Cannot open source file /etc/group: $!");
	open(DEST,">$Gtmp") 
	    || return Cobalt::NAS::group_abort("4714 Cannot open destination file /etc/locks/gtmp: $!");
	print DEST while (<SRC>);
	close DEST;
	close SRC;

	open(LOCK,">$Lockdir/group-$$")
	  || return Cobalt::NAS::group_abort("4715 Cannot get group lock: $!");
	print LOCK "$$\n$0";
	close LOCK;

	if (! -e $Htgroup)
	{
	    # this looks like a fresh system
	    print STDERR "Creating new htgroup file $Htgroup\n" if ($Debug);
	    open(HTGROUP,">$Htgroup")
	      || return "4716 Cannot write /etc/htgroup";
	    print HTGROUP "${Adminuser}:$Adminuser\n";
	    close HTGROUP;
	}

	open(SRC,$Htgroup) 
	    || return Cobalt::NAS::group_abort("4717 Cannot open source file /etc/htgroup: $!");
	open(DEST,">$Htgtmp") 
	    || return Cobalt::NAS::group_abort("4718 Cannot open destination file /etc/locks/htgtmp: $!");
	print DEST while (<SRC>);
	close DEST;
	close SRC;
    }
    print STDERR "Locked $Group with $Gtmp\n" if ($Debug);
    return "2098 Group file locked";
}


1;
