# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from NAS.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Gtmp = "/etc/locks/gtmp";
my $Lockdir = "/etc/locks";
my $MaxMembers = "60000";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/NAS.pm.  Changes made here will be lost.
package Cobalt::NAS;

# nas_group_addusers
#
# Args: $group, @list
# Effects: adds users to a group
#
# This is a variation on Group::group_set_membership that only modifies
# /etc/group.  It doesn't touch htacess or other files.
#
sub nas_group_addusers  {
  my ($gid, @list) = @_;

  my $return;

  return "4693 Group has too many members"
    if ($#list >= $MaxMembers);

  # Using the hash table is a cute way to guarantee no repeat
  # entries
  my %temp = map { $_, 1} @list;
  my $list = join(',',sort(keys(%temp)));

  # Don't go to any trouble if nothing is changing
  my $oldmembers = join(',',Cobalt::NAS::nas_group_show_bygid($gid));
  if ($oldmembers eq $list)
    {
      # no change... return success
      return "2094 Group unchanged";
    }
  
  # fix the group file
  open(GROUP,$Gtmp) ||  return Cobalt::NAS::group_abort("4694 Cannot read /etc/locks/gtmp: $!");
  open(GTMP,">$Lockdir/group") 
    || return Cobalt::NAS::group_abort("4695  ");
  "$gid:x:" =~ /^$gid:(.+):/;   # pre-compiled regexps are better
  while (<GROUP>)
    {
      if (//)
	{
	  print GTMP "$gid:$1:$list\n";
	}
      else
	{
	  print GTMP;
	}
    }
  close GTMP;
  close GROUP;
  rename("$Lockdir/group",$Gtmp) ||
    return "4696  ";
  
  return "2095 Group member list changed successfully"; # success
}


1;
