# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from NAS.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Gtmp = "/etc/locks/gtmp";
my $Lockdir = "/etc/locks";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/NAS.pm.  Changes made here will be lost.
package Cobalt::NAS;

# group_del: delete a group, and *only* deletes a group
# Arguments: the name of the group to delete
# Side effects: Removes the group from the group file
# Return value: a status string of the form "604 Gotta dance!"
#
# pulled from Groups:group_del.  Read notes for nas_group_add to see why.
sub nas_group_del {
    my($group) = @_;

    # error checking
    return "4697  " unless (getgrnam($group));
    my $return;
    return $return unless (($return = &lock_group) =~ /^2/o);
    # done error checking
    
    # removing line from groups file
    print STDERR "Cleaning from $Gtmp\n" if ($Debug);
    open(GROUP,$Gtmp) || return Cobalt::NAS::group_abort("4698  ");
    open(GTMP,">$Lockdir/group") || 
	return Cobalt::NAS::group_abort("4699  ");
    "$group:" =~ /^$group:/;   # pre-compile the pattern
    while (<GROUP>)
    {
	print GTMP unless (//);
    }
    close GTMP;
    close GROUP;
    rename("$Lockdir/group",$Gtmp) ||
	return Cobalt::NAS::group_abort("4700  ");

    print STDERR "Completed deletion of $group\n" if ($Debug);
    return "2096 Group deleted successfuly";  # success
}


1;
