# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from NAS.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Gtmp = "/etc/locks/gtmp";
my $MaxMembers = "60000";
my $MaxNameLen = "12";
my %System_groups = ("global","1","tty","1","users","1","adm","1","mail","1","site-adm","1","httpd","1","daemon","1","root","1","gopher","1","wheel","1","admin","1","bin","1","ftp","1","kmem","1","nobody","1","disk","1","homes","1","man","1","lp","1","dip","1","games","1","uucp","1","news","1","sys","1","mem","1");
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/NAS.pm.  Changes made here will be lost.
package Cobalt::NAS;

sub nas_group_new
# nas_group_new: Create a new group, but no group share, dir, or other stuff
#
# Arguments: name, gid, (optional) list of members
# Side effects: adds entries to the group file
# Return value: the usual status string of format "816 I said NO camels"
#
# This is pulled from the Group::group_add subroutine.  This is necessary
# b/c group_add is way too specific to the way the WG works.  Ideally this
# routine would be the abstract way to add a group and would replace the
# corresponding code inside of group_add, but I want to disrupt as little as
# possible in the existing code.
{
    my ($group, $gid, @members) = @_;

    # error checking
    my ($return);
    return "4686 Group name must be no longer than 12 characters."
	if (length($group) > $MaxNameLen);
    return "4687 The name is reserved by the system"
	if ($System_groups{$group});
    return "4688 Group already exists"
	if (getgrnam($group));
    return "4689 The group already exists as a user" 
	if (getpwnam($group));
    return "4690 The group already exists as an alias"
	if (Cobalt::List::alias_exist($group));
    return 
	Cobalt::NAS::group_abort("4691 Group has too many members")
	    if ($#members >= $MaxMembers);

    return $return unless (($return = &lock_group) =~ /^2/o);
    # whew... we're done with error checking

    # now add an entry to /etc/groups
    setgrent();
    my $line = "${group}::${gid}:" . join(',',@members) . "\n";
    print STDERR "Adding to $Gtmp: $line" if ($Debug);
    open(GTMP,">>$Gtmp") 
	|| return Cobalt::NAS::group_abort("4692  ");
    print GTMP $line;
    close GTMP;

    ### end game
    # commit the groups file
    return $return unless (($return = &commit_group) =~ /^2/o);

    print STDERR "Completed adding $group\n" if ($Debug);

    # success
    return "2093 Group created successfully";
}


1;
