# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from NAS.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $NAS_mode_allread_dir = "1533";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/NAS.pm.  Changes made here will be lost.
package Cobalt::NAS;

# nas_share_get_attribs
# arg: share name
# returns a hash containing:
#    fullAccess: list of users and groups with full access
#    allCanRead: whether or not all users can read the share
#    quota:      the quota assigned to the share
#    used:       space used on the share
#    accessible: whether or not the share is currently available
#    device:     the device containing the share
#    freespace:  available free space for the share
#
# perhaps this should be split it up... it may be innefficient to always
# retrieve all of these values.
#
sub nas_share_get_attribs {
  my $name = shift;
  my $ret;
  my %args;
  my $x;

  my %smbconf;
  $ret = Cobalt::Samba::get_smb_service_parms(\%smbconf);
  return $ret if ($ret !~ /^2/);
  
  # full access lists
  @{$args{'fullAccess'}} = split($smbconf{'write list'});
  
  # accessible
  $args{'accessible'} = $smbconf{'accessible'};
  
  # device
  $args{'device'}, $args{'shareid'} = Cobalt::NAS::nas_share_loc($smbconf{'path'});

  # quota & used (i ignore the hard quota here)
  ($args{'used'}, $args{'quota'}) = Cobalt::Quota::repquota($args{'shareid'}, 1, $args{'shareid'}, $smbconf{'path'});

  # device freespace
  ($x, $x, $args{'freespace'}) = Cobalt::NAS::nas_fs_freespace($args{'device'});
  
  # all can read
  my ($x,$x,$curmode) = stat($args{'path'});
  $args{'allCanRead'} = ($curmode == $NAS_mode_allread_dir);

  return %args;
}


1;
