# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from NAS.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $NAS_lastshare = "/home/shares/lastshare";
my $NAS_sharedir = "/home/shares";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/NAS.pm.  Changes made here will be lost.
package Cobalt::NAS;

# nas_new_share_path
#
# Returns a new unique path for a share.
# Args: $filesystem
#
# The NAS creates unique path names for each share using numbers.
# This may seem odd-- the point is that the sharename is completely independant
# of the pathname.  This allows the pathname to stay contant over the lifetime
# of the share, even though its name may change.  Why?  This means that I can
# let the admin modify a share's attributes, including its share name,
# without knocking current users off the system.  The UI simplicity this allows
# justifies the odd design under the hood (IMHO).  -john.
#
# News flash!  Modifying to support multiple filesystems.  Now the pathname
# will not stay constant if the share is moved from one fs to another.
#
# I considered using a more human readable format, but decided against it.
# It would be more confusing to have a pathname based on the original name of
# a share, especially after the share name was changed.
sub nas_share_newpath {
  my $fs = shift;

  if (Cobalt::NAS::nas_fs_mounted($fs)) {
    return "4702 Filesystem $fs does not exists";
  }

  open(LAST, $NAS_lastshare) ||
    return "4704 Cant open /home/shares/lastshare: $!";
  my $lastshare = <LAST>;
  close(LAST);

  $lastshare++;

  open(LAST, ">$NAS_lastshare") ||
    return "4706 Cant open /home/shares/lastshare: $!";
  print LAST $lastshare;
  close(LAST);

  return "$NAS_sharedir/$fs/$lastshare";
}


1;
