# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from NAS.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/NAS.pm.  Changes made here will be lost.
package Cobalt::NAS;

# nas_share_setmode
#
# Recursively descends a specified directory (or file) to set chmod & chown
#
# args: $dirpath, $uid, $gid, $mode
# returns: the usual
sub nas_share_setmode {
  my ($dirpath, $uid, $gid, $mode, $dirmode) = @_;

  my $path;
  my ($x, $curmode);

  my ($x,$x,$curmode) = stat($dirpath);
  # don't break if $dirpath isn't a directory
  if (-d $dirpath) {
    # only add to existing mode (preserves Samba's encoding of DOS attribs)
    chmod($curmode | $dirmode, $dirpath);

    opendir(DIR, $dirpath);
    while ($path = <DIR>) {
      next if (($path eq '.') || ($path eq '..'));
      
      if (-d $path) {
	# recurse!
	Cobalt::NAS::nas_share_setmode($path, $uid, $gid, $mode);
      }
      
      # set mode and ownerships
      chown($uid, $gid, $path);
      chmod($curmode | $mode, $dirpath);
    }
    closedir(DIR);
    
  } else {
    # a regular file!
    chmod($curmode | $mode, $dirpath);
  }
  chown($uid, $gid, $path);  
}


1;
