# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Nat.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Nat.pm.  Changes made here will be lost.
package Cobalt::Nat;

sub nat_check_user
# Check that the user is still allowed to connect using this ruleset
# Arguments: user's IP, default policy, ruleset
#   Each rule should be a list of:
#   source ip, source netmask, source port, dest ip, dest netmask, dest port, 
#   protocol, policy
# Side effects: none
# Return value: status string
{
  my ($user_ip,$defpol,@rules) = @_;
  my $r;
  foreach $r (@rules) {
    my @rule = @$r;
    my ($src_ip,$src_mask,$src_port,$dst_ip,$dst_mask,$dst_port,$prot,$pol) = @rule;
    if (($pol eq "deny") && (Cobalt::Network::net_network_ismember($user_ip,$src_ip,$src_mask)))
      {
	return "4748 Your address is blocked by: $pol $src_ip/$src_mask => $dst_ip/$dst_mask";
      }
    elsif (($pol eq "accept") && (Cobalt::Network::net_network_ismember($user_ip,$src_ip,$src_mask)))
      {
	return "2108 Explicitly allowed by this rule";
      }
  }
  if ($defpol eq "accept")
    {
      return "2109 Allowed by default rule";
    }
  else
    {
      return "4749 Your address is blocked by the default rule";
    }
}


1;
