# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Nat.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Filter_link = "/etc/rc.d/rc3.d/S11ipfilters";
my $Filter_script = "/etc/rc.d/init.d/ipfilters";
my $Lockdir = "/etc/locks";
my $Sauce_log = "/var/cobalt/sauce.log";
my %Features = ("networker","1","telnetConfig","1","dhcpd","0","shiftjis","Cobalt interface message for shiftjis (We should never see this)","pagebuilder","0","www","1","mx","1","gated","1","dns","1","nfs","0","securetty","1","english","1","atalk","0","fpx","1","siteAdminRedirect","1","users","1","ntp","0","mon_textdb_only","0","search","0","anonFTP","1","specialHomeSkel","0","viewGroups","0","cobaltHomePage","0","lastNameFirst","1","warnRootOnly","1","vsites","1","pam","1","discuss","0","docorg","0","groups","1","smb","0","mail","1","nat","0","squid","0","autoGenWebUsage","0","japanese","0","cobaltRedirect","0","backups","1","vmachine","1","mon_port_testing","1","viewUsers","0","usersCGIInWizard","1","privatedirs","0","telnetDefault","1","ssl","0","siteManagement","1","adm","1","bind8","1","personalRedirect","1","webRequests","1","usersAddUser","0","adminRedirect","1","quotas","1","snmp","1","defaultUserNameGen","1","groupdirs","1","proftpd","1");
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Nat.pm.  Changes made here will be lost.
package Cobalt::Nat;

sub nat_enable
# Enable or disable the filtering rules both now and at boot
# Arguments: 0 = disable, 1 = enable filtering, 2 = enable
#   masquerading, 3 = enable both filtering and masquerading
# Side effects: runs the ip filter script, sets up the boot-time symlink,
#   modifies $MODE in the script
# Return value: status string
# Note: it's a bad idea to have the rules go into effect immediately while
#   the user is editing them.  If they do their edits in the wrong order,
#   things could get really weird and connections could die.
{
  return "1003 IP filtering is not supported in this product." unless ($Features{'nat'});
  my ($filter_mode) = @_;

  # Set the $MODE variable in the filter script
  return "4723 You must create filtering/masquerading rules before you can enable them" if (! -e $Filter_script);
  return "4724 The filtering rules are being edited.  Try again later." if (-e "$Lockdir/ipfilters");
  open(LOCK,">$Lockdir/ipfilters") || return "4725 Cannot write new filtering rules: $!";
  open(NAT,$Filter_script) || return "4726 Cannot read default IP filter configuration: $!";
  while (<NAT>) {
    if (/^MODE=(\d+)/o) {
      print LOCK "MODE=$filter_mode\n";
    } else {
      print LOCK;
    }
  }
  close NAT;
  close LOCK;
  rename("$Lockdir/ipfilters",$Filter_script)
    || return "4727 Cannot write IP filter rules: $!";
  chmod(0755,$Filter_script);

  # Set the symlink.  The symlink should be there regardless,
  # because we turn things on and off with the $MODE variable
  # at the top of the ipfilters script.
  # We know the filter script exists, because we already exited
  # above if it doesn't.
  if( ! -l $Filter_link ) {
    symlink($Filter_script,$Filter_link)
      || return "4728 Cannot set IP filter boot script: $!";
  }

  # Now put those rules (or lack of rules) into effect
  system("$Filter_script >>$Sauce_log 2>&1")
    && return "4729 Cannot run IP filter script: $!";

  # Give a return code so we know what just happened...
  if ($filter_mode) {
	return "2105 Filters enabled";
  } else {
	return "2106 Disabled IP filtering";
  }
}


1;
