# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Nat.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Filter_cmd = "/sbin/ipfwadm";
my $Filter_script = "/etc/rc.d/init.d/ipfilters";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Nat.pm.  Changes made here will be lost.
package Cobalt::Nat;

sub nat_get_default
# Find out what the default policy is
# Arguments: none
# Return value: "accept", "deny", "masq", or "none" if no rules are set.
{
  return "none" if (! -e $Filter_script);
  my $policy;
  open(NAT,$Filter_script) 
    || return "4747 Cannot read default IP filter configuration: $!";
  while (<NAT>) {
    if (/^\t?$Filter_cmd -[FOI] -p (\w+)/o) {
      $policy = $1;
    } elsif (/\# 65536 defmasq/o) {
      $policy = "masq";
      last;
    }
  }
  close NAT;
  return $policy;
}


1;
