# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Nat.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Filter_script = "/etc/rc.d/init.d/ipfilters";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Nat.pm.  Changes made here will be lost.
package Cobalt::Nat;

sub nat_get_masq
# Is an interface being masqueraded?
# Arguments: interface name, or IP and netmask
# Return value: 1 if it is, 0 if it isn't
# Example: nat_get_masq("eth0");
{
  return 0 if (! -e $Filter_script);  # there's no masquerading at all...

  # Handle arguments
  my ($n_addr,$n_mask);
  if ($#_) {
    # Arguments given were IP and netmask
    ($n_addr,$n_mask) = @_;
    $n_mask = Cobalt::Network::net_convert_netmask($n_mask) 
      if ($n_mask =~ /\./o); # decimalize dotted quad netmasks
  } else {
    # Argument was the interface name
    my ($netif) = @_;
    ($n_addr,$n_mask) = Cobalt::Network::net_get_ipaddr($netif);
  }

  open(NAT,"$Filter_script") || return 0;
  # Scan through the ip filters rules for the masquerading rule
  while (<NAT>) {
    if (/-S $n_addr\/$n_mask \# masq/) {
      close NAT;
      return 1;
    }
  }
  close NAT;
  return 0;
}


1;
