# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Nat.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Filter_cmd = "/sbin/ipfwadm";
my $Filter_script = "/etc/rc.d/init.d/ipfilters";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Nat.pm.  Changes made here will be lost.
package Cobalt::Nat;

sub nat_get_rules
# Read in the rules from the file
# We don't look at what's loaded in the kernel; we look at the file
# Arguments: none
# Side effects: none
# Return value: a list of rules, which is empty if there are none.
#    Each rule is a list of source IP, source netmask, source port, 
#      dest IP, dest netmask, dest port, proto, policy, weight
{
  return if (! -e $Filter_script);
  my @rules;
  open(NAT,$Filter_script) 
    || return "4746 Cannot read default IP filter configuration: $!";
  while (<NAT>) {
    # Skip forward to the begin marker
    last if (/^\s*\# Begin rules/o);
  }
  while (<NAT>) {
    last if (/^\s*\# End rules/o);
    if (/^\t?$Filter_cmd -(\w)(\s-[VW]\s\S+)? -a (\w+)\s+(-m\s+)?-P (\w+) -S ([\d\.]+)\/([\d\.]+) ([\d:]+)? -D ([\d\.]+)\/([\d\.]+)\s*([\d:]+)?(\s*\#\s*(\d+)\s*(\w*))?/o) {
      my ($type,$policy,$proto,$src_ip,$src_mask,$src_port,$dst_ip,$dst_mask,$dst_port,$weight,$flags) = 
	($1,$3,$5,$6,$7,$8,$9,$10,$11,$13,$14);
      $src_port ||= "all";
      $dst_port ||= "all";
      $weight ||= 50;
      push(@rules,[($src_ip,$src_mask,$src_port,$dst_ip,$dst_mask,$dst_port,
			$proto,$policy,$weight)]);
      print STDERR "Found rule $src_ip/$src_mask:$src_port => $dst_ip/$dst_mask:$dst_port proto=$proto [$policy] # $weight\n" if ($Debug);
      }
  }
  close NAT;
  # Now sort the rules by weight (although they should already be in the
  # file that way)
  @rules = sort { return ($$b[8] <=> $$a[8]); } @rules;
  return @rules;
}


1;
