# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Netutil.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Nslookup = "/usr/bin/nslookup";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Netutil.pm.  Changes made here will be lost.
package Cobalt::Netutil;

sub netutil_get_mx
# Get MX records for a host/domain
# Arguments: a host/domain name
#   return type (optional): 0 for IP address, 1 for name
# Return value: an array of MX records sorted by preferrence
#   (from numerically lower to numerically higher)
{
    my( $name, $returnName )=@_;

    my %names;
    my %preferenceToName;
    my %nameToIP;

    open( NSLOOKUP, "echo \"set type=mx\n$name.\n\" | $Nslookup 2>&1 |" );
    while( <NSLOOKUP> ) {
	# get names and preferrences
	if( /preference = (\d+), mail exchanger = (.+)/ ) {
	    # DNS server can have 1 mail exchanger with different preferences
	    if( !$names{ $2 } ) { $preferenceToName{ $1 }=$2; }
	    $names{ $2 }=1;
	}

	# get IPs
	if( /(\S+)\s+internet address = (.+)/ ) {
	    $nameToIP{ $1 }=$2;
	}
    }
    close( NSLOOKUP );

    # sort by preference in ascending order
    my @preferences=keys %preferenceToName;
    @preferences=sort { $a <=> $b } @preferences;

    my @returnValues;
    my $preference;
    foreach $preference ( @preferences ) {
	if( $returnName ) {
	    push @returnValues, $preferenceToName{ $preference };
	}
	else {
	    push @returnValues, $nameToIP{ $preferenceToName{ $preference } };
	}
    }

    return @returnValues;
}

#
# not supported
#
#sub isMXExist
# Check to see if a MX record for a host/domain exists
# Arguments: a host/domain name
# Return value: a string of the form '2000 ready'
#{
#    my ( $name )=@_;

#    open( NSLOOKUP, "echo \"set type=mx\n$name.\n\" | $Nslookup 2>&1 |" );
#    while( <NSLOOKUP> ) {
#	if( /\*\*\*.+can't find/ ) { return 0; }
#    }
#    close( NSLOOKUP );

#    return 1;
#}


1;
