# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Netutil.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Netutil.pm.  Changes made here will be lost.
package Cobalt::Netutil;

sub netutil_test_domainname
# argument 0 is a domain name
# return 0 ( false ) or 1 ( true )
{
    # check if ends with '.'
    # technically, a domain name that ends in '.' is just fine;
    # the '.' is just a flag to the resolver telling it not to tack
    # a domain name on the end.  But, *we* don't accept the trailing '.'
    # Using substr seems like a lot of trouble to go to...
    #if( substr( $_[ 0 ], -1, 1 )=~/\./o ) { return 0; }
    #return 0 if( $_[ 0 ] =~ /\..?$/o );  # end in . or .a

    # Everybody including JPNIC violates RFCs
    # Therefore we allow 1 character subdomain
    # check for blank or 1-letter domain/subdomain names
#    return 0 if ($_[0] =~ /\..(\.|$)/o);

    # dots and dashes cannot stick together or end a name
    return 0 if( $_[0] =~ /(\.|\-)(\.|\-|$)/o );

    # domain can only have letters, digits and dashes, seperated by .'s,
    # and must begin with an alphanumeric character
    return 0 if( $_[0] !~ /^[a-z0-9][a-zA-Z0-9\-\.]*$/ );

    # an all numeric domain is not valid
    return 0 if( $_[ 0 ] =~ /^[0-9\.]+$/ );

    return 1;

#    my @subdomains=split /\./o, $_[ 0 ];
#    if( $#subdomains<0 ) { $subdomains[ 0 ]=$_[ 0 ]; }

#    my $subdomain;
#    foreach $subdomain ( @subdomains ) {
	# subdomain cannot be nothing or less than 2 characters
	# Of course, in practice you have things like www.x.org, which 
	# violates the RFC but exists anyway.  If we wanted to support
	# RFC-violation (we already do by allowing domains which begin with
	# number) use the second line instead of the first to just check
	# that the hostname is not null.
	#return 0 if( length( $subdomain )<=1 );
#	return 0 unless ($subdomain);

        # 1st character must be an alphanumeric
	# RFC 822 says it must be an alphabetic character, but our 
        # friends at Candlestick Park don't like it
#        if( $subdomain!~/^[a-z0-9]/o ) { return 0; }

        # 2 dashes cannot stick together
#        if( $subdomain=~/--/o ) { return 0; }

        # domain can only have letters, digits and dashes
#        if( $subdomain!~/^[a-z0-9\-]+$/ ) { return 0; }
#    }

#    return 1;
}


1;
