# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Netutil.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Netutil.pm.  Changes made here will be lost.
package Cobalt::Netutil;

sub netutil_test_ipaddr
# argument 0 is an IP address
# argument 1 is true if the IP address can be a network IP instead of a host IP (optional)
# return 0 ( false ) or 1 ( true )
{
    my @numbers=split /\./o, $_[ 0 ];

    if( !$_[ 1 ] ) {
	# a valid host IP has 4 numbers
	if( $#numbers!=3 ) { return 0; }
    }

    my $num;
    foreach $num ( @numbers ) {
        # check length
        my $len=length $num;
        if( $len<1 || $len>3 ) { return 0; }

        # check digit
        if( $num=~/\D/o ) { return 0; }

        #check number limit
        if( $num>255 ) { return 0; }
    }

    if( !$_[ 1 ] ) {
	# network 0 is not valid
	if( $numbers[ 0 ]==127 ) { return 0; }

	# loopback address is not valid
	if( $numbers[ 0 ]==127 && $numbers[ 1 ]==0 && $numbers[ 2 ]==0 && $numbers[ 3 ]==1 ) { return 0; }
    }

    return 1;
}


1;
