# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Netwatch.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my %Status = ("none","0","0","none","green","1","1","green","2","yellow","red","3","3","red","yellow","2");
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Netwatch.pm.  Changes made here will be lost.
package Cobalt::Netwatch;

#############################################################################
#
# Connect to various TCP ports to verify that network services are running
#
# $Id: Netwatch.pm,v 1.2 1998/07/16 00:20:27 brion Exp $
#
#############################################################################

sub portwatch
# Try to connect to a network port on a machine and verify that it
#            responds properly.
# Arguments:
#            the name of the service (text description)
#            the host (name or IP address) on which the service is running
#            the port (name or number) on which the service is running
#            optional - the instance of the service (defaults to service name)
# Return value: none of note
# Side effects: updates the database to record the last time the state
#            of the service changed
# Use time() instead of $^T so that log file entries show when things
#   actually happened
{
    my ($service,$remote,$port,$inst) = @_;
    $inst ||= $service;  # default value
    my ($proto,$iaddr,$paddr);

    # Set our variables for the connection
    $proto = getprotobyname('tcp');
    if ($port =~ /\D/o) { $port = getservbyname($port, 'tcp') }
    unless ($port)
    {
	return "4320 Invalid port";
    }
    unless ($iaddr = inet_aton($remote))
    {
	return "4321 Unrecognized host $remote";
    }
    $paddr = sockaddr_in($port, $iaddr);
    
    # Try to bind to a socket and connect to the service
    unless (socket(S, PF_INET(), SOCK_STREAM(), $proto))
    {
      db_add_entry($service,$Status{'red'},0,time(),"200",
		     "Can't create socket: $!",$inst);
	return 0;
    }
    unless (connect(S, $paddr))
    {
	db_add_entry($service,$Status{'red'},0,time(),"210",
		      "Can't connect to $service ($inst): $!",$inst);
	return 0;
    }
    
    # we don't actually test beyond the fact that something answered
    db_add_entry($service,$Status{"green"},0,time(),0,
		 "$inst has been running normally",$inst);
    return;
}

use Cobalt::Language;

1;
