# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Network.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $If_cfg_dir = "/etc/sysconfig/network-scripts";
my $Ifconfig_cmd = "/sbin/ifconfig";
my $Ifdown = "/etc/sysconfig/network-scripts/ifdown";
my $Lockdir = "/etc/locks";
my $Sauce_log = "/var/cobalt/sauce.log";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Network.pm.  Changes made here will be lost.
package Cobalt::Network;

sub net_del_vinterface
# Deletes a virtual interface - Automatically invoked by Vsite.pm
# Arguments: IP address of network interface
# Return value: return code + string of the form "2000 Ok"
# Example: $ret = Cobalt::Network::net_del_vinterface('eth0:4');
{
    my ($addr) = @_;

    # Determine the virtual network interface
    my($virtif,$netif);
    open(IFCFG,"$Ifconfig_cmd -a|")
      || return "4768 Cannot run /sbin/ifconfig: $!";
    while (<IFCFG>)
    {
	$netif = $1 if (/^(eth[\d\:]+)\s+Link/);
	$virtif = $netif if (/^\s*inet addr:$addr\s+/);
    }
    close IFCFG;

    # Avoid the ugly..
    undef $virtif if ($virtif eq 'lo'); 
    return "4769 IP address $addr not in use by a virtual network interface" unless ($virtif);
    return "2113 The specified IP address is associated with a real network interface.  There is not virtual network interface to remove." if ($virtif eq 'eth0');
    return "2114 The specified IP address is associated with a real network interface.  There is not virtual network interface to remove." if ($virtif eq 'eth1');
    return "4154 Cannot read /etc/sysconfig/network-scripts/ifcfg-$virtif: $!" unless (-r "$If_cfg_dir/ifcfg-$virtif");

    # get the main network lock file (and the rest of our locks)
    return "4386 Cannot reconfigure network: system busy"
      unless(Cobalt::Network::net_lock_network());
    return "4150 Cannot remove interface: ifcfg-$virtif is locked"
        if (-e "$Lockdir/ifcfg-$virtif");
    open(O,">$Lockdir/ifcfg-$virtif")
        || return "4151 Cannot lock interface config ifcfg-$virtif: $!";
    close O;

    system("$Ifdown $virtif >>$Sauce_log 2>&1");
    unlink("$If_cfg_dir/ifcfg-$virtif");
    unlink("$Lockdir/ifcfg-$virtif");

    Cobalt::Network::net_unlock_network();

    return "2142 Virtual interface deleted successfully";
}


1;
