# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Network.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $If_cfg_dir = "/etc/sysconfig/network-scripts";
my $Ifconfig_cmd = "/sbin/ifconfig";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Network.pm.  Changes made here will be lost.
package Cobalt::Network;

sub net_down_interface
# bring down a network interface
# Arguments: network interface
# Side effects: ifconfig down the interface and
#               remove interface associated files
# Return value: a status message of the form "600 success"
{
    my ( $netif )=@_;

    # lock it first
    if( !Cobalt::Network::net_lock_network() ) {
	return "4393 Cannot reconfigure network: system busy";
    }

    if( system( "$Ifconfig_cmd $netif down 1>&2" )!=0 ) {
	return Cobalt::Network::net_abort( "4394 Cannot bring down network interface $netif" );
    }

    # clean up network script
    unlink "$If_cfg_dir/ifcfg-$netif";

    Cobalt::Network::net_unlock_network();

    return "2068 Network interface brought down successfully";
}


1;
