# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Network.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Resolvconf = "/etc/resolv.conf";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Network.pm.  Changes made here will be lost.
package Cobalt::Network;

sub net_get_dnsclient
# Returns the DNS information
# Arguments: none
# Return value: the current settings in resolv.conf, as a list of the
#   form ($domain,@nameservers)
# Side effects: none
{
    my ($domain,@nameservers);
    return "" if (! -e $Resolvconf);
    open(RC,$Resolvconf) || return "4355 Cannot read /etc/resolv.conf: $!";
    while (<RC>)
    {
	if (/^(domain|search) (.+)/o)
	{
	    $domain = $2;
	}
	elsif (/^nameserver (.+)/o)
	{
	    push(@nameservers,$1);
	}
    }
    close RC;
    return ($domain,@nameservers);
}


1;
