# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Network.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Net_cfg = "/etc/sysconfig/network";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Network.pm.  Changes made here will be lost.
package Cobalt::Network;

sub net_get_forwarding
# Find out wether IP forwarding is set to on or off
# Arguments: none
# Return value: 1 if forwarding is allowed, 0 if we do not forward
# Side effects: none
{
  open(I,$Net_cfg) || return 0;
  while (<I>) {
    if (/^FORWARD_IPV4=false/o) {
      # we don't forward
      close I;
      return 0;
    } elsif (/^FORWARD_IPV4=true/o) {
      # we do forward
      close I;
      return 1;
    }
  }
  # defaults to no if its not explicitly set
  close I;
  return 0;
}


1;
