# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Network.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Network.pm.  Changes made here will be lost.
package Cobalt::Network;

sub net_get_gateway
# Returns the current gateway.
# Arguments: optional network interface argument
# Return value: the IP address of the gateway, the network interface
# Side effects: none
{
  my ($gw,$gwif);
  open(ROUTE,"/proc/net/route") 
    || return "4359 Cannot read routing table: $!";
  while (<ROUTE>)
    {
      if (/^(\w+)\s+00000000\s+(\w\w)(\w\w)(\w\w)(\w\w)\s/)
	{
	  my ($a,$b,$c,$d) = map(hex,($5,$4,$3,$2));
	  $gw = "$a.$b.$c.$d";
	  $gwif = $1;
	  last;
	}
    }
  close ROUTE;
  undef $gwif unless ($gw);  # can't return a interface w/o an address
  return ($gw,$gwif);
}


1;
