# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Network.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $DefaultName = "localhost";
my $Netif = "eth0";
my %Features = ("networker","1","telnetConfig","1","dhcpd","0","shiftjis","Cobalt interface message for shiftjis (We should never see this)","pagebuilder","0","www","1","mx","1","gated","1","dns","1","nfs","0","securetty","1","english","1","atalk","0","fpx","1","siteAdminRedirect","1","users","1","ntp","0","mon_textdb_only","0","search","0","anonFTP","1","specialHomeSkel","0","viewGroups","0","cobaltHomePage","0","lastNameFirst","1","warnRootOnly","1","vsites","1","pam","1","discuss","0","docorg","0","groups","1","smb","0","mail","1","nat","0","squid","0","autoGenWebUsage","0","japanese","0","cobaltRedirect","0","backups","1","vmachine","1","mon_port_testing","1","viewUsers","0","usersCGIInWizard","1","privatedirs","0","telnetDefault","1","ssl","0","siteManagement","1","adm","1","bind8","1","personalRedirect","1","webRequests","1","usersAddUser","0","adminRedirect","1","quotas","1","snmp","1","defaultUserNameGen","1","groupdirs","1","proftpd","1");
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Network.pm.  Changes made here will be lost.
package Cobalt::Network;

sub net_get_hostname
# Get the hostname
# Arguments: optional interface (e.g., "eth1")
# Return value: a string containing the hostname (unqualified)
# Side effects: none
{
  my ($netif) = @_;
  my $name;
  if ((defined($Features{'noinventhostnames'}) && $Features{'noinventhostnames'})
	|| ((! $netif) || ($netif eq $Netif))) {
    # if (noinventhostnames), always return official host name;  also, 
    # primary interface gets the official host name
    open(NAME,"/proc/sys/kernel/hostname") ||
	return "4351 Cannot read /proc/sys/kernel/hostname: $!";
    chomp($name = <NAME>);
    close NAME;
  }
  else {
    # I'm not the primary interface, look my name up
    my ($addr) = Cobalt::Network::net_get_ipaddr($netif);
    # Whoops, did I just hardcode AF_INET as 2?  Damn...
    ($name) = gethostbyaddr(pack('C4',split('\.',$addr)),2);
    $name ||= "cobalt-$netif";
  }
  my ($domain);
  if (($domain = (Cobalt::Network::net_get_dnsclient())[0])
      && ($name =~ /$domain$/))
  {
    $name =~ s/\.?$domain$//;
  }

  # Just in case...we should always return a name.
  $name ||= $DefaultName;

  return $name;
}


1;
