# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Network.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Ifconfig_cmd = "/sbin/ifconfig";
my $Netif = "eth0";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Network.pm.  Changes made here will be lost.
package Cobalt::Network;

sub net_get_ipaddr
# Returns the IP address, netmask, and MAC (ethernet) address of the 
#   running system, as set in the kernel.
# Arguments: an optional interface name (defaults to eth0)
# Return value: a list containing ("IP address","netmask","MAC address").
# Side effects: none
{
  # my $netif = (@_);
  my $netif = $_[0];
  $netif ||= $Netif;
  my ($ipaddr,$netmask,$hwaddr);
  open(IFCFG,"$Ifconfig_cmd $netif|")
    || return "4353 Cannot run /sbin/ifconfig: $!";
  while (<IFCFG>)
    {
      chomp;
      if (/inet addr:([\d\.]+).+Mask:([\d\.]+)/o)
	{
	  $ipaddr = $1;
	  $netmask = $2;
	}
      elsif (/HWaddr (.+)$/o)
	{
	  $hwaddr = $1;  # get the MAC address
	}
    }
  close IFCFG;
  return ($ipaddr,$netmask,$hwaddr);
}


1;
