# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Network.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Netlock = "/etc/locks/NETLOCK";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Network.pm.  Changes made here will be lost.
package Cobalt::Network;

sub net_lock_network
# We only want one person or process mucking with the network configuration
# at a time.  Use this to lock things.
# Arguments: none
# Return value: true if we get the lock, false if we can't get the lock
# Side effects: creates a lock file in $Lockdir
{
    # sometimes there are race conditions where another net_set function
    # still hasn't returned by the time we get called.  Give that extra
    # pause to let things settle if things look bad.
    my $i;
    # Poll for the netlock to go away
    for ($i = 0; $i < 15; $i++) {
      last if (! -e $Netlock);
      sleep 2;
    } 
    return 0 if (-e $Netlock);
    open(L,">$Netlock") || return 0;
    print L "$$\n$0\n";
    close L;
    return 1;
}


1;
