# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Network.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Domainword = "search";
my $Resolvconf = "/etc/resolv.conf";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Network.pm.  Changes made here will be lost.
package Cobalt::Network;

sub net_set_dnsclient
# Configure the DNS client settings
# Arguments: the domain name and a list of nameservers
#   If given an argument of "none", all DNS client information is wiped
# Return value: a status message of the form "600 success"
# Side effects: modifies resolv.conf
{
    my ($domain,@nameservers) = @_;
    my ($server);
    return "4373 Invalid domain name $domain"
	if ($domain !~ /^([\w\-\.]+)$/o);
    return "4363 Invalid character in name server address"
	if (grep(/[^\w\-\.]/o,@nameservers));

    # We should lock, but since we're just clobbering we're probably okay
    open (RC,">$Resolvconf") 
	|| return "4354 Cannot write /etc/resolv.conf";
    if ($domain eq "none")
    {
	close RC;
	return "2419 emptied resolv.conf";
    }
    elsif ($domain && @nameservers)
    {
	print RC "$Domainword $domain\n";
	foreach $server (@nameservers)
	{
	    $server =~ s/(\.|^)0+(\d)/$1$2/go;  # get rid of excess leading zeros
	    print RC "nameserver $server\n" if ($server);
	}
	close RC;

	# Tell the mail server to allow relaying from our and domain
	my($ret) = Cobalt::Email::mail_add_relay($domain);
	return Cobalt::Network::net_abort($ret) if ($ret !~ /^2/o);

	return "2418 wrote resolv.conf";
    }
    close RC;

    return "2417 No change to DNS client configuration";
}


1;
