# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Network.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $ForwardFile = "/proc/sys/net/ipv4/ip_forward";
my $Lockdir = "/etc/locks";
my $Net_cfg = "/etc/sysconfig/network";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Network.pm.  Changes made here will be lost.
package Cobalt::Network;

sub net_set_forwarding
# Turn IP forwarding between interfaces on or off
# Arguments: 1 to turn forwarding on, 0 to not forward packets
# Return value: status string of the form "4934 Never leave the room with
#   your hand still glued to the telephone."
# Side effects: Modifies /etc/sysconfig/network to set boot-time configuration,
#   and sets the kernel forwarding flag via writing to the appropriate file
#   in /proc.
{
  my ($we_forward_packets) = @_;
  return Cobalt::Network::net_abort("4762 Network configuration is in use.  Please try again later.")
    if (-e "$Lockdir/network");
  open(O,">$Lockdir/network")
    || return Cobalt::Network::net_abort("4763 Cannot write network configuration file: $!");
  open(I,$Net_cfg) 
    || return Cobalt::Network::net_abort("4764 Cannot read network configuration file: $!");
  my $done = 0;
  while (<I>) {
    if (/^FORWARD_IPV4=(\w+)$/o) {
      ($we_forward_packets) ? 
	($_ = "FORWARD_IPV4=true\n") : ($_ = "FORWARD_IPV4=false\n");
      $done = 1;
    }
    print O;
  }
  close I;
  unless ($done) {
    ($we_forward_packets) ? 
      (print O "FORWARD_IPV4=true\n") : (print O "FORWARD_IPV4=false\n");
  }
  close O;
  rename("$Lockdir/network",$Net_cfg) ||
    return Cobalt::Network::net_abort("4765 Cannot update network configuration file: $!");
  open(F,">$ForwardFile") || return "3030 Cannot set packet forwarding in the kernel: $!";
  print F "$we_forward_packets\n";
  close F;
  return "2112 Set packet forwarding";
}


1;
