# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Quota.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Q_GETQUOTA = "768";
my $Q_SETQLIM = "1792";
my $Q_SYNC = "1536";
my $SYS_quotactl = "4131";
my %Features = ("networker","1","telnetConfig","1","dhcpd","0","shiftjis","Cobalt interface message for shiftjis (We should never see this)","pagebuilder","0","www","1","mx","1","gated","1","dns","1","nfs","0","securetty","1","english","1","atalk","0","fpx","1","siteAdminRedirect","1","users","1","ntp","0","mon_textdb_only","0","search","0","anonFTP","1","specialHomeSkel","0","viewGroups","0","cobaltHomePage","0","lastNameFirst","1","warnRootOnly","1","vsites","1","pam","1","discuss","0","docorg","0","groups","1","smb","0","mail","1","nat","0","squid","0","autoGenWebUsage","0","japanese","0","cobaltRedirect","0","backups","1","vmachine","1","mon_port_testing","1","viewUsers","0","usersCGIInWizard","1","privatedirs","0","telnetDefault","1","ssl","0","siteManagement","1","adm","1","bind8","1","personalRedirect","1","webRequests","1","usersAddUser","0","adminRedirect","1","quotas","1","snmp","1","defaultUserNameGen","1","groupdirs","1","proftpd","1");
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Quota.pm.  Changes made here will be lost.
package Cobalt::Quota;

sub setqlim
# Set the quota for a user or group
# Arguments: device on which to set quotas, uid, soft limit, hard limit,type
#   (type = 0 for users, 1 for groups)
# Side effects: modifies the quota tables
{
    my ($dev,$uid,$soft,$hard,$type) = @_;
    return "1007 Quotas not implemented" unless ($Features{'quotas'});
    my ($stat);
    my ($dqblk)  = pack("LLLLLLLL",0,0,0,0,0,0,0,0); 
    $stat=syscall($SYS_quotactl,Cobalt::Quota::QCMD($Q_GETQUOTA,$type),$dev,$uid+0,$dqblk); 
    return "4770 Cannot get quota for UID $uid: $!" if ($stat);
    my (@vals) = unpack("LLLLLLLL",$dqblk);
    $vals[1] = $soft;
    $vals[0] = $hard if ($soft);
    $dqblk  = pack("LLLLLLLL",@vals); 
    $stat=syscall($SYS_quotactl,Cobalt::Quota::QCMD($Q_SETQLIM,$type),$dev,$uid+0,$dqblk); 
    return "4771 Cannot set quota for UID $uid: $!" if ($stat);
    $stat=syscall($SYS_quotactl,Cobalt::Quota::QCMD($Q_SYNC,$type),$dev,$uid+0,$dqblk); 
    return "4772 Cannot sync quota for UID $uid: $!" if ($stat);
    return "2115 Quota set for $uid";
}


1;
