# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Repair.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Cron_script = "/etc/rc.d/init.d/cron.init";
my $Crontab = "/etc/crontab";
my $Custo_script = "/etc/rc.d/init.d/custodiat";
my $Dhcpd_conf = "/etc/dhcpd.conf";
my $Dhcpdscript = "/etc/rc.d/init.d/dhcpd";
my $Inetd_conf = "/etc/inetd.conf";
my $Inetd_script = "/etc/rc.d/init.d/inet";
my $Lcdbin = "/sbin/lcdsleep";
my $Lcdsleepscript = "/etc/rc.d/init.d/sleep.init";
my $Mailscript = "/etc/rc.d/init.d/sendmail";
my $NTPscript = "/etc/rc.d/init.d/ntpd";
my $Named_boot = "/etc/named.boot";
my $Named_exe = "/usr/sbin/named";
my $Named_script = "/etc/rc.d/init.d/named";
my $Nfsd = "/usr/sbin/rpc.nfsd";
my $Nfsscript = "/etc/rc.d/init.d/nfs";
my $NtpDate = "/usr/sbin/ntpdate";
my $NtpcConf = "/etc/ntpc.conf";
my $Portmap_bin = "/usr/sbin/portmap";
my $Portmap_script = "/etc/rc.d/init.d/portmap";
my $SNMPconf = "/etc/snmpd.conf";
my $SNMPd = "/usr/sbin/snmpd";
my $SNMPscript = "/etc/rc.d/init.d/snmpd";
my $SSL_script = "/etc/rc.d/init.d/https.init";
my $Sendmail = "/usr/sbin/sendmail";
my $Sendmail_conf = "/etc/sendmail.cf";
my %Features = ("networker","1","telnetConfig","1","dhcpd","0","shiftjis","Cobalt interface message for shiftjis (We should never see this)","pagebuilder","0","www","1","mx","1","gated","1","dns","1","nfs","0","securetty","1","english","1","atalk","0","fpx","1","siteAdminRedirect","1","users","1","ntp","0","mon_textdb_only","0","search","0","anonFTP","1","specialHomeSkel","0","viewGroups","0","cobaltHomePage","0","lastNameFirst","1","warnRootOnly","1","vsites","1","pam","1","discuss","0","docorg","0","groups","1","smb","0","mail","1","nat","0","squid","0","autoGenWebUsage","0","japanese","0","cobaltRedirect","0","backups","1","vmachine","1","mon_port_testing","1","viewUsers","0","usersCGIInWizard","1","privatedirs","0","telnetDefault","1","ssl","0","siteManagement","1","adm","1","bind8","1","personalRedirect","1","webRequests","1","usersAddUser","0","adminRedirect","1","quotas","1","snmp","1","defaultUserNameGen","1","groupdirs","1","proftpd","1");
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Repair.pm.  Changes made here will be lost.
package Cobalt::Repair;

sub repair_fix
# Try to diagnose and fix problems
# Arguments: service name
# Side effects: attempts repairs
# Return value: status string
{
    my ($service) = @_;

    # Another big case statement...do the deed for the server we have
    if ($service eq "dns")        {
      return Cobalt::Repair::repair_generic($service,$Named_exe,$Named_boot,
			    $Named_script,0);    }
    elsif ($service eq "custo")   {
      return Cobalt::Repair::repair_generic("custo",0,0,$Custo_script,0);   }
    elsif ($service eq "crond")   {
      return Cobalt::Repair::repair_generic("crond",0,$Crontab,$Cron_script,0);   }
    elsif ($service eq "dhcpd")   {
      return Cobalt::Repair::repair_generic("dhcpd",0,$Dhcpd_conf,$Dhcpdscript,0); }
    elsif ($service eq "inetd")   {
      return Cobalt::Repair::repair_generic("inetd",0,$Inetd_conf,$Inetd_script,0); }
    elsif ($service eq "lcd")     {
      return Cobalt::Repair::repair_generic("lcd",$Lcdbin,0,$Lcdsleepscript,0);     }
    elsif ($service eq "modem") {
      return Cobalt::Repair::repair_modem();
    }
    elsif ($service eq "mail")    {
      return Cobalt::Repair::repair_generic("mail",$Sendmail,$Sendmail_conf,
			    $Mailscript,1);    }
    elsif ($service eq "ntp")     {
      return Cobalt::Repair::repair_generic("ntp",$NtpDate,$NtpcConf,
			    $NTPscript,0);     }
    elsif ($service eq "nfs")     {
      return Cobalt::Repair::repair_generic($service,$Nfsd,0,$Nfsscript,0);    }
    elsif ($service eq "portmap") {
      return Cobalt::Repair::repair_generic("portmap",$Portmap_bin,0,
			    $Portmap_script,0); }
    elsif ($service eq "snmp")    {
      return Cobalt::Repair::repair_generic("snmp",$SNMPd,$SNMPconf,
			    $SNMPscript,0);    }
    elsif ($service eq "ssl")     {
      return "1055 SSL is not implemented in this release"
	unless ($Features{'ssl'});
      return Cobalt::Repair::repair_generic("ssl",0,0,$SSL_script,0);
    }
    elsif ($service eq "telnet")   {
      return Cobalt::Repair::repair_generic("telnet",0,0,0,1); }
    elsif ($service eq "adm")        { return Cobalt::Repair::repair_adm();           }
    elsif ($service eq "atalk")      { return Cobalt::Repair::repair_atalk();         }
    elsif ($service eq "cpu")        { return Cobalt::Repair::repair_cpu();           }
    elsif ($service eq "filesystem") { return Cobalt::Repair::repair_disk($service);  }
    elsif ($service eq "userspace")  { return Cobalt::Repair::repair_disk($service);  }
    elsif ($service eq "groupspace") { return Cobalt::Repair::repair_disk($service);  }
    elsif ($service eq "ftp")        { return Cobalt::Repair::repair_ftp();           }
    elsif ($service eq "mem")        { return Cobalt::Repair::repair_mem();           }
    elsif ($service eq "net")        { return Cobalt::Repair::repair_net();           }
    elsif ($service eq "smb")        { return Cobalt::Repair::repair_smb();           }
    elsif ($service eq "www")        { return Cobalt::Repair::repair_www();           }

    else                             { return "4701 Unknown service"; }
}


1;
