# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Repair.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my %Features = ("networker","1","telnetConfig","1","dhcpd","0","shiftjis","Cobalt interface message for shiftjis (We should never see this)","pagebuilder","0","www","1","mx","1","gated","1","dns","1","nfs","0","securetty","1","english","1","atalk","0","fpx","1","siteAdminRedirect","1","users","1","ntp","0","mon_textdb_only","0","search","0","anonFTP","1","specialHomeSkel","0","viewGroups","0","cobaltHomePage","0","lastNameFirst","1","warnRootOnly","1","vsites","1","pam","1","discuss","0","docorg","0","groups","1","smb","0","mail","1","nat","0","squid","0","autoGenWebUsage","0","japanese","0","cobaltRedirect","0","backups","1","vmachine","1","mon_port_testing","1","viewUsers","0","usersCGIInWizard","1","privatedirs","0","telnetDefault","1","ssl","0","siteManagement","1","adm","1","bind8","1","personalRedirect","1","webRequests","1","usersAddUser","0","adminRedirect","1","quotas","1","snmp","1","defaultUserNameGen","1","groupdirs","1","proftpd","1");
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Repair.pm.  Changes made here will be lost.
package Cobalt::Repair;

sub repair_get_message
# Given the flags from the monitoring database, return the message.
#   This message should provide advice on how the user should deal
#   with the problem at hand.
# Arguments: service, instance
# Return value: message string
{
    my ($service,$instance) = @_;
    my $return;

    # We're really only interested in the $data fields
    my ($condition,$cond_time,$update_time,$notified,$attempts,
	$reserved,$data) = Cobalt::Monitor::mon_get_state($service,$instance);

    # Handle a few special cases, but pretty much generalize
    # the loop
    if ($service eq "groupspace") # user quota
      {
	# $instance is the group or site name
	# $data is (percentage of quota used, amount used, limit)
	my $name;
	my @data = split(/,/o,$data);
	if($Features{'vsites'}) {
	  $name = ( Cobalt::Vsite::vsite_get_bygroup($instance) )[2];
	  $name ||= $instance;	# Group name better than no name
	  $return = Cobalt::Language::msg_get("mon_sitespace_body");
	  $return = eval "\"$return\"";
	  return $return;
	}
	else {
	  $name = $instance;	# group name is the instance
	  $return = Cobalt::Language::msg_get("mon_${service}_body");
	  $return = eval "\"$return\"";
	  return $return;
	}

      }
    elsif ($service eq "dns")
      {
	if ($instance eq "nslookup") # can't resolve our name
	  {
	    return Cobalt::Language::msg_get("mon_dns_nslookup_body");
	  }
	else
	  {
	    my @data = split(/,/o,$data);
	    $return = Cobalt::Language::msg_get("mon_${service}_body");
	    $return = eval "\"$return\"";
	    return $return;
	  }
      }
    elsif ($service eq "mail")	# mail server
      {
	if    ($instance eq "smtp") # SMTP server
	  {
	    return Cobalt::Language::msg_get("mon_mail_smtp_body");
	  }
	elsif ($instance eq "pop3") # POP3 server (run via inetd)
	  {
	    return Cobalt::Language::msg_get("mon_mail_pop3_body");
	  }
	elsif ($instance eq "imap") # IMAP server (run via inetd)
	  {
	    return Cobalt::Language::msg_get("mon_mail_imap_body");
	  }
	else
	  {
	    return Cobalt::Language::msg_get("mon_mail_body");
	  }
      }
    else {
      my @data = split(/,/o,$data);
      $return = Cobalt::Language::msg_get("mon_${service}_body");
      $return = eval "\"$return\"";
      return $return;
    }
}


1;
