# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Samba.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Smb_nmblookup = "/usr/bin/nmblookup";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Samba.pm.  Changes made here will be lost.
package Cobalt::Samba;

sub get_node_status
# Gets the node status of a SMB server
# Returns: this long list:
# (netbios hostname, workgroup name, username, is browser, is potential
# browser, is local master browser, is domain master browser and/or PDC,
# is logon server)
# failure indicates that the machine is offline or is a win95 host
# Arguments: ip address of the host to scan
# Side effects: if a win95 query is performed nmbd must not be running
{
  my ($ip, $win95) = @_;
  my ($hname, $workgroup, $user, $ismb, $ispmb, $islmb, $isdmb, $islogon);
  my ($name, $type, $group, $win95hack, $status);
  
  $isdmb = 0;
  $ismb = 0;
  $ispmb = 0;
  $islmb = 0;
  $islogon = 0;
  
  if ($win95) {
    $win95hack = ' -r';
  }

  open(STATUS, "$Smb_nmblookup$win95hack -S -U $ip '*'|");
#  print "$Smb_nmblookup $win95hack-S -U $ip '*'|\n";
  foreach $status (<STATUS>) {

    if (/No status response/o) {
      print STDERR "no status from $ip\n";
      return 0;
    }

    if ($status =~ /^\t(.{15,15}) <(..)> . (.{7,7})/o) {
      $name = $1;
      $type = $2;
      $group = ($3 eq '<GROUP>');
    }
    
    # workgroup/domain name
    if (($type eq '00') &&
	($group)) {
      $workgroup = $name;
      $workgroup =~ s/^\s*(.*?)\s*$/$1/;
    }
    
    # hostname
    if (($type eq '00') &&
	(! $group) &&
	(! $hname)) {
      $hname = $name;
      $hname =~ s/^\s*(.*?)\s*$/$1/;
    }
    
    # domain master browser / PDC
    if (($type eq '1b') && (! $group)) {
      $isdmb = 1;
    }
    
    # master browser
    if (($type eq '01') && (! $group)) {
      $ismb = 1;
    }
    
    # local master browser
    if (($type eq '1d') && (! $group)) {
      $islmb = 1;
    }
    
    # potential master browser
    if (($type eq '1e') && ($group)) {
      $ispmb = 1;
    }
    
    # domain logon server
    if (($type eq '1c') && ($group)) {
      $islogon = 1;
    }
  }
  close(STATUS);
  return ($hname, $workgroup, $user, $ismb, $ispmb, $islmb, $isdmb, $islogon);
}


1;
