# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Samba.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Smbconf = "/etc/smb.conf";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Samba.pm.  Changes made here will be lost.
package Cobalt::Samba;

sub get_smb_service_parms 
{
  my ($name, $hash) = @_;
  my ($parm, $value);
  my $inserv = 0;
  my $found = 0;

  open(SMB, "$Smbconf") or 
    return "4779 Cannot read smb.conf file /etc/smb.conf: $!";
  while (<SMB>) {
    # ignore comments
    next if (/^.*[;\#]/o);

    # watch for service header
    if (/\[([^\]]+)\]/o) {
      $inserv = ($1 =~ /$name/i);
      $found = 1 if ($inserv);
    }
    # load setting
    if (($inserv) &&
	(/^([\w ]+)=(.*)$/o)) {
      $parm = $1;
      $value = $2;
      $parm =~ s/^\s*(.*?)\s*$/$1/;
      $parm =~ tr/[A-Z]/[a-z]/;
      $value =~ s/^\s*(.*?)\s*$/$1/;	
      $$hash{$parm} = $value;
    }
  }
  close(SMB);
  
  if ($found) {
    return 0;
  } else {
    return "4780 Service does not exist";
  }  
}


1;
