# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Samba.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Smbclient = "/usr/bin/smbclient";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Samba.pm.  Changes made here will be lost.
package Cobalt::Samba;

sub get_workgroups 
# Arguments: netbios name, IP address
# Returns: browse list or undefined (failure)
# Side effects: none
{
  my ($netbios, $ip) = @_;
  my ($temp, @list);
  my $inwg = 0;

  open(CLIENT, "$Smbclient -L $netbios -I $ip -U ''|") or 
    return "4776 Cannot execute /usr/bin/smbclient: $!";
  
  while (<CLIENT>) {
    if (/^\tWorkgroup\s+Master/o) {
      $inwg = 1;
    }
    
    elsif (/---------/o) {
      # do nothing
    }

    elsif ($inwg &&
	   (/^\t(.{16,16})/o)) {
      $temp = $1;
      # trim whitespace
      $temp =~ s/^\s*(.*?)\s*$/$1/;
      push @list, $temp;
    }
  }
  close(CLIENT);
  return @list;
}    


1;
