# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Samba.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Lockdir = "/etc/locks";
my $Smbconf = "/etc/smb.conf";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Samba.pm.  Changes made here will be lost.
package Cobalt::Samba;

sub samba_del_service {
  my $name = shift;
  my $inserv = 0;

  return "4784 smb.conf is locked" if (-e "$Lockdir/smb.conf");
  open(SMBLOCK,">$Lockdir/smb.conf") 
    or return "4785 Cannot write to lock file";
  open(SMB, "$Smbconf") 
    or return "4786 Cannot read smb.conf file /etc/smb.conf: $!";
  while (<SMB>) {
    # ignore comments
    if (/^.*[;\#]/o) {
      print SMBLOCK;
      next;
    }

    # watch for service header
    if (/\[([^\]]+)\]/o) {
      if ($1 =~ /$name/i) {
	# do nada
	$inserv = 1;
	next;
      } else {
	$inserv = 0;
      }
    }
    
    # write setting
    if (! $inserv) {
      print SMBLOCK;
    }
  }
  close(SMB);
  close(SMBLOCK);
  rename("$Lockdir/smb.conf", $Smbconf);

  return 0;
}


1;
