# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Samba.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Smbconf = "/etc/smb.conf";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Samba.pm.  Changes made here will be lost.
package Cobalt::Samba;

sub samba_service_exists
# return 1 if service exists, 0 if it does not
# Arguments: $service
#
# this may lead to potentially inefficient code (multiple readings of the
# smb.conf file when a single read could have been done) but using this
# makes my code more readable to me.
{
  my $service = shift;
  my $found = 0;
  
  open(SMB, "$Smbconf") or 
    return "4778 Cannot read smb.conf file /etc/smb.conf: $!";
  while (<SMB>) {
    # ignore comments
    if (! /^.*[;\#]/o) {
      # watch for service header
      if (/\[([^\]]+)\]/o) {
	$found = 1 if ($1 eq $service);
      }
    }
  }
  close(SMB);
  
  return $found;
}


1;
