# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Samba.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Smb_scanlock = "/etc/locks/smb_scanlock";
my $Smb_wglist = "/etc/workgroups";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Samba.pm.  Changes made here will be lost.
package Cobalt::Samba;

sub scan_for_workgroups_bg
# scan_for_workgroups_bg
# Forks a process to scan the network for a list of workgroups.
{
  my ($pid, @wglist, %smbconf);

  if (!defined($pid = fork)) {
    die "cannot fork: $!";
  } elsif ($pid) {
    # i'm the parent
    print STDERR "forking a child to scan for workgroups\n" if ($Debug);
  }
  else
    {
      # otherwise I'm the child
      if (-e $Smb_scanlock) {
	# another process is already performing the scan
	exit;
      }
      
      # there's a race condition between the above command and the next,
      # but I'm over it-- its unlikely to cause us trouble.
      
      # set the scan lock
      open(LOCK, ">$Smb_scanlock"); 
      print LOCK "$$\$0";
      close(LOCK);
      # open the workgroup list file
      open(LIST, ">$Smb_wglist");
      
      # add locally configured workgroup to the file, if necessary
      my $found = 0;
      Cobalt::Samba::get_smb_service_parms('global', \%smbconf);
      @wglist = Cobalt::Samba::scan_for_workgroups();
      foreach (@wglist) {
	if (/$smbconf{'workgroup'}/io) {
	  $found = 1;
	}
      }
      if (! $found) {
	push @wglist, $smbconf{'workgroup'};
      }

      print LIST join("\n", sort(@wglist));;

      close(LIST);
      # remove scan lock
      unlink($Smb_scanlock);
      
      exit;
    }
  
  # done!
  return 1;
}


1;
