# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Samba.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Lockdir = "/etc/locks";
my $Smbconf = "/etc/smb.conf";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Samba.pm.  Changes made here will be lost.
package Cobalt::Samba;

sub set_smb_service_parms
{
  my ($name, $newname, $hash) = @_;
  my ($parm, $value);
  my $inserv = 0;

  return "4781 smb.conf is locked" if (-e "$Lockdir/smb.conf");
  open(SMBLOCK,">$Lockdir/smb.conf") 
    or return "4782 Cannot write to lock file";
  open(SMB, "$Smbconf") 
    or return "4783 Cannot read smb.conf file /etc/smb.conf: $!";
  while (<SMB>) {
    # ignore comments
    if (/^.*[;\#]/o) {
      print SMBLOCK $_;
      next;
    }

    # watch for service header
    if (/\[([^\]]+)\]/o) {
      if ($1 =~ /$name/i) {
	# write parameters
	if (defined($newname)) {
	  print SMBLOCK "[$newname]\n";
	} else {
	  print SMBLOCK;
	}
	  
	foreach $parm (sort (keys %$hash)) {
	  print SMBLOCK "   $parm = $$hash{$parm}\n";
	}
	$inserv = 1;
	next;
      } else {
	$inserv = 0;
      }
    }
    
    # write setting
    if (! $inserv) {
      print SMBLOCK $_;
    }
  }
  close(SMB);
  close(SMBLOCK);
  rename("$Lockdir/smb.conf", $Smbconf);

  return 1;
}


1;
