# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Security.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Access_file = ".htaccess";
my $Adm_Authname = "CobaltAdmin";
my $Adminuser = "admin";
my $Groups_dir = "/usr/admserv/html/.cobalt/groups";
my $Htgroup = "/etc/htgroup";
my $Htpasswd = "/etc/htpasswd";
my %Features = ("networker","1","telnetConfig","1","dhcpd","0","shiftjis","Cobalt interface message for shiftjis (We should never see this)","pagebuilder","0","www","1","mx","1","gated","1","dns","1","nfs","0","securetty","1","english","1","atalk","0","fpx","1","siteAdminRedirect","1","users","1","ntp","0","mon_textdb_only","0","search","0","anonFTP","1","specialHomeSkel","0","viewGroups","0","cobaltHomePage","0","lastNameFirst","1","warnRootOnly","1","vsites","1","pam","1","discuss","0","docorg","0","groups","1","smb","0","mail","1","nat","0","squid","0","autoGenWebUsage","0","japanese","0","cobaltRedirect","0","backups","1","vmachine","1","mon_port_testing","1","viewUsers","0","usersCGIInWizard","1","privatedirs","0","telnetDefault","1","ssl","0","siteManagement","1","adm","1","bind8","1","personalRedirect","1","webRequests","1","usersAddUser","0","adminRedirect","1","quotas","1","snmp","1","defaultUserNameGen","1","groupdirs","1","proftpd","1");
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Security.pm.  Changes made here will be lost.
package Cobalt::Security;

sub security_set_group_management
# Allow or disallow anyone in the world to manage groups
# Arguments: 1 to allow anyone in the world to manage groups,
#   0 to allow only user "admin" to manage groups
# Return value: usual string of form "924 I eat chalk"
# Side effects: creates or deletes .htaccess files as appropriate
{
    my ($setting) = @_;
    return "1401 Groups not implemented" unless ($Features{'groups'});
    if ($setting)
    {
	# allow anyone
	if (! -e "$Groups_dir/$Access_file")
	{
	    return "2442 No change to group management";
	}
	else 
	{
	    unlink("$Groups_dir/$Access_file") ||
		return "4403 Cannot delete Groups_dir/.htaccess: $!";
	    return "2440 Anyone in the world can manage groups";
	}
    }
    else
    {
	# allow admin only
	if (-e "$Groups_dir/$Access_file")
	{
	    return "2444 No change to group management";
	}
	else 
	{
	    open(GXS,"$Groups_dir/$Access_file") ||
		return "4404 Cannot write Groups_dir/.htaccess: $!";
	    print GXS "<LIMIT GET>\norder allow,deny\nallow from all\n";
	    print GXS "require user $Adminuser\n</LIMIT>\n";
	    print GXS "Authname $Adm_Authname\n";
	    print GXS "Authtype Basic\n";
            unless ($Features{'pam'}) {
            print GXS "AuthUserFile $Htpasswd\n";
	    print GXS "AuthGroupFile $Htgroup\n";
            }
	    close GXS;
	    return "2448 Only the administrator may manage groups";
	}
    }
}


1;
