# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Services.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Gated_conf = "/etc/gated.conf";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Services.pm.  Changes made here will be lost.
package Cobalt::Services;

sub get_gated_interfaces
# Get the list of interfaces on which gated will listen
# Arguments: none
# Side effects: reads gated.conf
# Return value: list of interfaces ("eth0","eth1")
# Example: @netifs = Cobalt::Services::get_gated_interfaces();
{
  open(IN,$Gated_conf) || 
    return "4804 Cannot read gated configuration file /etc/gated.conf: $!";
  my $inrip;
  my @netifs;
  while (<IN>) {
    if (/^rip yes/o) {
      $inrip = 1;
    }
    elsif ($inrip && /\};/o) {
      last;
    }
    elsif ($inrip && /^\s*interface all/o) {
      # the default interface entry
      next;
    }
    elsif ($inrip && /^\s*interface (\S+)/o) {
      push(@netifs,$1);
    }
  }
  close IN;
  return @netifs;
}


1;
