# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Services.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Smbconf = "/etc/smb.conf";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Services.pm.  Changes made here will be lost.
package Cobalt::Services;

sub get_smb_controller
# Get the domain controller for the SMB server (samba)
# Arguments: none
# Side effects: modifies smb.conf and restarts samba
# Return value: an array containing a boolean of wether samba is using a
#    server, and the name of the server
# Example: ($using_domain_controller,$server) = Cobalt::Services::get_smb_controller();
#          print "Server is $server\n" if ($using_domain_controller);
{
    my ($security,$server);
    open(SMB,"$Smbconf") 
	|| return "3472 Cannot read samba config file /etc/smb.conf: $! ";
    while (<SMB>)
    {
	if (/^\s*security = (.+)/o)
	{
	    ($1 eq "user") ? ($security = 0) : ($security = 1);
	}
	elsif (/^\;?\s*password server = (.+)/o)
	{
	    $server = $1;
	}
    }
    close SMB;
    $server = "" if ($server =~ /\</o);
    return ($security,$server);
}


1;
