# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Services.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Smbconf = "/etc/smb.conf";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Services.pm.  Changes made here will be lost.
package Cobalt::Services;

sub get_smb_workgroup
# Get the workgroup for the SMB server (samba)
# Arguments: none
# Side effects: modifies smb.conf and restarts samba
# Return value: the name of the workgroup
# Example: $workgroup = Cobalt::Services::get_smb_workgroup();
{
    my ($workgroup);
    open(SMB,"$Smbconf") 
	|| return "3471 Cannot read samba config file /etc/smb.conf: $! ";
    while (<SMB>)
    {
	if (/\s*workgroup = (\w+)/o)
	{
	    $workgroup = $1;
	    last;
	}
    }
    close SMB;
    return $workgroup;
}


1;
