# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Services.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $SNMPconf = "/etc/snmpd.conf";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Services.pm.  Changes made here will be lost.
package Cobalt::Services;

sub get_snmp_community
# Gets the names of the SNMP communities
# Arguments: none
# Return value: the read-only community, the read/write community
#   If a community name is not set, then we return 0.
{
    my ($read_community,$write_community);
    $read_community ||= '';   # default in case there is none set
    $write_community ||= '';  # default in case there is none set
    open( SNMP, "<$SNMPconf" )
	|| return "3479 Cannot read SNMP config file /etc/snmpd.conf: $! ";
    while( <SNMP> ) {
	if( /^\s*community\s+(\S+)\s+xmini/o ) {
	    $read_community = $1;
	    # if we know both, then we're done
	    last if ($write_community);
	}
	elsif( /^\s*community\s+(\S+)\s+mini/o ) {
	    $write_community = $1;
	    # if we know both, then we're done
	    last if ($read_community);
	}
    }
    close SNMP;
    return ($read_community,$write_community);
}


1;
