# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Services.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Atalklink = "/etc/rc.d/rc3.d/S91atalk";
my $Atalkscript = "/etc/rc.d/init.d/atalk";
my $Lcdshowscript = "/etc/rc.d/init.d/showip";
my $Sauce_log = "/var/cobalt/sauce.log";
my %Features = ("networker","1","telnetConfig","1","dhcpd","0","shiftjis","Cobalt interface message for shiftjis (We should never see this)","pagebuilder","0","www","1","mx","1","gated","1","dns","1","nfs","0","securetty","1","english","1","atalk","0","fpx","1","siteAdminRedirect","1","users","1","ntp","0","mon_textdb_only","0","search","0","anonFTP","1","specialHomeSkel","0","viewGroups","0","cobaltHomePage","0","lastNameFirst","1","warnRootOnly","1","vsites","1","pam","1","discuss","0","docorg","0","groups","1","smb","0","mail","1","nat","0","squid","0","autoGenWebUsage","0","japanese","0","cobaltRedirect","0","backups","1","vmachine","1","mon_port_testing","1","viewUsers","0","usersCGIInWizard","1","privatedirs","0","telnetDefault","1","ssl","0","siteManagement","1","adm","1","bind8","1","personalRedirect","1","webRequests","1","usersAddUser","0","adminRedirect","1","quotas","1","snmp","1","defaultUserNameGen","1","groupdirs","1","proftpd","1");
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Services.pm.  Changes made here will be lost.
package Cobalt::Services;

sub set_atalk_server_on
# Turn the atalk server on or off
# Arguments: 1 for on, 0 for off
# Return value: a status string of the form "582 insufficient depth perception"
# Side effects: creates or breaks symlinks in /etc/rc.d/rc3.d
{
    my ($state) = @_;

    return "1104 AppleShare service is not implemented in this release"
      unless ($Features{'atalk'});

    if ($state && (! -e $Atalklink))
    {
	symlink($Atalkscript,$Atalklink) ||
	    return "4427 Cannot create link /etc/rc.d/rc3.d/S91atalk: $!";
	my $pid;
	if (!defined($pid = fork)) {
	    die "cannot fork: $!";
	} elsif ($pid) {
	    # i'm the parent
	    print STDERR "Forking to restart appletalk\n" if ($Debug);
	    return "2431 AppleShare server started";
	}
	else
	{
	    # otherwise I'm the child
	    open(STDERR,">>$Sauce_log");
	    open(STDOUT,">>$Sauce_log");
	    system ("$Atalkscript start >>$Sauce_log 2>&1 ") &&
		warn "3431 Cannot start AppleShare server: $!";
	    system ("$Lcdshowscript start >> $Sauce_log 2>&1")
	      if (-x $Lcdshowscript);
	    exit;
	}
    }
    elsif ((! $state) && (-e $Atalklink))
    {
	my $pid;
	if (!defined($pid = fork)) {
	    die "cannot fork: $!";
	} elsif ($pid) {
	    # i'm the parent
	    print STDERR "Forking to stop appletalk\n" if ($Debug);
	    return "2433 AppleShare server stopped";
	}
	else
	{
	    # otherwise I'm the child
	    open(STDERR,">>$Sauce_log");
	    open(STDOUT,">>$Sauce_log");
	    unlink($Atalklink) ||
	      die "3433 Cannot break link /etc/rc.d/rc3.d/S91atalk: $!";
	    system ("$Atalkscript stop 1>&2") &&
	      die "4428 Cannot stop AppleShare server: $!";
	    system ("$Lcdshowscript start >> $Sauce_log 2>&1")
	      if (-x $Lcdshowscript);
	    Cobalt::Network::net_set_ipaddr(Cobalt::Network::net_get_ipaddr());
	    exit;
	}
    }
    else
    {
	my $off;
        ($state) ? ($off = Cobalt::Language::msg_get('On_string')) : 
	  ($off = Cobalt::Language::msg_get('Off_string'));
	return "2454 No change -- AppleShare server was already $off";	
    }
}


1;
