# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Services.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Dhcpd_conf = "/etc/dhcpd.conf";
my $Dhcpd_leases = "/etc/dhcpd.leases";
my $Dhcpdlink = "/etc/rc.d/rc3.d/S86dhcpd";
my $Dhcpdscript = "/etc/rc.d/init.d/dhcpd";
my $Lcdshowscript = "/etc/rc.d/init.d/showip";
my $Sauce_log = "/var/cobalt/sauce.log";
my %Features = ("networker","1","telnetConfig","1","dhcpd","0","shiftjis","Cobalt interface message for shiftjis (We should never see this)","pagebuilder","0","www","1","mx","1","gated","1","dns","1","nfs","0","securetty","1","english","1","atalk","0","fpx","1","siteAdminRedirect","1","users","1","ntp","0","mon_textdb_only","0","search","0","anonFTP","1","specialHomeSkel","0","viewGroups","0","cobaltHomePage","0","lastNameFirst","1","warnRootOnly","1","vsites","1","pam","1","discuss","0","docorg","0","groups","1","smb","0","mail","1","nat","0","squid","0","autoGenWebUsage","0","japanese","0","cobaltRedirect","0","backups","1","vmachine","1","mon_port_testing","1","viewUsers","0","usersCGIInWizard","1","privatedirs","0","telnetDefault","1","ssl","0","siteManagement","1","adm","1","bind8","1","personalRedirect","1","webRequests","1","usersAddUser","0","adminRedirect","1","quotas","1","snmp","1","defaultUserNameGen","1","groupdirs","1","proftpd","1");
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Services.pm.  Changes made here will be lost.
package Cobalt::Services;

sub set_dhcp_server_on
# Turn the dhcp server on or off
# Arguments: 1 for on, 0 for off
# Return value: a status string of the form "4325 Massive ego impeding development"
# Side effects: creates or breaks symlink
{
    my ($state) = @_;

    return "1110 Dhcpd service is not implemented in this release"
      unless ($Features{'dhcpd'});

    return "4333 DHCP Server Parameters are not yet configured" if ($state && !(-e $Dhcpd_conf));

    if ($state && (! -e $Dhcpdlink))
    {
	unless (-e $Dhcpd_leases)
	{
	    open(LEES,"> $Dhcpd_leases") || return "4334 Can not create lease database";
	    close(LEES);
	}
	open(DHCPSTART,"$Dhcpdscript start 2>&1 |") ||
	  return "4787 Could not run DHCP server startup script";
	open(LOG,">>$Sauce_log") || return "4788 Could not write to log file /var/cobalt/sauce.log: $!";
	# The error message comes right before the "exiting" line...
	# so we remember the error and then return it if we see
	# "exiting"
	my ($line,$line1,$line2);
	while (<DHCPSTART>) {
	  if (/exiting/o) {
	    print LOG;
	    close LOG;
	    close DHCPSTART;
	    $line = "$line1 $line2";
	    return "4789 DHCP server could not start: $line";
	  }
	  unless (/^[\s\^]*$/o) {  # ignore blank lines
	    $line1 = $line2;
	    chomp($line2 = $_);
	  } 
	  print LOG;
	}
	close DHCPSTART;
	close LOG;
	system ("$Lcdshowscript start >> $Sauce_log 2>&1")
	  if (-x $Lcdshowscript);
	symlink($Dhcpdscript,$Dhcpdlink) ||
	    return "4335 Cannot create link /etc/rc.d/rc3.d/S86dhcpd: $!";
	return "2335 Dhcp server started successfully";
    }
    elsif ((! $state) && (-e $Dhcpdlink))
    {
	my $pid;
	if (!defined($pid = fork)) {
	    die "cannot fork: $!";
	} elsif ($pid) {
	    # i'm the parent
	    print STDERR "Forking to stop Dhcpd\n" if ($Debug);
	    return "2332 Dhcp server stopped";
	}
	else
	{
	    # otherwise I'm the child
	    open(STDERR,">>$Sauce_log");
	    open(STDOUT,">>$Sauce_log");
	    unlink($Dhcpdlink) ||
	      die "3503 Cannot break link /etc/rc.d/rc3.d/S86dhcpd: $!";
	    system ("$Dhcpdscript stop 1>&2") &&
	      die "4336 Cannot stop Dhcp server: $!";
	    system ("$Lcdshowscript start >> $Sauce_log 2>&1")
	      if (-x $Lcdshowscript);
	    exit;
	}
    }
    elsif ($state)
    {
      return "2333 No change -- Dhcp server was already on";	
    }
    else 
    {
      return "2334 No change -- Dhcp server was already off";	
    }
}


1;
