# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Services.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Named_boot = "/etc/named.boot";
my $Named_conf = "/etc/named.conf";
my $Named_dir = "/etc/named";
my $Named_disabled = "/etc/named.disabled";
my $Named_script = "/etc/rc.d/init.d/named";
my $Sauce_log = "/var/cobalt/sauce.log";
my $Subsys = "/var/lock/subsys";
my %Features = ("networker","1","telnetConfig","1","dhcpd","0","shiftjis","Cobalt interface message for shiftjis (We should never see this)","pagebuilder","0","www","1","mx","1","gated","1","dns","1","nfs","0","securetty","1","english","1","atalk","0","fpx","1","siteAdminRedirect","1","users","1","ntp","0","mon_textdb_only","0","search","0","anonFTP","1","specialHomeSkel","0","viewGroups","0","cobaltHomePage","0","lastNameFirst","1","warnRootOnly","1","vsites","1","pam","1","discuss","0","docorg","0","groups","1","smb","0","mail","1","nat","0","squid","0","autoGenWebUsage","0","japanese","0","cobaltRedirect","0","backups","1","vmachine","1","mon_port_testing","1","viewUsers","0","usersCGIInWizard","1","privatedirs","0","telnetDefault","1","ssl","0","siteManagement","1","adm","1","bind8","1","personalRedirect","1","webRequests","1","usersAddUser","0","adminRedirect","1","quotas","1","snmp","1","defaultUserNameGen","1","groupdirs","1","proftpd","1");
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Services.pm.  Changes made here will be lost.
package Cobalt::Services;

sub set_dns_server_on
# Turn the dns server on or off
# Arguments: 1 for on, 0 for off
# Side effects: creates or removes /etc/named.boot, runs or kills named
{
    my ($state) = @_;

    return "1103 DNS service is not implemented in this release"
      unless ($Features{'dns'});

    # Supports both Bind 4 and 8 formats
    my($bind_conf)=$Named_boot;
    $bind_conf=$Named_conf if ($Features{'bind8'});

    if ($state)
    {
        if (-e "$Named_disabled")
	{
            rename($Named_disabled,$bind_conf)
		|| return "4850 Cannot copy /etc/named.disabled to /etc/named.boot: $!";
            unless (system("$Named_script start >>$Sauce_log 2>&1"))
	    {
                return "2850 DNS server started";
	    }
            else
	    {
                return "4851 DNS server start failed: $!";
	    }
	}
        elsif (-e "$bind_conf")
        {
            return "2856 No change -- the DNS server was already on";
        }
        else
        {
            # Create fresh new named.boot
            my($named_boot,$srv);
	    if ($Features{'bind8'}) {
		$named_boot = <<EOF;
options { directory "$Named_dir"; };
zone "." { type hint; file "db.cache"; };
EOF
	    } else {
		$named_boot = "directory\t$Named_dir\n\ncache\t.\tdb.cache\n";
            }
            open(NAMED,"> $bind_conf")
		|| return "4852 Cannot write to /etc/named.boot: $!";
            print NAMED $named_boot;
            close(NAMED);
            $srv = system("$Named_script start >>$Sauce_log 2>&1");

            if (!$srv)
	    {
		return "2852 DNS server started";
	    }
            else
	    {
                return "4853 DNS server start failed: $!";
	    }
	}
    }
    else
    {
        if (-e "$bind_conf")
	{
	    my $srv = system("$Named_script stop >>$Sauce_log 2>&1");
	    unlink( "$Subsys/named" ) if (-f "$Subsys/named" );
	    
	    rename($bind_conf,$Named_disabled)
		|| return "4856 Cannot rename /etc/named.boot to /etc/named.disabled: $!";
	    if (!$srv)
	    {
		return "2854 DNS server stopped";
	    }
	    else
	    {
		return "4854 DNS server stop failed: $!";
	    }
	}
        else
	{
	    return "2855 No change -- the DNS server was already off";
	}
    }
    return 1;
}


1;
