# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Services.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Adminuser = "admin";
my $Fpx_admsrvexe = "/usr/local/frontpage/currentversion/bin/fpsrvadm.exe";
my $Fpx_we80cnf = "/usr/local/frontpage/we80.cnf";
my $Htconf = "/etc/httpd/conf";
my $Htgroup_dir = "/home/sites";
my $Htpasswd = "/etc/htpasswd";
my $MainGroup = "home";
my $WWWuser = "httpd";
my %Features = ("networker","1","telnetConfig","1","dhcpd","0","shiftjis","Cobalt interface message for shiftjis (We should never see this)","pagebuilder","0","www","1","mx","1","gated","1","dns","1","nfs","0","securetty","1","english","1","atalk","0","fpx","1","siteAdminRedirect","1","users","1","ntp","0","mon_textdb_only","0","search","0","anonFTP","1","specialHomeSkel","0","viewGroups","0","cobaltHomePage","0","lastNameFirst","1","warnRootOnly","1","vsites","1","pam","1","discuss","0","docorg","0","groups","1","smb","0","mail","1","nat","0","squid","0","autoGenWebUsage","0","japanese","0","cobaltRedirect","0","backups","1","vmachine","1","mon_port_testing","1","viewUsers","0","usersCGIInWizard","1","privatedirs","0","telnetDefault","1","ssl","0","siteManagement","1","adm","1","bind8","1","personalRedirect","1","webRequests","1","usersAddUser","0","adminRedirect","1","quotas","1","snmp","1","defaultUserNameGen","1","groupdirs","1","proftpd","1");
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Services.pm.  Changes made here will be lost.
package Cobalt::Services;

sub set_fpx_on
# Enable or disable FrontPage Server Extensions on the main site
# Arguments: 1 for on/0 for off
# Return value: a status string of the usual form form "2534 ho hum" 
# Side effects: Calls MS's fpsrvadm.exe, cats /etc/htpasswd
# Examples: $good = Cobalt::Services::set_fpx_on(0);
#            $bad = Cobalt::Services::set_fpx_on(1);
{
  my $state = shift(@_);
  my $fpx_active = get_fpx_on();

  if (! $Features{'fpx'} )
  {
    return "1011 Microsoft FrontPage Server Extensions are not supported in this release";
  }

  unless (-x "$Fpx_admsrvexe")
  {
    return "4794 The FrontPage Server Extensions configuration tools are not available";
  } 
  else 
  {

    if ($state && (! $fpx_active))
    {
	# Install

	# Temporarily move .htaccess files
	my(@htax,$hta);
	open(HTAS,"/usr/bin/find $Htgroup_dir/$MainGroup -name .htaccess -print |");
	while(<HTAS>) { chop; push(@htax,$_); }
	foreach $hta (@htax) 
	{
	    system("/bin/mv $hta $hta.FP98") unless ($hta eq "$Htgroup_dir/$MainGroup/.htaccess");
	}

	# Can't return after failure without .htaccess restoer
	my($could_not_install);
	
	# Call fpadmserv.exe (ugh)
	system("$Fpx_admsrvexe -o install -p 80 -t apache -m \"\" -u \"$Adminuser\" -pw \"$$\" -s \"$Htconf/httpd.conf\" -xu \"$WWWuser\" -xg \"$MainGroup\" > /dev/null")
	    && ($could_not_install = 1);

	# Restore .htaccess files asap!
	foreach $hta (@htax) 
	{
	    system("/bin/mv $hta.FP98 $hta") if (-e "$hta.FP98");
	}
	return "4795 A root web could not be configured successfully" if ($could_not_install);

	# chmod u+s g+s fpcount.exe
	chmod(06555,"$Htgroup_dir/$MainGroup/_vti_bin/fpcount.exe");

	# qube2/raq2 fpx configurations are different! don't mess w/ fpx
        # if you hate m-soft.
	unless ($Features{'pam'}) {
	  # Use admin's password, only sure user
	  open(HTPAS,"$Htpasswd") 
	    || return "3033 The root web password could not be set successfully";
	  open(MSHT,"> $Htgroup_dir/$MainGroup/_vti_pvt/service.pwd") 
	    || return "3034 The root web password could not be set successfully";
	  print MSHT "# -FrontPage-\n";
	  while(<HTPAS>) {
	    print MSHT if (/^$Adminuser\:/o);
	  }
	  close(MSHT);
	  close(HTPAS);
	  chown ( (getpwnam($WWWuser))[2], (getgrnam($MainGroup))[2], 
		  "$Htgroup_dir/$MainGroup/_vti_pvt/service.pwd" );
	}

	# Configure SMTP sender for fpx cgi files
	if (-w $Fpx_we80cnf && !$could_not_install)
	{ 
		# We first check to see if fpadmsrv could somehow have configured smtp
		# It's never happened before, but who knows how it may behave in the future
		# (feature requested by Kevin 01/11/99 /wdh)
		my($SMTPrelay)=0;
		open(FPCNF,"$Fpx_we80cnf") || return "4796 The FrontPage Server Extensions could not be configured successfully";
		while(<FPCNF>) { $SMTPrelay=1 if (/SMTPHost/o); }
		
		unless($SMTPrelay) # Append the SMTPHost: directive
		{
			open(FPCNF,">>$Fpx_we80cnf") || return "4797 The FrontPage Server Extensions could not be configured successfully";
			print FPCNF "SMTPHost:127.0.0.1\n";
			close(FPCNF);
		}
	}

        return "2121 A root web has been configured successfully";
    }
    elsif ((! $state) && $fpx_active)
    {
	# Uninstall
	# Call fpadmserv.exe (ugh)
	system("$Fpx_admsrvexe -o uninstall -p 80 -t apache -m \"\" -s \"$Htconf/httpd.conf\" > /dev/null")
	    && return "4798 The root web could not be uninstalled successfully";
	
	# Already done by fpadmsrv unless something went wrong AND it returned 0 anyways
	# (feature requested by Kevin 01/11/99 /wdh)
	unlink($Fpx_we80cnf) if (-e $Fpx_we80cnf); 
        
	return "2122 The root web has been uninstalled successfully";
    }
    elsif ($state)
    {
      return "2123 A root web is already configured";
    }
    else
    {
      return "2124 The root web has already been uninstalled";
    }
  }
}


1;
