# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Services.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Inetd_conf = "/etc/inetd.conf";
my $Inetd_pid = "/var/run/inetd.pid";
my $Lockdir = "/etc/locks";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Services.pm.  Changes made here will be lost.
package Cobalt::Services;

sub set_ftp_server_on
# Turn the ftp server on or off
# Arguments: 1 for on, 0 for off
# Return value: a status string of the form "638 smokey bacon"
# Side effects: modifies inetd.conf
{
    my ($state) = @_;
    if ($state)
    {
	# turn it on!
	return "4439 /etc/inetd.conf is locked"
	    if (-e "$Lockdir/inetd.conf");
	open(O,">$Lockdir/inetd.conf")
	    || return "4441 Cannot write /etc/locks/inetd.conf: $!";
	open(I,$Inetd_conf)
	    || return "4440 Cannot read /etc/inetd.conf: $!";
	while (<I>)
	{
	    if (/^\#ftp/o)
	    {
		$_ =~ s/^\#ftp/ftp/o;
	    }
	    print O;
	}
	close I;
	close O;
	rename("$Lockdir/inetd.conf",$Inetd_conf)
	    || return "4442 Cannot replace /etc/inetd.conf: $!";
	open(PID,$Inetd_pid) || return "3459 Network server down: $!";
	my ($pid);
	my $line = <PID>;
	if ($line =~ /^(\d+)$/o)
	{
	    $pid = $1;
	}
	close PID;
	kill(1,$pid) if ($pid);
	return "2453 Ftp server started";
    }
    else
    {
	return "4443 /etc/inetd.conf is locked"
	    if (-e "$Lockdir/inetd.conf");
	open(O,">$Lockdir/inetd.conf")
	    || return "4445 Cannot write /etc/locks/inetd.conf: $!";
	open(I,$Inetd_conf)
	    || return "4444 Cannot read /etc/inetd.conf: $!";
	while (<I>)
	{
	    if (/^ftp/o)
	    {
		$_ =~ s/^ftp/\#ftp/o;
	    }
	    print O;
	}
	close I;
	close O;
	rename("$Lockdir/inetd.conf",$Inetd_conf)
	    || return "4446 Cannot replace /etc/inetd.conf: $!";

	open(PID,$Inetd_pid) || return "3464 Network server down: $!";
	my $pid;
	my $line = <PID>;
	if ($line =~ /^(\d+)$/o)
	{
	    $pid = $1;
	}
	close PID;
	kill(1,$pid) if ($pid);
	return "2464 Ftp server stopped";
    }
}


1;
