# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Services.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Gated_conf = "/etc/gated.conf";
my $Lockdir = "/etc/locks";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Services.pm.  Changes made here will be lost.
package Cobalt::Services;

sub set_gated_interfaces
# Set the list of interfaces on which gated will listen
# Arguments: list of interfaces
# Side effects: modifies gated.conf
# Return value: return string of the form "2149 My tongue is glowing"
# Example: $ret = Cobalt::Services::set_gated_interfaces("eth0","eth1");
{
  my %netifs = map { $_, 1 } @_;   # make a hash of the interface list
  return "4801 The gated configuration file is busy.  Try again later."
    if (-e "$Lockdir/gated.conf");
  open(OUT,">$Lockdir/gated.conf") || return "4802 Cannot get lock for the gated configuration file.";
  unless (open(IN,$Gated_conf)) {
    unlink("$Lockdir/gated.conf");
    return "4803 Cannot read gated configuration file /etc/gated.conf: $!";
  }
  my $inrip;
  while (<IN>) {
    if (/^rip yes/o) {
      $inrip = 1;
      print OUT;
    }
    elsif ($inrip && /\};/o) {
      my $netif;
      foreach $netif (sort keys %netifs) {
	print OUT "        interface $netif ripin ripout version 2 broadcast;\n"
	  if ($netifs{$netif} == 1);
      }
      $inrip = 0;
      print OUT;
    }
    elsif ($inrip && /^\s*interface all/o) {
      # the default interface entry
      print OUT;
    }
    elsif ($inrip && /^\s*interface (\S+)\s/o) {
      print OUT if ($netifs{$1} == 1);
      $netifs{$1} = 0;
    }
    else {
      print OUT;
    }
  }
  close IN;
  close OUT;
  rename("$Lockdir/gated.conf",$Gated_conf);
  return "2129 Set the list of interfaces in /etc/gated.conf";
}


1;
