# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Services.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Gated_link = "/etc/rc.d/rc3.d/S53gated";
my $Gated_script = "/etc/rc.d/init.d/gated";
my $Lcdshowscript = "/etc/rc.d/init.d/showip";
my $Sauce_log = "/var/cobalt/sauce.log";
my %Features = ("networker","1","telnetConfig","1","dhcpd","0","shiftjis","Cobalt interface message for shiftjis (We should never see this)","pagebuilder","0","www","1","mx","1","gated","1","dns","1","nfs","0","securetty","1","english","1","atalk","0","fpx","1","siteAdminRedirect","1","users","1","ntp","0","mon_textdb_only","0","search","0","anonFTP","1","specialHomeSkel","0","viewGroups","0","cobaltHomePage","0","lastNameFirst","1","warnRootOnly","1","vsites","1","pam","1","discuss","0","docorg","0","groups","1","smb","0","mail","1","nat","0","squid","0","autoGenWebUsage","0","japanese","0","cobaltRedirect","0","backups","1","vmachine","1","mon_port_testing","1","viewUsers","0","usersCGIInWizard","1","privatedirs","0","telnetDefault","1","ssl","0","siteManagement","1","adm","1","bind8","1","personalRedirect","1","webRequests","1","usersAddUser","0","adminRedirect","1","quotas","1","snmp","1","defaultUserNameGen","1","groupdirs","1","proftpd","1");
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Services.pm.  Changes made here will be lost.
package Cobalt::Services;

sub set_gated_on
# Turn the Gate Daemon (gated) on or off
# Arguments: 1 for on/0 for off; optional list of interfaces on 
#    which to listen
# Return value: a status string of the form "2534 The doggy in the 
#    window is $10"
# Side effects: creates or breaks symlinks in /etc/rc.d/rc3.d
# Examples: $ret = Cobalt::Services::set_gated_on(0);
#           $ret = Cobalt::Services::set_gated_on(1,"eth0","eth1");
{
  my $state = shift(@_);

  if (! $Features{'gated'} )
  {
    return "1012 The Gate Daemon (gated) is not supported in this release";
  } 
  else 
  {
    # If we're given a list of interfaces, fix gated.conf
    if ($#_ >= 0) {
      my $ret = Cobalt::Services::set_gated_interfaces(@_);
      return $ret if ($ret !~ /^2/o);
    }

    if ($state && (! -e $Gated_link))
    {
        my $pid;
        if (!defined($pid = fork)) {
            die "cannot fork: $!";
        } elsif ($pid) {
            # i'm the parent
            print STDERR "Forking to restart gated\n"
	      if ($Debug);
            return "2125 gated has been started";
        }
        else
        {
            # otherwise I'm the child
            open(STDERR,">>$Sauce_log");
            open(STDOUT,">>$Sauce_log");
            symlink($Gated_script,$Gated_link) ||
	      die "4799 Cannot create link /etc/rc.d/rc3.d/S53gated: $!";
            system ("$Gated_script start >> $Sauce_log 2>&1") &&
	      die "3035 Cannot start gate daemon: $!";
            system ("$Lcdshowscript start >> $Sauce_log 2>&1")
	      if (-x $Lcdshowscript);
            exit;
        }
    }
    elsif ((! $state) && (-e $Gated_link))
    {
        unlink($Gated_link) ||
            return "4800 Cannot break link /etc/rc.d/rc3.d/S53gated: $!";
        system ("$Gated_script stop >> $Sauce_log 2>&1") &&
            return "3036 Cannot stop gate daemon: $!";
        system ("$Lcdshowscript start >> $Sauce_log 2>&1")
	  if (-x $Lcdshowscript);
        return "2126 gated stopped";
    }
    elsif ($state)
    {
      return "2127 gated was already on";
    }
    else
    {
      return "2128 gated was already off";
    }
  }
}


1;
