# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Services.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Inetd_conf = "/etc/inetd.conf";
my $Inetd_pid = "/var/run/inetd.pid";
my $Lcdshowscript = "/etc/rc.d/init.d/showip";
my $Lockdir = "/etc/locks";
my $Maillink = "/etc/rc.d/rc3.d/S80sendmail";
my $Mailscript = "/etc/rc.d/init.d/sendmail";
my $Newaliases_cmd = "/usr/bin/newaliases";
my $Sauce_log = "/var/cobalt/sauce.log";
my %Features = ("networker","1","telnetConfig","1","dhcpd","0","shiftjis","Cobalt interface message for shiftjis (We should never see this)","pagebuilder","0","www","1","mx","1","gated","1","dns","1","nfs","0","securetty","1","english","1","atalk","0","fpx","1","siteAdminRedirect","1","users","1","ntp","0","mon_textdb_only","0","search","0","anonFTP","1","specialHomeSkel","0","viewGroups","0","cobaltHomePage","0","lastNameFirst","1","warnRootOnly","1","vsites","1","pam","1","discuss","0","docorg","0","groups","1","smb","0","mail","1","nat","0","squid","0","autoGenWebUsage","0","japanese","0","cobaltRedirect","0","backups","1","vmachine","1","mon_port_testing","1","viewUsers","0","usersCGIInWizard","1","privatedirs","0","telnetDefault","1","ssl","0","siteManagement","1","adm","1","bind8","1","personalRedirect","1","webRequests","1","usersAddUser","0","adminRedirect","1","quotas","1","snmp","1","defaultUserNameGen","1","groupdirs","1","proftpd","1");
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Services.pm.  Changes made here will be lost.
package Cobalt::Services;

sub set_mail_server_on
# Turn the mail server on or off
# Arguments: 1 for on, 0 for off
# Return value: a status string of the form "778 can't tapdance"
# Side effects: creates or breaks symlinks in /etc/rc.d/rc3.d
{
    my ($state) = @_;
    return "1100 Mail service is not implemented in this release"
      unless ($Features{'mail'});

    if ($state && (! -e $Maillink))
    {
	symlink($Mailscript,$Maillink) ||
	    return "4420 Cannot create link to /etc/rc.d/init.d/sendmail: $!";
	return "4470 /etc/inetd.conf is locked"
	    if (-e "$Lockdir/inetd.conf");
	open(O,">$Lockdir/inetd.conf")
	    || return "4433 Cannot write /etc/locks/inetd.conf: $!";
	open(I,$Inetd_conf)
	    || return "4432 Cannot read /etc/inetd.conf: $!";
	while (<I>)
	{
	    if (/^\#(pop-3|imap)/o)
	    {
		$_ =~ s/^\#//o;
	    }
	    print O;
	}
	close I;
	close O;
	rename("$Lockdir/inetd.conf",$Inetd_conf)
	    || return "4434 Cannot replace /etc/inetd.conf: $!";
	open(PID,$Inetd_pid) || return "3458 Network server down: $!";
	my $line = <PID>;
	my $pid;
	if ($line =~ /^(\d+)$/o)
	{
	    $pid = $1;
	}
	close PID;
	kill(1,$pid) if ($pid);
	system ("$Mailscript start >> $Sauce_log 2>&1") &&
	    return "3455 Cannot start mail server: $!";
	system("$Newaliases_cmd >>$Sauce_log 2>&1");
	system ("$Lcdshowscript start >> $Sauce_log 2>&1")
	    if (-x $Lcdshowscript);
	return "2450 Mail server started";
    }
    elsif ((! $state) && (-e $Maillink))
    {
	unlink($Maillink) ||
	    return "3457 Cannot break link /etc/rc.d/rc3.d/S80sendmail: $!";
	return "4416 /etc/inetd.conf is locked"
	    if (-e "$Lockdir/inetd.conf");
	open(O,">$Lockdir/inetd.conf")
	    || return "4437 Cannot write /etc/locks/inetd.conf: $!";
	open(I,$Inetd_conf)
	    || return "4436 Cannot read /etc/inetd.conf: $!";
	while (<I>)
	{
	    if (/^(pop-3|imap)/o)
	    {
		$_ =~ s/^/\#/o;
	    }
	    print O;
	}
	close I;
	close O;
	rename("$Lockdir/inetd.conf",$Inetd_conf)
	    || return "4438 Cannot replace /etc/inetd.conf: $!";
	open(PID,$Inetd_pid) || return "3456 Network server down: $!";
	my ($pid);
	my $line = <PID>;
	if ($line =~ /^(\d+)$/o)
	{
	    $pid = $1;
	}
	close PID;
	kill(1,$pid) if ($pid);
	system ("$Mailscript stop >> $Sauce_log 2>&1") &&
	    return "4421 Cannot stop mail server: $!";
	system ("$Lcdshowscript start >> $Sauce_log 2>&1")
	    if (-x $Lcdshowscript);
	return "2452 Mail server stopped";
    }
    else
    {
	my $off;
	($state) ? ($off = Cobalt::Language::msg_get('On_string')) : 
	  ($off = Cobalt::Language::msg_get('Off_string'));
	return "2451 No change -- mail server was already $off";
    }
}


1;
