# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Services.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Exports_cmd = "/usr/sbin/exportfs";
my $Exports_file = "/etc/exports";
my $Htgroup_dir = "/home/sites";
my $Htusers_dir = "/usr/httpd/users";
my %Features = ("networker","1","telnetConfig","1","dhcpd","0","shiftjis","Cobalt interface message for shiftjis (We should never see this)","pagebuilder","0","www","1","mx","1","gated","1","dns","1","nfs","0","securetty","1","english","1","atalk","0","fpx","1","siteAdminRedirect","1","users","1","ntp","0","mon_textdb_only","0","search","0","anonFTP","1","specialHomeSkel","0","viewGroups","0","cobaltHomePage","0","lastNameFirst","1","warnRootOnly","1","vsites","1","pam","1","discuss","0","docorg","0","groups","1","smb","0","mail","1","nat","0","squid","0","autoGenWebUsage","0","japanese","0","cobaltRedirect","0","backups","1","vmachine","1","mon_port_testing","1","viewUsers","0","usersCGIInWizard","1","privatedirs","0","telnetDefault","1","ssl","0","siteManagement","1","adm","1","bind8","1","personalRedirect","1","webRequests","1","usersAddUser","0","adminRedirect","1","quotas","1","snmp","1","defaultUserNameGen","1","groupdirs","1","proftpd","1");
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Services.pm.  Changes made here will be lost.
package Cobalt::Services;

sub set_nfs_perms
# Define the list of hosts which are allowed to connect to the NFS server.
# Arguments: up to two strings specifying hosts which should be granted
#   access.  Empty arguments will clear the lines from the exports file.
#   The strings may include wilcards (*.foo.com) or IP addresses.
# Side effects: modifies /etc/exports and calls exportfs
# Return value: usual error string
{
    return "1105 NFS is not implemented in this release"
      unless ($Features{'nfs'});

    my ($allow1,$allow2) = @_;
    return "4449 Invalid export host $allow1"
	unless ($allow1 =~ /^[\w\*\.\-]*$/o);
    return "4462 Invalid export host $allow2"
	unless ($allow2 =~ /^[\w\*\.\-]*$/o);
    open(EXPORTS,">$Exports_file") ||
	return "4447 Cannot write exports file /etc/exports: $!";
    if ($allow1)
    {
	print EXPORTS "$Htgroup_dir\t$allow1(rw)\n";
	print EXPORTS "$Htusers_dir\t$allow1(rw)\n";
    }
    if ($allow2)
    {
	print EXPORTS "$Htgroup_dir\t$allow2(rw)\n";
	print EXPORTS "$Htusers_dir\t$allow2(rw)\n";
    }
    close EXPORTS;
    # exportfs sends signals to the NFS processes.  If the processes aren't
    # running, then don't bother with the signal
    if (Cobalt::Services::get_nfs_server_on())
    {
	system($Exports_cmd) && return "4448 Cannot reread exports list: $!";
    }
    return "2455 Updated NFS exports list";
}


1;
