# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Services.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Lcdshowscript = "/etc/rc.d/init.d/showip";
my $Sauce_log = "/var/cobalt/sauce.log";
my $Smblink = "/etc/rc.d/rc3.d/S91smb";
my $Smbscript = "/etc/rc.d/init.d/smb";
my %Features = ("networker","1","telnetConfig","1","dhcpd","0","shiftjis","Cobalt interface message for shiftjis (We should never see this)","pagebuilder","0","www","1","mx","1","gated","1","dns","1","nfs","0","securetty","1","english","1","atalk","0","fpx","1","siteAdminRedirect","1","users","1","ntp","0","mon_textdb_only","0","search","0","anonFTP","1","specialHomeSkel","0","viewGroups","0","cobaltHomePage","0","lastNameFirst","1","warnRootOnly","1","vsites","1","pam","1","discuss","0","docorg","0","groups","1","smb","0","mail","1","nat","0","squid","0","autoGenWebUsage","0","japanese","0","cobaltRedirect","0","backups","1","vmachine","1","mon_port_testing","1","viewUsers","0","usersCGIInWizard","1","privatedirs","0","telnetDefault","1","ssl","0","siteManagement","1","adm","1","bind8","1","personalRedirect","1","webRequests","1","usersAddUser","0","adminRedirect","1","quotas","1","snmp","1","defaultUserNameGen","1","groupdirs","1","proftpd","1");
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Services.pm.  Changes made here will be lost.
package Cobalt::Services;

sub set_smb_server_on
# Turn the smb server on or off
# Arguments: 1 for on, 0 for off
# Return value: a status string of the form "682 insufficient depth perception"
# Side effects: creates or breaks symlinks in /etc/rc.d/rc3.d
{
    my ($state) = @_;

    return "1101 Windows filesharing is not implemented in this release"
      unless ($Features{'smb'});

    if ($state && (! -e $Smblink))
    {
	my $pid;
	if (!defined($pid = fork)) {
	    die "cannot fork: $!";
	} elsif ($pid) {
	    # i'm the parent
	    print STDERR "Forking to restart samba\n" if ($Debug);
	    return "2493 Smb server started";
	}
	else
	{
	    # otherwise I'm the child
	    open(STDERR,">>$Sauce_log");
	    open(STDOUT,">>$Sauce_log");
	    # Note that we die() instead of return() because we are
	    # a child process, and if we return we'll end up back in
	    # the CGI, executing the same code our parent process
	    # is executing.  That would be Bad.
	    symlink($Smbscript,$Smblink) ||
	      die "4423 Cannot create link /etc/rc.d/rc3.d/S91smb: $!";
	    system ("$Smbscript start >> $Sauce_log 2>&1") &&
	      die "3493 Cannot start SMB server: $!";
	    system ("$Lcdshowscript start >> $Sauce_log 2>&1")
	      if (-x $Lcdshowscript);
	    exit;
	}
    }
    elsif ((! $state) && (-e $Smblink))
    {
	unlink($Smblink) ||
	    return "3497 Cannot break link /etc/rc.d/rc3.d/S91smb: $!";
	system ("$Smbscript stop >> $Sauce_log 2>&1") &&
	    return "4424 Cannot stop smb service: $!";
	system ("$Lcdshowscript start >> $Sauce_log 2>&1")
	    if (-x $Lcdshowscript);
	return "2497 Smb server stopped";
    }
    else
    {
	my $off;
        ($state) ? ($off = Cobalt::Language::msg_get('On_string')) : 
		    ($off = Cobalt::Language::msg_get('Off_string'));
	return "2491 No change -- smb server was already $off";
    }
}


1;
