# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Services.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Lcdshowscript = "/etc/rc.d/init.d/showip";
my $Lockdir = "/etc/locks";
my $Sauce_log = "/var/cobalt/sauce.log";
my $Smbconf = "/etc/smb.conf";
my $Smbscript = "/etc/rc.d/init.d/smb";
my $Subsys = "/var/lock/subsys";
my %Features = ("networker","1","telnetConfig","1","dhcpd","0","shiftjis","Cobalt interface message for shiftjis (We should never see this)","pagebuilder","0","www","1","mx","1","gated","1","dns","1","nfs","0","securetty","1","english","1","atalk","0","fpx","1","siteAdminRedirect","1","users","1","ntp","0","mon_textdb_only","0","search","0","anonFTP","1","specialHomeSkel","0","viewGroups","0","cobaltHomePage","0","lastNameFirst","1","warnRootOnly","1","vsites","1","pam","1","discuss","0","docorg","0","groups","1","smb","0","mail","1","nat","0","squid","0","autoGenWebUsage","0","japanese","0","cobaltRedirect","0","backups","1","vmachine","1","mon_port_testing","1","viewUsers","0","usersCGIInWizard","1","privatedirs","0","telnetDefault","1","ssl","0","siteManagement","1","adm","1","bind8","1","personalRedirect","1","webRequests","1","usersAddUser","0","adminRedirect","1","quotas","1","snmp","1","defaultUserNameGen","1","groupdirs","1","proftpd","1");
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Services.pm.  Changes made here will be lost.
package Cobalt::Services;

sub set_smb_workgroup
# Set the workgroup for the SMB server (samba)
# Arguments: the workgroup name
# Side effects: modifies smb.conf and restarts samba
# Return value: usual status thingy
# Example: Cobalt::Services::set_smb_workgroup("workgroup");
{
    return "1106 Windows filesharing is not implemented in this release"
      unless ($Features{'smb'});

    my ($workgroup) = @_;
    return "4464 /etc/smb.conf is locked" if (-e "$Lockdir/smb.conf");
    open(SNB,">$Lockdir/smb.conf") 
	|| return "4471 Cannot write samba config file /etc/locks/smb.conf: $! ";
    open(SMB,"$Smbconf") 
	|| return "3475 Cannot read samba config file /etc/smb.conf: $! ";
    while (<SMB>)
    {
	# Suppose you're thinking of a plate of shrimp...
	if (/^\s*workgroup = (\w+)/o)
	{
	    # $oldworkgroup = $1;
	    $_ = "   workgroup = $workgroup\n";
	}
	print SNB;
    }
    close SMB;
    close SNB;
    rename("$Lockdir/smb.conf",$Smbconf) ||
	return "3467 Cannot update /etc/smb.conf: $!";

    # Start a child process to restart the samba server
    my $pid;
    if (!defined($pid = fork)) {
	die "cannot fork: $!";
    } elsif ($pid) {
	# i'm the parent
	print STDERR "forking a child to restart daemons\n" if ($Debug);
    }
    else
    {
	# otherwise I'm the child
	open(STDERR,">>$Sauce_log");
	open(STDOUT,">>$Sauce_log");
	# restart samba
	if (-f "$Subsys/smb")
	{
	    system("$Smbscript stop >>$Sauce_log 2>&1 ");
	    system("$Smbscript start >>$Sauce_log 2>&1 ");
	}
	system ("$Lcdshowscript start >>$Sauce_log 2>&1")
	    if (-x $Lcdshowscript);
	exit;
    }

    # done!
    return "2413 Set samba workgroup to $workgroup";
}


1;
