# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Services.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Inetd_conf = "/etc/inetd.conf";
my $Inetd_pid = "/var/run/inetd.pid";
my $Lockdir = "/etc/locks";
my $SecretTelnetPort = "telnet";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Services.pm.  Changes made here will be lost.
package Cobalt::Services;

sub set_telnet_server_on
# Turn the telnet server on or off
# Arguments: 1 for on, 0 for off
# Return value: a status string of the form "619 Major Strasser's been shot"
# Side effects: modifies inetd.conf
{
    my ($state) = @_;
    if ($state)
    {
	# turn it on!
	return "4453 /etc/inetd.conf is locked"
	    if (-e "$Lockdir/inetd.conf");
	open(O,">$Lockdir/inetd.conf")
	    || return "4455 Cannot write /etc/locks/inetd.conf: $!";
	open(I,$Inetd_conf)
	    || return "4454 Cannot read /etc/inetd.conf: $!";
	while (<I>)
	{
	    if (/^\#$SecretTelnetPort/o)
	    {
		$_ =~ s/^\#$SecretTelnetPort/$SecretTelnetPort/o;
	    }
	    print O;
	}
	close I;
	close O;
	rename("$Lockdir/inetd.conf",$Inetd_conf)
	    || return "4456 Cannot replace /etc/inetd.conf: $!";
	open(PID,$Inetd_pid) || return "3465 Network server down: $!";
	my ($pid);
	my $line = <PID>;
	if ($line =~ /^(\d+)$/o)
	{
	    $pid = $1;
	}
	close PID;
	kill(1,$pid) if ($pid);
	return "2456 Telnet server started";
    }
    else
    {
	return "4457 /etc/inetd.conf is locked"
	    if (-e "$Lockdir/inetd.conf");
	open(O,">$Lockdir/inetd.conf")
	    || return "4459 Cannot write /etc/locks/inetd.conf: $!";
	open(I,$Inetd_conf)
	    || return "4458 Cannot read /etc/inetd.conf: $!";
	while (<I>)
	{
	    if (/^$SecretTelnetPort/o)
	    {
		$_ = "#$_";
	    }
	    print O;
	}
	close I;
	close O;
	rename("$Lockdir/inetd.conf",$Inetd_conf)
	    || return "4460 Cannot replace /etc/inetd.conf: $!";

	open(PID,$Inetd_pid) || return "3466 Network server down: $!";
	my $pid;
	my $line = <PID>;
	if ($line =~ /^(\d+)$/o)
	{
	    $pid = $1;
	}
	close PID;
	kill(1,$pid) if ($pid);
	return "2457 Telnet server stopped";
    }
}


1;
