# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Services.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Lockdir = "/etc/locks";
my $Nologin = "/etc/nologin";
my $Sysinit_script = "/etc/rc.d/rc.sysinit";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Services.pm.  Changes made here will be lost.
package Cobalt::Services;

sub set_telnet_server_open
# Set wether only root can telnet in, or anyone at all
# Arguments: 1 for anyone, 0 for root only
# Side effects: creates or removes /etc/nologin, modifies
#   /etc/rc.d/rc.sysinit to remove /etc/nologin or not
# Return value: usual status thingy
# Example: Cobalt::Services::set_telnet_server_open(1);
{
    my ($newstate) = @_;
    my ($nowstate) = (! -e $Nologin);
    if (($newstate && $nowstate) ||
	((! $newstate) && (! $nowstate)) )
    {
	return "2458 No change to telnet state";
    }
    elsif ($newstate)
    {
	# open 'er up!
	unlink($Nologin);

	# fix the boot script so that nologin gets removed at
	# boot time
	return "3411 rc.sysinit is in use, bootup state not set"
	  if (-e "$Lockdir/rc.sysinit");
	open(SO,">$Lockdir/rc.sysinit")
	    || return "4419 Cannot lock /etc/rc.d/rc.sysinit: $!";
	open(SI,"$Sysinit_script")
	    || return "4418 Cannot read /etc/rc.d/rc.sysinit: $!";
	while (<SI>)
	{
	    if (/^rm -f \/etc\/mtab~ \/fastboot/o)
	    {
		chomp $_;
		$_ .= " $Nologin\n";
	    }
	    print SO;
	}
	close SI;
	close SO;
	rename("$Lockdir/rc.sysinit","$Sysinit_script")
	    || return "4417 Cannot write /etc/rc.d/rc.sysinit: $!";
	chmod(0755,"$Sysinit_script");
	return "2460 Telnet access opened to all users";
    }
    else
    {
	# close it down
	open(N,">$Nologin") 
	    || return "4429 Cannot create /etc/nologin: $!";
	close N;

	# fix the boot script so that nologin won't get clobbered
	# on bootup
	return "3410 rc.sysinit is in use, bootup state not set"
	  if (-e "$Lockdir/rc.sysinit");
	open(SO,">$Lockdir/rc.sysinit") 
	    || return "4435 Cannot lock /etc/rc.d/rc.sysinit: $!";
	open(SI,"$Sysinit_script") 
	    || return "4431 Cannot read /etc/rc.d/rc.sysinit: $!";
	while (<SI>)
	{
	    if (/$Nologin/o)
	    {
		$_ =~ s/\s*$Nologin//og;
	    }
	    print SO;
	}
	close SI;
	close SO;
	rename("$Lockdir/rc.sysinit","$Sysinit_script")
	    || return "4422 Cannot write /etc/rc.d/rc.sysinit: $!";
	chmod(0755,"$Sysinit_script");
	return "2459 Telnet access restricted";
    }
}


1;
