# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Stats.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my @Cron_Intervals = ("quarter-hourly","half-hourly","hourly","quarter-daily","daily","weekly","monthly");
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Stats.pm.  Changes made here will be lost.
package Cobalt::Stats;

sub stats_set_www_report
# Sets periodic www report generation
# Arguments: interval, site-associated group name(s)
#   interval is one of (never,hourly,daily,weekly,monthly)
# Return value: string, "4040 Could not determine head from tail"
# Example: $ret = Cobalt::Stats::stats_set_www_report(24,"cobaltnet-com","cobaltmicro-com");
{
    my($Interval,@SiteGroups) = @_;
    $Interval = 0 if ($Interval eq "never");
    return "4560 Unsupported report interval." unless (!$Interval || (-d "/etc/cron.$Interval"));

    my($siteGroup,$crondir);
    foreach $siteGroup (@SiteGroups)
    {
	next if (-e "/etc/cron.$Interval/genWebUsage.$siteGroup");
	foreach $crondir (@Cron_Intervals)
	{
	    if ($crondir eq $Interval)
	    {
		Cobalt::Stats::stats_write_webusage($siteGroup,$crondir) || return "3510 Could not modify web report generation settings.";
	    } else {
		unlink("/etc/cron.$crondir/genWebUsage.$siteGroup") if (-e "/etc/cron.$crondir/genWebUsage.$siteGroup");
	    }
	}
    }
    return "2510 Web report settings updated.";
}


1;
