# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Stats.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $AdminCGIs_dir = "/usr/admserv/cgi-bin/.cobalt";
my $AdminPages_dir = "/usr/admserv/html/.cobalt";
my $Analog_cmd = "/usr/local/sbin/analog";
my $Big_tmp = "/home/tmp";
my $Htgroup_dir = "/home/sites";
my $Logdir = "logs";
my $Sauce_log = "/var/cobalt/sauce.log";
my $Weblog_dir = "/var/log/httpd";
my %Features = ("networker","1","telnetConfig","1","dhcpd","0","shiftjis","Cobalt interface message for shiftjis (We should never see this)","pagebuilder","0","www","1","mx","1","gated","1","dns","1","nfs","0","securetty","1","english","1","atalk","0","fpx","1","siteAdminRedirect","1","users","1","ntp","0","mon_textdb_only","0","search","0","anonFTP","1","specialHomeSkel","0","viewGroups","0","cobaltHomePage","0","lastNameFirst","1","warnRootOnly","1","vsites","1","pam","1","discuss","0","docorg","0","groups","1","smb","0","mail","1","nat","0","squid","0","autoGenWebUsage","0","japanese","0","cobaltRedirect","0","backups","1","vmachine","1","mon_port_testing","1","viewUsers","0","usersCGIInWizard","1","privatedirs","0","telnetDefault","1","ssl","0","siteManagement","1","adm","1","bind8","1","personalRedirect","1","webRequests","1","usersAddUser","0","adminRedirect","1","quotas","1","snmp","1","defaultUserNameGen","1","groupdirs","1","proftpd","1");
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Stats.pm.  Changes made here will be lost.
package Cobalt::Stats;

# --------------------------------------- Subs ---------------------

# Cobalt::Stats::stats_write_webusage($siteGroup,$crondir);
sub stats_write_webusage
{
    my($siteGroup,$crondir) = @_;
    my($cronFile) = "/etc/cron.$crondir/genWebUsage.$siteGroup";
    open(CRON,"> $cronFile") ||
      return "4561 Could not write cron entry $cronFile: $!";

    if( !$Features{ 'autoGenWebUsage' } ) {
	print CRON <<EOF;
#!/usr/bin/perl

# Web log generation
# Vitual Machine compatible
# Will DeHaan <will\@cobaltnet.com>
# Copyright 1998-1999 Cobalt Networks

my \$log="$Htgroup_dir/$siteGroup/$Logdir/access";
my \$analogReport="$Big_tmp/analog-$siteGroup.dat";

# analog generate report
system( "$Analog_cmd \$log >\$analogReport 2>>$Sauce_log" );

# generate web output
system( "$AdminCGIs_dir/webUsage/parseReport.pl -l \$log -a \$analogReport $AdminPages_dir/siteManage/$siteGroup" );

# clean up
unlink \$analogReport;
EOF
    }
    else {
	print CRON <<EOF;
#!/usr/bin/perl

# Web log generation
# Will DeHaan <will\@cobaltnet.com>
# Copyright 1998-1999 Cobalt Networks

my \$log="$Weblog_dir/$siteGroup-access";
my \$analogReport="$Big_tmp/analog-$siteGroup.dat";

# analog generate report
system( "$Analog_cmd \$log >\$analogReport 2>>$Sauce_log" );

# generate web output
system( "$AdminCGIs_dir/webUsage/parseReport.pl -l \$log -a \$analogReport $AdminPages_dir/webUsage" );

# clean up
unlink \$analogReport;
EOF
    }

    close(CRON);
    chmod(0755,$cronFile) || 
      return "4562 Could not set cron entry $cronFile: $!";
    return 1;
}


1;
