# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Syswatch.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Syswatch.pm.  Changes made here will be lost.
package Cobalt::Syswatch;

sub du_recursively
# Recursively gets the usage in a directory tree
# Arguments: the directory to start at
# Return value: the usage below the given directory
{
    my ($top) = @_;
    my (@files,$filename,$file,$usage);
    $usage = 0;

    if ($top =~ /^([^;\|]+)$/o)  {$top = $1; }  # untaint ourselves

    print STDERR "Reading usage in $top\n" if ($Debug);
    if ((-d $top) && (! -l $top))
    {
	# It's a directory, recurse
	opendir(DIR,"$top") 
	    || return &abort("4469 Cannot read directory $top: $!");
	@files = grep(!/^\.\.?$/o,readdir(DIR));
	closedir DIR;
	if (@files)
	{
	    foreach $filename (@files)
	    {
		my $file = "$top/$filename";
		print STDERR "Looking at $top/$filename ($file\n" if ($Debug);
		if ((-d $file) && (! -l $file))
		{
		    $usage += (stat(_))[7];
		    $usage += du_recursively($file);
		}
		else
		{
		    $usage += (stat(_))[7];
		}
	    }
	}
    }
    else
    {
	# it's just a file...
	$usage += (stat(_))[7];
    }
    print STDERR "Usage for $top is $usage\n" if ($Debug);
    return $usage;
}

use Cobalt::Language;

1;
