# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Syswatch.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my %Status = ("none","0","0","none","green","1","1","green","2","yellow","red","3","3","red","yellow","2");
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Syswatch.pm.  Changes made here will be lost.
package Cobalt::Syswatch;

sub loadwatch
# Log when the load is too great
# Arguments: yellow threshold, red threshold
# Side effects: updates the database
# Return value: none
{
    my ($yelt,$redt) = @_;
    my ($five,$fifteen);
    open(LOAD,"/proc/loadavg") ||
	return "4450 Cannot read load average: $!";
    my $line = <LOAD>;
    $line =~ /^(\d+\.\d+)\s*(\d+\.\d+)\s*(\d+\.\d+)/o;
    close LOAD;
    $five = $2;
    $fifteen = $3;
    if ($fifteen >= $redt)
    {
	# message depends on whether swapping is bad
	my ($mesnum);
	my ($swapsev) = db_prev_entry("mem","swapping");
	($swapsev > $Status{"green"}) ? 
	    ($mesnum = 125) : ($mesnum = 120);
	db_add_entry("cpu",$Status{"red"},0,time(),$mesnum,
		     "[load average $fifteen]","load",0,$fifteen);
    }
    elsif ($fifteen >= $yelt)
    {
	# message depends on whether swapping is bad
	my ($mesnum);
	my ($swapsev) = db_prev_entry("mem","swapping");
	($swapsev > $Status{"green"}) ? 
	    ($mesnum = 125) : ($mesnum = 120);
	db_add_entry("cpu",$Status{"yellow"},0,time(),$mesnum,
		     "[load average $fifteen]","load",0,$fifteen);
    }
    else
    {
	db_add_entry("cpu",$Status{"green"},0,time(),0,
		     "[load average $fifteen]","load",0,$fifteen);
    }

}

use Cobalt::Language;

1;
