# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Syswatch.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my %Status = ("none","0","0","none","green","1","1","green","2","yellow","red","3","3","red","yellow","2");
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Syswatch.pm.  Changes made here will be lost.
package Cobalt::Syswatch;

sub memwatch
# Keep an eye on the memory state and report excessive swapping
# Arguments: yellow threshold, red threshold
#   thresholds are in percent of virtual memory used
# Side effects: updates the database
# Return value: none
{
    my ($yelp,$redp) = @_;
    my ($ptot,$pfree,$stot,$sfree,$vtot,$vused,$usepcent);
    # there seems to be some inconsistency about the format of this
    # file.  Let's hope that it's okay.
    open(MEM,"/proc/meminfo") || die "Cannot read /proc/meminfo: $!\n";
    while (<MEM>)
    {
	if (/^MemTotal:\s+(\d+)/o)
	{
	    $ptot = $1;
	}
	elsif (/^MemFree:\s+(\d+)/o)
	{
	    $pfree = $1;
	}
	elsif (/^SwapTotal:\s+(\d+)/o)
	{
	    $stot = $1;
	}
	elsif (/^SwapFree:\s+(\d+)/o)
	{
	    $sfree = $1;
	}
    }
    close MEM;
    $vtot = $ptot + $stot;
    $vused = $vtot - ($pfree + $sfree);
    $usepcent = int(($vused / $vtot) * 1000) / 10;
    if ($usepcent >= $redp)
    {
	db_add_entry("mem",$Status{"red"},0,time(),"140",
		     "$usepcent% memory used","vmem",0,$usepcent);
    }
    elsif ($usepcent >= $yelp)
    {
	db_add_entry("mem",$Status{"yellow"},0,time(),"140",
		     "$usepcent% memory used","vmem",0,$usepcent);
    }
    else
    {
	db_add_entry("mem",$Status{"green"},0,time(),0,
		     "$usepcent% memory used","vmem",0,$usepcent);
    }
}

use Cobalt::Language;

1;
