# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Syswatch.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $ProcCache = "/etc/locks/proclist";
my $Ps_cmd = "/bin/ps";
my %Status = ("none","0","0","none","green","1","1","green","2","yellow","red","3","3","red","yellow","2");
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Syswatch.pm.  Changes made here will be lost.
package Cobalt::Syswatch;

sub procwatch
# Check to see if a process is running
# Arguments: process name (the command) and the name of the server
#   (for use in the database)
# Side effects: updates the database
# Return value: none
{
    my ($process,$server) = @_;
    # Use the process cache instead of running ps over and over
    if ((-e "$ProcCache") && ((time() - (stat(_))[10]) < 300))
    {
	unless (open (PS,"$ProcCache"))
	{
	    return "4466 Cannot read process list cache: $!";
	}
    }
    else
    {
	unless (open (PS,"$Ps_cmd axw|"))
	{
	    print STDERR "Cannot run $Ps_cmd: $!\n" if ($Debug);
	    return "4451 Cannot run $Ps_cmd: $!";
	}	
	<PS>;  # chop the top
    }

    "$process" =~ /$process/;  # minor speed increase by pre-compiling
    while (<PS>)
    {
	next unless (//);
	chomp;
	/^\s*\d+\s+\S+\s+\S+\s+\S+\s+(.+)/o;
	my ($cmd) = ($1);
	next unless ($cmd);
	if ($cmd =~ /$process/)
	{
	    close PS;
	    db_add_entry($server,$Status{"green"},0,time(),0,
			 "$process is running",$process);
	    return;
	}
    }
    close PS;

    db_add_entry($server,$Status{"red"},0,time(),"300",
		 "$process is not running",$process);
}

use Cobalt::Language;

1;
