# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Syswatch.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my %Status = ("none","0","0","none","green","1","1","green","2","yellow","red","3","3","red","yellow","2");
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Syswatch.pm.  Changes made here will be lost.
package Cobalt::Syswatch;

sub quotawatch
# monitor the quota for a user
# Arguments: name, type, yellow threshold (%), red threshold (%)
#   type = $UsrQuota or $GrpQuota
# Side effects: updates the database
# Return value: (severity,used)
{
    my ($name,$type,$yelp,$redp) = @_;
    my ($used,$soft) = repquota($name,$type);
    my ($t,$severity);
    unless ($soft)
    {
	# No quota.  No point.
	return;
    }
    ($type) ? ($t = "group") : ($t = "user");
    my $share = int(($used / $soft) * 1000) / 10;
    if ($share >= $redp)
    {
	db_add_entry("disk",$Status{"red"},0,time(),"110",
		     "$t $name is at $share% of quota ($used / $soft)",
		     "$name,$type",0,$share);
	$severity = $Status{"red"};
    }
    elsif ($share >= $yelp)
    {
	db_add_entry("disk",$Status{"yellow"},0,time(),"110",
		     "$t $name is at $share% of quota ($used / $soft)",
		     "$name,$type",0,$share);
	$severity = $Status{"yellow"};

    }
    else
    {
	db_add_entry("disk",$Status{"green"},0,time(),0,
		     "$t $name is at $share% of quota ($used / $soft)",
		     "$name,$type",0,$share);
	$severity = $Status{"green"};
    }
    return ($severity,$used);
}

use Cobalt::Language;

1;
