# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Syswatch.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $MailSpoolMax = "5000";
my $Mailspool = "/home/spool/mail";
my %Status = ("none","0","0","none","green","1","1","green","2","yellow","red","3","3","red","yellow","2");
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Syswatch.pm.  Changes made here will be lost.
package Cobalt::Syswatch;

sub spoolwatch
# monitor the size of a user's mail spool
# Arguments: name
# Side effects: updates the database
# Return value: none
{
    my ($name) = @_;
    # Get the size of the user's mail spool, in kilobytes
    my ($size) = int((stat("$Mailspool/$name"))[7] / 1024);
    if ($size >= $MailSpoolMax)
    {
	db_add_entry("disk",$Status{"yellow"},0,time(),"160",
		     "$name has $size kilobytes of mail ","$name,mail",0,$size);
    }
    else
    {
	db_add_entry("disk",$Status{"green"},0,time(),0,
		     "$name has $size kilobytes of mail","$name,mail",0,$size);
    }
}

use Cobalt::Language;

1;
