# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Time.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Localtime_link = "/etc/localtime";
my $Zone_dir = "/usr/share/zoneinfo";
my %Zones = ("Asia/Karachi","GMT+5","Europe/Athens","GMT+2","GMT+0","Europe/London","GMT+1","Europe/Rome","GMT+2","Europe/Athens","GMT-1","Atlantic/Azores","GMT+3","Asia/Baghdad","GMT+4","Asia/Muscat","GMT-3","Brazil/East","GMT+5","Asia/Karachi","Pacific/Midway","GMT-11","US/Eastern","GMT-5","GMT-4","Canada/Atlantic","Europe/London","GMT+0","US/Hawaii","GMT-10","GMT-5","US/Eastern","GMT+7","Asia/Bangkok","GMT-6","US/Central","GMT+8","Australia/Perth","GMT-7","US/Mountain","GMT+9","Asia/Tokyo","GMT-8","US/Pacific","GMT-9","US/Alaska","Asia/Magadan","GMT+11","Pacific/Fiji","GMT+12","Brazil/East","GMT-3","US/Central","GMT-6","US/Mountain","GMT-7","Asia/Tokyo","GMT+9","US/Alaska","GMT-9","US/Pacific","GMT-8","Asia/Baghdad","GMT+3","Pacific/Guam","GMT+10","Asia/Bangkok","GMT+7","Europe/Rome","GMT+1","Atlantic/Azores","GMT-1","GMT+10","Pacific/Guam","GMT+11","Asia/Magadan","GMT-10","US/Hawaii","GMT+12","Pacific/Fiji","GMT-11","Pacific/Midway","Canada/Atlantic","GMT-4","Australia/Perth","GMT+8","Asia/Muscat","GMT+4");
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Time.pm.  Changes made here will be lost.
package Cobalt::Time;

sub time_get_zone
# Get our timezone
# Arguments: none
# Return value: zone in terms of GMT +/- some number (e.g., "GMT+3")
# Side effects: none
{
    my $zone = readlink($Localtime_link);
    $zone =~ s/^$Zone_dir\///o;
    if ($Zones{$zone})
    {
	return($Zones{$zone});
    }
    else
    {
	# not mapped, return in GMT+# format
	return (split('/',$zone))[1];
    }
}


1;
