# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from User.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Htptmp = "/etc/locks/htptmp";
my $Lockdir = "/etc/locks";
my $Ptmp = "/etc/locks/ptmp";
my $Smbptmp = "/etc/locks/smbptmp";
my %Features = ("networker","1","telnetConfig","1","dhcpd","0","shiftjis","Cobalt interface message for shiftjis (We should never see this)","pagebuilder","0","www","1","mx","1","gated","1","dns","1","nfs","0","securetty","1","english","1","atalk","0","fpx","1","siteAdminRedirect","1","users","1","ntp","0","mon_textdb_only","0","search","0","anonFTP","1","specialHomeSkel","0","viewGroups","0","cobaltHomePage","0","lastNameFirst","1","warnRootOnly","1","vsites","1","pam","1","discuss","0","docorg","0","groups","1","smb","0","mail","1","nat","0","squid","0","autoGenWebUsage","0","japanese","0","cobaltRedirect","0","backups","1","vmachine","1","mon_port_testing","1","viewUsers","0","usersCGIInWizard","1","privatedirs","0","telnetDefault","1","ssl","0","siteManagement","1","adm","1","bind8","1","personalRedirect","1","webRequests","1","usersAddUser","0","adminRedirect","1","quotas","1","snmp","1","defaultUserNameGen","1","groupdirs","1","proftpd","1");
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/User.pm.  Changes made here will be lost.
package Cobalt::User;

sub unlock_passwd
# Unlocks the password file by wiping ptmp
# Arguments: none
# Side effects: wipes ptmp, htptmp
{
    unlink($Ptmp) || return "4512 Cannot delete password lock file /etc/locks/ptmp: $!";
    print STDERR "Removed $Ptmp\n" if ($Debug);

    unless ($Features{'pam'}) {
      unlink($Htptmp) || return "4513 Cannot delete web password lock file /etc/locks/htptmp: $!";
      print STDERR "Removed $Htptmp\n" if ($Debug);
    }

    if ($Features{'smb'}) {
      unlink($Smbptmp) || return "smb_cant_unlink_smbptmp Cannot unlink $Smbptmp: $!";
    }
    if ($Features{'atalk'}) {
      my $atalk_ret = Cobalt::Atalk::atalk_unlock_passwd();
      return $atalk_ret if ($atalk_ret !~ /^2/);
    }

    unlink("$Lockdir/user-$$");
    endpwent();  # flush the cache
    return "2513 Password file unlocked";
}


1;
