# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from User.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Adminuser = "admin";
my $Firstuid = "110";
my $Htgroup_dir = "/home/sites";
my $Htptmp = "/etc/locks/htptmp";
my $Mailspool = "/home/spool/mail";
my $MainGroup = "home";
my $MaxGcosLen = "256";
my $MaxNameLen = "12";
my $MaxQuota = "26624000";
my $Private_html = "private";
my $Ptmp = "/etc/locks/ptmp";
my $Quota_harder = "1";
my $Smb_gethash = "/usr/sbin/gethash";
my $Smbptmp = "/etc/locks/smbptmp";
my $Uid_file = "/var/cobalt/uid";
my $UserDirPermissions = "1529";
my $UserPrivateDirPermissions = "1512";
my $UserWebPermissions = "1533";
my $User_skel = "/etc/skel/user";
my $Userdir = "/home/sites";
my $Usergroup = "100";
my $Userpart = "/dev/hda4";
my $Usershell = "/bin/bash";
my $WWWgid = "11";
my $WWWuser = "httpd";
my $Webdir = "web";
my %Features = ("networker","1","telnetConfig","1","dhcpd","0","shiftjis","Cobalt interface message for shiftjis (We should never see this)","pagebuilder","0","www","1","mx","1","gated","1","dns","1","nfs","0","securetty","1","english","1","atalk","0","fpx","1","siteAdminRedirect","1","users","1","ntp","0","mon_textdb_only","0","search","0","anonFTP","1","specialHomeSkel","0","viewGroups","0","cobaltHomePage","0","lastNameFirst","1","warnRootOnly","1","vsites","1","pam","1","discuss","0","docorg","0","groups","1","smb","0","mail","1","nat","0","squid","0","autoGenWebUsage","0","japanese","0","cobaltRedirect","0","backups","1","vmachine","1","mon_port_testing","1","viewUsers","0","usersCGIInWizard","1","privatedirs","0","telnetDefault","1","ssl","0","siteManagement","1","adm","1","bind8","1","personalRedirect","1","webRequests","1","usersAddUser","0","adminRedirect","1","quotas","1","snmp","1","defaultUserNameGen","1","groupdirs","1","proftpd","1");
my %System_groups = ("global","1","tty","1","users","1","adm","1","mail","1","site-adm","1","httpd","1","daemon","1","root","1","gopher","1","wheel","1","admin","1","bin","1","ftp","1","kmem","1","nobody","1","disk","1","homes","1","man","1","lp","1","dip","1","games","1","uucp","1","news","1","sys","1","mem","1");
my %System_users = ("mail","1","httpd","1","root","1","gopher","1","squid","1","guest","1","anonymous","1","halt","1","ftp","1","nobody","1","operator","1","games","1","adm","1","daemon","1","bin","1","shutdown","1","lp","1","sync","1","news","1","uucp","1");
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/User.pm.  Changes made here will be lost.
package Cobalt::User;

sub user_add
# user_add: Create a new user
# Arguments: login, full name, cleartext password, quota, shell
#            optional group (necessary for RaQ),
#            optional home directory (if specified, don't create or touch)
# Side effects: adds the user to the password file and the htpassword file, 
#   and creates a home directory.
# Return value: a string of the form "526 The wicked witch is dead"
# Example: Cobalt::User::user_add("rblaine","Rick Blaine","SeCrEt",2048,$Usershell);
{
    my ($username,$descr,$passwd,$quota,$shell,$base_group,$user_home) = @_;
    my ($group) = $base_group;
    my ($id,$uid,$return,$cryptpw,$htmlfile);
    my ($user_group,$user_dirgroup);
    my ($homedir);

    return "4543 Invalid user name $username" if ($username !~ /^[\w\-\.]+$/o);
    return "4554 Names must be no longer than 12 characters."
	if (length($username) > $MaxNameLen);
    # Print out the max in megs, not kilobytes
    return "4544 The quota must be an integer greater than zero"
      if ($quota !~ /^\d+$/o);
    my $warn_quota = ($MaxQuota / 1024);
    return "4555 User quotas may not exceed $warn_quota"
	if ($quota > $MaxQuota);
    return "4546 $username is a reserved name" if ($System_users{$username});
    return "4500 User $username already exists" if (Cobalt::User::user_exist($username));
    return "4501 User names cannot contain colons"
	if ($descr =~ /:/o);
    return "4557 The name $username is reserved by the system"
	if ($System_groups{$username} && $username ne $Adminuser);
    return "4530 Name $username is already in use as a group"
	if (getgrnam($username));
    return "4545 Name $username is already in use as a mailing list or alias"
	if (Cobalt::List::alias_exist($username));
    return $cryptpw                    # error messages contain spaces
	if (($cryptpw = Cobalt::User::verify_password($passwd)) =~ /\s/o);

    if ($base_group && $Features{'vmachine'}) 
    {
 	unless (-d "$Htgroup_dir/$base_group/users")
	{
	    mkdir("$Htgroup_dir/$base_group/users",02775);
	    chown( (getpwnam($WWWuser))[2], (getgrnam($base_group))[2], "$Htgroup_dir/$base_group/users");
	    chmod(02775,"$Htgroup_dir/$base_group/users"); # the mkdir above doesn't work.
	}
	# all the files should be owned by the site group
	$user_group = (getgrnam($base_group))[2];
	$user_dirgroup = $user_group;
	$base_group = "/$base_group/users";
    }
    else {
	# the files should be owned by the generic users group
	$user_group = $WWWgid;
	$user_dirgroup = $WWWgid;
    }
    print STDERR "$username in group $user_group\n" if ($Debug);

    if ($user_home) { $homedir = $user_home; }
    else {
	if( $base_group ) {
	    $homedir = "$Userdir$base_group/$username";

	    # Make sure the parent directory exists
	    if( ! -d "$Userdir$base_group" ) { mkdir( "$Userdir$base_group", 02775 ); }
	}
	else {
	    $homedir = "$Userdir/$username";

	    # Make sure the parent directory exists
	    if( ! -d $Userdir ) { mkdir( $Userdir, 02775 ); }
	}
    }

    if ( !$user_home && -e $homedir) {
	return "4503 Cannot create $username: directory $homedir already exists.";
    }

    setpwent();

    # set default shell
    if( !$shell ) { $shell=$Usershell; }

    # Truncate the GCOS if it's too long
    $descr = substr($descr,0,$MaxGcosLen) if (length($descr) > $MaxGcosLen);
    $descr =~ s/>/&gt;/og;  # No HTML!
    $descr =~ s/</&lt;/og;
    $descr =~ s/\'/&\#039;/og;  # Replace quotes with HTML

    return $return unless (($return = Cobalt::User::lock_passwd()) =~ /^2/o);

    ### Add the entry to the password file

    # Keep track of what UIDs we've given and don't reassign them
    # (and don't forget to wipe this in sysreset if we use it)
    if (open(UID,$Uid_file))
    {
	# UID file exists
	$id = <UID>;
	close UID;
    }
    $id ||= $Firstuid;
    #setpwent();
    #for($id; getpwuid($id); $id++) {;}  # Get next UID
    #if ($id =~ /^(\d+)$/o)  { $uid = $1; }
    #else                    { return Cobalt::User::user_abort("4514 Malformed UID");  }
    $uid = Cobalt::User::user_get_first_available_uid($id);
    setpwent();
    if (getpwuid($uid)) {
      return Cobalt::User::user_abort("4506 getpwuid($uid) says true -- get_first_available_uid is hosed");
    }

    open(UID,">$Uid_file")
      || return Cobalt::User::user_abort("4556 Cannot write /var/cobalt/uid: $!");
    print UID $uid+1;
    close UID;
    
    my $line = "$username:$cryptpw:$uid:$Usergroup:$descr:$homedir:$shell\n";
    print STDERR "Adding to $Ptmp:\n$line" if ($Debug);
    open(PTMP,">>$Ptmp") 
	|| return Cobalt::User::user_abort("4515 Cannot append to /etc/locks/ptmp: $!");
    print PTMP $line;
    close PTMP;
    
    unless ($Features{'pam'}) {
      # Appends to the htpasswd file
      open(HTP,">>$Htptmp") 
	|| return Cobalt::User::user_abort("4516 Cannot append to /etc/locks/htptmp: $!");
      print HTP "$username:$cryptpw\n";
      close HTP;
    }
    
    unless ($user_home) {
      ### Create the directory and files for the user
      print STDERR "Creating directories under $homedir\n" if ($Debug);

      mkdir($homedir,$UserDirPermissions) 
	|| return Cobalt::User::user_abort("4805 Cannot create home $homedir: $!");
      chown($uid,$user_dirgroup,$homedir)
	|| return Cobalt::User::user_abort("3037 Cannot set ownership for $homedir to $uid/100: $!");
      chmod($UserDirPermissions,$homedir);

      # Add public web directory
      mkdir("$homedir/$Webdir",$UserWebPermissions) 
	|| return Cobalt::User::user_abort("4806 Cannot create home $homedir/web: $!");
      chown($uid,$user_dirgroup,"$homedir/$Webdir")
	|| return Cobalt::User::user_abort("3038 Cannot set ownership for $homedir to $uid/100: $!");
      chmod($UserWebPermissions,"$homedir/$Webdir");
    
      # Copy the HTML templates
      opendir(SKEL,$User_skel)
	|| return Cobalt::User::user_abort("3592 Cannot read /etc/skel/user: $!");
      foreach $htmlfile (grep(/\.html$/o,readdir(SKEL)))
      {
	next if ($htmlfile eq "index.html"); # special case, do later
	print STDERR "Copying $htmlfile to $homedir/$htmlfile\n"
	  if ($Debug);
	open(SRC,"$User_skel/$htmlfile") 
	  || return Cobalt::User::user_abort("4539 Cannot open source file /etc/skel/user/$htmlfile: $!");
	open(DEST,">$homedir/$Webdir/$htmlfile") 
	  || return Cobalt::User::user_abort("4542 Cannot open destination file $homedir/$htmlfile: $!");
	print DEST while (<SRC>);
	close DEST;
	close SRC;
	
	chown($uid,$user_group,"$homedir/$Webdir/$htmlfile");
	chmod(0664,"$homedir/$Webdir/$htmlfile") if ($Features{'vsites'});
      }
      closedir SKEL;

      # Now do index.html
      my $domain;
      if ($group) {
	  if ($group eq $MainGroup) { $domain = Cobalt::Netutil::netutil_get_fulldomain(); }
	  else { $domain = (Cobalt::Vsite::vsite_get_bygroup($group))[ 1 ]; }
      }
      print STDERR "Copying index.html to $homedir/$Webdir/index.html\n"
	if ($Debug);
      open(SRC,"$User_skel/index.html") 
	|| return Cobalt::User::user_abort("4550 Cannot open source file /etc/skel/user/index.html: $!");
      open(DEST,">$homedir/$Webdir/index.html") 
	|| return Cobalt::User::user_abort("4553 Cannot open destination file $homedir/index.html: $!");
      while (<SRC>)
      {
	if (/\[/o)
	{
	  s/\[DOMAIN\]/$domain/go;
	  s/\[PATH\]/$homedir\/index.html/o;
	  s/\[USER\]/$descr/o;
	  s/\[USERNAME\]/$username/go;
	}
	print DEST;
      }
      close DEST;
      close SRC;
      chown($uid,$user_group,"$homedir/$Webdir/index.html");
      chmod(0664,"$homedir/$Webdir/index.html") if ($Features{'vsites'});
      
      if ($Features{'privatedirs'})
      {
	mkdir("$homedir/$Webdir/$Private_html",$UserPrivateDirPermissions)
	  || return Cobalt::User::user_abort("4528 Cannot create $homedir/private: $!");
	chown($uid,$user_dirgroup,"$homedir/$Webdir/$Private_html");
	chmod(02750,"$homedir/$Webdir/$Private_html");
	Cobalt::Admserv::admserv_set_access("$homedir/$Webdir/$Private_html","require","user",$username);
	
	# Now do index.html for the private directory
	if (-e "$User_skel/private.tmpl")
	{
	  print STDERR "Copying private.tmpl to $homedir/$Webdir/$Private_html/index.html\n"
	    if ($Debug);
	  open(SRC,"$User_skel/private.tmpl") 
	    || return Cobalt::User::user_abort("4570 Cannot open source file /etc/skel/user/private.tmpl: $!");
	  open(DEST,">$homedir/$Webdir/$Private_html/index.html") 
	    || return Cobalt::User::user_abort("4571 Cannot open destination file $homedir/index.html: $!");
	  while (<SRC>)
	  {
	    if (/\[/o)
	    {
	      s/\[USER\]/$descr/;
	      s/\[PATH\]/$homedir\/$Private_html\/index.html/;
	    }
	    print DEST;
	  }
	  close DEST;
	  close SRC;
	  chown($uid,$user_group,"$homedir/$Private_html/index.html");
	}
      }

      # AppleTalk seems to feel some odd need for this directory.
      # Let the baby have its way.
      if ($Features{'atalk'}) {
	mkdir("$homedir/Network Trash Folder",$UserDirPermissions)
	  || return Cobalt::User::user_abort("4807 Cannot create Network Trash Foler: $!");
	chown($uid,$user_dirgroup,"$homedir/Network Trash Folder");
	chmod($UserDirPermissions,"$homedir/Network Trash Folder");
	mkdir("$homedir/$Webdir/Network Trash Folder",$UserDirPermissions)
	  || return Cobalt::User::user_abort("4808 Cannot create Network Trash Foler: $!");
	chown($uid,$user_dirgroup,"$homedir/$Webdir/Network Trash Folder");
	chmod($UserDirPermissions,"$homedir/$Webdir/Network Trash Folder");
      }
    }
    ### End dir creation

    # Touch the user mail spool and set ownership
    open(MLSPL,"> $Mailspool/$username")
      || return Cobalt::User::user_abort("4596 Cannot create mail spool for $username: $!"); 
    close(MLSPL);
    chmod(0600,"$Mailspool/$username");
    chown($uid, $user_group ,"$Mailspool/$username");

    # update the netatalk passwd file (will they ever end?)
    if ($Features{'atalk'}) {
      my $atalk_ret = Cobalt::Atalk::atalk_set_passwd($username, $passwd);
      return $atalk_ret if ($atalk_ret !~ /^2/);
    }

    # lastly, add an entry to the smbpasswd file
    if ($Features{'smb'}) {
      $ENV{'SMBPASSWD'} = $passwd;
      open(GETHASH, "$Smb_gethash|")
	|| return Cobalt::User::user_abort("4584 Cannot run /usr/sbin/gethash: $!");
      my $smbhashes = <GETHASH>;
      close(GETHASH);
      open(SMBPTMP, ">>$Smbptmp") or return "4575 Cannot append to /etc/locks/smbptmp: $!";
      print SMBPTMP "$username:$uid:$smbhashes:$descr:$homedir:$shell\n";
      close(SMBPTMP);
    }
    
    return $return unless (($return = Cobalt::User::commit_passwd()) =~ /^2/o);
    Cobalt::Quota::setqlim($Userpart,$uid,$quota,($quota + $Quota_harder));
    #Cobalt::Quota::setqlim($Varpart,$uid,$quota,($quota + $Quota_harder));
    
    print STDERR "User $username complete\n" if ($Debug);
    return "2530 User $username created successfully";
}


1;
