# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from User.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Adminuser = "admin";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/User.pm.  Changes made here will be lost.
package Cobalt::User;

sub user_info_sorted
# Get a sorted list of users, sorted by full name
# Arguments: noParseFullName
# Return value: a two dimensional array: each element of the array
#   is an array containing (full name, '', user name) if noParseFullName is true or (first name, last name, user name) otherwise
# Side effects: none
{
    my ( $noParseFullName )=@_;

    my ($login,@users,@admin);
    foreach $login (Cobalt::User::user_list())
    {
	#next if ($login eq $Adminuser);   # Don't change the admin user
	my $descr = (getpwnam($login))[6];
	my ($firstName,$lastName);

        if( !$noParseFullName ) {
	    # This way will split the first and last name by the last whitespace:
	    # @name = split(/\s+/o,$descr);
	    # $lastname = pop(@name);
	    # $firstname = join(' ',@name);

	    # This way will split the first and last name by the first whitespace:
	    if ($descr =~ /^\s*(\S+\s+)?(\S?.*\S)\s*$/o)
	    {
		($firstName,$lastName) = ($1,$2);
		# get rid of trailing whitespace
		$firstName =~ s/\s+$//og;
	    }
	}
        else {
	    $firstName=$descr;
	    $lastName='';
        }

	if ($login eq $Adminuser)
	{
	    @admin = ($firstName,$lastName,$login);
	}
	else
	{
	    my @user = ($firstName,$lastName,$login);
	    push(@users, [ @user ]);
	}
	print STDERR "My name is $firstName/$lastName/\n" if ($Debug);
    }

    # sort users 
    @users=sort { 
	# order by last name, first name, then user name 
	lc ( ${ $a }[ 1 ] ) cmp lc( ${ $b }[ 1 ] ) 
        or 
	lc( $ { $a }[ 0 ] ) cmp lc( $ { $b }[ 0 ] ) 
	or 
        lc( ${ $a }[ 2 ] ) cmp lc( ${ $b }[ 2 ] ); 
    } 
    @users; 

    # admin goes first
    #my @admin = ("",(getpwnam($Adminuser))[6],$Adminuser);
    unshift(@users, [ @admin ]);
    return @users;
}


1;
