# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from User.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Adminuser = "admin";
my %System_users = ("mail","1","httpd","1","root","1","gopher","1","squid","1","guest","1","anonymous","1","halt","1","ftp","1","nobody","1","operator","1","games","1","adm","1","daemon","1","bin","1","shutdown","1","lp","1","sync","1","news","1","uucp","1");
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/User.pm.  Changes made here will be lost.
package Cobalt::User;

sub user_list
# user_list: Return a list of users
#   Skip capitalized users, they're special.
# Arguments: none
# Return value: a sorted list of users, with admin on top
# Side effects: none
# Example: @users = Cobalt::User::user_list();
{
    my (@users,$name);
    setpwent();
    while ($name = getpwent)
    {
	next if ($name eq $Adminuser);
	next if ($name =~ /^[A-Z]/o);  # capitalized names are special
	push (@users,$name) unless ($System_users{$name});
    }
    endpwent();

    @users = ($Adminuser,sort(@users));
    return @users;
}


1;
