# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from User.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my %System_groups = ("global","1","tty","1","users","1","adm","1","mail","1","site-adm","1","httpd","1","daemon","1","root","1","gopher","1","wheel","1","admin","1","bin","1","ftp","1","kmem","1","nobody","1","disk","1","homes","1","man","1","lp","1","dip","1","games","1","uucp","1","news","1","sys","1","mem","1");
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/User.pm.  Changes made here will be lost.
package Cobalt::User;

sub user_list_groups
# Find out what groups a user is in.
# Arguments: username
# Return value: a list of groups
# Side effects: none
# Example: @debbies_groups = Cobalt::User::user_list_groups("debbie");
{
    my ($username) = @_;
    my ($gr,$members,@grouplist);
    setgrent();
    $username =~ /\b$username\b/;  # pre-compile
    while (($gr,$members) = (getgrent)[0,3])
    {
	next if ($System_groups{$gr});
	push(@grouplist,$gr) if ($members =~ //);
    }
    endgrent();
    return sort(@grouplist);
}


1;
