# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from User.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/User.pm.  Changes made here will be lost.
package Cobalt::User;

sub user_list_site
# Find out what site a user is in.
# Assuming the list groupName-users contains a list of users of group groupName
#   and a user can only belong to one groupName-users list
# Arguments: username
# Return value: fully qualified domain name of the site, group name
#   Nothing if nothing found
# Side effects: none
# Example: ( $domain, $group ) = Cobalt::User::user_list_site( 'kevin' );
{
    my ( $userName )=@_;

    my $domain;
    my $group;

    my (@lists, $list);
    return $lists[0] if ((@lists = list_lists())[0] =~ /^[134]/);
    foreach $list ( @lists ) {
	if( $list=~/^(.+)-users$/ ) {
	    $group=$1;
	    if( grep /^$userName$/, list_get_mem($list) ) {
		$domain=( Cobalt::Vsite::vsite_get_bygroup($group) )[ 1 ];
		last;
	    }
	}
    }

    return ( $domain, $group );
}


1;
