# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from User.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Adminuser = "admin";
my $Htpasswd = "/etc/htpasswd";
my $Htptmp = "/etc/locks/htptmp";
my $Lockdir = "/etc/locks";
my $MaxGcosLen = "256";
my $MaxQuota = "26624000";
my $Ptmp = "/etc/locks/ptmp";
my $Quota_harder = "1";
my $Smb_gethash = "/usr/sbin/gethash";
my $Smbptmp = "/etc/locks/smbptmp";
my $Userpart = "/dev/hda4";
my %Features = ("networker","1","telnetConfig","1","dhcpd","0","shiftjis","Cobalt interface message for shiftjis (We should never see this)","pagebuilder","0","www","1","mx","1","gated","1","dns","1","nfs","0","securetty","1","english","1","atalk","0","fpx","1","siteAdminRedirect","1","users","1","ntp","0","mon_textdb_only","0","search","0","anonFTP","1","specialHomeSkel","0","viewGroups","0","cobaltHomePage","0","lastNameFirst","1","warnRootOnly","1","vsites","1","pam","1","discuss","0","docorg","0","groups","1","smb","0","mail","1","nat","0","squid","0","autoGenWebUsage","0","japanese","0","cobaltRedirect","0","backups","1","vmachine","1","mon_port_testing","1","viewUsers","0","usersCGIInWizard","1","privatedirs","0","telnetDefault","1","ssl","0","siteManagement","1","adm","1","bind8","1","personalRedirect","1","webRequests","1","usersAddUser","0","adminRedirect","1","quotas","1","snmp","1","defaultUserNameGen","1","groupdirs","1","proftpd","1");
my %System_users = ("mail","1","httpd","1","root","1","gopher","1","squid","1","guest","1","anonymous","1","halt","1","ftp","1","nobody","1","operator","1","games","1","adm","1","daemon","1","bin","1","shutdown","1","lp","1","sync","1","news","1","uucp","1");
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/User.pm.  Changes made here will be lost.
package Cobalt::User;

sub user_mod
# user_mod: modify the settings for a user.  An argument of 0 or ""
#   for any given field means no change.
# Arguments: ("login","new description","new cleartext password","new quota","new shell")
# Side effects: modifies the password file
#   If we change the password for admin, we also do it for root.
# Return value: a string of the form "895 Out of paper"
# Example: Cobalt::User::user_mod("randy","Randy the Killer Clown",0,0);
{
    my ($name,$newdescr,$newpasswd,$newquota,$newshell) = @_;
    my ($return);
    return "4523 Cannot modify $name: no such user"
	unless (Cobalt::User::user_exist($name));
    my $warn_quota = ($MaxQuota / 1024);
    return "4525 User quotas may not be set above $warn_quota" 
	if ($newquota > $MaxQuota);
    return "4524 Cannot modify $name: prohibited user"
	if ($System_users{$name});
    return "4505 Names may not contain colons"
	if ($newdescr =~ /:/o);
    return $return unless (($return = Cobalt::User::lock_passwd()) =~ /^2/o);
    # Truncate the GCOS if it's too long
    $newdescr = substr($newdescr,0,$MaxGcosLen) 
	if (length($newdescr) > $MaxGcosLen);
    $newdescr =~ s/>/&gt;/og;  # No HTML!
    $newdescr =~ s/</&lt;/og;
    $newdescr =~ s/\'/&\#039;/og;

    ### modify the password file
    my ($name,$pass,$uid,$gid,$j1,$j2,$desc,$dir,$shell) = getpwnam($name);
    if ($newpasswd)
    {
	$pass = Cobalt::User::verify_password($newpasswd);
	if ($pass =~ /\s/o)
	{
	    # we got an error message, not a password
	    return Cobalt::User::user_abort("$pass");
	}
	
	print STDERR "Setting password for $name to $pass\n" if ($Debug);
    }
    if ($newdescr)
    {
	$desc = $newdescr;
    }
    if ($newshell)
    {
	$shell = $newshell;
    }
    if (($newdescr || $newpasswd || $newshell) && ($name eq $Adminuser))
    {
	open(PASSWD,$Ptmp) || return Cobalt::User::user_abort("4538 Cannot read /etc/locks/ptmp: $!");
	open(PTMP,">$Lockdir/passwd") 
	    || return Cobalt::User::user_abort("4541 Cannot write temporary file /etc/locks/passwd: $!");
	while (<PASSWD>)
	{
	    if (/^$Adminuser:/o)
	    {
		print PTMP "$name:$pass:$uid:$gid:$desc:$dir:$shell\n";
	    }
	    elsif (/^root:/o)
	    {
		print PTMP "root:$pass:0:0:Root:/root:/bin/sh\n";
	    }
	    else
	    {
		print PTMP;
	    }
	}
	close PASSWD;
	close PTMP;
	rename("$Lockdir/passwd",$Ptmp);
    }
    elsif ($newdescr || $newpasswd || $newshell)  # not the admin user
    {
	open(PASSWD,$Ptmp) || return Cobalt::User::user_abort("4532 Cannot read /etc/locks/ptmp: $!");
	open(PTMP,">$Lockdir/passwd") 
	    || return Cobalt::User::user_abort("4533 Cannot write lock file /etc/locks/passwd: $!");
	"$name:" =~ /^$name:/;
	while (<PASSWD>)
	{
	    if (//)
	    {
		# don't chomp
		print PTMP "$name:$pass:$uid:$gid:$desc:$dir:$shell\n";
	    }
	    else
	    {
		print PTMP;
	    }
	}
	close PASSWD;
	close PTMP;
	rename("$Lockdir/passwd",$Ptmp);
    }

    # modify the netatalk password entry
    if ($Features{'atalk'}) {
      my $atalk_ret = Cobalt::Atalk::atalk_set_passwd($name, $newpasswd);
      return $atalk_ret if ($atalk_ret !~ /^2/);
    }

    # modify the smbpasswd entry
    if ($Features{'smb'}) {
      # start by getting the new password hash
      $ENV{'SMBPASSWD'} = $newpasswd;
      open(GETHASH, "$Smb_gethash|")
	|| return Cobalt::User::user_abort("4579 Cannot run /usr/sbin/gethash: $!");
      my $smbhashes = <GETHASH>;
      close(GETHASH);
      
      # modify smbpasswd
      open(SMBPTMP,$Smbptmp) 
	|| return Cobalt::User::user_abort("4580 Cannot open /etc/locks/smbptmp to delete user: $!");
      open(SMBPASSWDLOCK,">$Lockdir/smbpasswd") 
	|| return Cobalt::User::user_abort("4582 Cannot clobber /etc/locks/smbpasswd: $!");
      "$name:" =~ /^$name:/; # pre-compile our pattern
      while (<SMBPTMP>)
	{
	  if (//) {
	    print SMBPASSWDLOCK "$name:$uid:$smbhashes:$desc:$dir:$shell\n";
	  } else {
	    print SMBPASSWDLOCK;
	  }
	}
      close SMBPASSWDLOCK;
      close SMBPTMP;
      rename("$Lockdir/smbpasswd",$Smbptmp) 
	|| return Cobalt::User::user_abort("4583 Cannot move /etc/locks/smbptmp: $!");
      # done modifying smbpasswd
    }
    
    unless ($Features{'pam'}) {
      if ($newpasswd)
      {
	# Fix the htpasswd file
	open(HTPASSWD,$Htptmp) 
	    || return Cobalt::User::user_abort("4549 Cannot open htpasswd file /etc/htpasswd: $!");
	open(HTP,">$Lockdir/htpasswd") 
	    || return Cobalt::User::user_abort("4547 Cannot clobber /etc/locks/htptmp: $!");
	"$name:" =~ /^$name:/; # pre-compile
	while (<HTPASSWD>)
	{
	    if (//)
	    {
		print HTP "$name:$pass\n";
	    }
	    else
	    {
		print HTP;
	    }
	}
	close HTP;
	close HTPASSWD;
	rename("$Lockdir/htpasswd",$Htptmp) 
	    || return Cobalt::User::user_abort("4548 Cannot rename /etc/locks/htptmp: $!");
      }
    }
    return $return unless (($return = Cobalt::User::commit_passwd()) =~ /^2/o);
    
    ### Set the quota
    if ($newquota)
    {
	Cobalt::Quota::setqlim($Userpart,(getpwnam($name))[2],
		$newquota,($newquota + $Quota_harder));
	#Cobalt::Quota::setqlim($Varpart,(getpwnam($name))[2],
	#	$newquota,($newquota + $Quota_harder));
    }
    
    print STDERR "Modification of user $name complete\n" if ($Debug);
    return "2533 User $name modified successfully";
}


1;
