# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from User.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $MaxPassLen = "16";
my $MinPassLen = "3";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/User.pm.  Changes made here will be lost.
package Cobalt::User;

sub verify_password
# Make sure the password is okay
# Arguments: the password
#   If the password is "*" then return a locked password entry
# Return value: the encrypted version of the password, or an error message.
#   Encrypted passwords will always be 13 characters; error messages
#   never will.
#TBD# SECURITY ALERT
# If we wanted to enforce strong passwords, this is where we would
# do it.  Add tests to this function to see if a password is good enough,
# and return an error if it isn't...
{
    my ($userpass) = @_;
    
    return "*" if ($userpass eq "*");  # Locked entry
    if ($userpass =~ /[\000-\037\177]/o)
    {
	return "4534 The password may not contain control characters";
    }
    if (length($userpass) > $MaxPassLen)
    {
	return "4535 The given password is too long.  Passwords must be less than 16 characters";
    }
    elsif (length($userpass) < $MinPassLen)
    {
	return "4536 The given password is too short.  Passwords must be at least 3 characters.";
    }

    # Generate the encrypted password
    srand();
    my $salt = ('a'..'z','A'..'Z',0..9)[rand(62)] . 
	('a'..'z','A'..'Z',0..9)[rand(62)];
    my $cryptpass = crypt($userpass, $salt);
    return $cryptpass;
}


1;
