# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Utility.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Issuefile = "/etc/issue";
my $Runlevel_cmd = "/sbin/runlevel";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Utility.pm.  Changes made here will be lost.
package Cobalt::Utility;

sub sauce_booted
# Are we booted up?
# The last thing done in the boot sequence is to re-create /etc/issue;
# so if that file is older than our current uptime, then we're in the
# early stages of bootup and should wait before doing anything.
# Arguments: none
# Return value: 1 if we're all up and going, 0 if we're still in the
#   process of booting
{
  my ($runtime,$boottime);

  # First check to make sure we aren't in the middle of boot-up or shutdown
  open(RL,"$Runlevel_cmd|") || die "Can't get runlevel: $!\n";
  my $rl = (split(/\s/o,<RL>))[1];
  close RL;
  return 0 if ($rl != 3);

  # Now check to see if we're all the way up
  open(UPTIME,"/proc/uptime") || die "Cannot read /proc/uptime: $!\n";
  $boottime = (split(/\s/o,<UPTIME>))[0];
  close UPTIME;

  # No way should we ever take more than an hour to boot.  If uptime is that 
  # big,assume we're booted (and let Active Monitor sort it out...)
  return 1 if ($boottime > 3600);  

  # Otherwise we're in that first hour of uptime.  The last thing that should
  # happen in the boot sequence is the issue file getting updated, so check 
  # that.
  $boottime = time() - $boottime;   # convert into time since the epoch
  $runtime = (stat($Issuefile))[9];
  print STDERR "Up since $boottime, running since $runtime\n" if ($Debug);
  ($runtime < $boottime) ? return 0 : return 1;
}


1;
