# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Utility.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Utility.pm.  Changes made here will be lost.
package Cobalt::Utility;

sub sauce_deltree
# Recursively deletes a directory tree
# Arguments: the directory to start at
# Side effects: kills a tree of files
{
    my ($top) = @_;
    my (@files,$filename,$file);

    if ($top =~ /^([^;\|]+)$/o)  {$top = $1; }  # untaint ourselves

    print STDERR "Deleting $top\n" if ($Debug);
    if ((-d $top) && (! -l $top))
    {
	# It's a directory, recurse
	opendir(DIR,"$top") || return "4537 Cannot read directory $top: $!";
	@files = grep(!/^\.\.?$/o,readdir(DIR));
	closedir DIR;
	if (@files)
	{
	    foreach $filename (@files)
	    {
		$file = "$top/$filename";
		if ((-d $file) && (! -l $file))
		{
		    Cobalt::Utility::sauce_deltree($file);
		}
		else
		{
		    unlink($file);
		}
	    }
	}
	rmdir($top);
    }
    else
    {
	# it's just a file...
	unlink($top);
    }
    return "2514 Directory deleted";
}


1;
