# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Vacation.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $ShiftJISToJIS_prog = "/usr/local/sbin/nkf";
my $Vaca_dir = "/var/vacation";
my %Language = ("english","1","shiftjis","Cobalt interface message for shiftjis (We should never see this)","lastNameFirst","1","japanese","0");
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Vacation.pm.  Changes made here will be lost.
package Cobalt::Vacation;

sub vacation_set_message
# Set the message being used by the vacation program
# Arguments: user name, the message in a big string
#   if the string is "", then the file is deleted.
# Return value: the usual status string
# Side effects: creates the message file
{
    if (! -e $Vaca_dir)
    {
	mkdir($Vaca_dir,01777) ;
	chmod(01777,$Vaca_dir);
    }
    my ($user,$message) = @_;
    my $messagefile = "$Vaca_dir/$user.msg";
    my $messagefileJ = "$Vaca_dir/$user.jmsg" if ($Language{"japanese"});
    if ($message)
    {
	open(VACA,">$messagefile") ||
	    return("4181 Cannot write auto-reply message for $user: $!");
	print VACA $message;
	# Brion, you just make the file longer everytime you save it
#	print VACA "\n";
	close VACA;

	# need to convert file from Shift-JIS to JIS for sendmail
	system( "$ShiftJISToJIS_prog $messagefile >$messagefileJ" )
	  if ($Language{"japanese"});

	my $uid;
	if ($uid = (getpwnam($user))[2])
	{
	    # might not be for a real user
	    chown($uid,-1,$messagefile)
		|| return "3040 Could not set owner $uid for message $messagefile: $!";
	    if ($Language{"japanese"}) {
		chown($uid,-1,$messagefileJ)
		    || return "3041 Could not set owner $uid for message $messagefileJ: $!";
	    }
	}

	# needs to be vacation.pl readable
	chmod 0644,$messagefile;
	if ($Language{"japanese"}) { chmod 0644,$messagefileJ; }

	return "2327 Auto-reply message set in $messagefile";
    }
    else
    {
	unlink($messagefile) if (-e $messagefile);
	unlink("$messagefileJ") if ($Language{"japanese"} &&
				    (-e "$messagefileJ"));
	return "2328 $user now has no message file";
    }
}


1;
