# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Vacation.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Vaca_dir = "/var/vacation";
my $Vaca_prog = "/usr/local/sbin/vacation.pl";
my %Language = ("english","1","shiftjis","Cobalt interface message for shiftjis (We should never see this)","lastNameFirst","1","japanese","0");
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Vacation.pm.  Changes made here will be lost.
package Cobalt::Vacation;

sub vacation_set_on
# Turn the vacation forwarding on or off
# Arguments: user name, state -- 1 for on, 0 for off,
#   domain where the user belongs to (optional)
# Return value: the usual
# Side effects: edits the alias file
{
    my ($user,$state,$domain) = @_;
    my $emailAddr=$user;
    if( $domain ) { $emailAddr.='@'.$domain; }

    my $return;
    if ($state && Cobalt::Vacation::vacation_get_on($user))
    {
	return "2325 $user already has auto-reply active";
    }
    elsif ((! $state) && (! Cobalt::Vacation::vacation_get_on($user)))
    {
	return "2326 $user already has auto-reply deactivated";
    }
    elsif ($state)  # turn it up, man
    {
	my $vacaline;

	if ($Language{"japanese"})
	{
	  $vacaline = "\"|$Vaca_prog $Vaca_dir/$user.jmsg $emailAddr\"";
	}
	else
	{
	  $vacaline = "\"|$Vaca_prog $Vaca_dir/$user.msg $emailAddr\"";
	}
	$return = Cobalt::List::alias_add($user, "\\$user", $vacaline);
    }
    else  # no vacation
    {
	$return = Cobalt::List::alias_set($user,Cobalt::List::alias_get_vacationless($user));
    }
    return $return;
}


1;
