# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Vhost.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $MaxNameLen = "12";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Vhost.pm.  Changes made here will be lost.
package Cobalt::Vhost;

sub vhost_gen_name
# Generate a back-end name that is associated with a hostname/vhost
# Arguments: a host name
# Return value: an appropriate name, at least two less characters than 
#   the maximum defined name length
{
        my $groupName=$_[0];
	my $maxlength = ($MaxNameLen);

        # Disallow generic www1, www2 naming
        $groupName=~s/^www\d*\.(\w+)/$1/;
        $groupName=substr( $groupName, 0, $maxlength );

	# no trailing dot
	$groupName=~s/\.+$//o;

        # check for uniqueness
        my $nameIndex=1;
        my $g=$groupName;
        while( Cobalt::Group::group_exist( $g ) ) {
            if( length( $groupName.$nameIndex )>$maxlength ) {
                $g=substr( $groupName, 0, length( $groupName )-length( $nameIndex ) ).$nameIndex;
            }
            else { $g=$groupName.$nameIndex; }

            $nameIndex++;
        }

	return($g);
}


1;
