# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Vhost.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Vhost.pm.  Changes made here will be lost.
package Cobalt::Vhost;

sub vhost_get_byaddr
# Get information about a virtual interface based on the IP address
# This only shows IP-based virtual sites
# Arguments: IP address
# Return value: interface, netmask, hostname, group
#   Returns 0 if we don't serve this (or if it isn't a virtual interface)
# Example: ($virtif,$mask,$host,$group) = Cobalt::Vhost::vhost_get_byaddr("192.168.41.5");
{
    my ($addr) = @_;
    my @virtifs = Cobalt::Vhost::vhost_list();
    my $virtif;
    foreach $virtif (@virtifs)
    {
	my ($ipaddr,$mask,$host,$group) = Cobalt::Vhost::vsite_get($virtif);
	if ($ipaddr eq $addr)
	{
	    return($virtif,$mask,$host,$group);
	}
    }
    return 0;
}


1;
