# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Vhost.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Htconf = "/etc/httpd/conf";
my $Lockdir = "/etc/locks";
my $Weblog_dir = "/var/log/httpd";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Vhost.pm.  Changes made here will be lost.
package Cobalt::Vhost;

sub vname_del
# Removes a name-based virtual web server
# This function is specifically for name-based sites and will do nothing
#   for IP-based ones
# Arguments: the IP address already in use, the name of the server, the
#    associated group name
# Return value: string of the form "3311 Humbolt lunch"
# Side effects: Might remove NameVirtualHost entry, removes <VirtualHost> 
#    block from the httpd.conf file
{
  my ($addr,$name,$group) = @_;
  my($found_interface,$found_namev,$new_conf,$nothinglost);

  open(HTCNF,"$Htconf/httpd.conf") || 
    return Cobalt::Network::net_abort("4590 Cannot open web configuration");
  while(<HTCNF>) {
	    if (/^\# VirtualHost label name /o)
	    {
		$nothinglost = $_;
		$_ = <HTCNF>;
		$nothinglost .= $_;

		if (/<VirtualHost $addr>/)
		{
		    $_ = <HTCNF>;
		    $nothinglost .= $_;
		    if (/ServerName $name\s*$/) 
  		    {
			$found_interface = 1;
	    	        # Skip past the rest of the entry
		        while (<HTCNF>)
            	        {
                            last if (/^<\/VirtualHost>/o);
            	        }
		    } else {
			$new_conf .= $nothinglost;
		    }
		} else {
		    $new_conf .= $nothinglost;
		}
	    } else {
	      $new_conf .= $_;
	    }
	  }
        close(HTCNF);

	return "4586 Virtual web server $addr does not exist." 
	  if (!$found_interface);

  # now get our locks
  return "4378 Cannot reconfigure network: system busy"
    unless(Cobalt::Network::net_lock_network());
  return Cobalt::Network::net_abort("4591 Web configuration in use, please try again") 
    if (-e "$Lockdir/httpd.conf");

	open(HTLOCK,"> $Lockdir/httpd.conf") || 
	  return Cobalt::Network::net_abort("4594 Cannot update the web server configuration file");
	print HTLOCK $new_conf;	
	close(HTLOCK);

  rename("$Lockdir/httpd.conf","$Htconf/httpd.conf") ||
    return Cobalt::Network::net_abort("4585 Cannot update the web server configuration file",
		     "Lockdir/httpd.conf");
	
	if ($group)
	{
		unlink("$Weblog_dir/$group-access") if (-e "$Weblog_dir/$group-access");
		unlink("$Weblog_dir/$group-error") if (-e "$Weblog_dir/$group-error");
	}

  # unlock the interface
  Cobalt::Network::net_unlock_network();
	return "2661 Name-based virtual server deleted successfully"; 
}


1;
