# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Vhost.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Sites_AdminGroup = "Site-adm";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Vhost.pm.  Changes made here will be lost.
package Cobalt::Vhost;

sub vsite_admin_list
# Lists the site admins for the given site
# Arguments: virtual interface (eth0:4) or site name (if name-based)
#   With no arguments, lists *all* site administrators
# Return value: the list of admins for that site
# Side effects: none
# Example: (@admins) = Cobalt::Vhost::vsite_admin_list("eth1:12");
{
  my ($virtsite) = @_;
  if ($virtsite) {
    # be specific
    my ($addr,$mask,$host,$group,$admin) = Cobalt::Vhost::vsite_get($virtsite);
    return Cobalt::Group::group_show($group);
  }
  else {
    # list everyone
    my @admins;
    foreach $virtsite (Cobalt::Vhost::vsite_list()) {
      push(@admins,Cobalt::Group::group_show($$virtsite[3]));
    }
    @admins = sort(@admins);

    # sanity check...am I being too paranoid?
    my @site_admins = Cobalt::Group::group_show($Sites_AdminGroup);
    if ($#site_admins ne $#admins) {
      print STDERR "Warning: site admin lists are out of sync.  Fixing...\n";
      Cobalt::Group::group_set_membership($Sites_AdminGroup,@admins);
    }

    return @admins;
  }
}


1;
