# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Vhost.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Sites_AdminGroup = "Site-adm";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Vhost.pm.  Changes made here will be lost.
package Cobalt::Vhost;

sub vsite_admin_set
# Set the list of site administrators for a virtual site
# Arguments: virtual site name or interface, list of users
# Side effects: sets the membership of the group for that site
#   to the given list, adds the site admins to the global
#   site admins group
# Return value: the usual status string of the form "3667 You are in
#   a dark place.  You are likely to be eaten by a grue."
{
  my ($vsite,@admins) = @_;
  my ($addr,$mask,$host,$group,$admin) = Cobalt::Vhost::vsite_get($vsite);
  my @current_admins = Cobalt::Group::group_show($group);
  Cobalt::Group::group_del_user($Sites_AdminGroup,@current_admins);

  Cobalt::Vhost::vsite_get_siteadmin_ftphelp(@current_admins);
  
  my $ret = Cobalt::Group::group_add_user($Sites_AdminGroup,@admins);
  return $ret if ($ret !~ /^2/o);  # abort if we can't fix the group

  Cobalt::Vhost::vsite_set_siteadmin_ftphelp($group,@admins);

  return Cobalt::Group::group_set_user($group,@admins);
}


1;
