# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Vhost.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Htconf = "/etc/httpd/conf";
my $MainGroup = "home";
my $Netif = "eth0";
my $Userdir = "/home/sites";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Vhost.pm.  Changes made here will be lost.
package Cobalt::Vhost;

sub vsite_get_ssi
# Get the current SSI settings for a virtual site
# Arguments: the site group name
# Return value: 1 for on, 0 for off
# Side effects: none
# Example: Cobalt::Vhost::vsite_get_ssi("home");
{
  my ($vsite) = @_;
  my $inentry;

  # special case for the primary network interface
  if (($vsite eq $Netif) || ($vsite eq $MainGroup)) {
    unless (open(HTCONF,"$Htconf/access.conf")) {
      return "4169 Cannot read $Htconf/access.conf: $!";
    }
    while (<HTCONF>) {
      if (/^<Directory $Userdir\/$MainGroup>/o) {
        # start of entry for the main site
        $inentry = 1;
      }
      elsif ($inentry && (/^\#AddHandler server-parsed .shtml/o)) {
        # looks like it's off
        close HTCONF;
        return 0;
      }
      elsif ($inentry && (/^AddHandler server-parsed .shtml/o)) {
        # looks like it's on
        close HTCONF;
        return 1;
      }
    }
  }
  else {
    # the general case for all other virtual sites
    unless (open(HTCONF,"$Htconf/httpd.conf")) {
      return "4166 Cannot read $Htconf/httpd.conf: $!";
    }
    while (<HTCONF>) {
      if (/^DocumentRoot $Userdir\/$vsite\s*$/o) {
        # start of entry for this site
        $inentry = 1;
      }
      elsif ($inentry && (/^\#AddHandler server-parsed .shtml/o)) {
        # looks like it's off
        close HTCONF;
        return 0;
      }
      elsif ($inentry && (/^AddHandler server-parsed .shtml/o)) {
        # looks like it's on
        close HTCONF;
        return 1;
      }
    }
  }
  return 0;
}


1;
