# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Vhost.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Htconf = "/etc/httpd/conf";
my $Htgroup_dir = "/home/sites";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Vhost.pm.  Changes made here will be lost.
package Cobalt::Vhost;

sub vsite_list
# Finds all virtual web interfaces, both ip and name-based.
# Arguments: none
# Return value: nested array of:
#    (interface||'name',ip,hostname,group,webmaster email)
#    sorted by hostname
# Example: @vhosts = Cobalt::Vhost::vsite_list();
#          foreach $vhost (@vhosts) { &use( @$vhost ); }
#    In this case &use is passed the simple array described above
# Parses httpd.conf
# Note that IP-based virtual sites are referred to by interface name
#  (e.g., eth0:9) while name-based are referred to by site name (e.g.,
#  "www.cobaltsys.com")
{
        my(@vnames,$nic,$ip,$name,$adminemail,$group);
        open(HTCNF,"$Htconf/httpd.conf") || 
	  return "4592 Cannot open web configuration: $!";
	while(<HTCNF>) 
	{ 
            if (/^\# VirtualHost label ([a-z\:\d\.]+) /o)
	    {
		$nic = $1;
		$_ = <HTCNF>;
		$ip = $1 if (/^<VirtualHost ([\d\.]+)>/o);
		$_ = <HTCNF>;
		$name = $1 if (/^ServerName ([a-z\d\.\-]+)/o);
		$_ = <HTCNF>;
		$adminemail = $1 if (/^ServerAdmin ([\w\@\-\.]+)/o);
		$_ = <HTCNF>;
		$group = $1 if (/^DocumentRoot $Htgroup_dir\/([\w\.\-]+)/o);
		push( @vnames, ([$nic,$ip,$name,$group,$adminemail]) ); 
		$nic = $ip = $name = $adminemail = $group = '';
	    }
	}
	close(HTCNF);

	# sort by hostname
	@vnames=sort { ${ $a }[ 2 ] cmp ${ $b }[ 2 ] } @vnames;

	return (@vnames);
}


1;
