# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Vsite.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $AdminPages_dir = "/usr/admserv/html/.cobalt";
my $Adminuser = "admin";
my $Htconf = "/etc/httpd/conf";
my $Htgroup_dir = "/home/sites";
my $Lockdir = "/etc/locks";
my $Logdir = "logs";
my $MainGroup = "home";
my $Userdir = "/home/sites";
my $WWWuser = "httpd";
my $Webdir = "web";
my %Features = ("networker","1","telnetConfig","1","dhcpd","0","shiftjis","Cobalt interface message for shiftjis (We should never see this)","pagebuilder","0","www","1","mx","1","gated","1","dns","1","nfs","0","securetty","1","english","1","atalk","0","fpx","1","siteAdminRedirect","1","users","1","ntp","0","mon_textdb_only","0","search","0","anonFTP","1","specialHomeSkel","0","viewGroups","0","cobaltHomePage","0","lastNameFirst","1","warnRootOnly","1","vsites","1","pam","1","discuss","0","docorg","0","groups","1","smb","0","mail","1","nat","0","squid","0","autoGenWebUsage","0","japanese","0","cobaltRedirect","0","backups","1","vmachine","1","mon_port_testing","1","viewUsers","0","usersCGIInWizard","1","privatedirs","0","telnetDefault","1","ssl","0","siteManagement","1","adm","1","bind8","1","personalRedirect","1","webRequests","1","usersAddUser","0","adminRedirect","1","quotas","1","snmp","1","defaultUserNameGen","1","groupdirs","1","proftpd","1");
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Vsite.pm.  Changes made here will be lost.
package Cobalt::Vsite;

sub vsite_add
# Adds a virtual web server
# Arguments: the IP address, server name, associated group name, admin email address, optional subnet mask
# Return value: string of the form "3310 High Anxiety"
# Side effects: Modifies httpd.conf, may add a virtual network interface
{
    my ($addr,$name,$group,$serveradmin,$mask) = @_;
    my($found_interface,$found_namev,$conf,$new_conf,$found_group);
    my $ret;

    # This is a new site, enforce a maximum site count
    #   "Not with RaQ 2" /wdh  
    # my (@siteslist) = Cobalt::Vsite::vsite_list();
    # return "4597 This system is limited to $Sites_Max virtual sites."
    #   if (($#siteslist + 1) >= $Sites_Max); # +1 to un-zero-index

    $serveradmin ||= $Adminuser; # Give it a default..
    # hack to prevent perl from joining the $ at the end of a here
    # document line to the text on the next line and do variable
    # interpolation on it...perl _is_ brain dead!!
    my $my = '$';		
    $new_conf .= <<EOF;
<VirtualHost $addr>
ServerName $name
ServerAdmin $serveradmin
DocumentRoot $Htgroup_dir/$group/$Webdir
RewriteEngine on
RewriteCond %{HTTP_HOST}                !^$addr(:80)?$my
RewriteCond %{HTTP_HOST}                !^$name(:80)?$my
RewriteRule ^/(.*)                      http://$name/\$1 [L,R]
RewriteOptions inherit
AliasMatch ^/~([^/]+)(/(.*))? $Htgroup_dir/$group/users/\$1/web/\$3
AliasMatch ^/users/([^/]+)(/(.*))? $Htgroup_dir/$group/users/\$1/web/\$3
</VirtualHost>
EOF

    # update the current configuration
    open(HTCNF,"$Htconf/httpd.conf") ||
      return "4809 Cannot read /etc/httpd/conf/httpd.conf: $!";

    # first, get the lock
    return $ret if (($ret = vsite_lock()) !~ /^2/);
    open (LOCK, ">$Lockdir/httpd.conf") ||
      return "4810 Something wicked happened..";

    $found_interface = 0;
    while(<HTCNF>)
    {
	if (!$found_interface and
	    /^<VirtualHost $addr>$/ ... /^<\/VirtualHost>$/) {
	    # sanity check
	    return vsite_abort("4811 Hostname $name already in use by a virtual site")
		if (/^DocumentRoot\s+$Userdir\/$group\/$Webdir$/ or
		    /^ServerName\s+$name$/);

	    # slurp!
	    $conf .= $_;

	    # end of section; throw up the slurped goo..
	    if (/^<\/VirtualHost>$/) {
		# first entry for $addr
		$found_interface = 1;
		print LOCK "\nNameVirtualHost $addr\n";

		# hack to get the maingroup conf first
		if ($group eq $MainGroup) {
		    print LOCK "${new_conf}${conf}";
		} else {
		    print LOCK "${conf}${new_conf}";
		}
		$conf = '';
	    }
	} else {
	    # spit it unless..
	    print LOCK unless (/NameVirtualHost $addr$/);
	}
    }
    print LOCK "\nNameVirtualHost $addr\n$new_conf" unless ($found_interface);
    close(HTCNF);
    close(LOCK);

    # Create web subdir
    unless(-d "$Htgroup_dir/$group/$Webdir")
    {
	mkdir("$Htgroup_dir/$group/$Webdir",775);
	chown((getpwnam($WWWuser))[2],(getgrnam($group))[2],
	      "$Htgroup_dir/$group/$Webdir");
	chmod(02775,"$Htgroup_dir/$group/$Webdir");
    }

    # Create logs subdir
    unless(-d "$Htgroup_dir/$group/$Logdir")
    {
	mkdir("$Htgroup_dir/$group/$Logdir",775);
	chown((getpwnam($WWWuser))[2],(getgrnam($group))[2],
	      "$Htgroup_dir/$group/$Logdir");
	chmod(02750,"$Htgroup_dir/$group/$Logdir");
    }

    # Add the network interface if necessary
    unless($group eq $MainGroup) # Special case handled by Network.pm
    {
	my(@all_IPs) = Cobalt::Network::net_get_alladdrs();
	my($ip_instance,%active_IPs);
	foreach $ip_instance (@all_IPs) { $active_IPs{"$ip_instance"}=1; }
	unless ($active_IPs{$addr})
	{
	    print STDERR "Vsite::vsite_add found IP address $addr not to be in use. Adding interface..\n" if ($Debug);
	    $mask ||= (net_get_ipaddr())[1];
	    # Insert subnet mask validation here..
	    ($ret)=net_set_vinterface($addr,$mask);
	    return vsite_abort($ret) unless ($ret =~ /^2/);
	    if ($Features{'proftpd'})
	    {
		print STDERR "Vsite::vsite_add configuring ftp server for new ip address $addr\n" if ($Debug);
		($ret)=ftp_set_vinterface($addr);
		return vsite_abort($ret) unless ($ret =~ /^2/);
	    }
	}
    }

    # Add mod_rewrite friendly symlink into the siteManage ui
    unless(-e "$AdminPages_dir/siteManage/$name")
    {
	symlink("$AdminPages_dir/siteManage/$group",
		"$AdminPages_dir/siteManage/$name");
    }

    # Add filesystem friendly symlink into the data partition
    #   necessary with ambiguous site group names
    unless(-e "$Userdir/$name")
    {
	symlink("$Htgroup_dir/$group","$Userdir/$name");
    }

    return $ret if (($ret = vsite_commit()) !~ /^2/);
    return "2660 Name-based virtual server added successfully"; 
}


1;
