# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Vsite.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Htconf = "/etc/httpd/conf";
my $Lockdir = "/etc/locks";
my $Userdir = "/home/sites";
my $Webdir = "web";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Vsite.pm.  Changes made here will be lost.
package Cobalt::Vsite;

sub vsite_add_alias
# Set alias names for a vhost
# Arguments: site group name, list of aliases
# Return value: string of the form "3311 allentown is my place"
# Note: does not remove any old server aliases
# Example: vsite_set_alias($group, $alias0, $alias1);
{
    my ($vsite, @aliases) = @_;
    my ($ret, $found);

    # update the current configuration
    open(HTCONF,"$Htconf/httpd.conf") || 
	return "4817 Cannot read /etc/httpd/conf/httpd.conf: $!";

    # first, get the lock
    return $ret if (($ret = vsite_lock()) !~ /^2/);
    open (HTCTMP, ">$Lockdir/httpd.conf") ||
	return "4818 Something wicked happened..";

    $found = 0;
    while (<HTCONF>) {
	if (!$found && /^DocumentRoot $Userdir\/$vsite\/$Webdir$/) {
	    print STDERR "vsite_add_alias found $vsite\n" if ($Debug);
	    print HTCTMP "ServerAlias ", join(" ", @aliases), "\n";
	    print HTCTMP;  # don't forget to include the DocumentRoot
	    $found = 1;
	}
	else {
	    # just spit it..
	    print HTCTMP;
	}
    }
    close HTCONF;
    close HTCTMP;
    return vsite_abort("4819 No virtual host entry for $vsite.") unless ($found);
    return $ret if (($ret = vsite_commit()) !~ /^2/);
    return "2131 Site aliases added successfully";
}


1;
