# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Vsite.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Sites_AdminGroup = "site-adm";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Vsite.pm.  Changes made here will be lost.
package Cobalt::Vsite;

sub vsite_admin_list
# Lists the site admins for the given site
# Arguments: site group name
#   With no arguments, lists *all* site administrators
# Return value: the list of admins for that site
# Side effects: none
# Example: (@admins) = Cobalt::Vsite::vsite_admin_list("eth1:12");
{
    my ($group) = @_;
    return Cobalt::Group::group_show($group) if ($group);
    
    # list everyone
    my @admins;
    my $virtsite;
    foreach $virtsite (Cobalt::Vsite::vsite_list()) {
	push(@admins,Cobalt::Group::group_show($$virtsite[2]));
    }
    @admins = sort(@admins);

    # sanity check...am I being too paranoid?
    my @site_admins = Cobalt::Group::group_show($Sites_AdminGroup);
    if ($#site_admins ne $#admins) {
	print STDERR "Warning: site admin lists are out of sync.  Fixing...\n";
        Cobalt::Group::group_set_membership($Sites_AdminGroup,@admins);
    }

    return @admins;
}


1;
