# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Vsite.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Sites_AdminGroup = "site-adm";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Vsite.pm.  Changes made here will be lost.
package Cobalt::Vsite;

sub vsite_admin_set
# Set the list of site administrators for a virtual site
# Arguments: site group, list of users
# Side effects: sets the membership of the group for that site
#   to the given list, adds the site admins to the global
#   site admins group
# Return value: the usual status string of the form "3667 You are in
#   a dark place.  You are likely to be eaten by a grue."
{
    my ($group,@admins) = @_;
    my @current_admins = Cobalt::Group::group_show($group);
    Cobalt::Group::group_del_user($Sites_AdminGroup,@current_admins);

    Cobalt::Vsite::vsite_get_siteadmin_ftphelp(@current_admins);
    
    my $ret = Cobalt::Group::group_add_user($Sites_AdminGroup,@admins);
    return $ret if ($ret !~ /^2/o);  # abort if we can't fix the group

    Cobalt::Vsite::vsite_set_siteadmin_ftphelp($group,@admins);
    return Cobalt::Group::group_set_user($group,@admins);
}


1;
