# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Vsite.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $AdminPages_dir = "/usr/admserv/html/.cobalt";
my $Htconf = "/etc/httpd/conf";
my $Lockdir = "/etc/locks";
my $MainGroup = "home";
my $Userdir = "/home/sites";
my $Webdir = "web";
my %Features = ("networker","1","telnetConfig","1","dhcpd","0","shiftjis","Cobalt interface message for shiftjis (We should never see this)","pagebuilder","0","www","1","mx","1","gated","1","dns","1","nfs","0","securetty","1","english","1","atalk","0","fpx","1","siteAdminRedirect","1","users","1","ntp","0","mon_textdb_only","0","search","0","anonFTP","1","specialHomeSkel","0","viewGroups","0","cobaltHomePage","0","lastNameFirst","1","warnRootOnly","1","vsites","1","pam","1","discuss","0","docorg","0","groups","1","smb","0","mail","1","nat","0","squid","0","autoGenWebUsage","0","japanese","0","cobaltRedirect","0","backups","1","vmachine","1","mon_port_testing","1","viewUsers","0","usersCGIInWizard","1","privatedirs","0","telnetDefault","1","ssl","0","siteManagement","1","adm","1","bind8","1","personalRedirect","1","webRequests","1","usersAddUser","0","adminRedirect","1","quotas","1","snmp","1","defaultUserNameGen","1","groupdirs","1","proftpd","1");
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Vsite.pm.  Changes made here will be lost.
package Cobalt::Vsite;

sub vsite_del
# Removes a name-based virtual web server
# Arguments: The site group name
# Return value: string of the form "3311 Humbolt lunch"
# Side effects: Modifies httpd.conf, may delete a virtual network interface
{
    my ($group) = @_;
    my($foundit,$found_web,$conf,$num_interface,$ret);
    my ($addr, $name);
    my @vsites = vsite_list();
    grep { ($addr, $name) = @$_ if ($group eq $$_[2]) } @vsites;
    $num_interface = scalar (grep { $addr eq $$_[0] } @vsites);
    return vsite_abort("4812 The web server associated with group $name could not be found") unless ($num_interface);

    # update the current configuration
    open(HTCNF,"$Htconf/httpd.conf") || 
	return "4813 Cannot read /etc/httpd/conf/httpd.conf: $!";

    # first, get the lock
    return $ret if (($ret = vsite_lock()) !~ /^2/);
    open (LOCK, ">$Lockdir/httpd.conf") ||
	return "4814 Something wicked happened..";

    $found_web = 0;
    while(<HTCNF>) 
    {
	if (/^<VirtualHost $addr>$/ ... /^<\/VirtualHost>$/)
	{
	    $found_web = 1 if (/^DocumentRoot $Userdir\/$group\/$Webdir$/);
	    # slurp!
	    $conf .= $_;

	    if (/^<\/VirtualHost>$/)
	    {
		# don't spit if we got a match
		if ($found_web) {
		    $foundit=1;
		} else {
		    print LOCK $conf;
		}
		$conf = '';
		$found_web = 0;
	    }
	} elsif (/^NameVirtualHost $addr$/) {
	    print LOCK if ($num_interface > 1);
	} else {
	    # spit it..
	    print LOCK;
	}
    }
    close(HTCNF);
    close(LOCK);
    return vsite_abort("4815 The web server associated with group $name could not be found") unless ($foundit);

    # remove the network interface if necessary
    unless($group eq $MainGroup) # Special case handled by Network.pm
    {
	if ($num_interface == 1)
	{
	    print STDERR "Vsite::vsite_del removing virtual network support for the ip address $addr\n" if ($Debug);
	    ($ret) = net_del_vinterface($addr);
	    return vsite_abort($ret) unless ($ret =~ /^2/);
	    if ($Features{'proftpd'})
	    {
		print STDERR "Vsite::vsite_del removing ftp server support for ip address $addr\n" if ($Debug);
		($ret)=ftp_del_vinterface($addr);
		return vsite_abort($ret) unless ($ret =~ /^2/);
	    }
	}
    }

    # Remove mod_rewrite friendly symlink from the siteManage ui
    unlink("$AdminPages_dir/siteManage/$name")
	if (-l "$AdminPages_dir/siteManage/$name");

    # Remove filesystem friendly symlink from the data partition
    #   necessary with ambiguous site group names
    unlink("$Userdir/$name") if (-l "$Userdir/$name");

    return $ret if (($ret = vsite_commit()) !~ /^2/);
    return "2130 Web server deleted successfully"; 
}


1;
