# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Vsite.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Htconf = "/etc/httpd/conf";
my $MainGroup = "home";
my $Netif = "eth0";
my $Userdir = "/home/sites";
my $Webdir = "web";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Vsite.pm.  Changes made here will be lost.
package Cobalt::Vsite;

sub vsite_get_fpx
# Get the current FPX settings for a virtual site
# Arguments: site group name
# Return value: array of user webs if enabled
#	        null if fpx disabled
# Side effects: parses httpd.conf
# Example: Cobalt::Vsite::vsite_get_fpx($MainGroup);
{
    my ($vsite) = @_;
    my ($found_web);
    my(@ret,%beenthere); # init return value, singularity check

    # special case for the primary network interface
    $vsite=$MainGroup if ($vsite eq $Netif);
    
    # update the current configuration
    open(HTCONF,"$Htconf/httpd.conf") || 
	return "4831 Cannot read /etc/httpd/conf/httpd.conf: $!";

    while (<HTCONF>) {
	if (/^<VirtualHost [\d\.]+>$/ ... /^<\/VirtualHost>$/) {
	    
	    $found_web = 1 if (/^DocumentRoot $Userdir\/$vsite\/$Webdir$/);
	    if ($found_web) {
		if (/^ScriptAlias\s+\/([^\/]+)\// && /_vti_bin/) {
		    my $user;

		    $user = $1 if (/^ScriptAlias\s+\/([^\/]+)\//); # user web
		    if ($user =~ /^\~/)
		    {
			$user =~ s/^\~//; # Strip ~ from ~user
			push(@ret,$user) unless ($beenthere{$user}); # user web
			$beenthere{$user}=1;
		    } else
		    {
			# $user eq _vti_bin, check algorithm
			push(@ret,$vsite) unless ($beenthere{$vsite});
			$beenthere{$vsite}=1;
		    }
		}

		last if (/^<\/VirtualHost>$/);
	    }
	}
    }
    close HTCONF;
    return @ret;
}


1;
