# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Vsite.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Htconf = "/etc/httpd/conf";
my $MainGroup = "home";
my $Netif = "eth0";
my $Userdir = "/home/sites";
my $Webdir = "web";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Vsite.pm.  Changes made here will be lost.
package Cobalt::Vsite;

sub vsite_get_ssi
# Get the current SSI settings for a virtual site
# Arguments: the site group name
# Return value: 1 for on, 0 for off
# Side effects: none
# Example: Cobalt::Vsite::vsite_get_ssi("home");
{
    my ($vsite) = @_;
    my ($found_web);

    # special case for the primary network interface
    $vsite=$MainGroup if ($vsite eq $Netif);
    
    # update the current configuration
    open(HTCONF,"$Htconf/httpd.conf") || 
	return "4823 Cannot read /etc/httpd/conf/httpd.conf: $!";

    while (<HTCONF>) {
	if (/^<VirtualHost [\d\.]+>$/ ... /^<\/VirtualHost>$/) {
	    
	    $found_web = 1 if (/^DocumentRoot $Userdir\/$vsite\/$Webdir$/);
	    if ($found_web) {
		if (/^AddHandler server-parsed .shtml/) {
		    close HTCONF;
		    return 1;
		} elsif (/^\#AddHandler server-parsed .shtml/) {
		    close HTCONF;
		    return 0;
		}

		last if (/^<\/VirtualHost>$/);
	    }
	}
    }
    close HTCONF;
    return 0;
}


1;
