# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Vsite.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Htconf = "/etc/httpd/conf";
my $Userdir = "/home/sites";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Vsite.pm.  Changes made here will be lost.
package Cobalt::Vsite;

sub vsite_list
# Finds all virtual web interfaces
# Arguments: none
# Return value: nested array of:
#    (ip,hostname,group,webmaster email)
#    sorted by fully qualified domain name (aka "hostname" for vsite_* functions)
# Example: @vhosts = Cobalt::Vsite::vsite_list();
#          ..OR.. 
#          foreach $vhost (@vhosts) { &use( @$vhost ); }
# Parses httpd.conf
{
    my(@vnames,$nic,$ip,$name,$adminemail,$group);
    open(HTCNF,"$Htconf/httpd.conf") || 
	return "4816 Cannot read /etc/httpd/conf/httpd.conf: $!";
    while(<HTCNF>) 
    {
	if (/^<VirtualHost [\d\.]+>$/ ... /^<\/VirtualHost>$/)
	{
	    $ip = $1 if (/^<VirtualHost ([\d\.]+)>/);
	    $name = $1 if (/^ServerName ([a-z\d\.\-]+)/);
	    $adminemail = $1 if (/^ServerAdmin ([\w\@\-\.]+)/);
	    $group = $1 if (/^DocumentRoot $Userdir\/([^\/]+)/o);

	    if ($group && /^<\/VirtualHost>$/) {
		chomp($group);
		push( @vnames, ([$ip,$name,$group,$adminemail]) ); 
		$ip = $name = $adminemail = $group = '';
	    }
	}
    }
    close(HTCNF);

    # sort by hostname
    @vnames=sort { ${ $a }[ 1 ] cmp ${ $b }[ 1 ] } @vnames;

return (@vnames);
}


1;
