# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Vsite.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Htconf = "/etc/httpd/conf";
my $Lockdir = "/etc/locks";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Vsite.pm.  Changes made here will be lost.
package Cobalt::Vsite;

sub vsite_migrate_ipaddr
# Moves virtual sites from an old IP address to a new one en mass
# Useful when changing the IP of a real network interface
#
# Does not restart daemons
#
# Arguments: Old IP address, New IP address
# Return value: 1 for success, 0 for failure
{
    my($oldip,$ip)=@_;

    sleep 1 if (-e "$Lockdir/httpd.conf"); # Avoid race
    return 0 if (vsite_lock() !~ /^2/);
    # update the current configuration
    open(HTCNF,"$Htconf/httpd.conf") || return 0;

    open (HTLOCK, ">$Lockdir/httpd.conf") ||
	return "4832 Something wicked happened..";
    while(<HTCNF>)
    {
	# subsitute the ip in apache <.> type directives
	s/(\s+)$oldip(>*)$/$1$ip$2/;
	# substitute the ip in the rewritecond..
	s/^(RewriteCond\s*!\^)$oldip\(:80\)\?\$$/$1$ip\$/;
	print HTLOCK;
    }
    close(HTLOCK);
    close(HTCNF);
    return 0 if (vsite_commit() !~ /^2/);
    return 1;
}


1;
