# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Vsite.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Htconf = "/etc/httpd/conf";
my $Lockdir = "/etc/locks";
my $MainGroup = "home";
my $Netif = "eth0";
my $Userdir = "/home/sites";
my $Webdir = "web";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Vsite.pm.  Changes made here will be lost.
package Cobalt::Vsite;

sub vsite_set_cgis
# Enable or disable the use of CGIs for a virtual site
# This affects the entire site
# Arguments: site group name, 1 to enable/0 to disable
# Return value: status string of the form "8750 I can't hear you, 
#   there's a bannana in my ear!"
# Side effects: modifies the virtual host entry in httpd.conf.
# Example: Cobalt::Vsite::vsite_set_cgis("eth0:0",1);
{
    my ($vsite,$cgis_enabled) = @_;
    my ($inentry, $found_web,$conf);
    my ($on,$ret);

    # special case for the primary network interface
    $vsite=$MainGroup if ($vsite eq $Netif);

    # update the current configuration
    open(HTCONF,"$Htconf/httpd.conf") || 
	return "4824 Cannot read /etc/httpd/conf/httpd.conf: $!";

    # first, get the lock
    return $ret if (($ret = vsite_lock()) !~ /^2/);
    open (HTCTMP, ">$Lockdir/httpd.conf") ||
	return "4825 Something wicked happened..";

    $found_web = $inentry = 0;
    # fix the httpd.conf file
    while (<HTCONF>) {
	if (!$inentry and
	    /^<VirtualHost [\d\.]+>$/ ... /^<\/VirtualHost>$/) {
	    
	    if (/^DocumentRoot $Userdir\/$vsite\/$Webdir$/) {
		$found_web = 1;
		print STDERR "vsite_set_cgis found $vsite\n" if ($Debug);
	    }

	    if (/^<\/VirtualHost>$/)
	    {
		if ($found_web) {
		    print HTCTMP $conf;
		    $inentry = 1;
		    # Put in the correct new AddHandler entries
		    if ($cgis_enabled) {
			print HTCTMP "AddHandler cgi-wrapper .cgi\n";
			print HTCTMP "AddHandler cgi-wrapper .pl\n";
			$on = Cobalt::Language::msg_get('On_string');
		    }
		    else {
			# httpd.conf gets big enough without this bloat /wdh
			# print HTCTMP "#AddHandler cgi-wrapper .cgi\n";
			# print HTCTMP "#AddHandler cgi-wrapper .pl\n";
			$on = Cobalt::Language::msg_get('Off_string');
		    }
		} else {
		    # end of vhost section but not the right one! spit it..
		    print HTCTMP $conf;
		}
		print HTCTMP;
		$conf = '';
	    } elsif ($found_web) {

		if (/^(\#)?AddHandler cgi-wrapper/) {
		    # clear the existing AddHandler entries
		    print STDERR "vsite_set_cgis found AddHandler\n"
			if ($Debug);
		} else {
		    # within vhost section but not a cgi line! slurp!
		    $conf .= $_;
		}
	    } else {
		# within vhost section but not the right one! slurp!
		$conf .= $_;
	    }
	} else {
	    # outside vhost section! spit it..
	    print HTCTMP;
	}
    }
    close HTCONF;
    close HTCTMP;
    return vsite_abort("4826 No virtual host entry for $vsite.") unless ($inentry);

    return $ret if (($ret = vsite_commit()) !~ /^2/);
    return "2144 CGI use on this virtual site is now $on";
}


1;
