# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Vsite.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Htconf = "/etc/httpd/conf";
my $Lockdir = "/etc/locks";
my $MainGroup = "home";
my $Netif = "eth0";
my $Userdir = "/home/sites";
my $Webdir = "web";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Vsite.pm.  Changes made here will be lost.
package Cobalt::Vsite;

sub vsite_set_fpx
# Enable or disable the use of FPX webs for a virtual site
# MS's fpadmsrv.exe can't be trusted to do anything right
#
# Arguments: site group name, true/false to enable/disable, 
#   optional array of user name (users with fpx webs)
# Return value: status string of the form "4999 MS slop incapable"  
# Side effects: modifies the virtual host entry in httpd.conf.
# fpadmsrv.exe is set to modify dummy file fp98.httpd.conf instead.
# Example: $ret=vsite_set_fpx($group,@userwebs);
{
    my ($vsite,$status,@userwebs) = @_;
    my ($inentry, $found_web,$conf);
    my ($on,$ret);

    # special case for the primary network interface
    $vsite=$MainGroup if ($vsite eq $Netif);

    # update the current configuration
    open(HTCONF,"$Htconf/httpd.conf") || 
	return "4828 Cannot read /etc/httpd/conf/httpd.conf: $!";

    # Uniquify arguments
    my(%userwebs) = map { $_, 1 } @userwebs;
    @userwebs = keys ( %userwebs );

    # first, get the lock
    return $ret if (($ret = vsite_lock()) !~ /^2/);
    open (HTCTMP, ">$Lockdir/httpd.conf") ||
	return "4829 Something wicked happened..";

    $found_web = $inentry = 0;
    # fix the httpd.conf file
    while (<HTCONF>) {
	if (!$inentry and
	    /^<VirtualHost [\d\.]+>$/ ... /^<\/VirtualHost>$/) {
	    
	    if (/^DocumentRoot $Userdir\/$vsite\/$Webdir$/) {
		$found_web = 1;
		print STDERR "vsite_set_fpx found $vsite\n" if ($Debug);
	    }

	    if (/^<\/VirtualHost>$/)
	    {
		if ($found_web) {
		    print HTCTMP $conf;
		    $inentry = 1;

		    # Put in the correct new ScriptAlias entries
		    if ($status) {
			print HTCTMP "ScriptAlias /_vti_bin/_vti_adm/ $Userdir/$vsite/$Webdir/_vti_bin/_vti_adm/\n";
			print HTCTMP "ScriptAlias /_vti_bin/_vti_adm/ $Userdir/$vsite/$Webdir/_vti_bin/_vti_aut/\n";
			print HTCTMP "ScriptAlias /_vti_bin/ $Userdir/$vsite/$Webdir/_vti_bin/\n";

			# User webs
			my($userInstance);
			foreach $userInstance (@userwebs)
			{
                            unless($userInstance eq $vsite)
 		  	    {
			        print HTCTMP "ScriptAlias /~$userInstance/_vti_bin/_vti_adm/ $Userdir/$vsite/users/$userInstance/$Webdir/_vti_bin/_vti_adm/\n";
			        print HTCTMP "ScriptAlias /~$userInstance/_vti_bin/_vti_aut/ $Userdir/$vsite/users/$userInstance/$Webdir/_vti_bin/_vti_aut/\n";
			        print HTCTMP "ScriptAlias /~$userInstance/_vti_bin/ $Userdir/$vsite/users/$userInstance/$Webdir/_vti_bin/\n";
			    }
			}
			$on = Cobalt::Language::msg_get('On_string');
		    }
		    else {
			$on = Cobalt::Language::msg_get('Off_string');
		    }
		    print HTCTMP <<EOF;
AliasMatch ^/~([^/]+)(/(.*))? $Userdir/$vsite/users/\$1/web/\$3
EOF
		} else {
		    # end of vhost section but not the right one! spit it..
		    print HTCTMP $conf;
		}
		print HTCTMP;
		$conf = '';
	    } elsif ($found_web) {

		if (/^ScriptAlias / && /\/_vti_bin/) {
		    # clear the existing ScriptAlias entries 
		    print STDERR "vsite_set_fpx found FPX ScriptAlias\n"
			if ($Debug);
		} elsif (/^AliasMatch \^\/~/) {
		    print STDERR "found aliasmatch and web\n" if ($Debug);
		} else {
		    # within vhost section but not an fpx line! slurp!
		    $conf .= $_;
		}
	    } else {
		# within vhost section but not the right one! slurp!
		$conf .= $_;
	    }
	} else {
	    # outside vhost section! spit it..
	    print HTCTMP;
	}
    }
    close HTCONF;
    close HTCTMP;
    return vsite_abort("4830 No virtual host entry for $vsite.") unless ($inentry);

    return $ret if (($ret = vsite_commit()) !~ /^2/);
    return "2134 FrontPage Server Extensions set $on successfully"; # Uses $on
}


1;
