# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Vsite.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Htgroup_dir = "/home/sites";
my $Logdir = "logs";
my $Logrotate_boot = "/etc/logrotate.onboot";
my $Logrotate_dir = "/etc/logrotate.d";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Vsite.pm.  Changes made here will be lost.
package Cobalt::Vsite;

sub vsite_set_logrotate
# Defines logrotate entries in /etc/logrotate.d and /etc/logrotate.onboot
# for individual site log access fragments (/home/sites/<group>/logs/access
# Arguments: Site group, Rotate size in megabytes
#            If log rotate size is set to zero, disable logrotations
# Return Value: Return code and descriptive string
# Example: $return=Cobalt::Vsite::vsite_set_logrotate($MainGroup,5)
{
    my($group,$size)=@_;

    unless($size) # Disable if asked
    {
	unlink("$Logrotate_dir/$group");
	unlink("$Logrotate_boot/$group");
	return "2135 Site log rotation disabled successfully";
    }

    # Minor sanity check if going to enable rotates
    return "4833 Log rotation could not be enabled because the site logs directory does not exist" unless (-e "$Htgroup_dir/$group/$Logdir");

    $size.='M';
    my($rotate)=<<EOF;
$Htgroup_dir/$group/$Logdir/access {
   compress
   size $size
}

EOF

    open(DOTD,"> $Logrotate_dir/$group") ||
	return "4834 Log rotation files could not be configured";
    print DOTD $rotate;
    close(DOTD);

    open(BOOT,"> $Logrotate_boot/$group") ||
	return "4835 Log rotation files could not be configured";
    print BOOT $rotate;
    close(BOOT);

    return "2136 Site log rotation configured successfully";
}


1;
