# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Vsite.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Htconf = "/etc/httpd/conf";
my $Lockdir = "/etc/locks";
my $MainGroup = "home";
my $Netif = "eth0";
my $Userdir = "/home/sites";
my $Webdir = "web";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Vsite.pm.  Changes made here will be lost.
package Cobalt::Vsite;

sub vsite_set_ssi
# Enable or disable the use of SSIs for a virtual site
# This affects the entire site
# Arguments: site group name, 1 to enable/0 to disable
# Return value: status string of the form "4400 not going to happen in java"
# Side effects: modifies the virtual host entry in httpd.conf
# Example: Cobalt::Vsite::vsite_set_ssi("home",1);
{
    my ($vsite,$ssi_enabled) = @_;
    my ($inentry, $found_web,$conf);
    my ($on,$ret);

    # special case for the primary network interface
    $vsite=$MainGroup if ($vsite eq $Netif);

    # update the current configuration
    open(HTCONF,"$Htconf/httpd.conf") || 
	return "4820 Cannot read /etc/httpd/conf/httpd.conf: $!";

    # first, get the lock
    return $ret if (($ret = vsite_lock()) !~ /^2/);
    open (HTCTMP, ">$Lockdir/httpd.conf") ||
	return "4821 Something wicked happened..";

    my $ssi_was = "";
    $found_web = $inentry = 0;
    # fix the httpd.conf file
    while (<HTCONF>) {
	if (!$inentry and
	    /^<VirtualHost [\d\.]+>$/ ... /^<\/VirtualHost>$/) {
	    
	    if (/^DocumentRoot $Userdir\/$vsite\/$Webdir$/) {
		$found_web = 1;
		print STDERR "vsite_set_ssi found $vsite\n" if ($Debug);
	    }

	    if (/^<\/VirtualHost>$/)
	    {
		if ($found_web) {
		    print HTCTMP $conf;
		    $inentry = 1;
		    if ($ssi_enabled) {
			print HTCTMP "AddHandler server-parsed .shtml\n";
			print HTCTMP "AddType    text/html     .shtml\n";
			$on = Cobalt::Language::msg_get('On_string');
		    }
		    else {
			# httpd.conf gets big enough without this bloat /wdh
			# print HTCTMP "#AddHandler server-parsed .shtml\n";
			# print HTCTMP "#AddType    text/html     .shtml\n";
			$on = Cobalt::Language::msg_get('Off_string');
		    }
		} else {
		    print HTCTMP $conf;
		}
		print HTCTMP;
		$conf = '';
	    } elsif ($found_web) {

		if (/^AddHandler server-parsed .shtml/) {
		    # clear the existing AddHandler .shtml entries
		    print STDERR "vsite_set_ssi found AddHandler .shtml\n"
			if ($Debug);
		    $ssi_was = "on";
		} elsif (/^\#AddHandler server-parsed .shtml/) {
		    # clear the existing AddHandler .shtml entries
		    print STDERR "vsite_set_ssi found AddHandler .shtml\n"
			if ($Debug);
		    $ssi_was = "";
		} elsif (/^(\#)?AddType\s+text\/html\s+.shtml/o) {
		    # clear the existing AddType .shtml entries
		    print STDERR "vsite_set_ssi found AddType .shtml\n"
			if ($Debug);
		} else {
		    # within vhost section but not a ssi line! slurp!
		    $conf .= $_;
		}
	    } else {
		# within vhost section but not the right one! slurp!
		$conf .= $_;
	    }
	} else {
	    # outside vhost section! spit it..
	    print HTCTMP;
	}
    }
    close HTCONF;
    close HTCTMP;
    return vsite_abort("4822 No virtual host entry for $vsite.") unless ($inentry);
    return vsite_abort("2132 No change to site SSI permissions")
	if ($ssi_was eq $ssi_enabled);

    return $ret if (($ret = vsite_commit()) !~ /^2/);
    return "2133 Site SSI permissions are now $on";
}


1;
