#! /usr/bin/perl
# ID: $Id: splitlogs.pl,v 1.8 1999/03/12 21:32:35 gsri Exp $
# Copyright 1999 Cobalt Networks, Inc.
# All rights reserved.

# Author: Will DeHaan <will@cobaltnet.com>

# Description: Split web access log by hostname

# Sites use their own log directories, the web stats generation program
# reads them in place

### START HARDCODED PATHS
my $Access_log = '/var/log/httpd/access';
my $Access_logrotate = '/var/log/httpd/combined-access';
my $Debug = '0';
my $Htgroup_dir = '/home/sites';
my $Logdir = 'logs';

my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = $Debug;
### END HARDCODED PATHS
use Cobalt::Http;
# use strict;

my($handlemax)=200;
my $RAMSUCKLIMIT = 100000;  # lines

# move the access log to a temporary name and restart the server; it will
# automagically create a new log file; this ensures no requests are
# dropped to the floor.
rename($Access_log, "$Access_log.tmp") ||
    die "Cannot rename web access log $Access_log\n";
http_restart();			# restart apache

open (AXS, "$Access_log.tmp") ||
    die "Cannot read web access log $Access_log.tmp\n";
open (COMB, ">>$Access_logrotate") ||
    die "Cannot append to web access log $Access_logrotate\n";
my(%ramSuckingLog,$ramsuck,%openFilz,$handlecnt);
while(<AXS>)
{
    # append the line to the combined access log
    print COMB;

    if ($_ =~ /^(\S+)\s+(.*)/)
    {
	my ($host,$data)=($1,$2);

	if($openFilz{$host})   # Open file handle
	{
	    print $host $data."\n";

	} elsif ($handlecnt < $handlemax) {
	    if ( open($host,">>$Htgroup_dir/$host/$Logdir/access") )
            {
	        $handlecnt++;
	        print $host $data."\n";
	        $openFilz{"$host"}=1;
            }
	    # else ignore unloggable data

	} else {
	    $ramSuckingLog{$host}.=$data."\n";
	    if (++$ramsuck > $RAMSUCKLIMIT) {
		output();
	    }
	}
    }
}
close COMB;
close AXS;
output();
unlink ("$Access_log.tmp");
exit 0;

sub output
# Close opened file handles and
# Write records waiting in ram
{
    my($openfile);
    foreach $openfile (keys %openFilz)
    {
	close(\*$openfile);
    }

    %openFilz = ();
    $handlecnt = 0;

    my($siteFqdn);
    foreach $siteFqdn (keys %ramSuckingLog)
    {
	if ( open(LGZ,">> $Htgroup_dir/$siteFqdn/$Logdir/access") )
        {
	    print LGZ $ramSuckingLog{$siteFqdn};
	    close(LGZ);
        }
        # else ignore unloggable data
    }

    $ramsuck = 0;
    %ramSuckingLog = ();
}

# splitlogs.pl ends here
