#!/usr/bin/perl

# usage: vacation.pl [message] [from-address]

# Copyright 1998-1999 Cobalt Microserver (http://www.cobaltmicro.com)

### START HARDCODED PATHS
my $Debug = '0';
my $Sendmail = '/usr/sbin/sendmail';
my $ShiftJISToJIS_prog = '/usr/local/sbin/nkf';
my $Vaca_dir = '/var/vacation';
my %Language = ('english','1','shiftjis','Cobalt interface message for shiftjis (We should never see this)','lastNameFirst','1','japanese','0');

my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = $Debug;
### END HARDCODED PATHS
require Cobalt::Language;
import Cobalt::Language qw(msg_get);
use strict;

use DB_File;
use Fcntl qw(O_RDWR O_CREAT);

my ($message_file,$user_from) = @ARGV;

my ($sendto,$sender,$returnpath,$from,$replyto,$precedence);

while (<STDIN>)
{
    if    (/From:\s*(.+)/)        { $from = &extract_address($1);       }
    elsif (/Reply-To:\s*(.+)/)    { $replyto = &extract_address($1);    }
    elsif (/Sender:\s*(.+)/)      { $sender = &extract_address($1);     }
    elsif (/Return-path:\s*(.+)/) { $returnpath = &extract_address($1); }
    elsif (/Precedence:\s*(.+)/)  { $precedence = $1;                   }
}
exit if ($precedence =~ /bulk|junk/oi);

if    ($replyto) { $sendto = $replyto;     }
elsif ($from)    { $sendto = $from;        }
elsif ($sender)  { $sendto = $sender;      }
elsif ($sender)  { $sendto = $returnpath;  }
else             { exit;                   }

my %vacadb;
tie(%vacadb,'DB_File',"$Vaca_dir/$user_from.db",O_RDWR|O_CREAT,0666)
    || die "Cannot open vacation database: $!\n";
if ($vacadb{$sendto} >= ($^T - 604800))
{
    # They've been given a reply recently
    untie %vacadb;
    exit;
}
else
{
    $vacadb{$sendto} = $^T;
    untie %vacadb;
}

my $gcos = (getpwnam($user_from))[6];
$gcos =~ tr/<>//d;
my $as_from = "$gcos <$user_from>";
my $subject = Cobalt::Language::msg_get('Vacation_Subject');
$subject = eval "\"$subject\"";  # need to eval to expand $as_from
my $tmpHeader="$Vaca_dir/header.$$";
open (OUTHEADER, ">$tmpHeader") || die "Cannot open $tmpHeader $!\n";
print OUTHEADER "From: $user_from\n";
print OUTHEADER "To: $sendto\n";
print OUTHEADER "Precedence: junk\n";
print OUTHEADER "Subject: $subject\n";
print OUTHEADER "Date: ", scalar(localtime($^T)), "\n";
close (OUTHEADER);

if ($Language{'japanese'}) {
    # convert header from Shift-JIS to JIS for sendmail
    my $tmpHeaderJ="$tmpHeader.sjis";
    system("$ShiftJISToJIS_prog $tmpHeader >$tmpHeaderJ");
    system("mv $tmpHeaderJ $tmpHeader");
}

open (OUT, "|$Sendmail -oi -t") || die "Can't open sendmail $!\n";
open (INHEADER, "<$tmpHeader") || die "Cannot open $tmpHeader to read $!\n";
open (INMESSAGE, "$message_file") || die "Can't open message file $!\n";
print OUT <INHEADER>;
print OUT "\n";
print OUT <INMESSAGE>;
close OUT;
close INHEADER;
close INMESSAGE;

# clean up
unlink $tmpHeader;


# boy, this is ugly
sub extract_address
{
    my ($from) = @_;
    my ($junk,$tmp1,$tmp2);
    if ($from =~ /.*<.*>/)              # From: Foo Bar <foobar@com.edu>
    {
        ($junk,$tmp1) = split('<',$from);
        ($tmp2,$junk) = split('>',$tmp1);
        return $tmp2;
    }
    elsif ($from =~ /.*(.*)/)   # From: foobar@com.edu (Foo Bar)
    {
        ($tmp1,$junk) = split('\(',$from);
        return $tmp1;
    }
    else                                # From: foobar@com.edu [we hope]
    {
        return $from;
    }
}
